
#ifndef ELECTRON_FUSES_H_
#define ELECTRON_FUSES_H_

#if defined(WIN32)
#define FUSE_EXPORT __declspec(dllexport)
#else
#define FUSE_EXPORT __attribute__((visibility("default")))
#endif

namespace electron::fuses {

constexpr char kFuseWire[] = { /* sentinel */ 0x55,0x6e,0x61,0x76,0x61,0x69,0x6c,0x61,0x62,0x6c,0x65,0x20,0x77,0x69,0x74,0x68,0x20,0x73,0x79,0x73,0x74,0x65,0x6d,0x20,0x65,0x6c,0x65,0x63,0x74,0x72,0x6f,0x6e, /* fuse_version */ 0x01, /* fuse_wire_length */ 0x08, /* fuse_wire */ 0x31,0x30,0x31,0x31,0x30,0x30,0x30,0x31};

constexpr bool INLINE_IsRunAsNodeEnabled() {
  return kFuseWire[34] == '1';
}
#define IsRunAsNodeEnabled INLINE_IsRunAsNodeEnabled

constexpr bool INLINE_IsCookieEncryptionEnabled() {
  return kFuseWire[35] == '1';
}
#define IsCookieEncryptionEnabled INLINE_IsCookieEncryptionEnabled

constexpr bool INLINE_IsNodeOptionsEnabled() {
  return kFuseWire[36] == '1';
}
#define IsNodeOptionsEnabled INLINE_IsNodeOptionsEnabled

constexpr bool INLINE_IsNodeCliInspectEnabled() {
  return kFuseWire[37] == '1';
}
#define IsNodeCliInspectEnabled INLINE_IsNodeCliInspectEnabled

constexpr bool INLINE_IsEmbeddedAsarIntegrityValidationEnabled() {
  return kFuseWire[38] == '1';
}
#define IsEmbeddedAsarIntegrityValidationEnabled INLINE_IsEmbeddedAsarIntegrityValidationEnabled

constexpr bool INLINE_IsOnlyLoadAppFromAsarEnabled() {
  return kFuseWire[39] == '1';
}
#define IsOnlyLoadAppFromAsarEnabled INLINE_IsOnlyLoadAppFromAsarEnabled

constexpr bool INLINE_IsLoadBrowserProcessSpecificV8SnapshotEnabled() {
  return kFuseWire[40] == '1';
}
#define IsLoadBrowserProcessSpecificV8SnapshotEnabled INLINE_IsLoadBrowserProcessSpecificV8SnapshotEnabled

constexpr bool INLINE_IsGrantFileProtocolExtraPrivilegesEnabled() {
  return kFuseWire[41] == '1';
}
#define IsGrantFileProtocolExtraPrivilegesEnabled INLINE_IsGrantFileProtocolExtraPrivilegesEnabled

}  // namespace electron::fuses

#endif  // ELECTRON_FUSES_H_
