// services/network/public/mojom/network_context.mojom-blink-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_CONTEXT_MOJOM_BLINK_TEST_UTILS_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_CONTEXT_MOJOM_BLINK_TEST_UTILS_H_

#include "services/network/public/mojom/network_context.mojom-blink.h"
#include "third_party/blink/public/platform/web_common.h"


namespace network::mojom::blink {


class BLINK_PLATFORM_EXPORT CustomProxyConnectionObserverInterceptorForTesting : public CustomProxyConnectionObserver {
  virtual CustomProxyConnectionObserver* GetForwardingInterface() = 0;
  void OnFallback(const ::net::ProxyChain& bad_chain, int32_t net_error) override;
  void OnTunnelHeadersReceived(const ::net::ProxyChain& proxy_chain, uint64_t chain_index, ::network::mojom::blink::HttpResponseHeadersPtr response_headers) override;
};
class BLINK_PLATFORM_EXPORT CustomProxyConnectionObserverAsyncWaiter {
 public:
  explicit CustomProxyConnectionObserverAsyncWaiter(CustomProxyConnectionObserver* proxy);

  CustomProxyConnectionObserverAsyncWaiter(const CustomProxyConnectionObserverAsyncWaiter&) = delete;
  CustomProxyConnectionObserverAsyncWaiter& operator=(const CustomProxyConnectionObserverAsyncWaiter&) = delete;

  ~CustomProxyConnectionObserverAsyncWaiter();

 private:
  CustomProxyConnectionObserver* const proxy_;
};


class BLINK_PLATFORM_EXPORT CustomProxyConfigClientInterceptorForTesting : public CustomProxyConfigClient {
  virtual CustomProxyConfigClient* GetForwardingInterface() = 0;
  void OnCustomProxyConfigUpdated(CustomProxyConfigPtr proxy_config, OnCustomProxyConfigUpdatedCallback callback) override;
};
class BLINK_PLATFORM_EXPORT CustomProxyConfigClientAsyncWaiter {
 public:
  explicit CustomProxyConfigClientAsyncWaiter(CustomProxyConfigClient* proxy);

  CustomProxyConfigClientAsyncWaiter(const CustomProxyConfigClientAsyncWaiter&) = delete;
  CustomProxyConfigClientAsyncWaiter& operator=(const CustomProxyConfigClientAsyncWaiter&) = delete;

  ~CustomProxyConfigClientAsyncWaiter();
  void OnCustomProxyConfigUpdated(
      CustomProxyConfigPtr proxy_config);
  

 private:
  CustomProxyConfigClient* const proxy_;
};


class BLINK_PLATFORM_EXPORT TrustedHeaderClientInterceptorForTesting : public TrustedHeaderClient {
  virtual TrustedHeaderClient* GetForwardingInterface() = 0;
  void OnBeforeSendHeaders(const ::net::HttpRequestHeaders& headers, OnBeforeSendHeadersCallback callback) override;
  void OnHeadersReceived(const WTF::String& headers, const ::net::IPEndPoint& remote_endpoint, OnHeadersReceivedCallback callback) override;
};
class BLINK_PLATFORM_EXPORT TrustedHeaderClientAsyncWaiter {
 public:
  explicit TrustedHeaderClientAsyncWaiter(TrustedHeaderClient* proxy);

  TrustedHeaderClientAsyncWaiter(const TrustedHeaderClientAsyncWaiter&) = delete;
  TrustedHeaderClientAsyncWaiter& operator=(const TrustedHeaderClientAsyncWaiter&) = delete;

  ~TrustedHeaderClientAsyncWaiter();
  void OnBeforeSendHeaders(
      const ::net::HttpRequestHeaders& headers, int32_t* out_result, std::optional<::net::HttpRequestHeaders>* out_headers);
  
  void OnHeadersReceived(
      const WTF::String& headers, const ::net::IPEndPoint& remote_endpoint, int32_t* out_result, WTF::String* out_headers, std::optional<::blink::KURL>* out_preserve_fragment_on_redirect_url);
  

 private:
  TrustedHeaderClient* const proxy_;
};


class BLINK_PLATFORM_EXPORT TrustedURLLoaderHeaderClientInterceptorForTesting : public TrustedURLLoaderHeaderClient {
  virtual TrustedURLLoaderHeaderClient* GetForwardingInterface() = 0;
  void OnLoaderCreated(int32_t request_id, ::mojo::PendingReceiver<TrustedHeaderClient> header_client) override;
  void OnLoaderForCorsPreflightCreated(const ::network::ResourceRequest& request, ::mojo::PendingReceiver<TrustedHeaderClient> header_client) override;
};
class BLINK_PLATFORM_EXPORT TrustedURLLoaderHeaderClientAsyncWaiter {
 public:
  explicit TrustedURLLoaderHeaderClientAsyncWaiter(TrustedURLLoaderHeaderClient* proxy);

  TrustedURLLoaderHeaderClientAsyncWaiter(const TrustedURLLoaderHeaderClientAsyncWaiter&) = delete;
  TrustedURLLoaderHeaderClientAsyncWaiter& operator=(const TrustedURLLoaderHeaderClientAsyncWaiter&) = delete;

  ~TrustedURLLoaderHeaderClientAsyncWaiter();

 private:
  TrustedURLLoaderHeaderClient* const proxy_;
};


class BLINK_PLATFORM_EXPORT CertVerifierClientInterceptorForTesting : public CertVerifierClient {
  virtual CertVerifierClient* GetForwardingInterface() = 0;
  void Verify(int32_t default_error, ::network::mojom::blink::CertVerifyResultPtr default_result, ::network::mojom::blink::X509CertificatePtr certificate, const WTF::String& hostname, int32_t flags, const WTF::String& ocsp_response, VerifyCallback callback) override;
};
class BLINK_PLATFORM_EXPORT CertVerifierClientAsyncWaiter {
 public:
  explicit CertVerifierClientAsyncWaiter(CertVerifierClient* proxy);

  CertVerifierClientAsyncWaiter(const CertVerifierClientAsyncWaiter&) = delete;
  CertVerifierClientAsyncWaiter& operator=(const CertVerifierClientAsyncWaiter&) = delete;

  ~CertVerifierClientAsyncWaiter();
  void Verify(
      int32_t default_error, ::network::mojom::blink::CertVerifyResultPtr default_result, ::network::mojom::blink::X509CertificatePtr certificate, const WTF::String& hostname, int32_t flags, const WTF::String& ocsp_response, int32_t* out_error_code, ::network::mojom::blink::CertVerifyResultPtr* out_result);
  

 private:
  CertVerifierClient* const proxy_;
};


class BLINK_PLATFORM_EXPORT NetworkContextClientInterceptorForTesting : public NetworkContextClient {
  virtual NetworkContextClient* GetForwardingInterface() = 0;
  void OnFileUploadRequested(int32_t process_id, bool async, const WTF::Vector<::base::FilePath>& file_paths, const ::blink::KURL& destination_url, OnFileUploadRequestedCallback callback) override;
  void OnCanSendReportingReports(const WTF::Vector<::scoped_refptr<const ::blink::SecurityOrigin>>& origins, OnCanSendReportingReportsCallback callback) override;
  void OnCanSendDomainReliabilityUpload(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, OnCanSendDomainReliabilityUploadCallback callback) override;
  void OnCanSendSCTAuditingReport(OnCanSendSCTAuditingReportCallback callback) override;
  void OnNewSCTAuditingReportSent() override;
};
class BLINK_PLATFORM_EXPORT NetworkContextClientAsyncWaiter {
 public:
  explicit NetworkContextClientAsyncWaiter(NetworkContextClient* proxy);

  NetworkContextClientAsyncWaiter(const NetworkContextClientAsyncWaiter&) = delete;
  NetworkContextClientAsyncWaiter& operator=(const NetworkContextClientAsyncWaiter&) = delete;

  ~NetworkContextClientAsyncWaiter();
  void OnFileUploadRequested(
      int32_t process_id, bool async, const WTF::Vector<::base::FilePath>& file_paths, const ::blink::KURL& destination_url, int32_t* out_net_error, WTF::Vector<::base::File>* out_files);
  
  void OnCanSendReportingReports(
      const WTF::Vector<::scoped_refptr<const ::blink::SecurityOrigin>>& origins, WTF::Vector<::scoped_refptr<const ::blink::SecurityOrigin>>* out_origins);
  WTF::Vector<::scoped_refptr<const ::blink::SecurityOrigin>> OnCanSendReportingReports(const WTF::Vector<::scoped_refptr<const ::blink::SecurityOrigin>>& origins);
  void OnCanSendDomainReliabilityUpload(
      const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, bool* out_allowed);
  bool OnCanSendDomainReliabilityUpload(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin);
  void OnCanSendSCTAuditingReport(
      bool* out_allowed);
  bool OnCanSendSCTAuditingReport();

 private:
  NetworkContextClient* const proxy_;
};


class BLINK_PLATFORM_EXPORT IpProtectionConfigGetterInterceptorForTesting : public IpProtectionConfigGetter {
  virtual IpProtectionConfigGetter* GetForwardingInterface() = 0;
  void TryGetAuthTokens(uint32_t batch_size, IpProtectionProxyLayer proxy_layer, TryGetAuthTokensCallback callback) override;
  void GetProxyList(GetProxyListCallback callback) override;
};
class BLINK_PLATFORM_EXPORT IpProtectionConfigGetterAsyncWaiter {
 public:
  explicit IpProtectionConfigGetterAsyncWaiter(IpProtectionConfigGetter* proxy);

  IpProtectionConfigGetterAsyncWaiter(const IpProtectionConfigGetterAsyncWaiter&) = delete;
  IpProtectionConfigGetterAsyncWaiter& operator=(const IpProtectionConfigGetterAsyncWaiter&) = delete;

  ~IpProtectionConfigGetterAsyncWaiter();
  void TryGetAuthTokens(
      uint32_t batch_size, IpProtectionProxyLayer proxy_layer, std::optional<WTF::Vector<BlindSignedAuthTokenPtr>>* out_bsa_tokens, std::optional<::base::Time>* out_try_again_after);
  
  void GetProxyList(
      std::optional<WTF::Vector<WTF::Vector<WTF::String>>>* out_proxy_list);
  std::optional<WTF::Vector<WTF::Vector<WTF::String>>> GetProxyList();

 private:
  IpProtectionConfigGetter* const proxy_;
};


class BLINK_PLATFORM_EXPORT IpProtectionProxyDelegateInterceptorForTesting : public IpProtectionProxyDelegate {
  virtual IpProtectionProxyDelegate* GetForwardingInterface() = 0;
  void VerifyIpProtectionConfigGetterForTesting(VerifyIpProtectionConfigGetterForTestingCallback callback) override;
  void InvalidateIpProtectionConfigCacheTryAgainAfterTime() override;
};
class BLINK_PLATFORM_EXPORT IpProtectionProxyDelegateAsyncWaiter {
 public:
  explicit IpProtectionProxyDelegateAsyncWaiter(IpProtectionProxyDelegate* proxy);

  IpProtectionProxyDelegateAsyncWaiter(const IpProtectionProxyDelegateAsyncWaiter&) = delete;
  IpProtectionProxyDelegateAsyncWaiter& operator=(const IpProtectionProxyDelegateAsyncWaiter&) = delete;

  ~IpProtectionProxyDelegateAsyncWaiter();
  void VerifyIpProtectionConfigGetterForTesting(
      BlindSignedAuthTokenPtr* out_bsa_token, std::optional<::base::Time>* out_try_again_after);
  

 private:
  IpProtectionProxyDelegate* const proxy_;
};


class BLINK_PLATFORM_EXPORT NetworkContextInterceptorForTesting : public NetworkContext {
  virtual NetworkContext* GetForwardingInterface() = 0;
  void SetClient(::mojo::PendingRemote<NetworkContextClient> client) override;
  void SetCertVerifierClient(::mojo::PendingRemote<CertVerifierClient> client) override;
  void CreateURLLoaderFactory(::mojo::PendingReceiver<::network::mojom::blink::URLLoaderFactory> url_loader_factory, URLLoaderFactoryParamsPtr params) override;
  void ResetURLLoaderFactories() override;
  void GetViaObliviousHttp(::network::mojom::blink::ObliviousHttpRequestPtr request, ::mojo::PendingRemote<::network::mojom::blink::ObliviousHttpClient> client) override;
  void GetCookieManager(::mojo::PendingReceiver<::network::mojom::blink::CookieManager> cookie_manager) override;
  void GetRestrictedCookieManager(::mojo::PendingReceiver<::network::mojom::blink::RestrictedCookieManager> restricted_cookie_manager, ::network::mojom::blink::RestrictedCookieManagerRole role, const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, const ::net::IsolationInfo& isolation_info, ::network::mojom::blink::CookieSettingOverridesPtr cookie_setting_overrides, ::mojo::PendingRemote<::network::mojom::blink::CookieAccessObserver> cookie_observer) override;
  void GetTrustTokenQueryAnswerer(::mojo::PendingReceiver<::network::mojom::blink::TrustTokenQueryAnswerer> trust_token_query_answerer, const ::scoped_refptr<const ::blink::SecurityOrigin>& top_frame_origin) override;
  void ClearTrustTokenData(::network::mojom::blink::ClearDataFilterPtr filter, ClearTrustTokenDataCallback callback) override;
  void ClearTrustTokenSessionOnlyData(ClearTrustTokenSessionOnlyDataCallback callback) override;
  void GetStoredTrustTokenCounts(GetStoredTrustTokenCountsCallback callback) override;
  void DeleteStoredTrustTokens(const ::scoped_refptr<const ::blink::SecurityOrigin>& issuer, DeleteStoredTrustTokensCallback callback) override;
  void SetBlockTrustTokens(bool block) override;
  void ClearNetworkingHistoryBetween(::base::Time start_time, ::base::Time end_time, ClearNetworkingHistoryBetweenCallback callback) override;
  void ClearHttpCache(::base::Time start_time, ::base::Time end_time, ::network::mojom::blink::ClearDataFilterPtr filter, ClearHttpCacheCallback callback) override;
  void ComputeHttpCacheSize(::base::Time start_time, ::base::Time end_time, ComputeHttpCacheSizeCallback callback) override;
  void NotifyExternalCacheHit(const ::blink::KURL& url, const WTF::String& http_method, ::network::mojom::blink::NetworkIsolationKeyPtr key, bool is_subframe_document_resource, bool include_credentials) override;
  void ClearHostCache(::network::mojom::blink::ClearDataFilterPtr filter, ClearHostCacheCallback callback) override;
  void ClearHttpAuthCache(::base::Time start_time, ::base::Time end_time, ::network::mojom::blink::ClearDataFilterPtr filter, ClearHttpAuthCacheCallback callback) override;
  void ClearCorsPreflightCache(::network::mojom::blink::ClearDataFilterPtr filter, ClearCorsPreflightCacheCallback callback) override;
  void ClearReportingCacheReports(::network::mojom::blink::ClearDataFilterPtr filter, ClearReportingCacheReportsCallback callback) override;
  void ClearReportingCacheClients(::network::mojom::blink::ClearDataFilterPtr filter, ClearReportingCacheClientsCallback callback) override;
  void ClearNetworkErrorLogging(::network::mojom::blink::ClearDataFilterPtr filter, ClearNetworkErrorLoggingCallback callback) override;
  void ClearDomainReliability(::network::mojom::blink::ClearDataFilterPtr filter, NetworkContext::DomainReliabilityClearMode mode, ClearDomainReliabilityCallback callback) override;
  void ClearSharedDictionaryCache(::base::Time start_time, ::base::Time end_time, ::network::mojom::blink::ClearDataFilterPtr filter, ClearSharedDictionaryCacheCallback callback) override;
  void ClearSharedDictionaryCacheForIsolationKey(::network::mojom::blink::SharedDictionaryIsolationKeyPtr isolation_key, ClearSharedDictionaryCacheForIsolationKeyCallback callback) override;
  void SetDocumentReportingEndpoints(const ::base::UnguessableToken& reporting_source, const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, const ::net::IsolationInfo& isolation_info, const WTF::HashMap<WTF::String, WTF::String>& endpoints) override;
  void SendReportsAndRemoveSource(const ::base::UnguessableToken& reporting_source) override;
  void QueueReport(const WTF::String& type, const WTF::String& group, const ::blink::KURL& url, const std::optional<::base::UnguessableToken>& reporting_source, ::network::mojom::blink::NetworkAnonymizationKeyPtr network_anonymization_key, const WTF::String& user_agent, ::base::Value::Dict body) override;
  void QueueSignedExchangeReport(SignedExchangeReportPtr report, ::network::mojom::blink::NetworkAnonymizationKeyPtr network_anonymization_key) override;
  void CloseAllConnections(CloseAllConnectionsCallback callback) override;
  void CloseIdleConnections(CloseIdleConnectionsCallback callback) override;
  void SetNetworkConditions(const ::base::UnguessableToken& throttling_profile_id, NetworkConditionsPtr conditions) override;
  void SetUserAgent(const WTF::String& new_user_agent) override;
  void SetAcceptLanguage(const WTF::String& new_accept_language) override;
  void SetEnableReferrers(bool enable_referrers) override;
  void SetCTPolicy(CTPolicyPtr ct_policy) override;
  void CreateUDPSocket(::mojo::PendingReceiver<::network::mojom::blink::UDPSocket> receiver, ::mojo::PendingRemote<::network::mojom::blink::UDPSocketListener> listener) override;
  void CreateRestrictedUDPSocket(const ::net::IPEndPoint& addr, ::network::mojom::blink::RestrictedUDPSocketMode mode, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::network::mojom::blink::RestrictedUDPSocketParamsPtr params, ::mojo::PendingReceiver<::network::mojom::blink::RestrictedUDPSocket> receiver, ::mojo::PendingRemote<::network::mojom::blink::UDPSocketListener> listener, CreateRestrictedUDPSocketCallback callback) override;
  void CreateTCPServerSocket(const ::net::IPEndPoint& local_addr, ::network::mojom::blink::TCPServerSocketOptionsPtr options, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingReceiver<::network::mojom::blink::TCPServerSocket> socket, CreateTCPServerSocketCallback callback) override;
  void CreateTCPConnectedSocket(const std::optional<::net::IPEndPoint>& local_addr, ::network::mojom::blink::AddressListPtr remote_addr_list, ::network::mojom::blink::TCPConnectedSocketOptionsPtr tcp_connected_socket_options, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingReceiver<::network::mojom::blink::TCPConnectedSocket> socket, ::mojo::PendingRemote<::network::mojom::blink::SocketObserver> observer, CreateTCPConnectedSocketCallback callback) override;
  void CreateTCPBoundSocket(const ::net::IPEndPoint& local_addr, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingReceiver<::network::mojom::blink::TCPBoundSocket> socket, CreateTCPBoundSocketCallback callback) override;
  void CreateProxyResolvingSocketFactory(::mojo::PendingReceiver<::network::mojom::blink::ProxyResolvingSocketFactory> factory) override;
  void LookUpProxyForURL(const ::blink::KURL& url, ::network::mojom::blink::NetworkAnonymizationKeyPtr network_anonymization_key, ::mojo::PendingRemote<::network::mojom::blink::ProxyLookupClient> proxy_lookup_client) override;
  void ForceReloadProxyConfig(ForceReloadProxyConfigCallback callback) override;
  void ClearBadProxiesCache(ClearBadProxiesCacheCallback callback) override;
  void CreateWebSocket(const ::blink::KURL& url, const WTF::Vector<WTF::String>& requested_protocols, const ::net::SiteForCookies& site_for_cookies, bool has_storage_access, const ::net::IsolationInfo& isolation_info, WTF::Vector<::network::mojom::blink::HttpHeaderPtr> additional_headers, int32_t process_id, const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, uint32_t options, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingRemote<::network::mojom::blink::WebSocketHandshakeClient> handshake_client, ::mojo::PendingRemote<::network::mojom::blink::URLLoaderNetworkServiceObserver> url_loader_network_observer, ::mojo::PendingRemote<::network::mojom::blink::WebSocketAuthenticationHandler> auth_handler, ::mojo::PendingRemote<TrustedHeaderClient> header_client, const std::optional<::base::UnguessableToken>& throttling_profile_id) override;
  void CreateWebTransport(const ::blink::KURL& url, const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, ::network::mojom::blink::NetworkAnonymizationKeyPtr network_anonymization_key, WTF::Vector<::network::mojom::blink::WebTransportCertificateFingerprintPtr> fingerprints, ::mojo::PendingRemote<::network::mojom::blink::WebTransportHandshakeClient> handshake_client) override;
  void CreateNetLogExporter(::mojo::PendingReceiver<::network::mojom::blink::NetLogExporter> receiver) override;
  void PreconnectSockets(uint32_t num_streams, const ::blink::KURL& url, bool allow_credentials, ::network::mojom::blink::NetworkAnonymizationKeyPtr network_anonymization_key) override;
  void CreateP2PSocketManager(::network::mojom::blink::NetworkAnonymizationKeyPtr network_anonymization_key, ::mojo::PendingRemote<::network::mojom::blink::P2PTrustedSocketManagerClient> client, ::mojo::PendingReceiver<::network::mojom::blink::P2PTrustedSocketManager> trusted_socket_manager, ::mojo::PendingReceiver<::network::mojom::blink::P2PSocketManager> socket_manager) override;
  void CreateMdnsResponder(::mojo::PendingReceiver<::network::mojom::blink::MdnsResponder> responder_receiver) override;
  void ResolveHost(::network::mojom::blink::HostResolverHostPtr host, ::network::mojom::blink::NetworkAnonymizationKeyPtr network_anonymization_key, ::network::mojom::blink::ResolveHostParametersPtr optional_parameters, ::mojo::PendingRemote<::network::mojom::blink::ResolveHostClient> response_client) override;
  void CreateHostResolver(::network::mojom::blink::DnsConfigOverridesPtr config_overrides, ::mojo::PendingReceiver<::network::mojom::blink::HostResolver> host_resolver) override;
  void VerifyCertForSignedExchange(::network::mojom::blink::X509CertificatePtr certificate, const ::blink::KURL& url, const WTF::String& ocsp_response, const WTF::String& sct_list, VerifyCertForSignedExchangeCallback callback) override;
  void AddHSTS(const WTF::String& host, ::base::Time expiry, bool include_subdomains, AddHSTSCallback callback) override;
  void IsHSTSActiveForHost(const WTF::String& host, IsHSTSActiveForHostCallback callback) override;
  void GetHSTSState(const WTF::String& domain, GetHSTSStateCallback callback) override;
  void SetCorsOriginAccessListsForOrigin(const ::scoped_refptr<const ::blink::SecurityOrigin>& source_origin, WTF::Vector<::network::mojom::blink::CorsOriginPatternPtr> allow_patterns, WTF::Vector<::network::mojom::blink::CorsOriginPatternPtr> block_patterns, SetCorsOriginAccessListsForOriginCallback callback) override;
  void DeleteDynamicDataForHost(const WTF::String& host, DeleteDynamicDataForHostCallback callback) override;
  void SetSplitAuthCacheByNetworkAnonymizationKey(bool split_auth_cache_by_network_anonymization_key) override;
  void SaveHttpAuthCacheProxyEntries(SaveHttpAuthCacheProxyEntriesCallback callback) override;
  void LoadHttpAuthCacheProxyEntries(const ::base::UnguessableToken& cache_key, LoadHttpAuthCacheProxyEntriesCallback callback) override;
  void AddAuthCacheEntry(const ::net::AuthChallengeInfo& challenge, ::network::mojom::blink::NetworkAnonymizationKeyPtr network_anonymization_key, ::network::mojom::blink::AuthCredentialsPtr credentials, AddAuthCacheEntryCallback callback) override;
  void SetCorsNonWildcardRequestHeadersSupport(bool value) override;
  void LookupServerBasicAuthCredentials(const ::blink::KURL& url, ::network::mojom::blink::NetworkAnonymizationKeyPtr network_anonymization_key, LookupServerBasicAuthCredentialsCallback callback) override;
  void EnableStaticKeyPinningForTesting(EnableStaticKeyPinningForTestingCallback callback) override;
  void VerifyCertificateForTesting(::network::mojom::blink::X509CertificatePtr certificate, const WTF::String& hostname, const WTF::String& ocsp_response, const WTF::String& sct_list, VerifyCertificateForTestingCallback callback) override;
  void AddDomainReliabilityContextForTesting(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, const ::blink::KURL& upload_url, AddDomainReliabilityContextForTestingCallback callback) override;
  void ForceDomainReliabilityUploadsForTesting(ForceDomainReliabilityUploadsForTestingCallback callback) override;
  void SetSCTAuditingMode(SCTAuditingMode mode) override;
  void GetSharedDictionaryUsageInfo(GetSharedDictionaryUsageInfoCallback callback) override;
  void GetSharedDictionaryInfo(::network::mojom::blink::SharedDictionaryIsolationKeyPtr isolation_key, GetSharedDictionaryInfoCallback callback) override;
  void GetSharedDictionaryOriginsBetween(::base::Time start_time, ::base::Time end_time, GetSharedDictionaryOriginsBetweenCallback callback) override;
  void SetSharedDictionaryCacheMaxSize(uint64_t cache_max_size) override;
  void ResourceSchedulerClientVisibilityChanged(const ::base::UnguessableToken& client_token, bool visible) override;
  void FlushCachedClientCertIfNeeded(const ::net::HostPortPair& host, ::network::mojom::blink::X509CertificatePtr certificate) override;
  void SetCookieDeprecationLabel(const WTF::String& label) override;
};
class BLINK_PLATFORM_EXPORT NetworkContextAsyncWaiter {
 public:
  explicit NetworkContextAsyncWaiter(NetworkContext* proxy);

  NetworkContextAsyncWaiter(const NetworkContextAsyncWaiter&) = delete;
  NetworkContextAsyncWaiter& operator=(const NetworkContextAsyncWaiter&) = delete;

  ~NetworkContextAsyncWaiter();
  void ClearTrustTokenData(
      ::network::mojom::blink::ClearDataFilterPtr filter);
  
  void ClearTrustTokenSessionOnlyData(
      bool* out_any_data_deleted);
  bool ClearTrustTokenSessionOnlyData();
  void GetStoredTrustTokenCounts(
      WTF::Vector<::network::mojom::blink::StoredTrustTokensForIssuerPtr>* out_tokens);
  WTF::Vector<::network::mojom::blink::StoredTrustTokensForIssuerPtr> GetStoredTrustTokenCounts();
  void DeleteStoredTrustTokens(
      const ::scoped_refptr<const ::blink::SecurityOrigin>& issuer, ::network::mojom::blink::DeleteStoredTrustTokensStatus* out_status);
  ::network::mojom::blink::DeleteStoredTrustTokensStatus DeleteStoredTrustTokens(const ::scoped_refptr<const ::blink::SecurityOrigin>& issuer);
  void ClearNetworkingHistoryBetween(
      ::base::Time start_time, ::base::Time end_time);
  
  void ClearHttpCache(
      ::base::Time start_time, ::base::Time end_time, ::network::mojom::blink::ClearDataFilterPtr filter);
  
  void ComputeHttpCacheSize(
      ::base::Time start_time, ::base::Time end_time, bool* out_is_upper_bound, int64_t* out_size_or_error);
  
  void ClearHostCache(
      ::network::mojom::blink::ClearDataFilterPtr filter);
  
  void ClearHttpAuthCache(
      ::base::Time start_time, ::base::Time end_time, ::network::mojom::blink::ClearDataFilterPtr filter);
  
  void ClearCorsPreflightCache(
      ::network::mojom::blink::ClearDataFilterPtr filter);
  
  void ClearReportingCacheReports(
      ::network::mojom::blink::ClearDataFilterPtr filter);
  
  void ClearReportingCacheClients(
      ::network::mojom::blink::ClearDataFilterPtr filter);
  
  void ClearNetworkErrorLogging(
      ::network::mojom::blink::ClearDataFilterPtr filter);
  
  void ClearDomainReliability(
      ::network::mojom::blink::ClearDataFilterPtr filter, NetworkContext::DomainReliabilityClearMode mode);
  
  void ClearSharedDictionaryCache(
      ::base::Time start_time, ::base::Time end_time, ::network::mojom::blink::ClearDataFilterPtr filter);
  
  void ClearSharedDictionaryCacheForIsolationKey(
      ::network::mojom::blink::SharedDictionaryIsolationKeyPtr isolation_key);
  
  void CloseAllConnections(
      );
  
  void CloseIdleConnections(
      );
  
  void CreateRestrictedUDPSocket(
      const ::net::IPEndPoint& addr, ::network::mojom::blink::RestrictedUDPSocketMode mode, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::network::mojom::blink::RestrictedUDPSocketParamsPtr params, ::mojo::PendingReceiver<::network::mojom::blink::RestrictedUDPSocket> receiver, ::mojo::PendingRemote<::network::mojom::blink::UDPSocketListener> listener, int32_t* out_result, std::optional<::net::IPEndPoint>* out_local_addr_out);
  
  void CreateTCPServerSocket(
      const ::net::IPEndPoint& local_addr, ::network::mojom::blink::TCPServerSocketOptionsPtr options, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingReceiver<::network::mojom::blink::TCPServerSocket> socket, int32_t* out_result, std::optional<::net::IPEndPoint>* out_local_addr_out);
  
  void CreateTCPConnectedSocket(
      const std::optional<::net::IPEndPoint>& local_addr, ::network::mojom::blink::AddressListPtr remote_addr_list, ::network::mojom::blink::TCPConnectedSocketOptionsPtr tcp_connected_socket_options, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingReceiver<::network::mojom::blink::TCPConnectedSocket> socket, ::mojo::PendingRemote<::network::mojom::blink::SocketObserver> observer, int32_t* out_result, std::optional<::net::IPEndPoint>* out_local_addr, std::optional<::net::IPEndPoint>* out_peer_addr, ::mojo::ScopedDataPipeConsumerHandle* out_receive_stream, ::mojo::ScopedDataPipeProducerHandle* out_send_stream);
  
  void CreateTCPBoundSocket(
      const ::net::IPEndPoint& local_addr, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingReceiver<::network::mojom::blink::TCPBoundSocket> socket, int32_t* out_result, std::optional<::net::IPEndPoint>* out_local_addr);
  
  void ForceReloadProxyConfig(
      );
  
  void ClearBadProxiesCache(
      );
  
  void VerifyCertForSignedExchange(
      ::network::mojom::blink::X509CertificatePtr certificate, const ::blink::KURL& url, const WTF::String& ocsp_response, const WTF::String& sct_list, int32_t* out_error_code, ::network::mojom::blink::CertVerifyResultPtr* out_cv_result, bool* out_pkp_bypassed);
  
  void AddHSTS(
      const WTF::String& host, ::base::Time expiry, bool include_subdomains);
  
  void IsHSTSActiveForHost(
      const WTF::String& host, bool* out_result);
  bool IsHSTSActiveForHost(const WTF::String& host);
  void GetHSTSState(
      const WTF::String& domain, ::base::Value::Dict* out_state);
  ::base::Value::Dict GetHSTSState(const WTF::String& domain);
  void SetCorsOriginAccessListsForOrigin(
      const ::scoped_refptr<const ::blink::SecurityOrigin>& source_origin, WTF::Vector<::network::mojom::blink::CorsOriginPatternPtr> allow_patterns, WTF::Vector<::network::mojom::blink::CorsOriginPatternPtr> block_patterns);
  
  void DeleteDynamicDataForHost(
      const WTF::String& host, bool* out_result);
  bool DeleteDynamicDataForHost(const WTF::String& host);
  void SaveHttpAuthCacheProxyEntries(
      ::base::UnguessableToken* out_cache_key);
  ::base::UnguessableToken SaveHttpAuthCacheProxyEntries();
  void LoadHttpAuthCacheProxyEntries(
      const ::base::UnguessableToken& cache_key);
  
  void AddAuthCacheEntry(
      const ::net::AuthChallengeInfo& challenge, ::network::mojom::blink::NetworkAnonymizationKeyPtr network_anonymization_key, ::network::mojom::blink::AuthCredentialsPtr credentials);
  
  void LookupServerBasicAuthCredentials(
      const ::blink::KURL& url, ::network::mojom::blink::NetworkAnonymizationKeyPtr network_anonymization_key, ::network::mojom::blink::AuthCredentialsPtr* out_credentials);
  ::network::mojom::blink::AuthCredentialsPtr LookupServerBasicAuthCredentials(const ::blink::KURL& url, ::network::mojom::blink::NetworkAnonymizationKeyPtr network_anonymization_key);
  void EnableStaticKeyPinningForTesting(
      );
  
  void VerifyCertificateForTesting(
      ::network::mojom::blink::X509CertificatePtr certificate, const WTF::String& hostname, const WTF::String& ocsp_response, const WTF::String& sct_list, int32_t* out_error_code);
  int32_t VerifyCertificateForTesting(::network::mojom::blink::X509CertificatePtr certificate, const WTF::String& hostname, const WTF::String& ocsp_response, const WTF::String& sct_list);
  void AddDomainReliabilityContextForTesting(
      const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, const ::blink::KURL& upload_url);
  
  void ForceDomainReliabilityUploadsForTesting(
      );
  
  void GetSharedDictionaryUsageInfo(
      WTF::Vector<::network::mojom::blink::SharedDictionaryUsageInfoPtr>* out_usage_info);
  WTF::Vector<::network::mojom::blink::SharedDictionaryUsageInfoPtr> GetSharedDictionaryUsageInfo();
  void GetSharedDictionaryInfo(
      ::network::mojom::blink::SharedDictionaryIsolationKeyPtr isolation_key, WTF::Vector<SharedDictionaryInfoPtr>* out_dictionaries);
  WTF::Vector<SharedDictionaryInfoPtr> GetSharedDictionaryInfo(::network::mojom::blink::SharedDictionaryIsolationKeyPtr isolation_key);
  void GetSharedDictionaryOriginsBetween(
      ::base::Time start_time, ::base::Time end_time, WTF::Vector<::scoped_refptr<const ::blink::SecurityOrigin>>* out_origins);
  WTF::Vector<::scoped_refptr<const ::blink::SecurityOrigin>> GetSharedDictionaryOriginsBetween(::base::Time start_time, ::base::Time end_time);

 private:
  NetworkContext* const proxy_;
};




}  // network::mojom::blink

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_CONTEXT_MOJOM_BLINK_TEST_UTILS_H_