// third_party/blink/public/mojom/frame/back_forward_cache_controller.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_BACK_FORWARD_CACHE_CONTROLLER_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_BACK_FORWARD_CACHE_CONTROLLER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/frame/back_forward_cache_controller.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/navigation/renderer_eviction_reason.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class BlockingDetailsDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::BlockingDetailsDataView> {
  using Data = ::blink::mojom::internal::BlockingDetails_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {
// Interface base classes. They are used for type safety check.
class BackForwardCacheControllerHostInterfaceBase {};

using BackForwardCacheControllerHostPtrDataView =
    mojo::InterfacePtrDataView<BackForwardCacheControllerHostInterfaceBase>;
using BackForwardCacheControllerHostRequestDataView =
    mojo::InterfaceRequestDataView<BackForwardCacheControllerHostInterfaceBase>;
using BackForwardCacheControllerHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<BackForwardCacheControllerHostInterfaceBase>;
using BackForwardCacheControllerHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<BackForwardCacheControllerHostInterfaceBase>;


class BlockingDetailsDataView {
 public:
  BlockingDetailsDataView() = default;

  BlockingDetailsDataView(
      internal::BlockingDetails_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  uint32_t feature() const {
    return data_->feature;
  }
  inline void GetUrlDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadUrl(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::StringDataView, UserType>(),
    "Attempting to read the optional `url` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadUrl` instead "
    "of `ReadUrl if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetFunctionNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadFunctionName(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::StringDataView, UserType>(),
    "Attempting to read the optional `function_name` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadFunctionName` instead "
    "of `ReadFunctionName if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->function_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  uint64_t line_number() const {
    return data_->line_number;
  }
  uint64_t column_number() const {
    return data_->column_number;
  }
 private:
  internal::BlockingDetails_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // blink::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::BlockingDetailsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::BlockingDetailsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::BlockingDetails_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->feature = Traits::feature(input);
    decltype(Traits::url(input)) in_url = Traits::url(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->url)::BaseType> url_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_url, url_fragment);
    fragment->url.Set(
        url_fragment.is_null() ? nullptr : url_fragment.data());
    decltype(Traits::function_name(input)) in_function_name = Traits::function_name(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->function_name)::BaseType> function_name_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_function_name, function_name_fragment);
    fragment->function_name.Set(
        function_name_fragment.is_null() ? nullptr : function_name_fragment.data());
    fragment->line_number = Traits::line_number(input);
    fragment->column_number = Traits::column_number(input);
  }

  static bool Deserialize(::blink::mojom::internal::BlockingDetails_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::BlockingDetailsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void BlockingDetailsDataView::GetUrlDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->url.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void BlockingDetailsDataView::GetFunctionNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->function_name.Get();
  *output = mojo::StringDataView(pointer, message_);
}



}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_BACK_FORWARD_CACHE_CONTROLLER_MOJOM_SHARED_H_