// third_party/blink/public/mojom/loader/javascript_framework_detection.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_JAVASCRIPT_FRAMEWORK_DETECTION_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_JAVASCRIPT_FRAMEWORK_DETECTION_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/loader/javascript_framework_detection.mojom-shared-internal.h"



#include "base/component_export.h"




namespace blink::mojom {
class JavaScriptFrameworkDetectionResultDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::JavaScriptFrameworkDetectionResultDataView> {
  using Data = ::blink::mojom::internal::JavaScriptFrameworkDetectionResult_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


enum class JavaScriptFramework : int32_t {
  
  kNuxt = 0,
  
  kVuePress = 1,
  
  kSapper = 2,
  
  kGatsby = 3,
  
  kNext = 4,
  
  kAngular = 5,
  
  kVue = 6,
  
  kSvelte = 7,
  
  kPreact = 8,
  
  kReact = 9,
  
  kDrupal = 10,
  
  kJoomla = 11,
  
  kShopify = 12,
  
  kSquarespace = 13,
  
  kWix = 14,
  
  kWordPress = 15,
  kMinValue = 0,
  kMaxValue = 15,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, JavaScriptFramework value);
inline bool IsKnownEnumValue(JavaScriptFramework value) {
  return internal::JavaScriptFramework_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


class JavaScriptFrameworkDetectionResultDataView {
 public:
  JavaScriptFrameworkDetectionResultDataView() = default;

  JavaScriptFrameworkDetectionResultDataView(
      internal::JavaScriptFrameworkDetectionResult_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetDetectedVersionsDataView(
      mojo::MapDataView<JavaScriptFramework, int16_t>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadDetectedVersions(UserType* output) {
    
    auto* pointer = data_->detected_versions.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<::blink::mojom::JavaScriptFramework, int16_t>>(
        pointer, output, message_);
  }
 private:
  internal::JavaScriptFrameworkDetectionResult_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // blink::mojom

namespace std {

template <>
struct hash<::blink::mojom::JavaScriptFramework>
    : public mojo::internal::EnumHashImpl<::blink::mojom::JavaScriptFramework> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::JavaScriptFramework, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::JavaScriptFramework, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::JavaScriptFramework>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::JavaScriptFrameworkDetectionResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::JavaScriptFrameworkDetectionResultDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::JavaScriptFrameworkDetectionResult_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::detected_versions(input)) in_detected_versions = Traits::detected_versions(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->detected_versions)::BaseType>
        detected_versions_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& detected_versions_validate_params =
        mojo::internal::GetMapValidator<*&mojo::internal::GetArrayOfEnumsValidator<0, ::blink::mojom::internal::JavaScriptFramework_Data::Validate>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::MapDataView<::blink::mojom::JavaScriptFramework, int16_t>>(
        in_detected_versions, detected_versions_fragment, &detected_versions_validate_params);
    fragment->detected_versions.Set(
        detected_versions_fragment.is_null() ? nullptr : detected_versions_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->detected_versions.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null detected_versions in JavaScriptFrameworkDetectionResult struct");
  }

  static bool Deserialize(::blink::mojom::internal::JavaScriptFrameworkDetectionResult_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::JavaScriptFrameworkDetectionResultDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void JavaScriptFrameworkDetectionResultDataView::GetDetectedVersionsDataView(
    mojo::MapDataView<JavaScriptFramework, int16_t>* output) {
  auto pointer = data_->detected_versions.Get();
  *output = mojo::MapDataView<JavaScriptFramework, int16_t>(pointer, message_);
}



}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::JavaScriptFramework> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::JavaScriptFramework value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_JAVASCRIPT_FRAMEWORK_DETECTION_MOJOM_SHARED_H_