// third_party/blink/public/mojom/sensor/web_sensor_provider_automation.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SENSOR_WEB_SENSOR_PROVIDER_AUTOMATION_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SENSOR_WEB_SENSOR_PROVIDER_AUTOMATION_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/sensor/web_sensor_provider_automation.mojom-features.h"
#include "third_party/blink/public/mojom/sensor/web_sensor_provider_automation.mojom-shared.h"
#include "third_party/blink/public/mojom/sensor/web_sensor_provider_automation.mojom-forward.h"
#include "services/device/public/mojom/sensor.mojom.h"
#include "services/device/public/mojom/sensor_provider.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::test::mojom {

class WebSensorProviderAutomationProxy;

template <typename ImplRefTraits>
class WebSensorProviderAutomationStub;

class WebSensorProviderAutomationRequestValidator;
class WebSensorProviderAutomationResponseValidator;


class BLINK_COMMON_EXPORT WebSensorProviderAutomation
    : public WebSensorProviderAutomationInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebSensorProviderAutomationInterfaceBase;
  using Proxy_ = WebSensorProviderAutomationProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebSensorProviderAutomationStub<ImplRefTraits>;

  using RequestValidator_ = WebSensorProviderAutomationRequestValidator;
  using ResponseValidator_ = WebSensorProviderAutomationResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateVirtualSensorMinVersion = 0,
    kUpdateVirtualSensorMinVersion = 0,
    kRemoveVirtualSensorMinVersion = 0,
    kGetVirtualSensorInformationMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CreateVirtualSensor_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct UpdateVirtualSensor_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct RemoveVirtualSensor_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct GetVirtualSensorInformation_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebSensorProviderAutomation() = default;


  using CreateVirtualSensorCallback = base::OnceCallback<void(::device::mojom::CreateVirtualSensorResult)>;
  
  virtual void CreateVirtualSensor(::device::mojom::SensorType type, ::device::mojom::VirtualSensorMetadataPtr metadata, CreateVirtualSensorCallback callback) = 0;


  using UpdateVirtualSensorCallback = base::OnceCallback<void(::device::mojom::UpdateVirtualSensorResult)>;
  
  virtual void UpdateVirtualSensor(::device::mojom::SensorType type, const ::device::SensorReading& reading, UpdateVirtualSensorCallback callback) = 0;


  using RemoveVirtualSensorCallback = base::OnceCallback<void()>;
  
  virtual void RemoveVirtualSensor(::device::mojom::SensorType type, RemoveVirtualSensorCallback callback) = 0;


  using GetVirtualSensorInformationCallback = base::OnceCallback<void(::device::mojom::GetVirtualSensorInformationResultPtr)>;
  
  virtual void GetVirtualSensorInformation(::device::mojom::SensorType type, GetVirtualSensorInformationCallback callback) = 0;
};



class BLINK_COMMON_EXPORT WebSensorProviderAutomationProxy
    : public WebSensorProviderAutomation {
 public:
  using InterfaceType = WebSensorProviderAutomation;

  explicit WebSensorProviderAutomationProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateVirtualSensor(::device::mojom::SensorType type, ::device::mojom::VirtualSensorMetadataPtr metadata, CreateVirtualSensorCallback callback) final;
  
  void UpdateVirtualSensor(::device::mojom::SensorType type, const ::device::SensorReading& reading, UpdateVirtualSensorCallback callback) final;
  
  void RemoveVirtualSensor(::device::mojom::SensorType type, RemoveVirtualSensorCallback callback) final;
  
  void GetVirtualSensorInformation(::device::mojom::SensorType type, GetVirtualSensorInformationCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT WebSensorProviderAutomationStubDispatch {
 public:
  static bool Accept(WebSensorProviderAutomation* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebSensorProviderAutomation* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebSensorProviderAutomation>>
class WebSensorProviderAutomationStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebSensorProviderAutomationStub() = default;
  ~WebSensorProviderAutomationStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebSensorProviderAutomationStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebSensorProviderAutomationStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT WebSensorProviderAutomationRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT WebSensorProviderAutomationResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::test::mojom

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_SENSOR_WEB_SENSOR_PROVIDER_AUTOMATION_MOJOM_H_