// third_party/blink/public/mojom/shared_storage/shared_storage_worklet_service.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SHARED_STORAGE_SHARED_STORAGE_WORKLET_SERVICE_MOJOM_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SHARED_STORAGE_SHARED_STORAGE_WORKLET_SERVICE_MOJOM_TEST_UTILS_H_

#include "third_party/blink/public/mojom/shared_storage/shared_storage_worklet_service.mojom.h"
#include "third_party/blink/public/common/common_export.h"


namespace blink::mojom {


class BLINK_COMMON_EXPORT SharedStorageEntriesListenerInterceptorForTesting : public SharedStorageEntriesListener {
  virtual SharedStorageEntriesListener* GetForwardingInterface() = 0;
  void DidReadEntries(bool success, const std::string& error_message, std::vector<SharedStorageKeyAndOrValuePtr> entries, bool has_more_entries, int32_t total_queued_to_send) override;
};
class BLINK_COMMON_EXPORT SharedStorageEntriesListenerAsyncWaiter {
 public:
  explicit SharedStorageEntriesListenerAsyncWaiter(SharedStorageEntriesListener* proxy);

  SharedStorageEntriesListenerAsyncWaiter(const SharedStorageEntriesListenerAsyncWaiter&) = delete;
  SharedStorageEntriesListenerAsyncWaiter& operator=(const SharedStorageEntriesListenerAsyncWaiter&) = delete;

  ~SharedStorageEntriesListenerAsyncWaiter();

 private:
  SharedStorageEntriesListener* const proxy_;
};


class BLINK_COMMON_EXPORT SharedStorageWorkletServiceClientInterceptorForTesting : public SharedStorageWorkletServiceClient {
  virtual SharedStorageWorkletServiceClient* GetForwardingInterface() = 0;
  void SharedStorageSet(const ::std::u16string& key, const ::std::u16string& value, bool ignore_if_present, SharedStorageSetCallback callback) override;
  void SharedStorageAppend(const ::std::u16string& key, const ::std::u16string& value, SharedStorageAppendCallback callback) override;
  void SharedStorageDelete(const ::std::u16string& key, SharedStorageDeleteCallback callback) override;
  void SharedStorageClear(SharedStorageClearCallback callback) override;
  void SharedStorageGet(const ::std::u16string& key, SharedStorageGetCallback callback) override;
  void SharedStorageKeys(::mojo::PendingRemote<SharedStorageEntriesListener> listener) override;
  void SharedStorageEntries(::mojo::PendingRemote<SharedStorageEntriesListener> listener) override;
  void SharedStorageLength(SharedStorageLengthCallback callback) override;
  void SharedStorageRemainingBudget(SharedStorageRemainingBudgetCallback callback) override;
  void DidAddMessageToConsole(::blink::mojom::ConsoleMessageLevel log_level, const std::string& message) override;
  void RecordUseCounters(const std::vector<::blink::mojom::WebFeature>& features) override;
};
class BLINK_COMMON_EXPORT SharedStorageWorkletServiceClientAsyncWaiter {
 public:
  explicit SharedStorageWorkletServiceClientAsyncWaiter(SharedStorageWorkletServiceClient* proxy);

  SharedStorageWorkletServiceClientAsyncWaiter(const SharedStorageWorkletServiceClientAsyncWaiter&) = delete;
  SharedStorageWorkletServiceClientAsyncWaiter& operator=(const SharedStorageWorkletServiceClientAsyncWaiter&) = delete;

  ~SharedStorageWorkletServiceClientAsyncWaiter();
  void SharedStorageSet(
      const ::std::u16string& key, const ::std::u16string& value, bool ignore_if_present, bool* out_success, std::string* out_error_message);
  
  void SharedStorageAppend(
      const ::std::u16string& key, const ::std::u16string& value, bool* out_success, std::string* out_error_message);
  
  void SharedStorageDelete(
      const ::std::u16string& key, bool* out_success, std::string* out_error_message);
  
  void SharedStorageClear(
      bool* out_success, std::string* out_error_message);
  
  void SharedStorageGet(
      const ::std::u16string& key, SharedStorageGetStatus* out_status, std::string* out_error_message, ::std::u16string* out_value);
  
  void SharedStorageLength(
      bool* out_success, std::string* out_error_message, uint32_t* out_length);
  
  void SharedStorageRemainingBudget(
      bool* out_success, std::string* out_error_message, double* out_bits);
  

 private:
  SharedStorageWorkletServiceClient* const proxy_;
};


class BLINK_COMMON_EXPORT SharedStorageWorkletServiceInterceptorForTesting : public SharedStorageWorkletService {
  virtual SharedStorageWorkletService* GetForwardingInterface() = 0;
  void Initialize(::mojo::PendingAssociatedRemote<SharedStorageWorkletServiceClient> client, bool private_aggregation_permissions_policy_allowed, const std::optional<::std::u16string>& embedder_context) override;
  void AddModule(::mojo::PendingRemote<::network::mojom::URLLoaderFactory> url_loader_factory, const ::GURL& script_source_url, AddModuleCallback callback) override;
  void RunURLSelectionOperation(const std::string& name, const std::vector<::GURL>& urls, ::blink::CloneableMessage serialized_data, ::mojo::PendingRemote<::blink::mojom::PrivateAggregationHost> pa_host, RunURLSelectionOperationCallback callback) override;
  void RunOperation(const std::string& name, ::blink::CloneableMessage serialized_data, ::mojo::PendingRemote<::blink::mojom::PrivateAggregationHost> pa_host, RunOperationCallback callback) override;
};
class BLINK_COMMON_EXPORT SharedStorageWorkletServiceAsyncWaiter {
 public:
  explicit SharedStorageWorkletServiceAsyncWaiter(SharedStorageWorkletService* proxy);

  SharedStorageWorkletServiceAsyncWaiter(const SharedStorageWorkletServiceAsyncWaiter&) = delete;
  SharedStorageWorkletServiceAsyncWaiter& operator=(const SharedStorageWorkletServiceAsyncWaiter&) = delete;

  ~SharedStorageWorkletServiceAsyncWaiter();
  void AddModule(
      ::mojo::PendingRemote<::network::mojom::URLLoaderFactory> url_loader_factory, const ::GURL& script_source_url, bool* out_success, std::string* out_error_message);
  
  void RunURLSelectionOperation(
      const std::string& name, const std::vector<::GURL>& urls, ::blink::CloneableMessage serialized_data, ::mojo::PendingRemote<::blink::mojom::PrivateAggregationHost> pa_host, bool* out_success, std::string* out_error_message, uint32_t* out_index);
  
  void RunOperation(
      const std::string& name, ::blink::CloneableMessage serialized_data, ::mojo::PendingRemote<::blink::mojom::PrivateAggregationHost> pa_host, bool* out_success, std::string* out_error_message);
  

 private:
  SharedStorageWorkletService* const proxy_;
};




}  // blink::mojom

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_SHARED_STORAGE_SHARED_STORAGE_WORKLET_SERVICE_MOJOM_TEST_UTILS_H_