// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_ARIA_NOTIFICATION_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_ARIA_NOTIFICATION_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_aria_notification_insertion_mode.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class CORE_EXPORT AriaNotificationOptions : public bindings::DictionaryBase {
  
  public:
static AriaNotificationOptions* Create() {
  return MakeGarbageCollected<AriaNotificationOptions>();
}
static AriaNotificationOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<AriaNotificationOptions>(isolate);
}
static AriaNotificationOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  AriaNotificationOptions();
explicit  AriaNotificationOptions(v8::Isolate* isolate);

bool hasInsertionMode() const {
  return true;
}
V8AriaNotificationInsertionMode insertionMode() const {
  return member_insertion_mode_;
}
void setInsertionMode(V8AriaNotificationInsertionMode value) {
  member_insertion_mode_ = value;
}
void setInsertionMode(V8AriaNotificationInsertionMode::Enum value) {
  member_insertion_mode_ = V8AriaNotificationInsertionMode(value);
}

bool hasInterruptCurrent() const {
  return true;
}
bool interruptCurrent() const {
  return member_interrupt_current_;
}
void setInterruptCurrent(bool value) {
  member_interrupt_current_ = value;
}

bool hasLabel() const {
  return true;
}
const String& label() const {
  return member_label_;
}
void setLabel(const String& value);
void setLabel(String&& value);

bool hasPreventInterrupt() const {
  return true;
}
bool preventInterrupt() const {
  return member_prevent_interrupt_;
}
void setPreventInterrupt(bool value) {
  member_prevent_interrupt_ = value;
}


// Obsolete accessor functions
void setInsertionMode(const String& value) {
  member_insertion_mode_ = V8AriaNotificationInsertionMode::Create(value).value();
}

void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



V8AriaNotificationInsertionMode member_insertion_mode_{V8AriaNotificationInsertionMode::Enum::kQueue};
bool member_interrupt_current_{false};
String member_label_{""};
bool member_prevent_interrupt_{false};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_ARIA_NOTIFICATION_OPTIONS_H_
