// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_check_visibility_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



CheckVisibilityOptions* CheckVisibilityOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  CheckVisibilityOptions* dictionary = MakeGarbageCollected<CheckVisibilityOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "CheckVisibilityOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 CheckVisibilityOptions::CheckVisibilityOptions() {
  
}

 CheckVisibilityOptions::CheckVisibilityOptions(v8::Isolate* isolate) {
  
}




























void CheckVisibilityOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_check_opacity_);
TraceIfNeeded<bool>::Trace(visitor, member_check_visibility_css_);
TraceIfNeeded<bool>::Trace(visitor, member_content_visibility_auto_);
TraceIfNeeded<bool>::Trace(visitor, member_opacity_property_);
TraceIfNeeded<bool>::Trace(visitor, member_visibility_property_);
bindings::DictionaryBase::Trace(visitor);
}

bool CheckVisibilityOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasCheckOpacity()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_check_opacity_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasCheckVisibilityCSS()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_check_visibility_css_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (RuntimeEnabledFeatures::CheckVisibilityExtraPropertiesEnabled()) {
  if (hasContentVisibilityAuto()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_content_visibility_auto_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
}
if (RuntimeEnabledFeatures::CheckVisibilityExtraPropertiesEnabled()) {
  if (hasOpacityProperty()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_opacity_property_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
}
if (RuntimeEnabledFeatures::CheckVisibilityExtraPropertiesEnabled()) {
  if (hasVisibilityProperty()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_visibility_property_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
}
return true;
}

void CheckVisibilityOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "CheckVisibilityOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("checkOpacity");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_check_opacity_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("checkVisibilityCSS");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_check_visibility_css_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::CheckVisibilityExtraPropertiesEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("contentVisibilityAuto");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_content_visibility_auto_, try_block, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::CheckVisibilityExtraPropertiesEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("opacityProperty");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_opacity_property_, try_block, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::CheckVisibilityExtraPropertiesEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("visibilityProperty");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_visibility_property_, try_block, exception_state)) {
  return;
}
}
}

const base::span<const v8::Eternal<v8::Name>> CheckVisibilityOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"checkOpacity",
"checkVisibilityCSS",
"contentVisibilityAuto",
"opacityProperty",
"visibilityProperty",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
