// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_function.h"

#include <tuple>

#include "third_party/blink/renderer/bindings/core/v8/callback_invoke_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"

namespace blink {





const char* V8Function::NameInHeapSnapshot() const {
  return "V8Function";
}

v8::Maybe<ScriptValue> V8Function::Invoke(bindings::V8ValueOrScriptWrappableAdapter arg0_receiver, const HeapVector<ScriptValue>& arg1_arguments) {
  const char* const class_like_name = "Function";
const char* const property_name = "invoke";
ScriptState* callback_relevant_script_state =
    CallbackRelevantScriptStateOrThrowException(
        class_like_name, property_name);
if (!callback_relevant_script_state) {
  return v8::Nothing<ScriptValue>();
}

v8::Isolate* isolate = GetIsolate();
if (!IsCallbackFunctionRunnable(callback_relevant_script_state, IncumbentScriptState())) {
  v8::HandleScope handle_scope(isolate);
v8::Context::Scope context_scope(callback_relevant_script_state->GetContext());
ExceptionState exception_state(isolate, ExceptionContextType::kOperationInvoke,class_like_name, property_name);
exception_state.ThrowException(static_cast<ExceptionCode>(ESErrorType::kError), "The provided callback is no longer runnable.");
return v8::Nothing<ScriptValue>();
}

bindings::CallbackInvokeHelper<CallbackFunctionWithTaskAttributionBase, bindings::CallbackInvokeHelperMode::kDefault, bindings::CallbackReturnTypeIsPromise::kNo> helper(
    this, class_like_name, property_name);
if (UNLIKELY(!helper.PrepareForCall(arg0_receiver))) {
  if (helper.V8Result().IsEmpty()) {
  return v8::Nothing<ScriptValue>();
}
return helper.Result<IDLAny, ScriptValue>();
}
const int argc = 0 + arg1_arguments.size();
v8::Local<v8::Value> argv[std::max(1, argc)];
ScriptState* script_state = CallbackRelevantScriptState();
for (wtf_size_t i = 0; i < arg1_arguments.size(); ++i) {
  v8::Local<v8::Value> v8_arg1_arguments;
v8_arg1_arguments = ToV8Traits<IDLAny>::ToV8(script_state, arg1_arguments[i]);
argv[0 + i] = v8_arg1_arguments;
}

if (!helper.Call(argc, argv)) {
  return v8::Nothing<ScriptValue>();
}
return helper.Result<IDLAny, ScriptValue>();
}

v8::Maybe<ScriptValue> V8Function::Construct(const HeapVector<ScriptValue>& arg1_arguments) {
  const char* const class_like_name = "Function";
const char* const property_name = "construct";
ScriptState* callback_relevant_script_state =
    CallbackRelevantScriptStateOrThrowException(
        class_like_name, property_name);
if (!callback_relevant_script_state) {
  return v8::Nothing<ScriptValue>();
}

v8::Isolate* isolate = GetIsolate();
if (!IsCallbackFunctionRunnable(callback_relevant_script_state, IncumbentScriptState())) {
  v8::HandleScope handle_scope(isolate);
v8::Context::Scope context_scope(callback_relevant_script_state->GetContext());
ExceptionState exception_state(isolate, ExceptionContextType::kOperationInvoke,class_like_name, property_name);
exception_state.ThrowException(static_cast<ExceptionCode>(ESErrorType::kError), "The provided callback is no longer runnable.");
return v8::Nothing<ScriptValue>();
}

bindings::CallbackInvokeHelper<CallbackFunctionWithTaskAttributionBase, bindings::CallbackInvokeHelperMode::kConstructorCall, bindings::CallbackReturnTypeIsPromise::kNo> helper(
    this, class_like_name, property_name);
if (UNLIKELY(!helper.PrepareForCall(nullptr))) {
  if (helper.V8Result().IsEmpty()) {
  return v8::Nothing<ScriptValue>();
}
return helper.Result<IDLAny, ScriptValue>();
}
const int argc = 0 + arg1_arguments.size();
v8::Local<v8::Value> argv[std::max(1, argc)];
ScriptState* script_state = CallbackRelevantScriptState();
for (wtf_size_t i = 0; i < arg1_arguments.size(); ++i) {
  v8::Local<v8::Value> v8_arg1_arguments;
v8_arg1_arguments = ToV8Traits<IDLAny>::ToV8(script_state, arg1_arguments[i]);
argv[0 + i] = v8_arg1_arguments;
}

if (!helper.Call(argc, argv)) {
  return v8::Nothing<ScriptValue>();
}
return helper.Result<IDLAny, ScriptValue>();
}

void V8Function::InvokeAndReportException(bindings::V8ValueOrScriptWrappableAdapter arg0_receiver, const HeapVector<ScriptValue>& arg1_arguments) {
  v8::Isolate* isolate = GetIsolate();
v8::TryCatch try_catch(isolate);
try_catch.SetVerbose(true);

std::ignore = Invoke(arg0_receiver, arg1_arguments);
}



}  // namespace blink
