// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_get_inner_html_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/dom/shadow_root.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



GetInnerHTMLOptions* GetInnerHTMLOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GetInnerHTMLOptions* dictionary = MakeGarbageCollected<GetInnerHTMLOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GetInnerHTMLOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 GetInnerHTMLOptions::GetInnerHTMLOptions() {
  
}

 GetInnerHTMLOptions::GetInnerHTMLOptions(v8::Isolate* isolate) {
  
}



HeapVector<Member<ShadowRoot>> GetInnerHTMLOptions::getClosedRootsOr(const HeapVector<Member<ShadowRoot>>& fallback_value) const {
  if (!hasClosedRoots()) {
  return fallback_value;
}
return member_closed_roots_;
}

HeapVector<Member<ShadowRoot>> GetInnerHTMLOptions::getClosedRootsOr(HeapVector<Member<ShadowRoot>>&& fallback_value) const {
  if (!hasClosedRoots()) {
  return std::move(fallback_value);
}
return member_closed_roots_;
}

void GetInnerHTMLOptions::setClosedRoots(const HeapVector<Member<ShadowRoot>>& value) {
  member_closed_roots_ = value;
has_closed_roots_ = true;
}

void GetInnerHTMLOptions::setClosedRoots(HeapVector<Member<ShadowRoot>>&& value) {
  member_closed_roots_ = std::move(value);
has_closed_roots_ = true;
}









void GetInnerHTMLOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<ShadowRoot>>>::Trace(visitor, member_closed_roots_);
TraceIfNeeded<bool>::Trace(visitor, member_include_shadow_roots_);
bindings::DictionaryBase::Trace(visitor);
}

bool GetInnerHTMLOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasClosedRoots()) {
  v8_value = ToV8Traits<IDLSequence<ShadowRoot>>::ToV8(script_state, member_closed_roots_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasIncludeShadowRoots()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_include_shadow_roots_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void GetInnerHTMLOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "GetInnerHTMLOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("closedRoots");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<ShadowRoot>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_closed_roots_, member_closed_roots_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("includeShadowRoots");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_include_shadow_roots_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GetInnerHTMLOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"closedRoots",
"includeShadowRoots",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
