// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_keyframe_animation_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_timeline_range_offset.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_string_timelinerangeoffset.h"
#include "third_party/blink/renderer/core/animation/animation_timeline.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



KeyframeAnimationOptions* KeyframeAnimationOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  KeyframeAnimationOptions* dictionary = MakeGarbageCollected<KeyframeAnimationOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "KeyframeAnimationOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 KeyframeAnimationOptions::KeyframeAnimationOptions() : member_range_end_(MakeGarbageCollected<V8UnionStringOrTimelineRangeOffset>("normal")), member_range_start_(MakeGarbageCollected<V8UnionStringOrTimelineRangeOffset>("normal")) {
  
}

 KeyframeAnimationOptions::KeyframeAnimationOptions(v8::Isolate* isolate) : KeyframeEffectOptions(isolate), member_range_end_(MakeGarbageCollected<V8UnionStringOrTimelineRangeOffset>("normal")), member_range_start_(MakeGarbageCollected<V8UnionStringOrTimelineRangeOffset>("normal")) {
  
}



void KeyframeAnimationOptions::setId(const String& value) {
  member_id_ = value;
}

void KeyframeAnimationOptions::setId(String&& value) {
  member_id_ = std::move(value);
}





















void KeyframeAnimationOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_id_);
TraceIfNeeded<Member<V8UnionStringOrTimelineRangeOffset>>::Trace(visitor, member_range_end_);
TraceIfNeeded<Member<V8UnionStringOrTimelineRangeOffset>>::Trace(visitor, member_range_start_);
TraceIfNeeded<Member<AnimationTimeline>>::Trace(visitor, member_timeline_);
KeyframeEffectOptions::Trace(visitor);
}

bool KeyframeAnimationOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!KeyframeEffectOptions::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasRangeEnd()) {
  v8_value = ToV8Traits<V8UnionStringOrTimelineRangeOffset>::ToV8(script_state, member_range_end_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasRangeStart()) {
  v8_value = ToV8Traits<V8UnionStringOrTimelineRangeOffset>::ToV8(script_state, member_range_start_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasTimeline()) {
  v8_value = ToV8Traits<IDLNullable<AnimationTimeline>>::ToV8(script_state, member_timeline_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void KeyframeAnimationOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  KeyframeEffectOptions::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "KeyframeAnimationOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("id");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rangeEnd");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionStringOrTimelineRangeOffset, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_range_end_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rangeStart");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionStringOrTimelineRangeOffset, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_range_start_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("timeline");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<AnimationTimeline>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_timeline_, member_timeline_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> KeyframeAnimationOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"id",
"rangeEnd",
"rangeStart",
"timeline",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
