// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_profiler_sample.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/execution_context/execution_context.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



ProfilerSample* ProfilerSample::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ProfilerSample* dictionary = MakeGarbageCollected<ProfilerSample>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ProfilerSample";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 ProfilerSample::ProfilerSample() {
  
}

 ProfilerSample::ProfilerSample(v8::Isolate* isolate) {
  
}






















void ProfilerSample::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8ProfilerMarker>::Trace(visitor, member_marker_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_stack_id_);
TraceIfNeeded<double>::Trace(visitor, member_timestamp_);
bindings::DictionaryBase::Trace(visitor);
}

bool ProfilerSample::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
ExecutionContext* execution_context = ExecutionContext::From(current_context);
const bool is_cross_origin_isolated = execution_context->CrossOriginIsolatedCapabilityOrDisabledWebSecurity();
v8::Local<v8::Value> v8_value;
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (is_cross_origin_isolated && RuntimeEnabledFeatures::ExperimentalJSProfilerMarkersEnabled()) {
  if (hasMarker()) {
  v8_value = ToV8Traits<V8ProfilerMarker>::ToV8(script_state, member_marker_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
}
if (hasStackId()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_stack_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasTimestamp()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_timestamp_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void ProfilerSample::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
ExecutionContext* execution_context = ExecutionContext::From(current_context);
const bool is_cross_origin_isolated = execution_context->CrossOriginIsolatedCapabilityOrDisabledWebSecurity();
const char* const class_like_name = "ProfilerSample";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
constexpr bool is_optional = false;
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (is_cross_origin_isolated && RuntimeEnabledFeatures::ExperimentalJSProfilerMarkersEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("marker");
if (!bindings::GetDictionaryMemberFromV8Object<V8ProfilerMarker, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_marker_, member_marker_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("stackId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_stack_id_, member_stack_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("timestamp");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_timestamp_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ProfilerSample::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"marker",
"stackId",
"timestamp",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
