// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_union_arraybuffer_arraybufferview.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {



V8UnionArrayBufferOrArrayBufferView* V8UnionArrayBufferOrArrayBufferView::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  if (v8_value->IsArrayBuffer() || v8_value->IsSharedArrayBuffer()) {
  auto&& blink_value = NativeValueTraits<DOMArrayBuffer>::NativeValue(isolate, v8_value, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionArrayBufferOrArrayBufferView>(blink_value);
}
if (v8_value->IsArrayBufferView()) {
  auto&& blink_value = NativeValueTraits<NotShared<DOMArrayBufferView>>::NativeValue(isolate, v8_value, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionArrayBufferOrArrayBufferView>(blink_value);
}
ThrowTypeErrorNotOfType(exception_state, UnionNameInIDL());
return nullptr;
}










v8::Local<v8::Value> V8UnionArrayBufferOrArrayBufferView::ToV8(ScriptState* script_state) const {
  switch (content_type_) {
  case ContentType::kArrayBuffer: {
    return ToV8Traits<DOMArrayBuffer>::ToV8(script_state, member_array_buffer_.Get());
  }
  case ContentType::kArrayBufferView: {
    return ToV8Traits<NotShared<DOMArrayBufferView>>::ToV8(script_state, member_array_buffer_view_);
  }
}

NOTREACHED();
return v8::Local<v8::Value>();
}

void V8UnionArrayBufferOrArrayBufferView::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<DOMArrayBuffer>>::Trace(visitor, member_array_buffer_);
TraceIfNeeded<NotShared<DOMArrayBufferView>>::Trace(visitor, member_array_buffer_view_);
bindings::UnionBase::Trace(visitor);
}

void V8UnionArrayBufferOrArrayBufferView::Clear() {
  member_array_buffer_.Clear();
member_array_buffer_view_.Clear();
}



}  // namespace blink
