// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_FENCEDFRAMECONFIG_USVSTRING_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_FENCEDFRAMECONFIG_USVSTRING_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class FencedFrameConfig;

class CORE_EXPORT V8UnionFencedFrameConfigOrUSVString final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kFencedFrameConfig, kUSVString
};

static V8UnionFencedFrameConfigOrUSVString* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionFencedFrameConfigOrUSVString(FencedFrameConfig* value) : content_type_(ContentType::kFencedFrameConfig), member_fenced_frame_config_(value) {
  DCHECK(value);
}
explicit  V8UnionFencedFrameConfigOrUSVString(const String& value);
explicit  V8UnionFencedFrameConfigOrUSVString(String&& value);

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsFencedFrameConfig() const {
  return content_type_ == ContentType::kFencedFrameConfig;
}
FencedFrameConfig* GetAsFencedFrameConfig() const {
  DCHECK_EQ(content_type_, ContentType::kFencedFrameConfig);
return member_fenced_frame_config_.Get();
}
void Set(FencedFrameConfig* value) {
  DCHECK(value);
Clear();
member_fenced_frame_config_ = value;
content_type_ = ContentType::kFencedFrameConfig;
}

bool IsUSVString() const {
  return content_type_ == ContentType::kUSVString;
}
const String& GetAsUSVString() const {
  DCHECK_EQ(content_type_, ContentType::kUSVString);
return member_usv_string_;
}
void Set(const String& value);
void Set(String&& value);


v8::Local<v8::Value> ToV8(ScriptState* script_state) const override;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(FencedFrameConfig or USVString)";
}

ContentType content_type_;

Member<FencedFrameConfig> member_fenced_frame_config_;
String member_usv_string_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_FENCEDFRAMECONFIG_USVSTRING_H_
