// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_union_string_trustedhtml.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_trusted_html.h"
#include "third_party/blink/renderer/core/trustedtypes/trusted_html.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {



V8UnionStringOrTrustedHTML* V8UnionStringOrTrustedHTML::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  if (V8TrustedHTML::HasInstance(isolate, v8_value)) {
  auto&& blink_value = V8TrustedHTML::ToWrappableUnsafe(v8_value.As<v8::Object>());
return MakeGarbageCollected<V8UnionStringOrTrustedHTML>(blink_value);
}
{
  auto&& blink_value = NativeValueTraits<IDLString>::NativeValue(isolate, v8_value, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionStringOrTrustedHTML>(std::move(blink_value));
}
}

 V8UnionStringOrTrustedHTML::V8UnionStringOrTrustedHTML(const String& value) : content_type_(ContentType::kString), member_string_(value) {
  
}

 V8UnionStringOrTrustedHTML::V8UnionStringOrTrustedHTML(String&& value) : content_type_(ContentType::kString), member_string_(std::move(value)) {
  
}




void V8UnionStringOrTrustedHTML::Set(const String& value) {
  Clear();
member_string_ = value;
content_type_ = ContentType::kString;
}

void V8UnionStringOrTrustedHTML::Set(String&& value) {
  Clear();
member_string_ = std::move(value);
content_type_ = ContentType::kString;
}





v8::Local<v8::Value> V8UnionStringOrTrustedHTML::ToV8(ScriptState* script_state) const {
  switch (content_type_) {
  case ContentType::kString: {
    return ToV8Traits<IDLString>::ToV8(script_state, member_string_);
  }
  case ContentType::kTrustedHTML: {
    return ToV8Traits<TrustedHTML>::ToV8(script_state, member_trusted_html_.Get());
  }
}

NOTREACHED();
return v8::Local<v8::Value>();
}

void V8UnionStringOrTrustedHTML::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_string_);
TraceIfNeeded<Member<TrustedHTML>>::Trace(visitor, member_trusted_html_);
bindings::UnionBase::Trace(visitor);
}

void V8UnionStringOrTrustedHTML::Clear() {
  member_string_ = String();
member_trusted_html_.Clear();
}



}  // namespace blink
