// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_union_string_workeroptions.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_worker_options.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {



V8UnionStringOrWorkerOptions* V8UnionStringOrWorkerOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  if (v8_value->IsNullOrUndefined()) {
  auto&& blink_value = WorkerOptions::Create(isolate);
return MakeGarbageCollected<V8UnionStringOrWorkerOptions>(blink_value);
}
if (v8_value->IsObject()) {
  auto&& blink_value = NativeValueTraits<WorkerOptions>::NativeValue(isolate, v8_value, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionStringOrWorkerOptions>(blink_value);
}
{
  auto&& blink_value = NativeValueTraits<IDLString>::NativeValue(isolate, v8_value, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionStringOrWorkerOptions>(std::move(blink_value));
}
}

 V8UnionStringOrWorkerOptions::V8UnionStringOrWorkerOptions(const String& value) : content_type_(ContentType::kString), member_string_(value) {
  
}

 V8UnionStringOrWorkerOptions::V8UnionStringOrWorkerOptions(String&& value) : content_type_(ContentType::kString), member_string_(std::move(value)) {
  
}




void V8UnionStringOrWorkerOptions::Set(const String& value) {
  Clear();
member_string_ = value;
content_type_ = ContentType::kString;
}

void V8UnionStringOrWorkerOptions::Set(String&& value) {
  Clear();
member_string_ = std::move(value);
content_type_ = ContentType::kString;
}





v8::Local<v8::Value> V8UnionStringOrWorkerOptions::ToV8(ScriptState* script_state) const {
  switch (content_type_) {
  case ContentType::kString: {
    return ToV8Traits<IDLString>::ToV8(script_state, member_string_);
  }
  case ContentType::kWorkerOptions: {
    return ToV8Traits<WorkerOptions>::ToV8(script_state, member_worker_options_.Get());
  }
}

NOTREACHED();
return v8::Local<v8::Value>();
}

void V8UnionStringOrWorkerOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_string_);
TraceIfNeeded<Member<WorkerOptions>>::Trace(visitor, member_worker_options_);
bindings::UnionBase::Trace(visitor);
}

void V8UnionStringOrWorkerOptions::Clear() {
  member_string_ = String();
member_worker_options_.Clear();
}



}  // namespace blink
