// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_union_usvstring_uint32array.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {



V8UnionUSVStringOrUint32Array* V8UnionUSVStringOrUint32Array::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  if (v8_value->IsUint32Array()) {
  auto&& blink_value = NativeValueTraits<NotShared<DOMUint32Array>>::NativeValue(isolate, v8_value, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionUSVStringOrUint32Array>(blink_value);
}
{
  auto&& blink_value = NativeValueTraits<IDLUSVString>::NativeValue(isolate, v8_value, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionUSVStringOrUint32Array>(std::move(blink_value));
}
}

 V8UnionUSVStringOrUint32Array::V8UnionUSVStringOrUint32Array(const String& value) : content_type_(ContentType::kUSVString), member_usv_string_(value) {
  
}

 V8UnionUSVStringOrUint32Array::V8UnionUSVStringOrUint32Array(String&& value) : content_type_(ContentType::kUSVString), member_usv_string_(std::move(value)) {
  
}




void V8UnionUSVStringOrUint32Array::Set(const String& value) {
  Clear();
member_usv_string_ = value;
content_type_ = ContentType::kUSVString;
}

void V8UnionUSVStringOrUint32Array::Set(String&& value) {
  Clear();
member_usv_string_ = std::move(value);
content_type_ = ContentType::kUSVString;
}





v8::Local<v8::Value> V8UnionUSVStringOrUint32Array::ToV8(ScriptState* script_state) const {
  switch (content_type_) {
  case ContentType::kUSVString: {
    return ToV8Traits<IDLUSVString>::ToV8(script_state, member_usv_string_);
  }
  case ContentType::kUint32Array: {
    return ToV8Traits<NotShared<DOMUint32Array>>::ToV8(script_state, member_uint32_array_);
  }
}

NOTREACHED();
return v8::Local<v8::Value>();
}

void V8UnionUSVStringOrUint32Array::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_usv_string_);
TraceIfNeeded<NotShared<DOMUint32Array>>::Trace(visitor, member_uint32_array_);
bindings::UnionBase::Trace(visitor);
}

void V8UnionUSVStringOrUint32Array::Clear() {
  member_usv_string_ = String();
member_uint32_array_.Clear();
}



}  // namespace blink
