// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_URL_PATTERN_COMPONENT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_URL_PATTERN_COMPONENT_H_

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/enumeration_base.h"

namespace blink {

class ExceptionState;

class CORE_EXPORT V8URLPatternComponent final : public bindings::EnumerationBase {
  
  public:
enum class Enum : enum_int_t {
kProtocol, kUsername, kPassword, kHostname, kPort, kPathname, kSearch, kHash
};
static constexpr size_t kEnumSize = 8;

static V8URLPatternComponent Create(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exception_state);
static absl::optional<V8URLPatternComponent> Create(const String& value);

explicit constexpr  V8URLPatternComponent(Enum value) : bindings::EnumerationBase(static_cast<enum_int_t>(value), string_table_[static_cast<enum_int_t>(value)]) {
  
}
constexpr  V8URLPatternComponent(const V8URLPatternComponent&) = default;
constexpr  V8URLPatternComponent(V8URLPatternComponent&&) = default;
 ~V8URLPatternComponent() = default;

V8URLPatternComponent& operator=(const V8URLPatternComponent&) = default;
V8URLPatternComponent& operator=(V8URLPatternComponent&&) = default;
V8URLPatternComponent& operator=(const String&);

Enum AsEnum() const {
  return static_cast<Enum>(GetEnumValue());
}


  
  private:
static const char* const string_table_[];

constexpr  V8URLPatternComponent() = default;


  
};

inline bool operator==(const V8URLPatternComponent& lhs, V8URLPatternComponent::Enum rhs) {
  return lhs.AsEnum() == rhs;
}

inline bool operator==(V8URLPatternComponent::Enum lhs, const V8URLPatternComponent& rhs) {
  return lhs == rhs.AsEnum();
}


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_URL_PATTERN_COMPONENT_H_
