// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_view_transition_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_view_transition_callback.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



ViewTransitionOptions* ViewTransitionOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ViewTransitionOptions* dictionary = MakeGarbageCollected<ViewTransitionOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ViewTransitionOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 ViewTransitionOptions::ViewTransitionOptions() {
  
}

 ViewTransitionOptions::ViewTransitionOptions(v8::Isolate* isolate) {
  
}



void ViewTransitionOptions::setType(const absl::optional<Vector<String>>& value) {
  member_type_ = value;
}

void ViewTransitionOptions::setType(absl::optional<Vector<String>>&& value) {
  member_type_ = std::move(value);
}

void ViewTransitionOptions::setType(const Vector<String>& value) {
  member_type_ = value;
}

void ViewTransitionOptions::setType(Vector<String>&& value) {
  member_type_ = std::move(value);
}








void ViewTransitionOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<absl::optional<Vector<String>>>::Trace(visitor, member_type_);
TraceIfNeeded<Member<V8ViewTransitionCallback>>::Trace(visitor, member_update_);
bindings::DictionaryBase::Trace(visitor);
}

bool ViewTransitionOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasType()) {
  v8_value = ToV8Traits<IDLNullable<IDLSequence<IDLString>>>::ToV8(script_state, member_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasUpdate()) {
  v8_value = ToV8Traits<IDLNullable<V8ViewTransitionCallback>>::ToV8(script_state, member_update_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void ViewTransitionOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "ViewTransitionOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("type");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLSequence<IDLString>>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("update");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<V8ViewTransitionCallback>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_update_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ViewTransitionOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"type",
"update",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
