// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_WHEEL_EVENT_INIT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_WHEEL_EVENT_INIT_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_mouse_event_init.h"
#include "third_party/blink/renderer/core/core_export.h"

namespace blink {

class ExceptionState;

class CORE_EXPORT WheelEventInit : public MouseEventInit {
  
  public:
static WheelEventInit* Create() {
  return MakeGarbageCollected<WheelEventInit>();
}
static WheelEventInit* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<WheelEventInit>(isolate);
}
static WheelEventInit* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  WheelEventInit();
explicit  WheelEventInit(v8::Isolate* isolate);

bool hasDeltaMode() const {
  return true;
}
uint32_t deltaMode() const {
  return member_delta_mode_;
}
void setDeltaMode(uint32_t value) {
  member_delta_mode_ = value;
}

bool hasDeltaX() const {
  return true;
}
double deltaX() const {
  return member_delta_x_;
}
void setDeltaX(double value) {
  member_delta_x_ = value;
}

bool hasDeltaY() const {
  return true;
}
double deltaY() const {
  return member_delta_y_;
}
void setDeltaY(double value) {
  member_delta_y_ = value;
}

bool hasDeltaZ() const {
  return true;
}
double deltaZ() const {
  return member_delta_z_;
}
void setDeltaZ(double value) {
  member_delta_z_ = value;
}

bool hasWheelDeltaX() const {
  return true;
}
int32_t wheelDeltaX() const {
  return member_wheel_delta_x_;
}
void setWheelDeltaX(int32_t value) {
  member_wheel_delta_x_ = value;
}

bool hasWheelDeltaY() const {
  return true;
}
int32_t wheelDeltaY() const {
  return member_wheel_delta_y_;
}
void setWheelDeltaY(int32_t value) {
  member_wheel_delta_y_ = value;
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



uint32_t member_delta_mode_{0};
double member_delta_x_{0.0};
double member_delta_y_{0.0};
double member_delta_z_{0.0};
int32_t member_wheel_delta_x_{0};
int32_t member_wheel_delta_y_{0};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_WHEEL_EVENT_INIT_H_
