// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ad_targeting.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/geolocation/geolocation_coordinates.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



AdTargeting* AdTargeting::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AdTargeting* dictionary = MakeGarbageCollected<AdTargeting>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AdTargeting";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AdTargeting::AdTargeting() {
  
}

 AdTargeting::AdTargeting(v8::Isolate* isolate) {
  
}










Vector<String> AdTargeting::getInterestsOr(const Vector<String>& fallback_value) const {
  if (!hasInterests()) {
  return fallback_value;
}
return member_interests_;
}

Vector<String> AdTargeting::getInterestsOr(Vector<String>&& fallback_value) const {
  if (!hasInterests()) {
  return std::move(fallback_value);
}
return member_interests_;
}

void AdTargeting::setInterests(const Vector<String>& value) {
  member_interests_ = value;
has_interests_ = true;
}

void AdTargeting::setInterests(Vector<String>&& value) {
  member_interests_ = std::move(value);
has_interests_ = true;
}




void AdTargeting::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<GeolocationCoordinates>>::Trace(visitor, member_geolocation_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_interests_);
bindings::DictionaryBase::Trace(visitor);
}

bool AdTargeting::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasGeolocation()) {
  v8_value = ToV8Traits<GeolocationCoordinates>::ToV8(script_state, member_geolocation_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasInterests()) {
  v8_value = ToV8Traits<IDLSequence<IDLString>>::ToV8(script_state, member_interests_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void AdTargeting::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AdTargeting";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("geolocation");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<GeolocationCoordinates, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_geolocation_, member_geolocation_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("interests");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_interests_, member_interests_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AdTargeting::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"geolocation",
"interests",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
