// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_auction_ad_interest_group.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_auction_ad.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_auction_ad_interest_group_size.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_protected_audience_private_aggregation_config.h"
#include "third_party/blink/renderer/core/execution_context/execution_context.h"
#include "third_party/blink/renderer/core/frame/deprecation/deprecation.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



AuctionAdInterestGroup* AuctionAdInterestGroup::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuctionAdInterestGroup* dictionary = MakeGarbageCollected<AuctionAdInterestGroup>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuctionAdInterestGroup";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AuctionAdInterestGroup::AuctionAdInterestGroup() {
  
}

 AuctionAdInterestGroup::AuctionAdInterestGroup(v8::Isolate* isolate) {
  
}



HeapVector<Member<AuctionAd>> AuctionAdInterestGroup::getAdComponentsOr(const HeapVector<Member<AuctionAd>>& fallback_value) const {
  if (!hasAdComponents()) {
  return fallback_value;
}
return member_ad_components_;
}

HeapVector<Member<AuctionAd>> AuctionAdInterestGroup::getAdComponentsOr(HeapVector<Member<AuctionAd>>&& fallback_value) const {
  if (!hasAdComponents()) {
  return std::move(fallback_value);
}
return member_ad_components_;
}

void AuctionAdInterestGroup::setAdComponents(const HeapVector<Member<AuctionAd>>& value) {
  member_ad_components_ = value;
has_ad_components_ = true;
}

void AuctionAdInterestGroup::setAdComponents(HeapVector<Member<AuctionAd>>&& value) {
  member_ad_components_ = std::move(value);
has_ad_components_ = true;
}




HeapVector<std::pair<String, Member<AuctionAdInterestGroupSize>>> AuctionAdInterestGroup::getAdSizesOr(const HeapVector<std::pair<String, Member<AuctionAdInterestGroupSize>>>& fallback_value) const {
  if (!hasAdSizes()) {
  return fallback_value;
}
return member_ad_sizes_;
}

HeapVector<std::pair<String, Member<AuctionAdInterestGroupSize>>> AuctionAdInterestGroup::getAdSizesOr(HeapVector<std::pair<String, Member<AuctionAdInterestGroupSize>>>&& fallback_value) const {
  if (!hasAdSizes()) {
  return std::move(fallback_value);
}
return member_ad_sizes_;
}

void AuctionAdInterestGroup::setAdSizes(const HeapVector<std::pair<String, Member<AuctionAdInterestGroupSize>>>& value) {
  member_ad_sizes_ = value;
has_ad_sizes_ = true;
}

void AuctionAdInterestGroup::setAdSizes(HeapVector<std::pair<String, Member<AuctionAdInterestGroupSize>>>&& value) {
  member_ad_sizes_ = std::move(value);
has_ad_sizes_ = true;
}




String AuctionAdInterestGroup::getAdditionalBidKeyOr(const String& fallback_value) const {
  if (!hasAdditionalBidKey()) {
  return fallback_value;
}
return member_additional_bid_key_;
}

String AuctionAdInterestGroup::getAdditionalBidKeyOr(String&& fallback_value) const {
  if (!hasAdditionalBidKey()) {
  return std::move(fallback_value);
}
return member_additional_bid_key_;
}

void AuctionAdInterestGroup::setAdditionalBidKey(const String& value) {
  member_additional_bid_key_ = value;
has_additional_bid_key_ = true;
}

void AuctionAdInterestGroup::setAdditionalBidKey(String&& value) {
  member_additional_bid_key_ = std::move(value);
has_additional_bid_key_ = true;
}




HeapVector<Member<AuctionAd>> AuctionAdInterestGroup::getAdsOr(const HeapVector<Member<AuctionAd>>& fallback_value) const {
  if (!hasAds()) {
  return fallback_value;
}
return member_ads_;
}

HeapVector<Member<AuctionAd>> AuctionAdInterestGroup::getAdsOr(HeapVector<Member<AuctionAd>>&& fallback_value) const {
  if (!hasAds()) {
  return std::move(fallback_value);
}
return member_ads_;
}

void AuctionAdInterestGroup::setAds(const HeapVector<Member<AuctionAd>>& value) {
  member_ads_ = value;
has_ads_ = true;
}

void AuctionAdInterestGroup::setAds(HeapVector<Member<AuctionAd>>&& value) {
  member_ads_ = std::move(value);
has_ads_ = true;
}




Vector<String> AuctionAdInterestGroup::getAuctionServerRequestFlagsOr(const Vector<String>& fallback_value) const {
  if (!hasAuctionServerRequestFlags()) {
  return fallback_value;
}
return member_auction_server_request_flags_;
}

Vector<String> AuctionAdInterestGroup::getAuctionServerRequestFlagsOr(Vector<String>&& fallback_value) const {
  if (!hasAuctionServerRequestFlags()) {
  return std::move(fallback_value);
}
return member_auction_server_request_flags_;
}

void AuctionAdInterestGroup::setAuctionServerRequestFlags(const Vector<String>& value) {
  member_auction_server_request_flags_ = value;
has_auction_server_request_flags_ = true;
}

void AuctionAdInterestGroup::setAuctionServerRequestFlags(Vector<String>&& value) {
  member_auction_server_request_flags_ = std::move(value);
has_auction_server_request_flags_ = true;
}




String AuctionAdInterestGroup::getBiddingLogicURLOr(const String& fallback_value) const {
  if (!hasBiddingLogicURL()) {
  return fallback_value;
}
return member_bidding_logic_url_;
}

String AuctionAdInterestGroup::getBiddingLogicURLOr(String&& fallback_value) const {
  if (!hasBiddingLogicURL()) {
  return std::move(fallback_value);
}
return member_bidding_logic_url_;
}

void AuctionAdInterestGroup::setBiddingLogicURL(const String& value) {
  member_bidding_logic_url_ = value;
has_bidding_logic_url_ = true;
}

void AuctionAdInterestGroup::setBiddingLogicURL(String&& value) {
  member_bidding_logic_url_ = std::move(value);
has_bidding_logic_url_ = true;
}




String AuctionAdInterestGroup::getBiddingLogicUrlDeprecatedOr(const String& fallback_value) const {
  if (!hasBiddingLogicUrlDeprecated()) {
  return fallback_value;
}
return member_bidding_logic_url_deprecated_;
}

String AuctionAdInterestGroup::getBiddingLogicUrlDeprecatedOr(String&& fallback_value) const {
  if (!hasBiddingLogicUrlDeprecated()) {
  return std::move(fallback_value);
}
return member_bidding_logic_url_deprecated_;
}

void AuctionAdInterestGroup::setBiddingLogicUrlDeprecated(const String& value) {
  member_bidding_logic_url_deprecated_ = value;
has_bidding_logic_url_deprecated_ = true;
}

void AuctionAdInterestGroup::setBiddingLogicUrlDeprecated(String&& value) {
  member_bidding_logic_url_deprecated_ = std::move(value);
has_bidding_logic_url_deprecated_ = true;
}




String AuctionAdInterestGroup::getBiddingWasmHelperURLOr(const String& fallback_value) const {
  if (!hasBiddingWasmHelperURL()) {
  return fallback_value;
}
return member_bidding_wasm_helper_url_;
}

String AuctionAdInterestGroup::getBiddingWasmHelperURLOr(String&& fallback_value) const {
  if (!hasBiddingWasmHelperURL()) {
  return std::move(fallback_value);
}
return member_bidding_wasm_helper_url_;
}

void AuctionAdInterestGroup::setBiddingWasmHelperURL(const String& value) {
  member_bidding_wasm_helper_url_ = value;
has_bidding_wasm_helper_url_ = true;
}

void AuctionAdInterestGroup::setBiddingWasmHelperURL(String&& value) {
  member_bidding_wasm_helper_url_ = std::move(value);
has_bidding_wasm_helper_url_ = true;
}




String AuctionAdInterestGroup::getBiddingWasmHelperUrlDeprecatedOr(const String& fallback_value) const {
  if (!hasBiddingWasmHelperUrlDeprecated()) {
  return fallback_value;
}
return member_bidding_wasm_helper_url_deprecated_;
}

String AuctionAdInterestGroup::getBiddingWasmHelperUrlDeprecatedOr(String&& fallback_value) const {
  if (!hasBiddingWasmHelperUrlDeprecated()) {
  return std::move(fallback_value);
}
return member_bidding_wasm_helper_url_deprecated_;
}

void AuctionAdInterestGroup::setBiddingWasmHelperUrlDeprecated(const String& value) {
  member_bidding_wasm_helper_url_deprecated_ = value;
has_bidding_wasm_helper_url_deprecated_ = true;
}

void AuctionAdInterestGroup::setBiddingWasmHelperUrlDeprecated(String&& value) {
  member_bidding_wasm_helper_url_deprecated_ = std::move(value);
has_bidding_wasm_helper_url_deprecated_ = true;
}




String AuctionAdInterestGroup::getDailyUpdateUrlOr(const String& fallback_value) const {
  if (!hasDailyUpdateUrl()) {
  return fallback_value;
}
return member_daily_update_url_;
}

String AuctionAdInterestGroup::getDailyUpdateUrlOr(String&& fallback_value) const {
  if (!hasDailyUpdateUrl()) {
  return std::move(fallback_value);
}
return member_daily_update_url_;
}

void AuctionAdInterestGroup::setDailyUpdateUrl(const String& value) {
  member_daily_update_url_ = value;
has_daily_update_url_ = true;
}

void AuctionAdInterestGroup::setDailyUpdateUrl(String&& value) {
  member_daily_update_url_ = std::move(value);
has_daily_update_url_ = true;
}











String AuctionAdInterestGroup::getExecutionModeOr(const String& fallback_value) const {
  if (!hasExecutionMode()) {
  return fallback_value;
}
return member_execution_mode_;
}

String AuctionAdInterestGroup::getExecutionModeOr(String&& fallback_value) const {
  if (!hasExecutionMode()) {
  return std::move(fallback_value);
}
return member_execution_mode_;
}

void AuctionAdInterestGroup::setExecutionMode(const String& value) {
  member_execution_mode_ = value;
has_execution_mode_ = true;
}

void AuctionAdInterestGroup::setExecutionMode(String&& value) {
  member_execution_mode_ = std::move(value);
has_execution_mode_ = true;
}


















void AuctionAdInterestGroup::setName(const String& value) {
  member_name_ = value;
}

void AuctionAdInterestGroup::setName(String&& value) {
  member_name_ = std::move(value);
}




void AuctionAdInterestGroup::setOwner(const String& value) {
  member_owner_ = value;
}

void AuctionAdInterestGroup::setOwner(String&& value) {
  member_owner_ = std::move(value);
}











Vector<std::pair<String, double>> AuctionAdInterestGroup::getPrioritySignalsOverridesOr(const Vector<std::pair<String, double>>& fallback_value) const {
  if (!hasPrioritySignalsOverrides()) {
  return fallback_value;
}
return member_priority_signals_overrides_;
}

Vector<std::pair<String, double>> AuctionAdInterestGroup::getPrioritySignalsOverridesOr(Vector<std::pair<String, double>>&& fallback_value) const {
  if (!hasPrioritySignalsOverrides()) {
  return std::move(fallback_value);
}
return member_priority_signals_overrides_;
}

void AuctionAdInterestGroup::setPrioritySignalsOverrides(const Vector<std::pair<String, double>>& value) {
  member_priority_signals_overrides_ = value;
has_priority_signals_overrides_ = true;
}

void AuctionAdInterestGroup::setPrioritySignalsOverrides(Vector<std::pair<String, double>>&& value) {
  member_priority_signals_overrides_ = std::move(value);
has_priority_signals_overrides_ = true;
}




Vector<std::pair<String, double>> AuctionAdInterestGroup::getPriorityVectorOr(const Vector<std::pair<String, double>>& fallback_value) const {
  if (!hasPriorityVector()) {
  return fallback_value;
}
return member_priority_vector_;
}

Vector<std::pair<String, double>> AuctionAdInterestGroup::getPriorityVectorOr(Vector<std::pair<String, double>>&& fallback_value) const {
  if (!hasPriorityVector()) {
  return std::move(fallback_value);
}
return member_priority_vector_;
}

void AuctionAdInterestGroup::setPriorityVector(const Vector<std::pair<String, double>>& value) {
  member_priority_vector_ = value;
has_priority_vector_ = true;
}

void AuctionAdInterestGroup::setPriorityVector(Vector<std::pair<String, double>>&& value) {
  member_priority_vector_ = std::move(value);
has_priority_vector_ = true;
}











Vector<std::pair<String, Vector<String>>> AuctionAdInterestGroup::getSellerCapabilitiesOr(const Vector<std::pair<String, Vector<String>>>& fallback_value) const {
  if (!hasSellerCapabilities()) {
  return fallback_value;
}
return member_seller_capabilities_;
}

Vector<std::pair<String, Vector<String>>> AuctionAdInterestGroup::getSellerCapabilitiesOr(Vector<std::pair<String, Vector<String>>>&& fallback_value) const {
  if (!hasSellerCapabilities()) {
  return std::move(fallback_value);
}
return member_seller_capabilities_;
}

void AuctionAdInterestGroup::setSellerCapabilities(const Vector<std::pair<String, Vector<String>>>& value) {
  member_seller_capabilities_ = value;
has_seller_capabilities_ = true;
}

void AuctionAdInterestGroup::setSellerCapabilities(Vector<std::pair<String, Vector<String>>>&& value) {
  member_seller_capabilities_ = std::move(value);
has_seller_capabilities_ = true;
}




Vector<std::pair<String, Vector<String>>> AuctionAdInterestGroup::getSizeGroupsOr(const Vector<std::pair<String, Vector<String>>>& fallback_value) const {
  if (!hasSizeGroups()) {
  return fallback_value;
}
return member_size_groups_;
}

Vector<std::pair<String, Vector<String>>> AuctionAdInterestGroup::getSizeGroupsOr(Vector<std::pair<String, Vector<String>>>&& fallback_value) const {
  if (!hasSizeGroups()) {
  return std::move(fallback_value);
}
return member_size_groups_;
}

void AuctionAdInterestGroup::setSizeGroups(const Vector<std::pair<String, Vector<String>>>& value) {
  member_size_groups_ = value;
has_size_groups_ = true;
}

void AuctionAdInterestGroup::setSizeGroups(Vector<std::pair<String, Vector<String>>>&& value) {
  member_size_groups_ = std::move(value);
has_size_groups_ = true;
}




Vector<String> AuctionAdInterestGroup::getTrustedBiddingSignalsKeysOr(const Vector<String>& fallback_value) const {
  if (!hasTrustedBiddingSignalsKeys()) {
  return fallback_value;
}
return member_trusted_bidding_signals_keys_;
}

Vector<String> AuctionAdInterestGroup::getTrustedBiddingSignalsKeysOr(Vector<String>&& fallback_value) const {
  if (!hasTrustedBiddingSignalsKeys()) {
  return std::move(fallback_value);
}
return member_trusted_bidding_signals_keys_;
}

void AuctionAdInterestGroup::setTrustedBiddingSignalsKeys(const Vector<String>& value) {
  member_trusted_bidding_signals_keys_ = value;
has_trusted_bidding_signals_keys_ = true;
}

void AuctionAdInterestGroup::setTrustedBiddingSignalsKeys(Vector<String>&& value) {
  member_trusted_bidding_signals_keys_ = std::move(value);
has_trusted_bidding_signals_keys_ = true;
}




String AuctionAdInterestGroup::getTrustedBiddingSignalsSlotSizeModeOr(const String& fallback_value) const {
  if (!hasTrustedBiddingSignalsSlotSizeMode()) {
  return fallback_value;
}
return member_trusted_bidding_signals_slot_size_mode_;
}

String AuctionAdInterestGroup::getTrustedBiddingSignalsSlotSizeModeOr(String&& fallback_value) const {
  if (!hasTrustedBiddingSignalsSlotSizeMode()) {
  return std::move(fallback_value);
}
return member_trusted_bidding_signals_slot_size_mode_;
}

void AuctionAdInterestGroup::setTrustedBiddingSignalsSlotSizeMode(const String& value) {
  member_trusted_bidding_signals_slot_size_mode_ = value;
has_trusted_bidding_signals_slot_size_mode_ = true;
}

void AuctionAdInterestGroup::setTrustedBiddingSignalsSlotSizeMode(String&& value) {
  member_trusted_bidding_signals_slot_size_mode_ = std::move(value);
has_trusted_bidding_signals_slot_size_mode_ = true;
}




String AuctionAdInterestGroup::getTrustedBiddingSignalsURLOr(const String& fallback_value) const {
  if (!hasTrustedBiddingSignalsURL()) {
  return fallback_value;
}
return member_trusted_bidding_signals_url_;
}

String AuctionAdInterestGroup::getTrustedBiddingSignalsURLOr(String&& fallback_value) const {
  if (!hasTrustedBiddingSignalsURL()) {
  return std::move(fallback_value);
}
return member_trusted_bidding_signals_url_;
}

void AuctionAdInterestGroup::setTrustedBiddingSignalsURL(const String& value) {
  member_trusted_bidding_signals_url_ = value;
has_trusted_bidding_signals_url_ = true;
}

void AuctionAdInterestGroup::setTrustedBiddingSignalsURL(String&& value) {
  member_trusted_bidding_signals_url_ = std::move(value);
has_trusted_bidding_signals_url_ = true;
}




String AuctionAdInterestGroup::getTrustedBiddingSignalsUrlDeprecatedOr(const String& fallback_value) const {
  if (!hasTrustedBiddingSignalsUrlDeprecated()) {
  return fallback_value;
}
return member_trusted_bidding_signals_url_deprecated_;
}

String AuctionAdInterestGroup::getTrustedBiddingSignalsUrlDeprecatedOr(String&& fallback_value) const {
  if (!hasTrustedBiddingSignalsUrlDeprecated()) {
  return std::move(fallback_value);
}
return member_trusted_bidding_signals_url_deprecated_;
}

void AuctionAdInterestGroup::setTrustedBiddingSignalsUrlDeprecated(const String& value) {
  member_trusted_bidding_signals_url_deprecated_ = value;
has_trusted_bidding_signals_url_deprecated_ = true;
}

void AuctionAdInterestGroup::setTrustedBiddingSignalsUrlDeprecated(String&& value) {
  member_trusted_bidding_signals_url_deprecated_ = std::move(value);
has_trusted_bidding_signals_url_deprecated_ = true;
}




String AuctionAdInterestGroup::getUpdateURLOr(const String& fallback_value) const {
  if (!hasUpdateURL()) {
  return fallback_value;
}
return member_update_url_;
}

String AuctionAdInterestGroup::getUpdateURLOr(String&& fallback_value) const {
  if (!hasUpdateURL()) {
  return std::move(fallback_value);
}
return member_update_url_;
}

void AuctionAdInterestGroup::setUpdateURL(const String& value) {
  member_update_url_ = value;
has_update_url_ = true;
}

void AuctionAdInterestGroup::setUpdateURL(String&& value) {
  member_update_url_ = std::move(value);
has_update_url_ = true;
}




String AuctionAdInterestGroup::getUpdateUrlDeprecatedOr(const String& fallback_value) const {
  if (!hasUpdateUrlDeprecated()) {
  return fallback_value;
}
return member_update_url_deprecated_;
}

String AuctionAdInterestGroup::getUpdateUrlDeprecatedOr(String&& fallback_value) const {
  if (!hasUpdateUrlDeprecated()) {
  return std::move(fallback_value);
}
return member_update_url_deprecated_;
}

void AuctionAdInterestGroup::setUpdateUrlDeprecated(const String& value) {
  member_update_url_deprecated_ = value;
has_update_url_deprecated_ = true;
}

void AuctionAdInterestGroup::setUpdateUrlDeprecated(String&& value) {
  member_update_url_deprecated_ = std::move(value);
has_update_url_deprecated_ = true;
}











void AuctionAdInterestGroup::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<AuctionAd>>>::Trace(visitor, member_ad_components_);
TraceIfNeeded<HeapVector<std::pair<String, Member<AuctionAdInterestGroupSize>>>>::Trace(visitor, member_ad_sizes_);
TraceIfNeeded<String>::Trace(visitor, member_additional_bid_key_);
TraceIfNeeded<HeapVector<Member<AuctionAd>>>::Trace(visitor, member_ads_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_auction_server_request_flags_);
TraceIfNeeded<String>::Trace(visitor, member_bidding_logic_url_);
TraceIfNeeded<String>::Trace(visitor, member_bidding_logic_url_deprecated_);
TraceIfNeeded<String>::Trace(visitor, member_bidding_wasm_helper_url_);
TraceIfNeeded<String>::Trace(visitor, member_bidding_wasm_helper_url_deprecated_);
TraceIfNeeded<String>::Trace(visitor, member_daily_update_url_);
TraceIfNeeded<bool>::Trace(visitor, member_enable_bidding_signals_prioritization_);
TraceIfNeeded<String>::Trace(visitor, member_execution_mode_);
TraceIfNeeded<double>::Trace(visitor, member_lifetime_ms_);
TraceIfNeeded<int32_t>::Trace(visitor, member_max_trusted_bidding_signals_url_length_);
TraceIfNeeded<String>::Trace(visitor, member_name_);
TraceIfNeeded<String>::Trace(visitor, member_owner_);
TraceIfNeeded<double>::Trace(visitor, member_priority_);
TraceIfNeeded<Vector<std::pair<String, double>>>::Trace(visitor, member_priority_signals_overrides_);
TraceIfNeeded<Vector<std::pair<String, double>>>::Trace(visitor, member_priority_vector_);
TraceIfNeeded<Member<ProtectedAudiencePrivateAggregationConfig>>::Trace(visitor, member_private_aggregation_config_);
TraceIfNeeded<Vector<std::pair<String, Vector<String>>>>::Trace(visitor, member_seller_capabilities_);
TraceIfNeeded<Vector<std::pair<String, Vector<String>>>>::Trace(visitor, member_size_groups_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_trusted_bidding_signals_keys_);
TraceIfNeeded<String>::Trace(visitor, member_trusted_bidding_signals_slot_size_mode_);
TraceIfNeeded<String>::Trace(visitor, member_trusted_bidding_signals_url_);
TraceIfNeeded<String>::Trace(visitor, member_trusted_bidding_signals_url_deprecated_);
TraceIfNeeded<String>::Trace(visitor, member_update_url_);
TraceIfNeeded<String>::Trace(visitor, member_update_url_deprecated_);
TraceIfNeeded<ScriptValue>::Trace(visitor, member_user_bidding_signals_);
bindings::DictionaryBase::Trace(visitor);
}

bool AuctionAdInterestGroup::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAdComponents()) {
  v8_value = ToV8Traits<IDLSequence<AuctionAd>>::ToV8(script_state, member_ad_components_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasAdSizes()) {
  v8_value = ToV8Traits<IDLRecord<IDLString, AuctionAdInterestGroupSize>>::ToV8(script_state, member_ad_sizes_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasAdditionalBidKey()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_additional_bid_key_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasAds()) {
  v8_value = ToV8Traits<IDLSequence<AuctionAd>>::ToV8(script_state, member_ads_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasAuctionServerRequestFlags()) {
  v8_value = ToV8Traits<IDLSequence<IDLString>>::ToV8(script_state, member_auction_server_request_flags_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasBiddingLogicURL()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_bidding_logic_url_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasBiddingLogicUrlDeprecated()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_bidding_logic_url_deprecated_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (hasBiddingWasmHelperURL()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_bidding_wasm_helper_url_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
if (hasBiddingWasmHelperUrlDeprecated()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_bidding_wasm_helper_url_deprecated_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[8].Get(isolate), v8_value).ToChecked();
}
if (hasDailyUpdateUrl()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_daily_update_url_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[9].Get(isolate), v8_value).ToChecked();
}
if (hasEnableBiddingSignalsPrioritization()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_enable_bidding_signals_prioritization_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[10].Get(isolate), v8_value).ToChecked();
}
if (hasExecutionMode()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_execution_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[11].Get(isolate), v8_value).ToChecked();
}
if (hasLifetimeMs()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_lifetime_ms_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[12].Get(isolate), v8_value).ToChecked();
}
if (hasMaxTrustedBiddingSignalsURLLength()) {
  v8_value = ToV8Traits<IDLLong>::ToV8(script_state, member_max_trusted_bidding_signals_url_length_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[13].Get(isolate), v8_value).ToChecked();
}
if (hasName()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_name_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[14].Get(isolate), v8_value).ToChecked();
}
if (hasOwner()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_owner_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[15].Get(isolate), v8_value).ToChecked();
}
if (hasPriority()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_priority_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[16].Get(isolate), v8_value).ToChecked();
}
if (hasPrioritySignalsOverrides()) {
  v8_value = ToV8Traits<IDLRecord<IDLUSVString, IDLDouble>>::ToV8(script_state, member_priority_signals_overrides_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[17].Get(isolate), v8_value).ToChecked();
}
if (hasPriorityVector()) {
  v8_value = ToV8Traits<IDLRecord<IDLUSVString, IDLDouble>>::ToV8(script_state, member_priority_vector_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[18].Get(isolate), v8_value).ToChecked();
}
if (hasPrivateAggregationConfig()) {
  v8_value = ToV8Traits<ProtectedAudiencePrivateAggregationConfig>::ToV8(script_state, member_private_aggregation_config_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[19].Get(isolate), v8_value).ToChecked();
}
if (hasSellerCapabilities()) {
  v8_value = ToV8Traits<IDLRecord<IDLUSVString, IDLSequence<IDLString>>>::ToV8(script_state, member_seller_capabilities_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[20].Get(isolate), v8_value).ToChecked();
}
if (hasSizeGroups()) {
  v8_value = ToV8Traits<IDLRecord<IDLString, IDLSequence<IDLString>>>::ToV8(script_state, member_size_groups_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[21].Get(isolate), v8_value).ToChecked();
}
if (hasTrustedBiddingSignalsKeys()) {
  v8_value = ToV8Traits<IDLSequence<IDLUSVString>>::ToV8(script_state, member_trusted_bidding_signals_keys_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[22].Get(isolate), v8_value).ToChecked();
}
if (hasTrustedBiddingSignalsSlotSizeMode()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_trusted_bidding_signals_slot_size_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[23].Get(isolate), v8_value).ToChecked();
}
if (hasTrustedBiddingSignalsURL()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_trusted_bidding_signals_url_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[24].Get(isolate), v8_value).ToChecked();
}
if (hasTrustedBiddingSignalsUrlDeprecated()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_trusted_bidding_signals_url_deprecated_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[25].Get(isolate), v8_value).ToChecked();
}
if (hasUpdateURL()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_update_url_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[26].Get(isolate), v8_value).ToChecked();
}
if (hasUpdateUrlDeprecated()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_update_url_deprecated_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[27].Get(isolate), v8_value).ToChecked();
}
if (hasUserBiddingSignals()) {
  v8_value = ToV8Traits<IDLAny>::ToV8(script_state, member_user_bidding_signals_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[28].Get(isolate), v8_value).ToChecked();
}
return true;
}

void AuctionAdInterestGroup::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AuctionAdInterestGroup";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("adComponents");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<AuctionAd>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_ad_components_, member_ad_components_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("adSizes");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLString, AuctionAdInterestGroupSize>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_ad_sizes_, member_ad_sizes_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("additionalBidKey");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_additional_bid_key_, member_additional_bid_key_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("ads");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<AuctionAd>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_ads_, member_ads_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("auctionServerRequestFlags");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_auction_server_request_flags_, member_auction_server_request_flags_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("biddingLogicURL");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_bidding_logic_url_, member_bidding_logic_url_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("biddingLogicUrl");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_bidding_logic_url_deprecated_, member_bidding_logic_url_deprecated_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("biddingWasmHelperURL");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_bidding_wasm_helper_url_, member_bidding_wasm_helper_url_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("biddingWasmHelperUrl");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_bidding_wasm_helper_url_deprecated_, member_bidding_wasm_helper_url_deprecated_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("dailyUpdateUrl");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), has_daily_update_url_, member_daily_update_url_, try_block, exception_state)) {
  return;
}
// [DeprecateAs]
bool has_deprecated;
if (!v8_dictionary->Has(current_context, v8_own_member_names[9].Get(isolate)).To(&has_deprecated)) {
  return;
}
if (has_deprecated) {
  ExecutionContext* execution_context = ExecutionContext::From(current_context);
Deprecation::CountDeprecation(execution_context, WebFeature::kDeprecatedInterestGroupDailyUpdateUrl);
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("enableBiddingSignalsPrioritization");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), has_enable_bidding_signals_prioritization_, member_enable_bidding_signals_prioritization_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("executionMode");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), has_execution_mode_, member_execution_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("lifetimeMs");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), has_lifetime_ms_, member_lifetime_ms_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("maxTrustedBiddingSignalsURLLength");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[13].Get(isolate), has_max_trusted_bidding_signals_url_length_, member_max_trusted_bidding_signals_url_length_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("name");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[14].Get(isolate), fallback_presence_var, member_name_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("owner");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[15].Get(isolate), fallback_presence_var, member_owner_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("priority");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[16].Get(isolate), has_priority_, member_priority_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("prioritySignalsOverrides");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, IDLDouble>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[17].Get(isolate), has_priority_signals_overrides_, member_priority_signals_overrides_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("priorityVector");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, IDLDouble>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[18].Get(isolate), has_priority_vector_, member_priority_vector_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("privateAggregationConfig");
if (!bindings::GetDictionaryMemberFromV8Object<ProtectedAudiencePrivateAggregationConfig, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[19].Get(isolate), has_private_aggregation_config_, member_private_aggregation_config_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sellerCapabilities");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, IDLSequence<IDLString>>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[20].Get(isolate), has_seller_capabilities_, member_seller_capabilities_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sizeGroups");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLString, IDLSequence<IDLString>>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[21].Get(isolate), has_size_groups_, member_size_groups_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("trustedBiddingSignalsKeys");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[22].Get(isolate), has_trusted_bidding_signals_keys_, member_trusted_bidding_signals_keys_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("trustedBiddingSignalsSlotSizeMode");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[23].Get(isolate), has_trusted_bidding_signals_slot_size_mode_, member_trusted_bidding_signals_slot_size_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("trustedBiddingSignalsURL");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[24].Get(isolate), has_trusted_bidding_signals_url_, member_trusted_bidding_signals_url_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("trustedBiddingSignalsUrl");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[25].Get(isolate), has_trusted_bidding_signals_url_deprecated_, member_trusted_bidding_signals_url_deprecated_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("updateURL");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[26].Get(isolate), has_update_url_, member_update_url_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("updateUrl");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[27].Get(isolate), has_update_url_deprecated_, member_update_url_deprecated_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("userBiddingSignals");
if (!bindings::GetDictionaryMemberFromV8Object<IDLAny, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[28].Get(isolate), fallback_presence_var, member_user_bidding_signals_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuctionAdInterestGroup::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"adComponents",
"adSizes",
"additionalBidKey",
"ads",
"auctionServerRequestFlags",
"biddingLogicURL",
"biddingLogicUrl",
"biddingWasmHelperURL",
"biddingWasmHelperUrl",
"dailyUpdateUrl",
"enableBiddingSignalsPrioritization",
"executionMode",
"lifetimeMs",
"maxTrustedBiddingSignalsURLLength",
"name",
"owner",
"priority",
"prioritySignalsOverrides",
"priorityVector",
"privateAggregationConfig",
"sellerCapabilities",
"sizeGroups",
"trustedBiddingSignalsKeys",
"trustedBiddingSignalsSlotSizeMode",
"trustedBiddingSignalsURL",
"trustedBiddingSignalsUrl",
"updateURL",
"updateUrl",
"userBiddingSignals",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
