// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_prf_inputs_js_on.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_prf_values_js_on.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



AuthenticationExtensionsPRFInputsJSON* AuthenticationExtensionsPRFInputsJSON::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuthenticationExtensionsPRFInputsJSON* dictionary = MakeGarbageCollected<AuthenticationExtensionsPRFInputsJSON>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuthenticationExtensionsPRFInputsJSON";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AuthenticationExtensionsPRFInputsJSON::AuthenticationExtensionsPRFInputsJSON() {
  
}

 AuthenticationExtensionsPRFInputsJSON::AuthenticationExtensionsPRFInputsJSON(v8::Isolate* isolate) {
  
}










HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValuesJSON>>> AuthenticationExtensionsPRFInputsJSON::getEvalByCredentialOr(const HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValuesJSON>>>& fallback_value) const {
  if (!hasEvalByCredential()) {
  return fallback_value;
}
return member_eval_by_credential_;
}

HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValuesJSON>>> AuthenticationExtensionsPRFInputsJSON::getEvalByCredentialOr(HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValuesJSON>>>&& fallback_value) const {
  if (!hasEvalByCredential()) {
  return std::move(fallback_value);
}
return member_eval_by_credential_;
}

void AuthenticationExtensionsPRFInputsJSON::setEvalByCredential(const HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValuesJSON>>>& value) {
  member_eval_by_credential_ = value;
has_eval_by_credential_ = true;
}

void AuthenticationExtensionsPRFInputsJSON::setEvalByCredential(HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValuesJSON>>>&& value) {
  member_eval_by_credential_ = std::move(value);
has_eval_by_credential_ = true;
}




void AuthenticationExtensionsPRFInputsJSON::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<AuthenticationExtensionsPRFValuesJSON>>::Trace(visitor, member_eval_);
TraceIfNeeded<HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValuesJSON>>>>::Trace(visitor, member_eval_by_credential_);
bindings::DictionaryBase::Trace(visitor);
}

bool AuthenticationExtensionsPRFInputsJSON::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasEval()) {
  v8_value = ToV8Traits<AuthenticationExtensionsPRFValuesJSON>::ToV8(script_state, member_eval_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasEvalByCredential()) {
  v8_value = ToV8Traits<IDLRecord<IDLUSVString, AuthenticationExtensionsPRFValuesJSON>>::ToV8(script_state, member_eval_by_credential_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void AuthenticationExtensionsPRFInputsJSON::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AuthenticationExtensionsPRFInputsJSON";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("eval");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<AuthenticationExtensionsPRFValuesJSON, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_eval_, member_eval_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("evalByCredential");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, AuthenticationExtensionsPRFValuesJSON>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_eval_by_credential_, member_eval_by_credential_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuthenticationExtensionsPRFInputsJSON::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"eval",
"evalByCredential",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
