// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_supplemental_pub_keys_inputs.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



AuthenticationExtensionsSupplementalPubKeysInputs* AuthenticationExtensionsSupplementalPubKeysInputs::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuthenticationExtensionsSupplementalPubKeysInputs* dictionary = MakeGarbageCollected<AuthenticationExtensionsSupplementalPubKeysInputs>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuthenticationExtensionsSupplementalPubKeysInputs";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AuthenticationExtensionsSupplementalPubKeysInputs::AuthenticationExtensionsSupplementalPubKeysInputs() {
  
}

 AuthenticationExtensionsSupplementalPubKeysInputs::AuthenticationExtensionsSupplementalPubKeysInputs(v8::Isolate* isolate) {
  
}



void AuthenticationExtensionsSupplementalPubKeysInputs::setAttestation(const String& value) {
  member_attestation_ = value;
}

void AuthenticationExtensionsSupplementalPubKeysInputs::setAttestation(String&& value) {
  member_attestation_ = std::move(value);
}




void AuthenticationExtensionsSupplementalPubKeysInputs::setAttestationFormats(const Vector<String>& value) {
  member_attestation_formats_ = value;
}

void AuthenticationExtensionsSupplementalPubKeysInputs::setAttestationFormats(Vector<String>&& value) {
  member_attestation_formats_ = std::move(value);
}




void AuthenticationExtensionsSupplementalPubKeysInputs::setScopes(const Vector<String>& value) {
  member_scopes_ = value;
}

void AuthenticationExtensionsSupplementalPubKeysInputs::setScopes(Vector<String>&& value) {
  member_scopes_ = std::move(value);
}




void AuthenticationExtensionsSupplementalPubKeysInputs::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_attestation_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_attestation_formats_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_scopes_);
bindings::DictionaryBase::Trace(visitor);
}

bool AuthenticationExtensionsSupplementalPubKeysInputs::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAttestation()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_attestation_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasAttestationFormats()) {
  v8_value = ToV8Traits<IDLSequence<IDLString>>::ToV8(script_state, member_attestation_formats_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasScopes()) {
  v8_value = ToV8Traits<IDLSequence<IDLString>>::ToV8(script_state, member_scopes_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void AuthenticationExtensionsSupplementalPubKeysInputs::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AuthenticationExtensionsSupplementalPubKeysInputs";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("attestation");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_attestation_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("attestationFormats");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_attestation_formats_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("scopes");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_scopes_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuthenticationExtensionsSupplementalPubKeysInputs::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"attestation",
"attestationFormats",
"scopes",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
