// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_authenticator_attestation_response_js_on.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



AuthenticatorAttestationResponseJSON* AuthenticatorAttestationResponseJSON::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuthenticatorAttestationResponseJSON* dictionary = MakeGarbageCollected<AuthenticatorAttestationResponseJSON>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuthenticatorAttestationResponseJSON";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AuthenticatorAttestationResponseJSON::AuthenticatorAttestationResponseJSON() {
  
}

 AuthenticatorAttestationResponseJSON::AuthenticatorAttestationResponseJSON(v8::Isolate* isolate) {
  
}



String AuthenticatorAttestationResponseJSON::getAttestationObjectOr(const String& fallback_value) const {
  if (!hasAttestationObject()) {
  return fallback_value;
}
return member_attestation_object_;
}

String AuthenticatorAttestationResponseJSON::getAttestationObjectOr(String&& fallback_value) const {
  if (!hasAttestationObject()) {
  return std::move(fallback_value);
}
return member_attestation_object_;
}

void AuthenticatorAttestationResponseJSON::setAttestationObject(const String& value) {
  member_attestation_object_ = value;
has_attestation_object_ = true;
}

void AuthenticatorAttestationResponseJSON::setAttestationObject(String&& value) {
  member_attestation_object_ = std::move(value);
has_attestation_object_ = true;
}




String AuthenticatorAttestationResponseJSON::getClientDataJSONOr(const String& fallback_value) const {
  if (!hasClientDataJSON()) {
  return fallback_value;
}
return member_client_data_js_on_;
}

String AuthenticatorAttestationResponseJSON::getClientDataJSONOr(String&& fallback_value) const {
  if (!hasClientDataJSON()) {
  return std::move(fallback_value);
}
return member_client_data_js_on_;
}

void AuthenticatorAttestationResponseJSON::setClientDataJSON(const String& value) {
  member_client_data_js_on_ = value;
has_client_data_js_on_ = true;
}

void AuthenticatorAttestationResponseJSON::setClientDataJSON(String&& value) {
  member_client_data_js_on_ = std::move(value);
has_client_data_js_on_ = true;
}




Vector<String> AuthenticatorAttestationResponseJSON::getTransportsOr(const Vector<String>& fallback_value) const {
  if (!hasTransports()) {
  return fallback_value;
}
return member_transports_;
}

Vector<String> AuthenticatorAttestationResponseJSON::getTransportsOr(Vector<String>&& fallback_value) const {
  if (!hasTransports()) {
  return std::move(fallback_value);
}
return member_transports_;
}

void AuthenticatorAttestationResponseJSON::setTransports(const Vector<String>& value) {
  member_transports_ = value;
has_transports_ = true;
}

void AuthenticatorAttestationResponseJSON::setTransports(Vector<String>&& value) {
  member_transports_ = std::move(value);
has_transports_ = true;
}




void AuthenticatorAttestationResponseJSON::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_attestation_object_);
TraceIfNeeded<String>::Trace(visitor, member_client_data_js_on_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_transports_);
bindings::DictionaryBase::Trace(visitor);
}

bool AuthenticatorAttestationResponseJSON::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAttestationObject()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_attestation_object_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasClientDataJSON()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_client_data_js_on_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasTransports()) {
  v8_value = ToV8Traits<IDLSequence<IDLString>>::ToV8(script_state, member_transports_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void AuthenticatorAttestationResponseJSON::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AuthenticatorAttestationResponseJSON";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("attestationObject");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_attestation_object_, member_attestation_object_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("clientDataJSON");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_client_data_js_on_, member_client_data_js_on_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("transports");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_transports_, member_transports_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuthenticatorAttestationResponseJSON::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"attestationObject",
"clientDataJSON",
"transports",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
