// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AUTHENTICATOR_ATTESTATION_RESPONSE_JS_ON_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AUTHENTICATOR_ATTESTATION_RESPONSE_JS_ON_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT AuthenticatorAttestationResponseJSON : public bindings::DictionaryBase {
  
  public:
static AuthenticatorAttestationResponseJSON* Create() {
  return MakeGarbageCollected<AuthenticatorAttestationResponseJSON>();
}
static AuthenticatorAttestationResponseJSON* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<AuthenticatorAttestationResponseJSON>(isolate);
}
static AuthenticatorAttestationResponseJSON* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  AuthenticatorAttestationResponseJSON();
explicit  AuthenticatorAttestationResponseJSON(v8::Isolate* isolate);

bool hasAttestationObject() const {
  return has_attestation_object_;
}
const String& attestationObject() const {
  DCHECK(hasAttestationObject());
return member_attestation_object_;
}
String getAttestationObjectOr(const String& fallback_value) const;
String getAttestationObjectOr(String&& fallback_value) const;
void setAttestationObject(const String& value);
void setAttestationObject(String&& value);

bool hasClientDataJSON() const {
  return has_client_data_js_on_;
}
const String& clientDataJSON() const {
  DCHECK(hasClientDataJSON());
return member_client_data_js_on_;
}
String getClientDataJSONOr(const String& fallback_value) const;
String getClientDataJSONOr(String&& fallback_value) const;
void setClientDataJSON(const String& value);
void setClientDataJSON(String&& value);

bool hasTransports() const {
  return has_transports_;
}
const Vector<String>& transports() const {
  DCHECK(hasTransports());
return member_transports_;
}
Vector<String> getTransportsOr(const Vector<String>& fallback_value) const;
Vector<String> getTransportsOr(Vector<String>&& fallback_value) const;
void setTransports(const Vector<String>& value);
void setTransports(Vector<String>&& value);




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_attestation_object_ = false;
bool has_client_data_js_on_ = false;
bool has_transports_ = false;

String member_attestation_object_;
String member_client_data_js_on_;
Vector<String> member_transports_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AUTHENTICATOR_ATTESTATION_RESPONSE_JS_ON_H_
