// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_background_fetch_ui_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_image_resource.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



BackgroundFetchUIOptions* BackgroundFetchUIOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  BackgroundFetchUIOptions* dictionary = MakeGarbageCollected<BackgroundFetchUIOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "BackgroundFetchUIOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 BackgroundFetchUIOptions::BackgroundFetchUIOptions() {
  
}

 BackgroundFetchUIOptions::BackgroundFetchUIOptions(v8::Isolate* isolate) {
  
}



void BackgroundFetchUIOptions::setIcons(const HeapVector<Member<ManifestImageResource>>& value) {
  member_icons_ = value;
}

void BackgroundFetchUIOptions::setIcons(HeapVector<Member<ManifestImageResource>>&& value) {
  member_icons_ = std::move(value);
}




String BackgroundFetchUIOptions::getTitleOr(const String& fallback_value) const {
  if (!hasTitle()) {
  return fallback_value;
}
return member_title_;
}

String BackgroundFetchUIOptions::getTitleOr(String&& fallback_value) const {
  if (!hasTitle()) {
  return std::move(fallback_value);
}
return member_title_;
}

void BackgroundFetchUIOptions::setTitle(const String& value) {
  member_title_ = value;
has_title_ = true;
}

void BackgroundFetchUIOptions::setTitle(String&& value) {
  member_title_ = std::move(value);
has_title_ = true;
}




void BackgroundFetchUIOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<ManifestImageResource>>>::Trace(visitor, member_icons_);
TraceIfNeeded<String>::Trace(visitor, member_title_);
bindings::DictionaryBase::Trace(visitor);
}

bool BackgroundFetchUIOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasIcons()) {
  v8_value = ToV8Traits<IDLSequence<ManifestImageResource>>::ToV8(script_state, member_icons_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasTitle()) {
  v8_value = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_title_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void BackgroundFetchUIOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "BackgroundFetchUIOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("icons");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<ManifestImageResource>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_icons_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("title");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_title_, member_title_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> BackgroundFetchUIOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"icons",
"title",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
