// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_CAPTURE_HANDLE_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_CAPTURE_HANDLE_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT CaptureHandle : public bindings::DictionaryBase {
  
  public:
static CaptureHandle* Create() {
  return MakeGarbageCollected<CaptureHandle>();
}
static CaptureHandle* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<CaptureHandle>(isolate);
}
static CaptureHandle* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  CaptureHandle();
explicit  CaptureHandle(v8::Isolate* isolate);

bool hasHandle() const {
  return has_handle_;
}
const String& handle() const {
  DCHECK(hasHandle());
return member_handle_;
}
String getHandleOr(const String& fallback_value) const;
String getHandleOr(String&& fallback_value) const;
void setHandle(const String& value);
void setHandle(String&& value);

bool hasOrigin() const {
  return has_origin_;
}
const String& origin() const {
  DCHECK(hasOrigin());
return member_origin_;
}
String getOriginOr(const String& fallback_value) const;
String getOriginOr(String&& fallback_value) const;
void setOrigin(const String& value);
void setOrigin(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_handle_ = false;
bool has_origin_ = false;

String member_handle_;
String member_origin_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_CAPTURE_HANDLE_H_
