// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_constrain_point_2d_parameters.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_point_2d.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



ConstrainPoint2DParameters* ConstrainPoint2DParameters::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ConstrainPoint2DParameters* dictionary = MakeGarbageCollected<ConstrainPoint2DParameters>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ConstrainPoint2DParameters";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 ConstrainPoint2DParameters::ConstrainPoint2DParameters() {
  
}

 ConstrainPoint2DParameters::ConstrainPoint2DParameters(v8::Isolate* isolate) {
  
}



HeapVector<Member<Point2D>> ConstrainPoint2DParameters::getExactOr(const HeapVector<Member<Point2D>>& fallback_value) const {
  if (!hasExact()) {
  return fallback_value;
}
return member_exact_;
}

HeapVector<Member<Point2D>> ConstrainPoint2DParameters::getExactOr(HeapVector<Member<Point2D>>&& fallback_value) const {
  if (!hasExact()) {
  return std::move(fallback_value);
}
return member_exact_;
}

void ConstrainPoint2DParameters::setExact(const HeapVector<Member<Point2D>>& value) {
  member_exact_ = value;
has_exact_ = true;
}

void ConstrainPoint2DParameters::setExact(HeapVector<Member<Point2D>>&& value) {
  member_exact_ = std::move(value);
has_exact_ = true;
}




HeapVector<Member<Point2D>> ConstrainPoint2DParameters::getIdealOr(const HeapVector<Member<Point2D>>& fallback_value) const {
  if (!hasIdeal()) {
  return fallback_value;
}
return member_ideal_;
}

HeapVector<Member<Point2D>> ConstrainPoint2DParameters::getIdealOr(HeapVector<Member<Point2D>>&& fallback_value) const {
  if (!hasIdeal()) {
  return std::move(fallback_value);
}
return member_ideal_;
}

void ConstrainPoint2DParameters::setIdeal(const HeapVector<Member<Point2D>>& value) {
  member_ideal_ = value;
has_ideal_ = true;
}

void ConstrainPoint2DParameters::setIdeal(HeapVector<Member<Point2D>>&& value) {
  member_ideal_ = std::move(value);
has_ideal_ = true;
}




void ConstrainPoint2DParameters::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<Point2D>>>::Trace(visitor, member_exact_);
TraceIfNeeded<HeapVector<Member<Point2D>>>::Trace(visitor, member_ideal_);
bindings::DictionaryBase::Trace(visitor);
}

bool ConstrainPoint2DParameters::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasExact()) {
  v8_value = ToV8Traits<IDLSequence<Point2D>>::ToV8(script_state, member_exact_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasIdeal()) {
  v8_value = ToV8Traits<IDLSequence<Point2D>>::ToV8(script_state, member_ideal_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void ConstrainPoint2DParameters::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "ConstrainPoint2DParameters";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("exact");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<Point2D>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_exact_, member_exact_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("ideal");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<Point2D>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_ideal_, member_ideal_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ConstrainPoint2DParameters::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"exact",
"ideal",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
