// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DETECTED_FACE_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DETECTED_FACE_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class DOMRectReadOnly;
class ExceptionState;
class Landmark;

class MODULES_EXPORT DetectedFace : public bindings::DictionaryBase {
  
  public:
static DetectedFace* Create() {
  return MakeGarbageCollected<DetectedFace>();
}
static DetectedFace* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<DetectedFace>(isolate);
}
static DetectedFace* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  DetectedFace();
explicit  DetectedFace(v8::Isolate* isolate);

bool hasBoundingBox() const {
  return true;
}
DOMRectReadOnly* boundingBox() const {
  return member_bounding_box_.Get();
}
void setBoundingBox(DOMRectReadOnly* value) {
  member_bounding_box_ = value;
DCHECK(member_bounding_box_);
}

bool hasLandmarks() const {
  return true;
}
const HeapVector<Member<Landmark>>& landmarks() const {
  return member_landmarks_;
}
void setLandmarks(const HeapVector<Member<Landmark>>& value);
void setLandmarks(HeapVector<Member<Landmark>>&& value);




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



Member<DOMRectReadOnly> member_bounding_box_;
HeapVector<Member<Landmark>> member_landmarks_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DETECTED_FACE_H_
