// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_device_motion_event_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_device_motion_event_acceleration_init.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_device_motion_event_rotation_rate_init.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



DeviceMotionEventInit* DeviceMotionEventInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  DeviceMotionEventInit* dictionary = MakeGarbageCollected<DeviceMotionEventInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "DeviceMotionEventInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 DeviceMotionEventInit::DeviceMotionEventInit() {
  
}

 DeviceMotionEventInit::DeviceMotionEventInit(v8::Isolate* isolate) : EventInit(isolate) {
  
}





























void DeviceMotionEventInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<DeviceMotionEventAccelerationInit>>::Trace(visitor, member_acceleration_);
TraceIfNeeded<Member<DeviceMotionEventAccelerationInit>>::Trace(visitor, member_acceleration_including_gravity_);
TraceIfNeeded<double>::Trace(visitor, member_interval_);
TraceIfNeeded<Member<DeviceMotionEventRotationRateInit>>::Trace(visitor, member_rotation_rate_);
EventInit::Trace(visitor);
}

bool DeviceMotionEventInit::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!EventInit::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAcceleration()) {
  v8_value = ToV8Traits<DeviceMotionEventAccelerationInit>::ToV8(script_state, member_acceleration_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasAccelerationIncludingGravity()) {
  v8_value = ToV8Traits<DeviceMotionEventAccelerationInit>::ToV8(script_state, member_acceleration_including_gravity_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasInterval()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_interval_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasRotationRate()) {
  v8_value = ToV8Traits<DeviceMotionEventRotationRateInit>::ToV8(script_state, member_rotation_rate_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void DeviceMotionEventInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  EventInit::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "DeviceMotionEventInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("acceleration");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<DeviceMotionEventAccelerationInit, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_acceleration_, member_acceleration_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("accelerationIncludingGravity");
if (!bindings::GetDictionaryMemberFromV8Object<DeviceMotionEventAccelerationInit, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_acceleration_including_gravity_, member_acceleration_including_gravity_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("interval");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_interval_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rotationRate");
if (!bindings::GetDictionaryMemberFromV8Object<DeviceMotionEventRotationRateInit, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_rotation_rate_, member_rotation_rate_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> DeviceMotionEventInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"acceleration",
"accelerationIncludingGravity",
"interval",
"rotationRate",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
