// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_digital_credential_field_requirement.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



DigitalCredentialFieldRequirement* DigitalCredentialFieldRequirement::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  DigitalCredentialFieldRequirement* dictionary = MakeGarbageCollected<DigitalCredentialFieldRequirement>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "DigitalCredentialFieldRequirement";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 DigitalCredentialFieldRequirement::DigitalCredentialFieldRequirement() {
  
}

 DigitalCredentialFieldRequirement::DigitalCredentialFieldRequirement(v8::Isolate* isolate) {
  
}



String DigitalCredentialFieldRequirement::getEqualsOr(const String& fallback_value) const {
  if (!hasEquals()) {
  return fallback_value;
}
return member_equals_;
}

String DigitalCredentialFieldRequirement::getEqualsOr(String&& fallback_value) const {
  if (!hasEquals()) {
  return std::move(fallback_value);
}
return member_equals_;
}

void DigitalCredentialFieldRequirement::setEquals(const String& value) {
  member_equals_ = value;
has_equals_ = true;
}

void DigitalCredentialFieldRequirement::setEquals(String&& value) {
  member_equals_ = std::move(value);
has_equals_ = true;
}




void DigitalCredentialFieldRequirement::setName(const String& value) {
  member_name_ = value;
}

void DigitalCredentialFieldRequirement::setName(String&& value) {
  member_name_ = std::move(value);
}




void DigitalCredentialFieldRequirement::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_equals_);
TraceIfNeeded<String>::Trace(visitor, member_name_);
bindings::DictionaryBase::Trace(visitor);
}

bool DigitalCredentialFieldRequirement::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasEquals()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_equals_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasName()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_name_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void DigitalCredentialFieldRequirement::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "DigitalCredentialFieldRequirement";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("equals");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_equals_, member_equals_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("name");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_name_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> DigitalCredentialFieldRequirement::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"equals",
"name",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
