// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_digital_credential_provider.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_digital_credential_selector.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



DigitalCredentialProvider* DigitalCredentialProvider::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  DigitalCredentialProvider* dictionary = MakeGarbageCollected<DigitalCredentialProvider>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "DigitalCredentialProvider";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 DigitalCredentialProvider::DigitalCredentialProvider() {
  
}

 DigitalCredentialProvider::DigitalCredentialProvider(v8::Isolate* isolate) {
  
}



Vector<std::pair<String, String>> DigitalCredentialProvider::getParamsOr(const Vector<std::pair<String, String>>& fallback_value) const {
  if (!hasParams()) {
  return fallback_value;
}
return member_params_;
}

Vector<std::pair<String, String>> DigitalCredentialProvider::getParamsOr(Vector<std::pair<String, String>>&& fallback_value) const {
  if (!hasParams()) {
  return std::move(fallback_value);
}
return member_params_;
}

void DigitalCredentialProvider::setParams(const Vector<std::pair<String, String>>& value) {
  member_params_ = value;
has_params_ = true;
}

void DigitalCredentialProvider::setParams(Vector<std::pair<String, String>>&& value) {
  member_params_ = std::move(value);
has_params_ = true;
}




String DigitalCredentialProvider::getProtocolOr(const String& fallback_value) const {
  if (!hasProtocol()) {
  return fallback_value;
}
return member_protocol_;
}

String DigitalCredentialProvider::getProtocolOr(String&& fallback_value) const {
  if (!hasProtocol()) {
  return std::move(fallback_value);
}
return member_protocol_;
}

void DigitalCredentialProvider::setProtocol(const String& value) {
  member_protocol_ = value;
has_protocol_ = true;
}

void DigitalCredentialProvider::setProtocol(String&& value) {
  member_protocol_ = std::move(value);
has_protocol_ = true;
}




String DigitalCredentialProvider::getPublicKeyOr(const String& fallback_value) const {
  if (!hasPublicKey()) {
  return fallback_value;
}
return member_public_key_;
}

String DigitalCredentialProvider::getPublicKeyOr(String&& fallback_value) const {
  if (!hasPublicKey()) {
  return std::move(fallback_value);
}
return member_public_key_;
}

void DigitalCredentialProvider::setPublicKey(const String& value) {
  member_public_key_ = value;
has_public_key_ = true;
}

void DigitalCredentialProvider::setPublicKey(String&& value) {
  member_public_key_ = std::move(value);
has_public_key_ = true;
}




String DigitalCredentialProvider::getRequestOr(const String& fallback_value) const {
  if (!hasRequest()) {
  return fallback_value;
}
return member_request_;
}

String DigitalCredentialProvider::getRequestOr(String&& fallback_value) const {
  if (!hasRequest()) {
  return std::move(fallback_value);
}
return member_request_;
}

void DigitalCredentialProvider::setRequest(const String& value) {
  member_request_ = value;
has_request_ = true;
}

void DigitalCredentialProvider::setRequest(String&& value) {
  member_request_ = std::move(value);
has_request_ = true;
}











void DigitalCredentialProvider::Trace(Visitor* visitor) const {
  TraceIfNeeded<Vector<std::pair<String, String>>>::Trace(visitor, member_params_);
TraceIfNeeded<String>::Trace(visitor, member_protocol_);
TraceIfNeeded<String>::Trace(visitor, member_public_key_);
TraceIfNeeded<String>::Trace(visitor, member_request_);
TraceIfNeeded<Member<DigitalCredentialSelector>>::Trace(visitor, member_selector_);
bindings::DictionaryBase::Trace(visitor);
}

bool DigitalCredentialProvider::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasParams()) {
  v8_value = ToV8Traits<IDLRecord<IDLUSVString, IDLUSVString>>::ToV8(script_state, member_params_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasProtocol()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_protocol_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasPublicKey()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_public_key_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasRequest()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_request_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasSelector()) {
  v8_value = ToV8Traits<DigitalCredentialSelector>::ToV8(script_state, member_selector_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
return true;
}

void DigitalCredentialProvider::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "DigitalCredentialProvider";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("params");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_params_, member_params_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("protocol");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_protocol_, member_protocol_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("publicKey");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_public_key_, member_public_key_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("request");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_request_, member_request_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("selector");
if (!bindings::GetDictionaryMemberFromV8Object<DigitalCredentialSelector, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_selector_, member_selector_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> DigitalCredentialProvider::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"params",
"protocol",
"publicKey",
"request",
"selector",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
