// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_encoded_video_chunk_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_arraybufferallowshared_arraybufferviewallowshared.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_decrypt_config.h"
#include "third_party/blink/renderer/core/execution_context/execution_context.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



EncodedVideoChunkInit* EncodedVideoChunkInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  EncodedVideoChunkInit* dictionary = MakeGarbageCollected<EncodedVideoChunkInit>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "EncodedVideoChunkInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 EncodedVideoChunkInit::EncodedVideoChunkInit() {
  
}

 EncodedVideoChunkInit::EncodedVideoChunkInit(v8::Isolate* isolate) {
  
}



























void EncodedVideoChunkInit::setTransfer(const HeapVector<Member<DOMArrayBuffer>>& value) {
  member_transfer_ = value;
}

void EncodedVideoChunkInit::setTransfer(HeapVector<Member<DOMArrayBuffer>>&& value) {
  member_transfer_ = std::move(value);
}









void EncodedVideoChunkInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<V8UnionArrayBufferAllowSharedOrArrayBufferViewAllowShared>>::Trace(visitor, member_data_);
TraceIfNeeded<Member<DecryptConfig>>::Trace(visitor, member_decrypt_config_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_duration_);
TraceIfNeeded<int64_t>::Trace(visitor, member_timestamp_);
TraceIfNeeded<HeapVector<Member<DOMArrayBuffer>>>::Trace(visitor, member_transfer_);
TraceIfNeeded<V8EncodedVideoChunkType>::Trace(visitor, member_type_);
bindings::DictionaryBase::Trace(visitor);
}

bool EncodedVideoChunkInit::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasData()) {
  v8_value = ToV8Traits<V8UnionArrayBufferAllowSharedOrArrayBufferViewAllowShared>::ToV8(script_state, member_data_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
ExecutionContext* execution_context = ExecutionContext::From(current_context);
if (RuntimeEnabledFeatures::MediaSourceExtensionsForWebCodecsEnabled(execution_context)) {
  if (hasDecryptConfig()) {
  v8_value = ToV8Traits<DecryptConfig>::ToV8(script_state, member_decrypt_config_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
}
if (hasDuration()) {
  v8_value = ToV8Traits<IDLUnsignedLongLongEnforceRange>::ToV8(script_state, member_duration_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasTimestamp()) {
  v8_value = ToV8Traits<IDLLongLongEnforceRange>::ToV8(script_state, member_timestamp_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasTransfer()) {
  v8_value = ToV8Traits<IDLSequence<DOMArrayBuffer>>::ToV8(script_state, member_transfer_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasType()) {
  v8_value = ToV8Traits<V8EncodedVideoChunkType>::ToV8(script_state, member_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
return true;
}

void EncodedVideoChunkInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "EncodedVideoChunkInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("data");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionArrayBufferAllowSharedOrArrayBufferViewAllowShared, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_data_, try_block, exception_state)) {
  return;
}
ExecutionContext* execution_context = ExecutionContext::From(current_context);
constexpr bool is_optional = false;
if (RuntimeEnabledFeatures::MediaSourceExtensionsForWebCodecsEnabled(execution_context)) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("decryptConfig");
if (!bindings::GetDictionaryMemberFromV8Object<DecryptConfig, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_decrypt_config_, member_decrypt_config_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("duration");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_duration_, member_duration_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("timestamp");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLongLongEnforceRange, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_timestamp_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("transfer");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<DOMArrayBuffer>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_transfer_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("type");
if (!bindings::GetDictionaryMemberFromV8Object<V8EncodedVideoChunkType, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_type_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> EncodedVideoChunkInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"data",
"decryptConfig",
"duration",
"timestamp",
"transfer",
"type",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
