// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_extendable_cookie_change_event_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_cookie_list_item.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



ExtendableCookieChangeEventInit* ExtendableCookieChangeEventInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ExtendableCookieChangeEventInit* dictionary = MakeGarbageCollected<ExtendableCookieChangeEventInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ExtendableCookieChangeEventInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 ExtendableCookieChangeEventInit::ExtendableCookieChangeEventInit() {
  
}

 ExtendableCookieChangeEventInit::ExtendableCookieChangeEventInit(v8::Isolate* isolate) : ExtendableEventInit(isolate) {
  
}



HeapVector<Member<CookieListItem>> ExtendableCookieChangeEventInit::getChangedOr(const HeapVector<Member<CookieListItem>>& fallback_value) const {
  if (!hasChanged()) {
  return fallback_value;
}
return member_changed_;
}

HeapVector<Member<CookieListItem>> ExtendableCookieChangeEventInit::getChangedOr(HeapVector<Member<CookieListItem>>&& fallback_value) const {
  if (!hasChanged()) {
  return std::move(fallback_value);
}
return member_changed_;
}

void ExtendableCookieChangeEventInit::setChanged(const HeapVector<Member<CookieListItem>>& value) {
  member_changed_ = value;
has_changed_ = true;
}

void ExtendableCookieChangeEventInit::setChanged(HeapVector<Member<CookieListItem>>&& value) {
  member_changed_ = std::move(value);
has_changed_ = true;
}




HeapVector<Member<CookieListItem>> ExtendableCookieChangeEventInit::getDeletedOr(const HeapVector<Member<CookieListItem>>& fallback_value) const {
  if (!hasDeleted()) {
  return fallback_value;
}
return member_deleted_;
}

HeapVector<Member<CookieListItem>> ExtendableCookieChangeEventInit::getDeletedOr(HeapVector<Member<CookieListItem>>&& fallback_value) const {
  if (!hasDeleted()) {
  return std::move(fallback_value);
}
return member_deleted_;
}

void ExtendableCookieChangeEventInit::setDeleted(const HeapVector<Member<CookieListItem>>& value) {
  member_deleted_ = value;
has_deleted_ = true;
}

void ExtendableCookieChangeEventInit::setDeleted(HeapVector<Member<CookieListItem>>&& value) {
  member_deleted_ = std::move(value);
has_deleted_ = true;
}




void ExtendableCookieChangeEventInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<CookieListItem>>>::Trace(visitor, member_changed_);
TraceIfNeeded<HeapVector<Member<CookieListItem>>>::Trace(visitor, member_deleted_);
ExtendableEventInit::Trace(visitor);
}

bool ExtendableCookieChangeEventInit::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!ExtendableEventInit::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasChanged()) {
  v8_value = ToV8Traits<IDLSequence<CookieListItem>>::ToV8(script_state, member_changed_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasDeleted()) {
  v8_value = ToV8Traits<IDLSequence<CookieListItem>>::ToV8(script_state, member_deleted_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void ExtendableCookieChangeEventInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  ExtendableEventInit::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "ExtendableCookieChangeEventInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("changed");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<CookieListItem>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_changed_, member_changed_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("deleted");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<CookieListItem>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_deleted_, member_deleted_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ExtendableCookieChangeEventInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"changed",
"deleted",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
