// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_file_system_cloud_identifier.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



FileSystemCloudIdentifier* FileSystemCloudIdentifier::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  FileSystemCloudIdentifier* dictionary = MakeGarbageCollected<FileSystemCloudIdentifier>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "FileSystemCloudIdentifier";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 FileSystemCloudIdentifier::FileSystemCloudIdentifier() {
  
}

 FileSystemCloudIdentifier::FileSystemCloudIdentifier(v8::Isolate* isolate) {
  
}



String FileSystemCloudIdentifier::getIdOr(const String& fallback_value) const {
  if (!hasId()) {
  return fallback_value;
}
return member_id_;
}

String FileSystemCloudIdentifier::getIdOr(String&& fallback_value) const {
  if (!hasId()) {
  return std::move(fallback_value);
}
return member_id_;
}

void FileSystemCloudIdentifier::setId(const String& value) {
  member_id_ = value;
has_id_ = true;
}

void FileSystemCloudIdentifier::setId(String&& value) {
  member_id_ = std::move(value);
has_id_ = true;
}




String FileSystemCloudIdentifier::getProviderNameOr(const String& fallback_value) const {
  if (!hasProviderName()) {
  return fallback_value;
}
return member_provider_name_;
}

String FileSystemCloudIdentifier::getProviderNameOr(String&& fallback_value) const {
  if (!hasProviderName()) {
  return std::move(fallback_value);
}
return member_provider_name_;
}

void FileSystemCloudIdentifier::setProviderName(const String& value) {
  member_provider_name_ = value;
has_provider_name_ = true;
}

void FileSystemCloudIdentifier::setProviderName(String&& value) {
  member_provider_name_ = std::move(value);
has_provider_name_ = true;
}




void FileSystemCloudIdentifier::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_id_);
TraceIfNeeded<String>::Trace(visitor, member_provider_name_);
bindings::DictionaryBase::Trace(visitor);
}

bool FileSystemCloudIdentifier::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasProviderName()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_provider_name_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void FileSystemCloudIdentifier::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "FileSystemCloudIdentifier";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("id");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_id_, member_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("providerName");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_provider_name_, member_provider_name_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> FileSystemCloudIdentifier::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"id",
"providerName",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
