// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_file_system_create_writable_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



FileSystemCreateWritableOptions* FileSystemCreateWritableOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  FileSystemCreateWritableOptions* dictionary = MakeGarbageCollected<FileSystemCreateWritableOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "FileSystemCreateWritableOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 FileSystemCreateWritableOptions::FileSystemCreateWritableOptions() {
  
}

 FileSystemCreateWritableOptions::FileSystemCreateWritableOptions(v8::Isolate* isolate) {
  
}


















void FileSystemCreateWritableOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_auto_close_);
TraceIfNeeded<bool>::Trace(visitor, member_keep_existing_data_);
TraceIfNeeded<V8FileSystemWritableFileStreamMode>::Trace(visitor, member_mode_);
bindings::DictionaryBase::Trace(visitor);
}

bool FileSystemCreateWritableOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (RuntimeEnabledFeatures::FileSystemAccessAPIExperimentalEnabled()) {
  if (hasAutoClose()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_auto_close_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
}
if (hasKeepExistingData()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_keep_existing_data_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (RuntimeEnabledFeatures::FileSystemAccessLockingSchemeEnabled()) {
  if (hasMode()) {
  v8_value = ToV8Traits<V8FileSystemWritableFileStreamMode>::ToV8(script_state, member_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
}
return true;
}

void FileSystemCreateWritableOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "FileSystemCreateWritableOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (RuntimeEnabledFeatures::FileSystemAccessAPIExperimentalEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("autoClose");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_auto_close_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("keepExistingData");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_keep_existing_data_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::FileSystemAccessLockingSchemeEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("mode");
if (!bindings::GetDictionaryMemberFromV8Object<V8FileSystemWritableFileStreamMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_mode_, try_block, exception_state)) {
  return;
}
}
}

const base::span<const v8::Eternal<v8::Name>> FileSystemCreateWritableOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"autoClose",
"keepExistingData",
"mode",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
