// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_render_pass_descriptor.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_render_pass_color_attachment.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_render_pass_depth_stencil_attachment.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_render_pass_timestamp_writes.h"
#include "third_party/blink/renderer/modules/webgpu/gpu_query_set.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



GPURenderPassDescriptor* GPURenderPassDescriptor::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPURenderPassDescriptor* dictionary = MakeGarbageCollected<GPURenderPassDescriptor>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPURenderPassDescriptor";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 GPURenderPassDescriptor::GPURenderPassDescriptor() {
  
}

 GPURenderPassDescriptor::GPURenderPassDescriptor(v8::Isolate* isolate) : GPUObjectDescriptorBase(isolate) {
  
}



void GPURenderPassDescriptor::setColorAttachments(const HeapVector<Member<GPURenderPassColorAttachment>>& value) {
  member_color_attachments_ = value;
}

void GPURenderPassDescriptor::setColorAttachments(HeapVector<Member<GPURenderPassColorAttachment>>&& value) {
  member_color_attachments_ = std::move(value);
}
































void GPURenderPassDescriptor::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<GPURenderPassColorAttachment>>>::Trace(visitor, member_color_attachments_);
TraceIfNeeded<Member<GPURenderPassDepthStencilAttachment>>::Trace(visitor, member_depth_stencil_attachment_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_max_draw_count_);
TraceIfNeeded<Member<GPUQuerySet>>::Trace(visitor, member_occlusion_query_set_);
TraceIfNeeded<Member<GPURenderPassTimestampWrites>>::Trace(visitor, member_timestamp_writes_);
GPUObjectDescriptorBase::Trace(visitor);
}

bool GPURenderPassDescriptor::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!GPUObjectDescriptorBase::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasColorAttachments()) {
  v8_value = ToV8Traits<IDLSequence<IDLNullable<GPURenderPassColorAttachment>>>::ToV8(script_state, member_color_attachments_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasDepthStencilAttachment()) {
  v8_value = ToV8Traits<GPURenderPassDepthStencilAttachment>::ToV8(script_state, member_depth_stencil_attachment_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasMaxDrawCount()) {
  v8_value = ToV8Traits<IDLUnsignedLongLongEnforceRange>::ToV8(script_state, member_max_draw_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasOcclusionQuerySet()) {
  v8_value = ToV8Traits<GPUQuerySet>::ToV8(script_state, member_occlusion_query_set_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasTimestampWrites()) {
  v8_value = ToV8Traits<GPURenderPassTimestampWrites>::ToV8(script_state, member_timestamp_writes_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
return true;
}

void GPURenderPassDescriptor::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  GPUObjectDescriptorBase::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "GPURenderPassDescriptor";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("colorAttachments");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLNullable<GPURenderPassColorAttachment>>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_color_attachments_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthStencilAttachment");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<GPURenderPassDepthStencilAttachment, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_depth_stencil_attachment_, member_depth_stencil_attachment_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("maxDrawCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_max_draw_count_, member_max_draw_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("occlusionQuerySet");
if (!bindings::GetDictionaryMemberFromV8Object<GPUQuerySet, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_occlusion_query_set_, member_occlusion_query_set_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("timestampWrites");
if (!bindings::GetDictionaryMemberFromV8Object<GPURenderPassTimestampWrites, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_timestamp_writes_, member_timestamp_writes_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPURenderPassDescriptor::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"colorAttachments",
"depthStencilAttachment",
"maxDrawCount",
"occlusionQuerySet",
"timestampWrites",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
