// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_GPU_STORAGE_TEXTURE_BINDING_LAYOUT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_GPU_STORAGE_TEXTURE_BINDING_LAYOUT_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_storage_texture_access.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_texture_format.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_texture_view_dimension.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT GPUStorageTextureBindingLayout : public bindings::DictionaryBase {
  
  public:
static GPUStorageTextureBindingLayout* Create() {
  return MakeGarbageCollected<GPUStorageTextureBindingLayout>();
}
static GPUStorageTextureBindingLayout* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<GPUStorageTextureBindingLayout>(isolate);
}
static GPUStorageTextureBindingLayout* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  GPUStorageTextureBindingLayout();
explicit  GPUStorageTextureBindingLayout(v8::Isolate* isolate);

bool hasAccess() const {
  return true;
}
V8GPUStorageTextureAccess access() const {
  return member_access_;
}
void setAccess(V8GPUStorageTextureAccess value) {
  member_access_ = value;
}
void setAccess(V8GPUStorageTextureAccess::Enum value) {
  member_access_ = V8GPUStorageTextureAccess(value);
}

bool hasFormat() const {
  return true;
}
V8GPUTextureFormat format() const {
  return member_format_;
}
void setFormat(V8GPUTextureFormat value) {
  member_format_ = value;
}
void setFormat(V8GPUTextureFormat::Enum value) {
  member_format_ = V8GPUTextureFormat(value);
}

bool hasViewDimension() const {
  return true;
}
V8GPUTextureViewDimension viewDimension() const {
  return member_view_dimension_;
}
void setViewDimension(V8GPUTextureViewDimension value) {
  member_view_dimension_ = value;
}
void setViewDimension(V8GPUTextureViewDimension::Enum value) {
  member_view_dimension_ = V8GPUTextureViewDimension(value);
}


// Obsolete accessor functions
void setAccess(const String& value) {
  member_access_ = V8GPUStorageTextureAccess::Create(value).value();
}
void setFormat(const String& value) {
  member_format_ = V8GPUTextureFormat::Create(value).value();
}
void setViewDimension(const String& value) {
  member_view_dimension_ = V8GPUTextureViewDimension::Create(value).value();
}

void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



V8GPUStorageTextureAccess member_access_{V8GPUStorageTextureAccess::Enum::kWriteOnly};
V8GPUTextureFormat member_format_{static_cast<V8GPUTextureFormat::Enum>(0)};
V8GPUTextureViewDimension member_view_dimension_{V8GPUTextureViewDimension::Enum::k2D};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_GPU_STORAGE_TEXTURE_BINDING_LAYOUT_H_
