// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_texture_view_descriptor.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



GPUTextureViewDescriptor* GPUTextureViewDescriptor::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPUTextureViewDescriptor* dictionary = MakeGarbageCollected<GPUTextureViewDescriptor>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPUTextureViewDescriptor";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 GPUTextureViewDescriptor::GPUTextureViewDescriptor() {
  
}

 GPUTextureViewDescriptor::GPUTextureViewDescriptor(v8::Isolate* isolate) : GPUObjectDescriptorBase(isolate) {
  
}














































void GPUTextureViewDescriptor::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_array_layer_count_);
TraceIfNeeded<V8GPUTextureAspect>::Trace(visitor, member_aspect_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_base_array_layer_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_base_mip_level_);
TraceIfNeeded<V8GPUTextureViewDimension>::Trace(visitor, member_dimension_);
TraceIfNeeded<V8GPUTextureFormat>::Trace(visitor, member_format_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_mip_level_count_);
GPUObjectDescriptorBase::Trace(visitor);
}

bool GPUTextureViewDescriptor::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!GPUObjectDescriptorBase::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasArrayLayerCount()) {
  v8_value = ToV8Traits<IDLUnsignedLongEnforceRange>::ToV8(script_state, member_array_layer_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasAspect()) {
  v8_value = ToV8Traits<V8GPUTextureAspect>::ToV8(script_state, member_aspect_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasBaseArrayLayer()) {
  v8_value = ToV8Traits<IDLUnsignedLongEnforceRange>::ToV8(script_state, member_base_array_layer_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasBaseMipLevel()) {
  v8_value = ToV8Traits<IDLUnsignedLongEnforceRange>::ToV8(script_state, member_base_mip_level_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasDimension()) {
  v8_value = ToV8Traits<V8GPUTextureViewDimension>::ToV8(script_state, member_dimension_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasFormat()) {
  v8_value = ToV8Traits<V8GPUTextureFormat>::ToV8(script_state, member_format_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasMipLevelCount()) {
  v8_value = ToV8Traits<IDLUnsignedLongEnforceRange>::ToV8(script_state, member_mip_level_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
return true;
}

void GPUTextureViewDescriptor::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  GPUObjectDescriptorBase::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "GPUTextureViewDescriptor";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("arrayLayerCount");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_array_layer_count_, member_array_layer_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("aspect");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUTextureAspect, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_aspect_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("baseArrayLayer");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_base_array_layer_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("baseMipLevel");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_base_mip_level_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("dimension");
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUTextureViewDimension, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_dimension_, member_dimension_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("format");
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUTextureFormat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_format_, member_format_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mipLevelCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_mip_level_count_, member_mip_level_count_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPUTextureViewDescriptor::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"arrayLayerCount",
"aspect",
"baseArrayLayer",
"baseMipLevel",
"dimension",
"format",
"mipLevelCount",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
