// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_handwriting_hints.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



HandwritingHints* HandwritingHints::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  HandwritingHints* dictionary = MakeGarbageCollected<HandwritingHints>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "HandwritingHints";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 HandwritingHints::HandwritingHints() {
  
}

 HandwritingHints::HandwritingHints(v8::Isolate* isolate) {
  
}








void HandwritingHints::setInputType(const String& value) {
  member_input_type_ = value;
}

void HandwritingHints::setInputType(String&& value) {
  member_input_type_ = std::move(value);
}




void HandwritingHints::setRecognitionType(const String& value) {
  member_recognition_type_ = value;
}

void HandwritingHints::setRecognitionType(String&& value) {
  member_recognition_type_ = std::move(value);
}




String HandwritingHints::getTextContextOr(const String& fallback_value) const {
  if (!hasTextContext()) {
  return fallback_value;
}
return member_text_context_;
}

String HandwritingHints::getTextContextOr(String&& fallback_value) const {
  if (!hasTextContext()) {
  return std::move(fallback_value);
}
return member_text_context_;
}

void HandwritingHints::setTextContext(const String& value) {
  member_text_context_ = value;
has_text_context_ = true;
}

void HandwritingHints::setTextContext(String&& value) {
  member_text_context_ = std::move(value);
has_text_context_ = true;
}




void HandwritingHints::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_alternatives_);
TraceIfNeeded<String>::Trace(visitor, member_input_type_);
TraceIfNeeded<String>::Trace(visitor, member_recognition_type_);
TraceIfNeeded<String>::Trace(visitor, member_text_context_);
bindings::DictionaryBase::Trace(visitor);
}

bool HandwritingHints::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAlternatives()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_alternatives_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasInputType()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_input_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasRecognitionType()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_recognition_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasTextContext()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_text_context_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void HandwritingHints::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "HandwritingHints";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("alternatives");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_alternatives_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("inputType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_input_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("recognitionType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_recognition_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("textContext");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_text_context_, member_text_context_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> HandwritingHints::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"alternatives",
"inputType",
"recognitionType",
"textContext",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
