// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_hid_device_request_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_hid_device_filter.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



HIDDeviceRequestOptions* HIDDeviceRequestOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  HIDDeviceRequestOptions* dictionary = MakeGarbageCollected<HIDDeviceRequestOptions>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "HIDDeviceRequestOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 HIDDeviceRequestOptions::HIDDeviceRequestOptions() {
  
}

 HIDDeviceRequestOptions::HIDDeviceRequestOptions(v8::Isolate* isolate) {
  
}



HeapVector<Member<HIDDeviceFilter>> HIDDeviceRequestOptions::getExclusionFiltersOr(const HeapVector<Member<HIDDeviceFilter>>& fallback_value) const {
  if (!hasExclusionFilters()) {
  return fallback_value;
}
return member_exclusion_filters_;
}

HeapVector<Member<HIDDeviceFilter>> HIDDeviceRequestOptions::getExclusionFiltersOr(HeapVector<Member<HIDDeviceFilter>>&& fallback_value) const {
  if (!hasExclusionFilters()) {
  return std::move(fallback_value);
}
return member_exclusion_filters_;
}

void HIDDeviceRequestOptions::setExclusionFilters(const HeapVector<Member<HIDDeviceFilter>>& value) {
  member_exclusion_filters_ = value;
has_exclusion_filters_ = true;
}

void HIDDeviceRequestOptions::setExclusionFilters(HeapVector<Member<HIDDeviceFilter>>&& value) {
  member_exclusion_filters_ = std::move(value);
has_exclusion_filters_ = true;
}




void HIDDeviceRequestOptions::setFilters(const HeapVector<Member<HIDDeviceFilter>>& value) {
  member_filters_ = value;
}

void HIDDeviceRequestOptions::setFilters(HeapVector<Member<HIDDeviceFilter>>&& value) {
  member_filters_ = std::move(value);
}




void HIDDeviceRequestOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<HIDDeviceFilter>>>::Trace(visitor, member_exclusion_filters_);
TraceIfNeeded<HeapVector<Member<HIDDeviceFilter>>>::Trace(visitor, member_filters_);
bindings::DictionaryBase::Trace(visitor);
}

bool HIDDeviceRequestOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasExclusionFilters()) {
  v8_value = ToV8Traits<IDLSequence<HIDDeviceFilter>>::ToV8(script_state, member_exclusion_filters_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasFilters()) {
  v8_value = ToV8Traits<IDLSequence<HIDDeviceFilter>>::ToV8(script_state, member_filters_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void HIDDeviceRequestOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "HIDDeviceRequestOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("exclusionFilters");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<HIDDeviceFilter>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_exclusion_filters_, member_exclusion_filters_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("filters");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<HIDDeviceFilter>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_filters_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> HIDDeviceRequestOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"exclusionFilters",
"filters",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
