// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_identity_user_info.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



IdentityUserInfo* IdentityUserInfo::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  IdentityUserInfo* dictionary = MakeGarbageCollected<IdentityUserInfo>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "IdentityUserInfo";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 IdentityUserInfo::IdentityUserInfo() {
  
}

 IdentityUserInfo::IdentityUserInfo(v8::Isolate* isolate) {
  
}



String IdentityUserInfo::getEmailOr(const String& fallback_value) const {
  if (!hasEmail()) {
  return fallback_value;
}
return member_email_;
}

String IdentityUserInfo::getEmailOr(String&& fallback_value) const {
  if (!hasEmail()) {
  return std::move(fallback_value);
}
return member_email_;
}

void IdentityUserInfo::setEmail(const String& value) {
  member_email_ = value;
has_email_ = true;
}

void IdentityUserInfo::setEmail(String&& value) {
  member_email_ = std::move(value);
has_email_ = true;
}




String IdentityUserInfo::getGivenNameOr(const String& fallback_value) const {
  if (!hasGivenName()) {
  return fallback_value;
}
return member_given_name_;
}

String IdentityUserInfo::getGivenNameOr(String&& fallback_value) const {
  if (!hasGivenName()) {
  return std::move(fallback_value);
}
return member_given_name_;
}

void IdentityUserInfo::setGivenName(const String& value) {
  member_given_name_ = value;
has_given_name_ = true;
}

void IdentityUserInfo::setGivenName(String&& value) {
  member_given_name_ = std::move(value);
has_given_name_ = true;
}




String IdentityUserInfo::getNameOr(const String& fallback_value) const {
  if (!hasName()) {
  return fallback_value;
}
return member_name_;
}

String IdentityUserInfo::getNameOr(String&& fallback_value) const {
  if (!hasName()) {
  return std::move(fallback_value);
}
return member_name_;
}

void IdentityUserInfo::setName(const String& value) {
  member_name_ = value;
has_name_ = true;
}

void IdentityUserInfo::setName(String&& value) {
  member_name_ = std::move(value);
has_name_ = true;
}




String IdentityUserInfo::getPictureOr(const String& fallback_value) const {
  if (!hasPicture()) {
  return fallback_value;
}
return member_picture_;
}

String IdentityUserInfo::getPictureOr(String&& fallback_value) const {
  if (!hasPicture()) {
  return std::move(fallback_value);
}
return member_picture_;
}

void IdentityUserInfo::setPicture(const String& value) {
  member_picture_ = value;
has_picture_ = true;
}

void IdentityUserInfo::setPicture(String&& value) {
  member_picture_ = std::move(value);
has_picture_ = true;
}




void IdentityUserInfo::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_email_);
TraceIfNeeded<String>::Trace(visitor, member_given_name_);
TraceIfNeeded<String>::Trace(visitor, member_name_);
TraceIfNeeded<String>::Trace(visitor, member_picture_);
bindings::DictionaryBase::Trace(visitor);
}

bool IdentityUserInfo::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasEmail()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_email_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasGivenName()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_given_name_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasName()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_name_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasPicture()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_picture_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void IdentityUserInfo::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "IdentityUserInfo";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("email");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_email_, member_email_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("givenName");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_given_name_, member_given_name_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("name");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_name_, member_name_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("picture");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_picture_, member_picture_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> IdentityUserInfo::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"email",
"givenName",
"name",
"picture",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
