// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_iir_filter_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



IIRFilterOptions* IIRFilterOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  IIRFilterOptions* dictionary = MakeGarbageCollected<IIRFilterOptions>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "IIRFilterOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 IIRFilterOptions::IIRFilterOptions() {
  
}

 IIRFilterOptions::IIRFilterOptions(v8::Isolate* isolate) : AudioNodeOptions(isolate) {
  
}



void IIRFilterOptions::setFeedback(const Vector<double>& value) {
  member_feedback_ = value;
}

void IIRFilterOptions::setFeedback(Vector<double>&& value) {
  member_feedback_ = std::move(value);
}




void IIRFilterOptions::setFeedforward(const Vector<double>& value) {
  member_feedforward_ = value;
}

void IIRFilterOptions::setFeedforward(Vector<double>&& value) {
  member_feedforward_ = std::move(value);
}




void IIRFilterOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Vector<double>>::Trace(visitor, member_feedback_);
TraceIfNeeded<Vector<double>>::Trace(visitor, member_feedforward_);
AudioNodeOptions::Trace(visitor);
}

bool IIRFilterOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!AudioNodeOptions::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasFeedback()) {
  v8_value = ToV8Traits<IDLSequence<IDLDouble>>::ToV8(script_state, member_feedback_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasFeedforward()) {
  v8_value = ToV8Traits<IDLSequence<IDLDouble>>::ToV8(script_state, member_feedforward_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void IIRFilterOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  AudioNodeOptions::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "IIRFilterOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("feedback");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLDouble>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_feedback_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("feedforward");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLDouble>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_feedforward_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> IIRFilterOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"feedback",
"feedforward",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
