// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_media_capabilities_decoding_info.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/encryptedmedia/media_key_system_access.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



MediaCapabilitiesDecodingInfo* MediaCapabilitiesDecodingInfo::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MediaCapabilitiesDecodingInfo* dictionary = MakeGarbageCollected<MediaCapabilitiesDecodingInfo>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MediaCapabilitiesDecodingInfo";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MediaCapabilitiesDecodingInfo::MediaCapabilitiesDecodingInfo() {
  
}

 MediaCapabilitiesDecodingInfo::MediaCapabilitiesDecodingInfo(v8::Isolate* isolate) : MediaCapabilitiesInfo(isolate) {
  
}








void MediaCapabilitiesDecodingInfo::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<MediaKeySystemAccess>>::Trace(visitor, member_key_system_access_);
MediaCapabilitiesInfo::Trace(visitor);
}

bool MediaCapabilitiesDecodingInfo::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!MediaCapabilitiesInfo::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

if (hasKeySystemAccess()) {
  v8::Local<v8::Value> v8_value;
v8_value = ToV8Traits<IDLNullable<MediaKeySystemAccess>>::ToV8(script_state, member_key_system_access_.Get());
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
return true;
}

void MediaCapabilitiesDecodingInfo::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  MediaCapabilitiesInfo::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "MediaCapabilitiesDecodingInfo";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("keySystemAccess");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<MediaKeySystemAccess>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_key_system_access_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MediaCapabilitiesDecodingInfo::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"keySystemAccess",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
