// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_media_recorder_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



MediaRecorderOptions* MediaRecorderOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MediaRecorderOptions* dictionary = MakeGarbageCollected<MediaRecorderOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MediaRecorderOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MediaRecorderOptions::MediaRecorderOptions() {
  
}

 MediaRecorderOptions::MediaRecorderOptions(v8::Isolate* isolate) {
  
}






















void MediaRecorderOptions::setMimeType(const String& value) {
  member_mime_type_ = value;
}

void MediaRecorderOptions::setMimeType(String&& value) {
  member_mime_type_ = std::move(value);
}

























void MediaRecorderOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8BitrateMode>::Trace(visitor, member_audio_bitrate_mode_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_audio_bits_per_second_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_bits_per_second_);
TraceIfNeeded<String>::Trace(visitor, member_mime_type_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_video_bits_per_second_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_video_key_frame_interval_count_);
TraceIfNeeded<double>::Trace(visitor, member_video_key_frame_interval_duration_);
bindings::DictionaryBase::Trace(visitor);
}

bool MediaRecorderOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAudioBitrateMode()) {
  v8_value = ToV8Traits<V8BitrateMode>::ToV8(script_state, member_audio_bitrate_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasAudioBitsPerSecond()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_audio_bits_per_second_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasBitsPerSecond()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_bits_per_second_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasMimeType()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_mime_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasVideoBitsPerSecond()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_video_bits_per_second_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasVideoKeyFrameIntervalCount()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_video_key_frame_interval_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasVideoKeyFrameIntervalDuration()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_video_key_frame_interval_duration_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
return true;
}

void MediaRecorderOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MediaRecorderOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("audioBitrateMode");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8BitrateMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_audio_bitrate_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("audioBitsPerSecond");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_audio_bits_per_second_, member_audio_bits_per_second_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("bitsPerSecond");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_bits_per_second_, member_bits_per_second_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mimeType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_mime_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("videoBitsPerSecond");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_video_bits_per_second_, member_video_bits_per_second_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("videoKeyFrameIntervalCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_video_key_frame_interval_count_, member_video_key_frame_interval_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("videoKeyFrameIntervalDuration");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_video_key_frame_interval_duration_, member_video_key_frame_interval_duration_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MediaRecorderOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"audioBitrateMode",
"audioBitsPerSecond",
"bitsPerSecond",
"mimeType",
"videoBitsPerSecond",
"videoKeyFrameIntervalCount",
"videoKeyFrameIntervalDuration",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
