// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_media_track_settings.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_point_2d.h"
#include "third_party/blink/renderer/core/execution_context/execution_context.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



MediaTrackSettings* MediaTrackSettings::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MediaTrackSettings* dictionary = MakeGarbageCollected<MediaTrackSettings>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MediaTrackSettings";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MediaTrackSettings::MediaTrackSettings() {
  
}

 MediaTrackSettings::MediaTrackSettings(v8::Isolate* isolate) {
  
}




















































String MediaTrackSettings::getCursorOr(const String& fallback_value) const {
  if (!hasCursor()) {
  return fallback_value;
}
return member_cursor_;
}

String MediaTrackSettings::getCursorOr(String&& fallback_value) const {
  if (!hasCursor()) {
  return std::move(fallback_value);
}
return member_cursor_;
}

void MediaTrackSettings::setCursor(const String& value) {
  member_cursor_ = value;
has_cursor_ = true;
}

void MediaTrackSettings::setCursor(String&& value) {
  member_cursor_ = std::move(value);
has_cursor_ = true;
}




String MediaTrackSettings::getDeviceIdOr(const String& fallback_value) const {
  if (!hasDeviceId()) {
  return fallback_value;
}
return member_device_id_;
}

String MediaTrackSettings::getDeviceIdOr(String&& fallback_value) const {
  if (!hasDeviceId()) {
  return std::move(fallback_value);
}
return member_device_id_;
}

void MediaTrackSettings::setDeviceId(const String& value) {
  member_device_id_ = value;
has_device_id_ = true;
}

void MediaTrackSettings::setDeviceId(String&& value) {
  member_device_id_ = std::move(value);
has_device_id_ = true;
}




String MediaTrackSettings::getDisplaySurfaceOr(const String& fallback_value) const {
  if (!hasDisplaySurface()) {
  return fallback_value;
}
return member_display_surface_;
}

String MediaTrackSettings::getDisplaySurfaceOr(String&& fallback_value) const {
  if (!hasDisplaySurface()) {
  return std::move(fallback_value);
}
return member_display_surface_;
}

void MediaTrackSettings::setDisplaySurface(const String& value) {
  member_display_surface_ = value;
has_display_surface_ = true;
}

void MediaTrackSettings::setDisplaySurface(String&& value) {
  member_display_surface_ = std::move(value);
has_display_surface_ = true;
}


















String MediaTrackSettings::getExposureModeOr(const String& fallback_value) const {
  if (!hasExposureMode()) {
  return fallback_value;
}
return member_exposure_mode_;
}

String MediaTrackSettings::getExposureModeOr(String&& fallback_value) const {
  if (!hasExposureMode()) {
  return std::move(fallback_value);
}
return member_exposure_mode_;
}

void MediaTrackSettings::setExposureMode(const String& value) {
  member_exposure_mode_ = value;
has_exposure_mode_ = true;
}

void MediaTrackSettings::setExposureMode(String&& value) {
  member_exposure_mode_ = std::move(value);
has_exposure_mode_ = true;
}

























String MediaTrackSettings::getFacingModeOr(const String& fallback_value) const {
  if (!hasFacingMode()) {
  return fallback_value;
}
return member_facing_mode_;
}

String MediaTrackSettings::getFacingModeOr(String&& fallback_value) const {
  if (!hasFacingMode()) {
  return std::move(fallback_value);
}
return member_facing_mode_;
}

void MediaTrackSettings::setFacingMode(const String& value) {
  member_facing_mode_ = value;
has_facing_mode_ = true;
}

void MediaTrackSettings::setFacingMode(String&& value) {
  member_facing_mode_ = std::move(value);
has_facing_mode_ = true;
}











String MediaTrackSettings::getFocusModeOr(const String& fallback_value) const {
  if (!hasFocusMode()) {
  return fallback_value;
}
return member_focus_mode_;
}

String MediaTrackSettings::getFocusModeOr(String&& fallback_value) const {
  if (!hasFocusMode()) {
  return std::move(fallback_value);
}
return member_focus_mode_;
}

void MediaTrackSettings::setFocusMode(const String& value) {
  member_focus_mode_ = value;
has_focus_mode_ = true;
}

void MediaTrackSettings::setFocusMode(String&& value) {
  member_focus_mode_ = std::move(value);
has_focus_mode_ = true;
}











String MediaTrackSettings::getGroupIdOr(const String& fallback_value) const {
  if (!hasGroupId()) {
  return fallback_value;
}
return member_group_id_;
}

String MediaTrackSettings::getGroupIdOr(String&& fallback_value) const {
  if (!hasGroupId()) {
  return std::move(fallback_value);
}
return member_group_id_;
}

void MediaTrackSettings::setGroupId(const String& value) {
  member_group_id_ = value;
has_group_id_ = true;
}

void MediaTrackSettings::setGroupId(String&& value) {
  member_group_id_ = std::move(value);
has_group_id_ = true;
}














































HeapVector<Member<Point2D>> MediaTrackSettings::getPointsOfInterestOr(const HeapVector<Member<Point2D>>& fallback_value) const {
  if (!hasPointsOfInterest()) {
  return fallback_value;
}
return member_points_of_interest_;
}

HeapVector<Member<Point2D>> MediaTrackSettings::getPointsOfInterestOr(HeapVector<Member<Point2D>>&& fallback_value) const {
  if (!hasPointsOfInterest()) {
  return std::move(fallback_value);
}
return member_points_of_interest_;
}

void MediaTrackSettings::setPointsOfInterest(const HeapVector<Member<Point2D>>& value) {
  member_points_of_interest_ = value;
has_points_of_interest_ = true;
}

void MediaTrackSettings::setPointsOfInterest(HeapVector<Member<Point2D>>&& value) {
  member_points_of_interest_ = std::move(value);
has_points_of_interest_ = true;
}




String MediaTrackSettings::getResizeModeOr(const String& fallback_value) const {
  if (!hasResizeMode()) {
  return fallback_value;
}
return member_resize_mode_;
}

String MediaTrackSettings::getResizeModeOr(String&& fallback_value) const {
  if (!hasResizeMode()) {
  return std::move(fallback_value);
}
return member_resize_mode_;
}

void MediaTrackSettings::setResizeMode(const String& value) {
  member_resize_mode_ = value;
has_resize_mode_ = true;
}

void MediaTrackSettings::setResizeMode(String&& value) {
  member_resize_mode_ = std::move(value);
has_resize_mode_ = true;
}




























































String MediaTrackSettings::getWhiteBalanceModeOr(const String& fallback_value) const {
  if (!hasWhiteBalanceMode()) {
  return fallback_value;
}
return member_white_balance_mode_;
}

String MediaTrackSettings::getWhiteBalanceModeOr(String&& fallback_value) const {
  if (!hasWhiteBalanceMode()) {
  return std::move(fallback_value);
}
return member_white_balance_mode_;
}

void MediaTrackSettings::setWhiteBalanceMode(const String& value) {
  member_white_balance_mode_ = value;
has_white_balance_mode_ = true;
}

void MediaTrackSettings::setWhiteBalanceMode(String&& value) {
  member_white_balance_mode_ = std::move(value);
has_white_balance_mode_ = true;
}


















void MediaTrackSettings::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_aspect_ratio_);
TraceIfNeeded<bool>::Trace(visitor, member_auto_gain_control_);
TraceIfNeeded<bool>::Trace(visitor, member_background_blur_);
TraceIfNeeded<double>::Trace(visitor, member_brightness_);
TraceIfNeeded<int32_t>::Trace(visitor, member_channel_count_);
TraceIfNeeded<double>::Trace(visitor, member_color_temperature_);
TraceIfNeeded<double>::Trace(visitor, member_contrast_);
TraceIfNeeded<String>::Trace(visitor, member_cursor_);
TraceIfNeeded<String>::Trace(visitor, member_device_id_);
TraceIfNeeded<String>::Trace(visitor, member_display_surface_);
TraceIfNeeded<bool>::Trace(visitor, member_echo_cancellation_);
TraceIfNeeded<double>::Trace(visitor, member_exposure_compensation_);
TraceIfNeeded<String>::Trace(visitor, member_exposure_mode_);
TraceIfNeeded<double>::Trace(visitor, member_exposure_time_);
TraceIfNeeded<bool>::Trace(visitor, member_eye_gaze_correction_);
TraceIfNeeded<bool>::Trace(visitor, member_face_framing_);
TraceIfNeeded<String>::Trace(visitor, member_facing_mode_);
TraceIfNeeded<double>::Trace(visitor, member_focus_distance_);
TraceIfNeeded<String>::Trace(visitor, member_focus_mode_);
TraceIfNeeded<double>::Trace(visitor, member_frame_rate_);
TraceIfNeeded<String>::Trace(visitor, member_group_id_);
TraceIfNeeded<int32_t>::Trace(visitor, member_height_);
TraceIfNeeded<double>::Trace(visitor, member_iso_);
TraceIfNeeded<double>::Trace(visitor, member_latency_);
TraceIfNeeded<bool>::Trace(visitor, member_logical_surface_);
TraceIfNeeded<bool>::Trace(visitor, member_noise_suppression_);
TraceIfNeeded<double>::Trace(visitor, member_pan_);
TraceIfNeeded<HeapVector<Member<Point2D>>>::Trace(visitor, member_points_of_interest_);
TraceIfNeeded<String>::Trace(visitor, member_resize_mode_);
TraceIfNeeded<int32_t>::Trace(visitor, member_sample_rate_);
TraceIfNeeded<int32_t>::Trace(visitor, member_sample_size_);
TraceIfNeeded<double>::Trace(visitor, member_saturation_);
TraceIfNeeded<double>::Trace(visitor, member_sharpness_);
TraceIfNeeded<bool>::Trace(visitor, member_suppress_local_audio_playback_);
TraceIfNeeded<double>::Trace(visitor, member_tilt_);
TraceIfNeeded<bool>::Trace(visitor, member_torch_);
TraceIfNeeded<bool>::Trace(visitor, member_voice_isolation_);
TraceIfNeeded<String>::Trace(visitor, member_white_balance_mode_);
TraceIfNeeded<int32_t>::Trace(visitor, member_width_);
TraceIfNeeded<double>::Trace(visitor, member_zoom_);
bindings::DictionaryBase::Trace(visitor);
}

bool MediaTrackSettings::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAspectRatio()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_aspect_ratio_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasAutoGainControl()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_auto_gain_control_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
ExecutionContext* execution_context = ExecutionContext::From(current_context);
if (RuntimeEnabledFeatures::MediaCaptureBackgroundBlurEnabled(execution_context)) {
  if (hasBackgroundBlur()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_background_blur_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
}
if (hasBrightness()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_brightness_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasChannelCount()) {
  v8_value = ToV8Traits<IDLLong>::ToV8(script_state, member_channel_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasColorTemperature()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_color_temperature_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasContrast()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_contrast_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (RuntimeEnabledFeatures::GetDisplayMediaEnabled()) {
  if (hasCursor()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_cursor_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
}
if (hasDeviceId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_device_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[8].Get(isolate), v8_value).ToChecked();
}
if (RuntimeEnabledFeatures::GetDisplayMediaEnabled()) {
  if (hasDisplaySurface()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_display_surface_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[9].Get(isolate), v8_value).ToChecked();
}
}
if (hasEchoCancellation()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_echo_cancellation_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[10].Get(isolate), v8_value).ToChecked();
}
if (hasExposureCompensation()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_exposure_compensation_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[11].Get(isolate), v8_value).ToChecked();
}
if (hasExposureMode()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_exposure_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[12].Get(isolate), v8_value).ToChecked();
}
if (hasExposureTime()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_exposure_time_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[13].Get(isolate), v8_value).ToChecked();
}
if (RuntimeEnabledFeatures::MediaCaptureCameraControlsEnabled()) {
  if (hasEyeGazeCorrection()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_eye_gaze_correction_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[14].Get(isolate), v8_value).ToChecked();
}
}
if (RuntimeEnabledFeatures::MediaCaptureCameraControlsEnabled()) {
  if (hasFaceFraming()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_face_framing_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[15].Get(isolate), v8_value).ToChecked();
}
}
if (hasFacingMode()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_facing_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[16].Get(isolate), v8_value).ToChecked();
}
if (hasFocusDistance()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_focus_distance_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[17].Get(isolate), v8_value).ToChecked();
}
if (hasFocusMode()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_focus_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[18].Get(isolate), v8_value).ToChecked();
}
if (hasFrameRate()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_frame_rate_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[19].Get(isolate), v8_value).ToChecked();
}
if (hasGroupId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_group_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[20].Get(isolate), v8_value).ToChecked();
}
if (hasHeight()) {
  v8_value = ToV8Traits<IDLLong>::ToV8(script_state, member_height_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[21].Get(isolate), v8_value).ToChecked();
}
if (hasIso()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_iso_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[22].Get(isolate), v8_value).ToChecked();
}
if (hasLatency()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_latency_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[23].Get(isolate), v8_value).ToChecked();
}
if (RuntimeEnabledFeatures::GetDisplayMediaEnabled()) {
  if (hasLogicalSurface()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_logical_surface_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[24].Get(isolate), v8_value).ToChecked();
}
}
if (hasNoiseSuppression()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_noise_suppression_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[25].Get(isolate), v8_value).ToChecked();
}
if (hasPan()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_pan_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[26].Get(isolate), v8_value).ToChecked();
}
if (hasPointsOfInterest()) {
  v8_value = ToV8Traits<IDLSequence<Point2D>>::ToV8(script_state, member_points_of_interest_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[27].Get(isolate), v8_value).ToChecked();
}
if (hasResizeMode()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_resize_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[28].Get(isolate), v8_value).ToChecked();
}
if (hasSampleRate()) {
  v8_value = ToV8Traits<IDLLong>::ToV8(script_state, member_sample_rate_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[29].Get(isolate), v8_value).ToChecked();
}
if (hasSampleSize()) {
  v8_value = ToV8Traits<IDLLong>::ToV8(script_state, member_sample_size_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[30].Get(isolate), v8_value).ToChecked();
}
if (hasSaturation()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_saturation_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[31].Get(isolate), v8_value).ToChecked();
}
if (hasSharpness()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_sharpness_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[32].Get(isolate), v8_value).ToChecked();
}
if (RuntimeEnabledFeatures::GetDisplayMediaEnabled()) {
  if (hasSuppressLocalAudioPlayback()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_suppress_local_audio_playback_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[33].Get(isolate), v8_value).ToChecked();
}
}
if (hasTilt()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_tilt_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[34].Get(isolate), v8_value).ToChecked();
}
if (hasTorch()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_torch_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[35].Get(isolate), v8_value).ToChecked();
}
if (RuntimeEnabledFeatures::MediaCaptureVoiceIsolationEnabled()) {
  if (hasVoiceIsolation()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_voice_isolation_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[36].Get(isolate), v8_value).ToChecked();
}
}
if (hasWhiteBalanceMode()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_white_balance_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[37].Get(isolate), v8_value).ToChecked();
}
if (hasWidth()) {
  v8_value = ToV8Traits<IDLLong>::ToV8(script_state, member_width_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[38].Get(isolate), v8_value).ToChecked();
}
if (hasZoom()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_zoom_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[39].Get(isolate), v8_value).ToChecked();
}
return true;
}

void MediaTrackSettings::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MediaTrackSettings";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("aspectRatio");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_aspect_ratio_, member_aspect_ratio_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("autoGainControl");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_auto_gain_control_, member_auto_gain_control_, try_block, exception_state)) {
  return;
}
ExecutionContext* execution_context = ExecutionContext::From(current_context);
if (RuntimeEnabledFeatures::MediaCaptureBackgroundBlurEnabled(execution_context)) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("backgroundBlur");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_background_blur_, member_background_blur_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("brightness");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_brightness_, member_brightness_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("channelCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_channel_count_, member_channel_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("colorTemperature");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_color_temperature_, member_color_temperature_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("contrast");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_contrast_, member_contrast_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::GetDisplayMediaEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("cursor");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_cursor_, member_cursor_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("deviceId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_device_id_, member_device_id_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::GetDisplayMediaEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("displaySurface");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), has_display_surface_, member_display_surface_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("echoCancellation");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), has_echo_cancellation_, member_echo_cancellation_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("exposureCompensation");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), has_exposure_compensation_, member_exposure_compensation_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("exposureMode");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), has_exposure_mode_, member_exposure_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("exposureTime");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[13].Get(isolate), has_exposure_time_, member_exposure_time_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::MediaCaptureCameraControlsEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("eyeGazeCorrection");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[14].Get(isolate), has_eye_gaze_correction_, member_eye_gaze_correction_, try_block, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::MediaCaptureCameraControlsEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("faceFraming");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[15].Get(isolate), has_face_framing_, member_face_framing_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("facingMode");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[16].Get(isolate), has_facing_mode_, member_facing_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("focusDistance");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[17].Get(isolate), has_focus_distance_, member_focus_distance_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("focusMode");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[18].Get(isolate), has_focus_mode_, member_focus_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("frameRate");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[19].Get(isolate), has_frame_rate_, member_frame_rate_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("groupId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[20].Get(isolate), has_group_id_, member_group_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("height");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[21].Get(isolate), has_height_, member_height_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("iso");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[22].Get(isolate), has_iso_, member_iso_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("latency");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[23].Get(isolate), has_latency_, member_latency_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::GetDisplayMediaEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("logicalSurface");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[24].Get(isolate), has_logical_surface_, member_logical_surface_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("noiseSuppression");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[25].Get(isolate), has_noise_suppression_, member_noise_suppression_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("pan");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[26].Get(isolate), has_pan_, member_pan_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("pointsOfInterest");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<Point2D>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[27].Get(isolate), has_points_of_interest_, member_points_of_interest_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("resizeMode");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[28].Get(isolate), has_resize_mode_, member_resize_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sampleRate");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[29].Get(isolate), has_sample_rate_, member_sample_rate_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sampleSize");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[30].Get(isolate), has_sample_size_, member_sample_size_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("saturation");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[31].Get(isolate), has_saturation_, member_saturation_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sharpness");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[32].Get(isolate), has_sharpness_, member_sharpness_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::GetDisplayMediaEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("suppressLocalAudioPlayback");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[33].Get(isolate), has_suppress_local_audio_playback_, member_suppress_local_audio_playback_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("tilt");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[34].Get(isolate), has_tilt_, member_tilt_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("torch");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[35].Get(isolate), has_torch_, member_torch_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::MediaCaptureVoiceIsolationEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("voiceIsolation");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[36].Get(isolate), has_voice_isolation_, member_voice_isolation_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("whiteBalanceMode");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[37].Get(isolate), has_white_balance_mode_, member_white_balance_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("width");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[38].Get(isolate), has_width_, member_width_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("zoom");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[39].Get(isolate), has_zoom_, member_zoom_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MediaTrackSettings::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"aspectRatio",
"autoGainControl",
"backgroundBlur",
"brightness",
"channelCount",
"colorTemperature",
"contrast",
"cursor",
"deviceId",
"displaySurface",
"echoCancellation",
"exposureCompensation",
"exposureMode",
"exposureTime",
"eyeGazeCorrection",
"faceFraming",
"facingMode",
"focusDistance",
"focusMode",
"frameRate",
"groupId",
"height",
"iso",
"latency",
"logicalSurface",
"noiseSuppression",
"pan",
"pointsOfInterest",
"resizeMode",
"sampleRate",
"sampleSize",
"saturation",
"sharpness",
"suppressLocalAudioPlayback",
"tilt",
"torch",
"voiceIsolation",
"whiteBalanceMode",
"width",
"zoom",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
