// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_layer_normalization_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/ml/webnn/ml_operand.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



MLLayerNormalizationOptions* MLLayerNormalizationOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MLLayerNormalizationOptions* dictionary = MakeGarbageCollected<MLLayerNormalizationOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MLLayerNormalizationOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MLLayerNormalizationOptions::MLLayerNormalizationOptions() {
  
}

 MLLayerNormalizationOptions::MLLayerNormalizationOptions(v8::Isolate* isolate) {
  
}



Vector<uint32_t> MLLayerNormalizationOptions::getAxesOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasAxes()) {
  return fallback_value;
}
return member_axes_;
}

Vector<uint32_t> MLLayerNormalizationOptions::getAxesOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasAxes()) {
  return std::move(fallback_value);
}
return member_axes_;
}

void MLLayerNormalizationOptions::setAxes(const Vector<uint32_t>& value) {
  member_axes_ = value;
has_axes_ = true;
}

void MLLayerNormalizationOptions::setAxes(Vector<uint32_t>&& value) {
  member_axes_ = std::move(value);
has_axes_ = true;
}























void MLLayerNormalizationOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_axes_);
TraceIfNeeded<Member<MLOperand>>::Trace(visitor, member_bias_);
TraceIfNeeded<float>::Trace(visitor, member_epsilon_);
TraceIfNeeded<Member<MLOperand>>::Trace(visitor, member_scale_);
bindings::DictionaryBase::Trace(visitor);
}

bool MLLayerNormalizationOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAxes()) {
  v8_value = ToV8Traits<IDLSequence<IDLUnsignedLongEnforceRange>>::ToV8(script_state, member_axes_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasBias()) {
  v8_value = ToV8Traits<MLOperand>::ToV8(script_state, member_bias_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasEpsilon()) {
  v8_value = ToV8Traits<IDLFloat>::ToV8(script_state, member_epsilon_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasScale()) {
  v8_value = ToV8Traits<MLOperand>::ToV8(script_state, member_scale_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void MLLayerNormalizationOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MLLayerNormalizationOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("axes");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_axes_, member_axes_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("bias");
if (!bindings::GetDictionaryMemberFromV8Object<MLOperand, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_bias_, member_bias_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("epsilon");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_epsilon_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("scale");
if (!bindings::GetDictionaryMemberFromV8Object<MLOperand, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_scale_, member_scale_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MLLayerNormalizationOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"axes",
"bias",
"epsilon",
"scale",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
