// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_panner_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



PannerOptions* PannerOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PannerOptions* dictionary = MakeGarbageCollected<PannerOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PannerOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 PannerOptions::PannerOptions() {
  
}

 PannerOptions::PannerOptions(v8::Isolate* isolate) : AudioNodeOptions(isolate) {
  
}









































































void PannerOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_cone_inner_angle_);
TraceIfNeeded<double>::Trace(visitor, member_cone_outer_angle_);
TraceIfNeeded<double>::Trace(visitor, member_cone_outer_gain_);
TraceIfNeeded<V8DistanceModelType>::Trace(visitor, member_distance_model_);
TraceIfNeeded<double>::Trace(visitor, member_max_distance_);
TraceIfNeeded<float>::Trace(visitor, member_orientation_x_);
TraceIfNeeded<float>::Trace(visitor, member_orientation_y_);
TraceIfNeeded<float>::Trace(visitor, member_orientation_z_);
TraceIfNeeded<V8PanningModelType>::Trace(visitor, member_panning_model_);
TraceIfNeeded<float>::Trace(visitor, member_position_x_);
TraceIfNeeded<float>::Trace(visitor, member_position_y_);
TraceIfNeeded<float>::Trace(visitor, member_position_z_);
TraceIfNeeded<double>::Trace(visitor, member_ref_distance_);
TraceIfNeeded<double>::Trace(visitor, member_rolloff_factor_);
AudioNodeOptions::Trace(visitor);
}

bool PannerOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!AudioNodeOptions::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasConeInnerAngle()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_cone_inner_angle_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasConeOuterAngle()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_cone_outer_angle_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasConeOuterGain()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_cone_outer_gain_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasDistanceModel()) {
  v8_value = ToV8Traits<V8DistanceModelType>::ToV8(script_state, member_distance_model_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasMaxDistance()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_max_distance_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasOrientationX()) {
  v8_value = ToV8Traits<IDLFloat>::ToV8(script_state, member_orientation_x_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasOrientationY()) {
  v8_value = ToV8Traits<IDLFloat>::ToV8(script_state, member_orientation_y_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (hasOrientationZ()) {
  v8_value = ToV8Traits<IDLFloat>::ToV8(script_state, member_orientation_z_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
if (hasPanningModel()) {
  v8_value = ToV8Traits<V8PanningModelType>::ToV8(script_state, member_panning_model_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[8].Get(isolate), v8_value).ToChecked();
}
if (hasPositionX()) {
  v8_value = ToV8Traits<IDLFloat>::ToV8(script_state, member_position_x_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[9].Get(isolate), v8_value).ToChecked();
}
if (hasPositionY()) {
  v8_value = ToV8Traits<IDLFloat>::ToV8(script_state, member_position_y_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[10].Get(isolate), v8_value).ToChecked();
}
if (hasPositionZ()) {
  v8_value = ToV8Traits<IDLFloat>::ToV8(script_state, member_position_z_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[11].Get(isolate), v8_value).ToChecked();
}
if (hasRefDistance()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_ref_distance_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[12].Get(isolate), v8_value).ToChecked();
}
if (hasRolloffFactor()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_rolloff_factor_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[13].Get(isolate), v8_value).ToChecked();
}
return true;
}

void PannerOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  AudioNodeOptions::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "PannerOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("coneInnerAngle");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_cone_inner_angle_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("coneOuterAngle");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_cone_outer_angle_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("coneOuterGain");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_cone_outer_gain_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("distanceModel");
if (!bindings::GetDictionaryMemberFromV8Object<V8DistanceModelType, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_distance_model_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("maxDistance");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_max_distance_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("orientationX");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_orientation_x_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("orientationY");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_orientation_y_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("orientationZ");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_orientation_z_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("panningModel");
if (!bindings::GetDictionaryMemberFromV8Object<V8PanningModelType, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), fallback_presence_var, member_panning_model_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("positionX");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), fallback_presence_var, member_position_x_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("positionY");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), fallback_presence_var, member_position_y_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("positionZ");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), fallback_presence_var, member_position_z_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("refDistance");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), fallback_presence_var, member_ref_distance_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rolloffFactor");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[13].Get(isolate), fallback_presence_var, member_rolloff_factor_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PannerOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"coneInnerAngle",
"coneOuterAngle",
"coneOuterGain",
"distanceModel",
"maxDistance",
"orientationX",
"orientationY",
"orientationZ",
"panningModel",
"positionX",
"positionY",
"positionZ",
"refDistance",
"rolloffFactor",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
