// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_payment_details_modifier.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_payment_item.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



PaymentDetailsModifier* PaymentDetailsModifier::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PaymentDetailsModifier* dictionary = MakeGarbageCollected<PaymentDetailsModifier>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PaymentDetailsModifier";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 PaymentDetailsModifier::PaymentDetailsModifier() {
  
}

 PaymentDetailsModifier::PaymentDetailsModifier(v8::Isolate* isolate) {
  
}



HeapVector<Member<PaymentItem>> PaymentDetailsModifier::getAdditionalDisplayItemsOr(const HeapVector<Member<PaymentItem>>& fallback_value) const {
  if (!hasAdditionalDisplayItems()) {
  return fallback_value;
}
return member_additional_display_items_;
}

HeapVector<Member<PaymentItem>> PaymentDetailsModifier::getAdditionalDisplayItemsOr(HeapVector<Member<PaymentItem>>&& fallback_value) const {
  if (!hasAdditionalDisplayItems()) {
  return std::move(fallback_value);
}
return member_additional_display_items_;
}

void PaymentDetailsModifier::setAdditionalDisplayItems(const HeapVector<Member<PaymentItem>>& value) {
  member_additional_display_items_ = value;
has_additional_display_items_ = true;
}

void PaymentDetailsModifier::setAdditionalDisplayItems(HeapVector<Member<PaymentItem>>&& value) {
  member_additional_display_items_ = std::move(value);
has_additional_display_items_ = true;
}











void PaymentDetailsModifier::setSupportedMethod(const String& value) {
  member_supported_method_ = value;
}

void PaymentDetailsModifier::setSupportedMethod(String&& value) {
  member_supported_method_ = std::move(value);
}











void PaymentDetailsModifier::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<PaymentItem>>>::Trace(visitor, member_additional_display_items_);
TraceIfNeeded<ScriptValue>::Trace(visitor, member_data_);
TraceIfNeeded<String>::Trace(visitor, member_supported_method_);
TraceIfNeeded<Member<PaymentItem>>::Trace(visitor, member_total_);
bindings::DictionaryBase::Trace(visitor);
}

bool PaymentDetailsModifier::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAdditionalDisplayItems()) {
  v8_value = ToV8Traits<IDLSequence<PaymentItem>>::ToV8(script_state, member_additional_display_items_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasData()) {
  v8_value = ToV8Traits<IDLObject>::ToV8(script_state, member_data_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasSupportedMethod()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_supported_method_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasTotal()) {
  v8_value = ToV8Traits<PaymentItem>::ToV8(script_state, member_total_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void PaymentDetailsModifier::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "PaymentDetailsModifier";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("additionalDisplayItems");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<PaymentItem>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_additional_display_items_, member_additional_display_items_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("data");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLObject, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_data_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("supportedMethods");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_supported_method_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("total");
if (!bindings::GetDictionaryMemberFromV8Object<PaymentItem, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_total_, member_total_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PaymentDetailsModifier::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"additionalDisplayItems",
"data",
"supportedMethods",
"total",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
