// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_payment_instrument.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_image_object.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



PaymentInstrument* PaymentInstrument::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PaymentInstrument* dictionary = MakeGarbageCollected<PaymentInstrument>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PaymentInstrument";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 PaymentInstrument::PaymentInstrument() {
  
}

 PaymentInstrument::PaymentInstrument(v8::Isolate* isolate) {
  
}










HeapVector<Member<ImageObject>> PaymentInstrument::getIconsOr(const HeapVector<Member<ImageObject>>& fallback_value) const {
  if (!hasIcons()) {
  return fallback_value;
}
return member_icons_;
}

HeapVector<Member<ImageObject>> PaymentInstrument::getIconsOr(HeapVector<Member<ImageObject>>&& fallback_value) const {
  if (!hasIcons()) {
  return std::move(fallback_value);
}
return member_icons_;
}

void PaymentInstrument::setIcons(const HeapVector<Member<ImageObject>>& value) {
  member_icons_ = value;
has_icons_ = true;
}

void PaymentInstrument::setIcons(HeapVector<Member<ImageObject>>&& value) {
  member_icons_ = std::move(value);
has_icons_ = true;
}




String PaymentInstrument::getMethodOr(const String& fallback_value) const {
  if (!hasMethod()) {
  return fallback_value;
}
return member_method_;
}

String PaymentInstrument::getMethodOr(String&& fallback_value) const {
  if (!hasMethod()) {
  return std::move(fallback_value);
}
return member_method_;
}

void PaymentInstrument::setMethod(const String& value) {
  member_method_ = value;
has_method_ = true;
}

void PaymentInstrument::setMethod(String&& value) {
  member_method_ = std::move(value);
has_method_ = true;
}




void PaymentInstrument::setName(const String& value) {
  member_name_ = value;
}

void PaymentInstrument::setName(String&& value) {
  member_name_ = std::move(value);
}




void PaymentInstrument::Trace(Visitor* visitor) const {
  TraceIfNeeded<ScriptValue>::Trace(visitor, member_capabilities_);
TraceIfNeeded<HeapVector<Member<ImageObject>>>::Trace(visitor, member_icons_);
TraceIfNeeded<String>::Trace(visitor, member_method_);
TraceIfNeeded<String>::Trace(visitor, member_name_);
bindings::DictionaryBase::Trace(visitor);
}

bool PaymentInstrument::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasCapabilities()) {
  v8_value = ToV8Traits<IDLObject>::ToV8(script_state, member_capabilities_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasIcons()) {
  v8_value = ToV8Traits<IDLSequence<ImageObject>>::ToV8(script_state, member_icons_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasMethod()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_method_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasName()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_name_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void PaymentInstrument::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "PaymentInstrument";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("capabilities");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLObject, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_capabilities_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("icons");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<ImageObject>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_icons_, member_icons_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("method");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_method_, member_method_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("name");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_name_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PaymentInstrument::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"capabilities",
"icons",
"method",
"name",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
