// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_request_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_arraybuffer_arraybufferview.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_client_inputs.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_descriptor.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



PublicKeyCredentialRequestOptions* PublicKeyCredentialRequestOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PublicKeyCredentialRequestOptions* dictionary = MakeGarbageCollected<PublicKeyCredentialRequestOptions>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PublicKeyCredentialRequestOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 PublicKeyCredentialRequestOptions::PublicKeyCredentialRequestOptions() {
  
}

 PublicKeyCredentialRequestOptions::PublicKeyCredentialRequestOptions(v8::Isolate* isolate) {
  
}



void PublicKeyCredentialRequestOptions::setAllowCredentials(const HeapVector<Member<PublicKeyCredentialDescriptor>>& value) {
  member_allow_credentials_ = value;
}

void PublicKeyCredentialRequestOptions::setAllowCredentials(HeapVector<Member<PublicKeyCredentialDescriptor>>&& value) {
  member_allow_credentials_ = std::move(value);
}
















void PublicKeyCredentialRequestOptions::setHints(const Vector<String>& value) {
  member_hints_ = value;
}

void PublicKeyCredentialRequestOptions::setHints(Vector<String>&& value) {
  member_hints_ = std::move(value);
}




String PublicKeyCredentialRequestOptions::getRpIdOr(const String& fallback_value) const {
  if (!hasRpId()) {
  return fallback_value;
}
return member_rp_id_;
}

String PublicKeyCredentialRequestOptions::getRpIdOr(String&& fallback_value) const {
  if (!hasRpId()) {
  return std::move(fallback_value);
}
return member_rp_id_;
}

void PublicKeyCredentialRequestOptions::setRpId(const String& value) {
  member_rp_id_ = value;
has_rp_id_ = true;
}

void PublicKeyCredentialRequestOptions::setRpId(String&& value) {
  member_rp_id_ = std::move(value);
has_rp_id_ = true;
}











String PublicKeyCredentialRequestOptions::getUserVerificationOr(const String& fallback_value) const {
  if (!hasUserVerification()) {
  return fallback_value;
}
return member_user_verification_;
}

String PublicKeyCredentialRequestOptions::getUserVerificationOr(String&& fallback_value) const {
  if (!hasUserVerification()) {
  return std::move(fallback_value);
}
return member_user_verification_;
}

void PublicKeyCredentialRequestOptions::setUserVerification(const String& value) {
  member_user_verification_ = value;
has_user_verification_ = true;
}

void PublicKeyCredentialRequestOptions::setUserVerification(String&& value) {
  member_user_verification_ = std::move(value);
has_user_verification_ = true;
}




void PublicKeyCredentialRequestOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<PublicKeyCredentialDescriptor>>>::Trace(visitor, member_allow_credentials_);
TraceIfNeeded<Member<V8UnionArrayBufferOrArrayBufferView>>::Trace(visitor, member_challenge_);
TraceIfNeeded<Member<AuthenticationExtensionsClientInputs>>::Trace(visitor, member_extensions_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_hints_);
TraceIfNeeded<String>::Trace(visitor, member_rp_id_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_timeout_);
TraceIfNeeded<String>::Trace(visitor, member_user_verification_);
bindings::DictionaryBase::Trace(visitor);
}

bool PublicKeyCredentialRequestOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAllowCredentials()) {
  v8_value = ToV8Traits<IDLSequence<PublicKeyCredentialDescriptor>>::ToV8(script_state, member_allow_credentials_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasChallenge()) {
  v8_value = ToV8Traits<V8UnionArrayBufferOrArrayBufferView>::ToV8(script_state, member_challenge_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasExtensions()) {
  v8_value = ToV8Traits<AuthenticationExtensionsClientInputs>::ToV8(script_state, member_extensions_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (RuntimeEnabledFeatures::WebAuthenticationHintsEnabled()) {
  if (hasHints()) {
  v8_value = ToV8Traits<IDLSequence<IDLString>>::ToV8(script_state, member_hints_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
}
if (hasRpId()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_rp_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasTimeout()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_timeout_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasUserVerification()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_user_verification_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
return true;
}

void PublicKeyCredentialRequestOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "PublicKeyCredentialRequestOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("allowCredentials");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<PublicKeyCredentialDescriptor>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_allow_credentials_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("challenge");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionArrayBufferOrArrayBufferView, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_challenge_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("extensions");
if (!bindings::GetDictionaryMemberFromV8Object<AuthenticationExtensionsClientInputs, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_extensions_, member_extensions_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::WebAuthenticationHintsEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("hints");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_hints_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rpId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_rp_id_, member_rp_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("timeout");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_timeout_, member_timeout_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("userVerification");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_user_verification_, member_user_verification_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PublicKeyCredentialRequestOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"allowCredentials",
"challenge",
"extensions",
"hints",
"rpId",
"timeout",
"userVerification",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
