// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_registration_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RegistrationOptions* RegistrationOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RegistrationOptions* dictionary = MakeGarbageCollected<RegistrationOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RegistrationOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RegistrationOptions::RegistrationOptions() {
  
}

 RegistrationOptions::RegistrationOptions(v8::Isolate* isolate) {
  
}



String RegistrationOptions::getScopeOr(const String& fallback_value) const {
  if (!hasScope()) {
  return fallback_value;
}
return member_scope_;
}

String RegistrationOptions::getScopeOr(String&& fallback_value) const {
  if (!hasScope()) {
  return std::move(fallback_value);
}
return member_scope_;
}

void RegistrationOptions::setScope(const String& value) {
  member_scope_ = value;
has_scope_ = true;
}

void RegistrationOptions::setScope(String&& value) {
  member_scope_ = std::move(value);
has_scope_ = true;
}














void RegistrationOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_scope_);
TraceIfNeeded<V8WorkerType>::Trace(visitor, member_type_);
TraceIfNeeded<V8ServiceWorkerUpdateViaCache>::Trace(visitor, member_update_via_cache_);
bindings::DictionaryBase::Trace(visitor);
}

bool RegistrationOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasScope()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_scope_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasType()) {
  v8_value = ToV8Traits<V8WorkerType>::ToV8(script_state, member_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasUpdateViaCache()) {
  v8_value = ToV8Traits<V8ServiceWorkerUpdateViaCache>::ToV8(script_state, member_update_via_cache_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RegistrationOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "RegistrationOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("scope");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_scope_, member_scope_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("type");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8WorkerType, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("updateViaCache");
if (!bindings::GetDictionaryMemberFromV8Object<V8ServiceWorkerUpdateViaCache, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_update_via_cache_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RegistrationOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"scope",
"type",
"updateViaCache",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
