// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_audio_playout_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCAudioPlayoutStats* RTCAudioPlayoutStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCAudioPlayoutStats* dictionary = MakeGarbageCollected<RTCAudioPlayoutStats>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCAudioPlayoutStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCAudioPlayoutStats::RTCAudioPlayoutStats() {
  
}

 RTCAudioPlayoutStats::RTCAudioPlayoutStats(v8::Isolate* isolate) : RTCStats(isolate) {
  
}



void RTCAudioPlayoutStats::setKind(const String& value) {
  member_kind_ = value;
}

void RTCAudioPlayoutStats::setKind(String&& value) {
  member_kind_ = std::move(value);
}







































void RTCAudioPlayoutStats::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_kind_);
TraceIfNeeded<double>::Trace(visitor, member_synthesized_samples_duration_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_synthesized_samples_events_);
TraceIfNeeded<double>::Trace(visitor, member_total_playout_delay_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_total_samples_count_);
TraceIfNeeded<double>::Trace(visitor, member_total_samples_duration_);
RTCStats::Trace(visitor);
}

bool RTCAudioPlayoutStats::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!RTCStats::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasKind()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_kind_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasSynthesizedSamplesDuration()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_synthesized_samples_duration_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasSynthesizedSamplesEvents()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_synthesized_samples_events_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasTotalPlayoutDelay()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_playout_delay_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasTotalSamplesCount()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_total_samples_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasTotalSamplesDuration()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_samples_duration_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCAudioPlayoutStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  RTCStats::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCAudioPlayoutStats";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("kind");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_kind_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("synthesizedSamplesDuration");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_synthesized_samples_duration_, member_synthesized_samples_duration_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("synthesizedSamplesEvents");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_synthesized_samples_events_, member_synthesized_samples_events_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalPlayoutDelay");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_total_playout_delay_, member_total_playout_delay_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalSamplesCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_total_samples_count_, member_total_samples_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalSamplesDuration");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_total_samples_duration_, member_total_samples_duration_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCAudioPlayoutStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"kind",
"synthesizedSamplesDuration",
"synthesizedSamplesEvents",
"totalPlayoutDelay",
"totalSamplesCount",
"totalSamplesDuration",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
