// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_data_channel_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCDataChannelStats* RTCDataChannelStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCDataChannelStats* dictionary = MakeGarbageCollected<RTCDataChannelStats>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCDataChannelStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCDataChannelStats::RTCDataChannelStats() {
  
}

 RTCDataChannelStats::RTCDataChannelStats(v8::Isolate* isolate) : RTCStats(isolate) {
  
}
























String RTCDataChannelStats::getLabelOr(const String& fallback_value) const {
  if (!hasLabel()) {
  return fallback_value;
}
return member_label_;
}

String RTCDataChannelStats::getLabelOr(String&& fallback_value) const {
  if (!hasLabel()) {
  return std::move(fallback_value);
}
return member_label_;
}

void RTCDataChannelStats::setLabel(const String& value) {
  member_label_ = value;
has_label_ = true;
}

void RTCDataChannelStats::setLabel(String&& value) {
  member_label_ = std::move(value);
has_label_ = true;
}


















String RTCDataChannelStats::getProtocolOr(const String& fallback_value) const {
  if (!hasProtocol()) {
  return fallback_value;
}
return member_protocol_;
}

String RTCDataChannelStats::getProtocolOr(String&& fallback_value) const {
  if (!hasProtocol()) {
  return std::move(fallback_value);
}
return member_protocol_;
}

void RTCDataChannelStats::setProtocol(const String& value) {
  member_protocol_ = value;
has_protocol_ = true;
}

void RTCDataChannelStats::setProtocol(String&& value) {
  member_protocol_ = std::move(value);
has_protocol_ = true;
}









void RTCDataChannelStats::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint64_t>::Trace(visitor, member_bytes_received_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_bytes_sent_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_data_channel_identifier_);
TraceIfNeeded<String>::Trace(visitor, member_label_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_messages_received_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_messages_sent_);
TraceIfNeeded<String>::Trace(visitor, member_protocol_);
TraceIfNeeded<V8RTCDataChannelState>::Trace(visitor, member_state_);
RTCStats::Trace(visitor);
}

bool RTCDataChannelStats::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!RTCStats::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasBytesReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_bytes_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasBytesSent()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_bytes_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasDataChannelIdentifier()) {
  v8_value = ToV8Traits<IDLUnsignedShort>::ToV8(script_state, member_data_channel_identifier_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasLabel()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_label_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasMessagesReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_messages_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasMessagesSent()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_messages_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasProtocol()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_protocol_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (hasState()) {
  v8_value = ToV8Traits<V8RTCDataChannelState>::ToV8(script_state, member_state_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCDataChannelStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  RTCStats::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCDataChannelStats";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("bytesReceived");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_bytes_received_, member_bytes_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("bytesSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_bytes_sent_, member_bytes_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("dataChannelIdentifier");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_data_channel_identifier_, member_data_channel_identifier_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("label");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_label_, member_label_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("messagesReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_messages_received_, member_messages_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("messagesSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_messages_sent_, member_messages_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("protocol");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_protocol_, member_protocol_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("state");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCDataChannelState, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_state_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCDataChannelStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"bytesReceived",
"bytesSent",
"dataChannelIdentifier",
"label",
"messagesReceived",
"messagesSent",
"protocol",
"state",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
