// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_encoded_audio_frame_metadata.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/execution_context/execution_context.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCEncodedAudioFrameMetadata* RTCEncodedAudioFrameMetadata::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCEncodedAudioFrameMetadata* dictionary = MakeGarbageCollected<RTCEncodedAudioFrameMetadata>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCEncodedAudioFrameMetadata";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCEncodedAudioFrameMetadata::RTCEncodedAudioFrameMetadata() {
  
}

 RTCEncodedAudioFrameMetadata::RTCEncodedAudioFrameMetadata(v8::Isolate* isolate) {
  
}










Vector<uint32_t> RTCEncodedAudioFrameMetadata::getContributingSourcesOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasContributingSources()) {
  return fallback_value;
}
return member_contributing_sources_;
}

Vector<uint32_t> RTCEncodedAudioFrameMetadata::getContributingSourcesOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasContributingSources()) {
  return std::move(fallback_value);
}
return member_contributing_sources_;
}

void RTCEncodedAudioFrameMetadata::setContributingSources(const Vector<uint32_t>& value) {
  member_contributing_sources_ = value;
has_contributing_sources_ = true;
}

void RTCEncodedAudioFrameMetadata::setContributingSources(Vector<uint32_t>&& value) {
  member_contributing_sources_ = std::move(value);
has_contributing_sources_ = true;
}




String RTCEncodedAudioFrameMetadata::getMimeTypeOr(const String& fallback_value) const {
  if (!hasMimeType()) {
  return fallback_value;
}
return member_mime_type_;
}

String RTCEncodedAudioFrameMetadata::getMimeTypeOr(String&& fallback_value) const {
  if (!hasMimeType()) {
  return std::move(fallback_value);
}
return member_mime_type_;
}

void RTCEncodedAudioFrameMetadata::setMimeType(const String& value) {
  member_mime_type_ = value;
has_mime_type_ = true;
}

void RTCEncodedAudioFrameMetadata::setMimeType(String&& value) {
  member_mime_type_ = std::move(value);
has_mime_type_ = true;
}
































void RTCEncodedAudioFrameMetadata::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint64_t>::Trace(visitor, member_abs_capture_time_);
TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_contributing_sources_);
TraceIfNeeded<String>::Trace(visitor, member_mime_type_);
TraceIfNeeded<uint8_t>::Trace(visitor, member_payload_type_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_rtp_timestamp_);
TraceIfNeeded<absl::optional<uint16_t>>::Trace(visitor, member_sequence_number_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_synchronization_source_);
bindings::DictionaryBase::Trace(visitor);
}

bool RTCEncodedAudioFrameMetadata::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (RuntimeEnabledFeatures::RTCEncodedAudioFrameAbsCaptureTimeEnabled()) {
  if (hasAbsCaptureTime()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_abs_capture_time_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
}
if (hasContributingSources()) {
  v8_value = ToV8Traits<IDLSequence<IDLUnsignedLong>>::ToV8(script_state, member_contributing_sources_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasMimeType()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_mime_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasPayloadType()) {
  v8_value = ToV8Traits<IDLOctet>::ToV8(script_state, member_payload_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
ExecutionContext* execution_context = ExecutionContext::From(current_context);
if (RuntimeEnabledFeatures::RTCEncodedFrameSetMetadataEnabled(execution_context)) {
  if (hasRtpTimestamp()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_rtp_timestamp_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
}
if (hasSequenceNumber()) {
  v8_value = ToV8Traits<IDLNullable<IDLUnsignedShort>>::ToV8(script_state, member_sequence_number_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasSynchronizationSource()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_synchronization_source_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCEncodedAudioFrameMetadata::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "RTCEncodedAudioFrameMetadata";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (RuntimeEnabledFeatures::RTCEncodedAudioFrameAbsCaptureTimeEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("absCaptureTime");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_abs_capture_time_, member_abs_capture_time_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("contributingSources");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLong>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_contributing_sources_, member_contributing_sources_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mimeType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_mime_type_, member_mime_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("payloadType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLOctet, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_payload_type_, member_payload_type_, try_block, exception_state)) {
  return;
}
ExecutionContext* execution_context = ExecutionContext::From(current_context);
if (RuntimeEnabledFeatures::RTCEncodedFrameSetMetadataEnabled(execution_context)) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("rtpTimestamp");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_rtp_timestamp_, member_rtp_timestamp_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sequenceNumber");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLUnsignedShort>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_sequence_number_, member_sequence_number_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("synchronizationSource");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_synchronization_source_, member_synchronization_source_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCEncodedAudioFrameMetadata::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"absCaptureTime",
"contributingSources",
"mimeType",
"payloadType",
"rtpTimestamp",
"sequenceNumber",
"synchronizationSource",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
