// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_ice_candidate_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCIceCandidateInit* RTCIceCandidateInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCIceCandidateInit* dictionary = MakeGarbageCollected<RTCIceCandidateInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCIceCandidateInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCIceCandidateInit::RTCIceCandidateInit() {
  
}

 RTCIceCandidateInit::RTCIceCandidateInit(v8::Isolate* isolate) {
  
}



void RTCIceCandidateInit::setCandidate(const String& value) {
  member_candidate_ = value;
}

void RTCIceCandidateInit::setCandidate(String&& value) {
  member_candidate_ = std::move(value);
}









void RTCIceCandidateInit::setSdpMid(const String& value) {
  member_sdp_mid_ = value;
}

void RTCIceCandidateInit::setSdpMid(String&& value) {
  member_sdp_mid_ = std::move(value);
}




void RTCIceCandidateInit::setUsernameFragment(const String& value) {
  member_username_fragment_ = value;
}

void RTCIceCandidateInit::setUsernameFragment(String&& value) {
  member_username_fragment_ = std::move(value);
}




void RTCIceCandidateInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_candidate_);
TraceIfNeeded<absl::optional<uint16_t>>::Trace(visitor, member_sdp_m_line_index_);
TraceIfNeeded<String>::Trace(visitor, member_sdp_mid_);
TraceIfNeeded<String>::Trace(visitor, member_username_fragment_);
bindings::DictionaryBase::Trace(visitor);
}

bool RTCIceCandidateInit::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasCandidate()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_candidate_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasSdpMLineIndex()) {
  v8_value = ToV8Traits<IDLNullable<IDLUnsignedShort>>::ToV8(script_state, member_sdp_m_line_index_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasSdpMid()) {
  v8_value = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_sdp_mid_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasUsernameFragment()) {
  v8_value = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_username_fragment_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCIceCandidateInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "RTCIceCandidateInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("candidate");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_candidate_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sdpMLineIndex");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLUnsignedShort>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_sdp_m_line_index_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sdpMid");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_sdp_mid_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("usernameFragment");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_username_fragment_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCIceCandidateInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"candidate",
"sdpMLineIndex",
"sdpMid",
"usernameFragment",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
