// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_ice_candidate_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCIceCandidateStats* RTCIceCandidateStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCIceCandidateStats* dictionary = MakeGarbageCollected<RTCIceCandidateStats>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCIceCandidateStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCIceCandidateStats::RTCIceCandidateStats() {
  
}

 RTCIceCandidateStats::RTCIceCandidateStats(v8::Isolate* isolate) : RTCStats(isolate) {
  
}



String RTCIceCandidateStats::getAddressOr(const String& fallback_value) const {
  if (!hasAddress()) {
  return fallback_value;
}
return member_address_;
}

String RTCIceCandidateStats::getAddressOr(String&& fallback_value) const {
  if (!hasAddress()) {
  return std::move(fallback_value);
}
return member_address_;
}

void RTCIceCandidateStats::setAddress(const String& value) {
  member_address_ = value;
has_address_ = true;
}

void RTCIceCandidateStats::setAddress(String&& value) {
  member_address_ = std::move(value);
has_address_ = true;
}









String RTCIceCandidateStats::getFoundationOr(const String& fallback_value) const {
  if (!hasFoundation()) {
  return fallback_value;
}
return member_foundation_;
}

String RTCIceCandidateStats::getFoundationOr(String&& fallback_value) const {
  if (!hasFoundation()) {
  return std::move(fallback_value);
}
return member_foundation_;
}

void RTCIceCandidateStats::setFoundation(const String& value) {
  member_foundation_ = value;
has_foundation_ = true;
}

void RTCIceCandidateStats::setFoundation(String&& value) {
  member_foundation_ = std::move(value);
has_foundation_ = true;
}




String RTCIceCandidateStats::getIpOr(const String& fallback_value) const {
  if (!hasIp()) {
  return fallback_value;
}
return member_ip_;
}

String RTCIceCandidateStats::getIpOr(String&& fallback_value) const {
  if (!hasIp()) {
  return std::move(fallback_value);
}
return member_ip_;
}

void RTCIceCandidateStats::setIp(const String& value) {
  member_ip_ = value;
has_ip_ = true;
}

void RTCIceCandidateStats::setIp(String&& value) {
  member_ip_ = std::move(value);
has_ip_ = true;
}
































String RTCIceCandidateStats::getProtocolOr(const String& fallback_value) const {
  if (!hasProtocol()) {
  return fallback_value;
}
return member_protocol_;
}

String RTCIceCandidateStats::getProtocolOr(String&& fallback_value) const {
  if (!hasProtocol()) {
  return std::move(fallback_value);
}
return member_protocol_;
}

void RTCIceCandidateStats::setProtocol(const String& value) {
  member_protocol_ = value;
has_protocol_ = true;
}

void RTCIceCandidateStats::setProtocol(String&& value) {
  member_protocol_ = std::move(value);
has_protocol_ = true;
}




String RTCIceCandidateStats::getRelatedAddressOr(const String& fallback_value) const {
  if (!hasRelatedAddress()) {
  return fallback_value;
}
return member_related_address_;
}

String RTCIceCandidateStats::getRelatedAddressOr(String&& fallback_value) const {
  if (!hasRelatedAddress()) {
  return std::move(fallback_value);
}
return member_related_address_;
}

void RTCIceCandidateStats::setRelatedAddress(const String& value) {
  member_related_address_ = value;
has_related_address_ = true;
}

void RTCIceCandidateStats::setRelatedAddress(String&& value) {
  member_related_address_ = std::move(value);
has_related_address_ = true;
}

























void RTCIceCandidateStats::setTransportId(const String& value) {
  member_transport_id_ = value;
}

void RTCIceCandidateStats::setTransportId(String&& value) {
  member_transport_id_ = std::move(value);
}




String RTCIceCandidateStats::getUrlOr(const String& fallback_value) const {
  if (!hasUrl()) {
  return fallback_value;
}
return member_url_;
}

String RTCIceCandidateStats::getUrlOr(String&& fallback_value) const {
  if (!hasUrl()) {
  return std::move(fallback_value);
}
return member_url_;
}

void RTCIceCandidateStats::setUrl(const String& value) {
  member_url_ = value;
has_url_ = true;
}

void RTCIceCandidateStats::setUrl(String&& value) {
  member_url_ = std::move(value);
has_url_ = true;
}




String RTCIceCandidateStats::getUsernameFragmentOr(const String& fallback_value) const {
  if (!hasUsernameFragment()) {
  return fallback_value;
}
return member_username_fragment_;
}

String RTCIceCandidateStats::getUsernameFragmentOr(String&& fallback_value) const {
  if (!hasUsernameFragment()) {
  return std::move(fallback_value);
}
return member_username_fragment_;
}

void RTCIceCandidateStats::setUsernameFragment(const String& value) {
  member_username_fragment_ = value;
has_username_fragment_ = true;
}

void RTCIceCandidateStats::setUsernameFragment(String&& value) {
  member_username_fragment_ = std::move(value);
has_username_fragment_ = true;
}




void RTCIceCandidateStats::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_address_);
TraceIfNeeded<V8RTCIceCandidateType>::Trace(visitor, member_candidate_type_);
TraceIfNeeded<String>::Trace(visitor, member_foundation_);
TraceIfNeeded<String>::Trace(visitor, member_ip_);
TraceIfNeeded<bool>::Trace(visitor, member_is_remote_);
TraceIfNeeded<V8RTCNetworkType>::Trace(visitor, member_network_type_);
TraceIfNeeded<int32_t>::Trace(visitor, member_port_);
TraceIfNeeded<int32_t>::Trace(visitor, member_priority_);
TraceIfNeeded<String>::Trace(visitor, member_protocol_);
TraceIfNeeded<String>::Trace(visitor, member_related_address_);
TraceIfNeeded<int32_t>::Trace(visitor, member_related_port_);
TraceIfNeeded<V8RTCIceServerTransportProtocol>::Trace(visitor, member_relay_protocol_);
TraceIfNeeded<V8RTCIceTcpCandidateType>::Trace(visitor, member_tcp_type_);
TraceIfNeeded<String>::Trace(visitor, member_transport_id_);
TraceIfNeeded<String>::Trace(visitor, member_url_);
TraceIfNeeded<String>::Trace(visitor, member_username_fragment_);
RTCStats::Trace(visitor);
}

bool RTCIceCandidateStats::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!RTCStats::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAddress()) {
  v8_value = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_address_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasCandidateType()) {
  v8_value = ToV8Traits<V8RTCIceCandidateType>::ToV8(script_state, member_candidate_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasFoundation()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_foundation_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasIp()) {
  v8_value = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_ip_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasIsRemote()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_is_remote_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasNetworkType()) {
  v8_value = ToV8Traits<V8RTCNetworkType>::ToV8(script_state, member_network_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasPort()) {
  v8_value = ToV8Traits<IDLLong>::ToV8(script_state, member_port_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (hasPriority()) {
  v8_value = ToV8Traits<IDLLong>::ToV8(script_state, member_priority_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
if (hasProtocol()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_protocol_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[8].Get(isolate), v8_value).ToChecked();
}
if (hasRelatedAddress()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_related_address_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[9].Get(isolate), v8_value).ToChecked();
}
if (hasRelatedPort()) {
  v8_value = ToV8Traits<IDLLong>::ToV8(script_state, member_related_port_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[10].Get(isolate), v8_value).ToChecked();
}
if (hasRelayProtocol()) {
  v8_value = ToV8Traits<V8RTCIceServerTransportProtocol>::ToV8(script_state, member_relay_protocol_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[11].Get(isolate), v8_value).ToChecked();
}
if (hasTcpType()) {
  v8_value = ToV8Traits<V8RTCIceTcpCandidateType>::ToV8(script_state, member_tcp_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[12].Get(isolate), v8_value).ToChecked();
}
if (hasTransportId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_transport_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[13].Get(isolate), v8_value).ToChecked();
}
if (hasUrl()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_url_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[14].Get(isolate), v8_value).ToChecked();
}
if (hasUsernameFragment()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_username_fragment_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[15].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCIceCandidateStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  RTCStats::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCIceCandidateStats";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("address");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_address_, member_address_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("candidateType");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCIceCandidateType, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_candidate_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("foundation");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_foundation_, member_foundation_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("ip");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_ip_, member_ip_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("isRemote");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_is_remote_, member_is_remote_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("networkType");
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCNetworkType, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_network_type_, member_network_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("port");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_port_, member_port_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("priority");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_priority_, member_priority_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("protocol");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_protocol_, member_protocol_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("relatedAddress");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), has_related_address_, member_related_address_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("relatedPort");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), has_related_port_, member_related_port_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("relayProtocol");
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCIceServerTransportProtocol, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), has_relay_protocol_, member_relay_protocol_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("tcpType");
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCIceTcpCandidateType, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), has_tcp_type_, member_tcp_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("transportId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[13].Get(isolate), fallback_presence_var, member_transport_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("url");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[14].Get(isolate), has_url_, member_url_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("usernameFragment");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[15].Get(isolate), has_username_fragment_, member_username_fragment_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCIceCandidateStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"address",
"candidateType",
"foundation",
"ip",
"isRemote",
"networkType",
"port",
"priority",
"protocol",
"relatedAddress",
"relatedPort",
"relayProtocol",
"tcpType",
"transportId",
"url",
"usernameFragment",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
