// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_inbound_rtp_stream_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCInboundRtpStreamStats* RTCInboundRtpStreamStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCInboundRtpStreamStats* dictionary = MakeGarbageCollected<RTCInboundRtpStreamStats>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCInboundRtpStreamStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCInboundRtpStreamStats::RTCInboundRtpStreamStats() {
  
}

 RTCInboundRtpStreamStats::RTCInboundRtpStreamStats(v8::Isolate* isolate) : RTCReceivedRtpStreamStats(isolate) {
  
}































String RTCInboundRtpStreamStats::getContentTypeOr(const String& fallback_value) const {
  if (!hasContentType()) {
  return fallback_value;
}
return member_content_type_;
}

String RTCInboundRtpStreamStats::getContentTypeOr(String&& fallback_value) const {
  if (!hasContentType()) {
  return std::move(fallback_value);
}
return member_content_type_;
}

void RTCInboundRtpStreamStats::setContentType(const String& value) {
  member_content_type_ = value;
has_content_type_ = true;
}

void RTCInboundRtpStreamStats::setContentType(String&& value) {
  member_content_type_ = std::move(value);
has_content_type_ = true;
}




String RTCInboundRtpStreamStats::getDecoderImplementationOr(const String& fallback_value) const {
  if (!hasDecoderImplementation()) {
  return fallback_value;
}
return member_decoder_implementation_;
}

String RTCInboundRtpStreamStats::getDecoderImplementationOr(String&& fallback_value) const {
  if (!hasDecoderImplementation()) {
  return std::move(fallback_value);
}
return member_decoder_implementation_;
}

void RTCInboundRtpStreamStats::setDecoderImplementation(const String& value) {
  member_decoder_implementation_ = value;
has_decoder_implementation_ = true;
}

void RTCInboundRtpStreamStats::setDecoderImplementation(String&& value) {
  member_decoder_implementation_ = std::move(value);
has_decoder_implementation_ = true;
}






































































































String RTCInboundRtpStreamStats::getGoogTimingFrameInfoOr(const String& fallback_value) const {
  if (!hasGoogTimingFrameInfo()) {
  return fallback_value;
}
return member_goog_timing_frame_info_;
}

String RTCInboundRtpStreamStats::getGoogTimingFrameInfoOr(String&& fallback_value) const {
  if (!hasGoogTimingFrameInfo()) {
  return std::move(fallback_value);
}
return member_goog_timing_frame_info_;
}

void RTCInboundRtpStreamStats::setGoogTimingFrameInfo(const String& value) {
  member_goog_timing_frame_info_ = value;
has_goog_timing_frame_info_ = true;
}

void RTCInboundRtpStreamStats::setGoogTimingFrameInfo(String&& value) {
  member_goog_timing_frame_info_ = std::move(value);
has_goog_timing_frame_info_ = true;
}




























































String RTCInboundRtpStreamStats::getMidOr(const String& fallback_value) const {
  if (!hasMid()) {
  return fallback_value;
}
return member_mid_;
}

String RTCInboundRtpStreamStats::getMidOr(String&& fallback_value) const {
  if (!hasMid()) {
  return std::move(fallback_value);
}
return member_mid_;
}

void RTCInboundRtpStreamStats::setMid(const String& value) {
  member_mid_ = value;
has_mid_ = true;
}

void RTCInboundRtpStreamStats::setMid(String&& value) {
  member_mid_ = std::move(value);
has_mid_ = true;
}

























String RTCInboundRtpStreamStats::getPlayoutIdOr(const String& fallback_value) const {
  if (!hasPlayoutId()) {
  return fallback_value;
}
return member_playout_id_;
}

String RTCInboundRtpStreamStats::getPlayoutIdOr(String&& fallback_value) const {
  if (!hasPlayoutId()) {
  return std::move(fallback_value);
}
return member_playout_id_;
}

void RTCInboundRtpStreamStats::setPlayoutId(const String& value) {
  member_playout_id_ = value;
has_playout_id_ = true;
}

void RTCInboundRtpStreamStats::setPlayoutId(String&& value) {
  member_playout_id_ = std::move(value);
has_playout_id_ = true;
}

























String RTCInboundRtpStreamStats::getRemoteIdOr(const String& fallback_value) const {
  if (!hasRemoteId()) {
  return fallback_value;
}
return member_remote_id_;
}

String RTCInboundRtpStreamStats::getRemoteIdOr(String&& fallback_value) const {
  if (!hasRemoteId()) {
  return std::move(fallback_value);
}
return member_remote_id_;
}

void RTCInboundRtpStreamStats::setRemoteId(const String& value) {
  member_remote_id_ = value;
has_remote_id_ = true;
}

void RTCInboundRtpStreamStats::setRemoteId(String&& value) {
  member_remote_id_ = std::move(value);
has_remote_id_ = true;
}













































































































void RTCInboundRtpStreamStats::setTrackIdentifier(const String& value) {
  member_track_identifier_ = value;
}

void RTCInboundRtpStreamStats::setTrackIdentifier(String&& value) {
  member_track_identifier_ = std::move(value);
}




void RTCInboundRtpStreamStats::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_audio_level_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_bytes_received_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_concealed_samples_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_concealment_events_);
TraceIfNeeded<String>::Trace(visitor, member_content_type_);
TraceIfNeeded<String>::Trace(visitor, member_decoder_implementation_);
TraceIfNeeded<double>::Trace(visitor, member_estimated_playout_timestamp_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_fec_bytes_received_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_fec_packets_discarded_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_fec_packets_received_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_fec_ssrc_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_fir_count_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_frame_height_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_frame_width_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_frames_assembled_from_multiple_packets_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_frames_decoded_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_frames_dropped_);
TraceIfNeeded<double>::Trace(visitor, member_frames_per_second_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_frames_received_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_freeze_count_);
TraceIfNeeded<String>::Trace(visitor, member_goog_timing_frame_info_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_header_bytes_received_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_inserted_samples_for_deceleration_);
TraceIfNeeded<double>::Trace(visitor, member_jitter_buffer_delay_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_jitter_buffer_emitted_count_);
TraceIfNeeded<double>::Trace(visitor, member_jitter_buffer_minimum_delay_);
TraceIfNeeded<double>::Trace(visitor, member_jitter_buffer_target_delay_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_key_frames_decoded_);
TraceIfNeeded<double>::Trace(visitor, member_last_packet_received_timestamp_);
TraceIfNeeded<String>::Trace(visitor, member_mid_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_nack_count_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_packets_discarded_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_pause_count_);
TraceIfNeeded<String>::Trace(visitor, member_playout_id_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_pli_count_);
TraceIfNeeded<bool>::Trace(visitor, member_power_efficient_decoder_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_qp_sum_);
TraceIfNeeded<String>::Trace(visitor, member_remote_id_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_removed_samples_for_acceleration_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_retransmitted_bytes_received_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_retransmitted_packets_received_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_rtx_ssrc_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_silent_concealed_samples_);
TraceIfNeeded<double>::Trace(visitor, member_total_assembly_time_);
TraceIfNeeded<double>::Trace(visitor, member_total_audio_energy_);
TraceIfNeeded<double>::Trace(visitor, member_total_decode_time_);
TraceIfNeeded<double>::Trace(visitor, member_total_freezes_duration_);
TraceIfNeeded<double>::Trace(visitor, member_total_inter_frame_delay_);
TraceIfNeeded<double>::Trace(visitor, member_total_pauses_duration_);
TraceIfNeeded<double>::Trace(visitor, member_total_processing_delay_);
TraceIfNeeded<double>::Trace(visitor, member_total_samples_duration_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_total_samples_received_);
TraceIfNeeded<double>::Trace(visitor, member_total_squared_inter_frame_delay_);
TraceIfNeeded<String>::Trace(visitor, member_track_identifier_);
RTCReceivedRtpStreamStats::Trace(visitor);
}

bool RTCInboundRtpStreamStats::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!RTCReceivedRtpStreamStats::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAudioLevel()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_audio_level_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasBytesReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_bytes_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasConcealedSamples()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_concealed_samples_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasConcealmentEvents()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_concealment_events_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasContentType()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_content_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasDecoderImplementation()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_decoder_implementation_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasEstimatedPlayoutTimestamp()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_estimated_playout_timestamp_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (hasFecBytesReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_fec_bytes_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
if (hasFecPacketsDiscarded()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_fec_packets_discarded_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[8].Get(isolate), v8_value).ToChecked();
}
if (hasFecPacketsReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_fec_packets_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[9].Get(isolate), v8_value).ToChecked();
}
if (hasFecSsrc()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_fec_ssrc_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[10].Get(isolate), v8_value).ToChecked();
}
if (hasFirCount()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_fir_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[11].Get(isolate), v8_value).ToChecked();
}
if (hasFrameHeight()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_frame_height_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[12].Get(isolate), v8_value).ToChecked();
}
if (hasFrameWidth()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_frame_width_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[13].Get(isolate), v8_value).ToChecked();
}
if (hasFramesAssembledFromMultiplePackets()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_frames_assembled_from_multiple_packets_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[14].Get(isolate), v8_value).ToChecked();
}
if (hasFramesDecoded()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_frames_decoded_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[15].Get(isolate), v8_value).ToChecked();
}
if (hasFramesDropped()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_frames_dropped_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[16].Get(isolate), v8_value).ToChecked();
}
if (hasFramesPerSecond()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_frames_per_second_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[17].Get(isolate), v8_value).ToChecked();
}
if (hasFramesReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_frames_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[18].Get(isolate), v8_value).ToChecked();
}
if (hasFreezeCount()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_freeze_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[19].Get(isolate), v8_value).ToChecked();
}
if (hasGoogTimingFrameInfo()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_goog_timing_frame_info_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[20].Get(isolate), v8_value).ToChecked();
}
if (hasHeaderBytesReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_header_bytes_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[21].Get(isolate), v8_value).ToChecked();
}
if (hasInsertedSamplesForDeceleration()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_inserted_samples_for_deceleration_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[22].Get(isolate), v8_value).ToChecked();
}
if (hasJitterBufferDelay()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_jitter_buffer_delay_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[23].Get(isolate), v8_value).ToChecked();
}
if (hasJitterBufferEmittedCount()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_jitter_buffer_emitted_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[24].Get(isolate), v8_value).ToChecked();
}
if (hasJitterBufferMinimumDelay()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_jitter_buffer_minimum_delay_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[25].Get(isolate), v8_value).ToChecked();
}
if (hasJitterBufferTargetDelay()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_jitter_buffer_target_delay_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[26].Get(isolate), v8_value).ToChecked();
}
if (hasKeyFramesDecoded()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_key_frames_decoded_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[27].Get(isolate), v8_value).ToChecked();
}
if (hasLastPacketReceivedTimestamp()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_last_packet_received_timestamp_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[28].Get(isolate), v8_value).ToChecked();
}
if (hasMid()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_mid_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[29].Get(isolate), v8_value).ToChecked();
}
if (hasNackCount()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_nack_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[30].Get(isolate), v8_value).ToChecked();
}
if (hasPacketsDiscarded()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_packets_discarded_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[31].Get(isolate), v8_value).ToChecked();
}
if (hasPauseCount()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_pause_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[32].Get(isolate), v8_value).ToChecked();
}
if (hasPlayoutId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_playout_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[33].Get(isolate), v8_value).ToChecked();
}
if (hasPliCount()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_pli_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[34].Get(isolate), v8_value).ToChecked();
}
if (hasPowerEfficientDecoder()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_power_efficient_decoder_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[35].Get(isolate), v8_value).ToChecked();
}
if (hasQpSum()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_qp_sum_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[36].Get(isolate), v8_value).ToChecked();
}
if (hasRemoteId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_remote_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[37].Get(isolate), v8_value).ToChecked();
}
if (hasRemovedSamplesForAcceleration()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_removed_samples_for_acceleration_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[38].Get(isolate), v8_value).ToChecked();
}
if (hasRetransmittedBytesReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_retransmitted_bytes_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[39].Get(isolate), v8_value).ToChecked();
}
if (hasRetransmittedPacketsReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_retransmitted_packets_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[40].Get(isolate), v8_value).ToChecked();
}
if (hasRtxSsrc()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_rtx_ssrc_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[41].Get(isolate), v8_value).ToChecked();
}
if (hasSilentConcealedSamples()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_silent_concealed_samples_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[42].Get(isolate), v8_value).ToChecked();
}
if (hasTotalAssemblyTime()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_assembly_time_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[43].Get(isolate), v8_value).ToChecked();
}
if (hasTotalAudioEnergy()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_audio_energy_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[44].Get(isolate), v8_value).ToChecked();
}
if (hasTotalDecodeTime()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_decode_time_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[45].Get(isolate), v8_value).ToChecked();
}
if (hasTotalFreezesDuration()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_freezes_duration_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[46].Get(isolate), v8_value).ToChecked();
}
if (hasTotalInterFrameDelay()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_inter_frame_delay_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[47].Get(isolate), v8_value).ToChecked();
}
if (hasTotalPausesDuration()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_pauses_duration_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[48].Get(isolate), v8_value).ToChecked();
}
if (hasTotalProcessingDelay()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_processing_delay_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[49].Get(isolate), v8_value).ToChecked();
}
if (hasTotalSamplesDuration()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_samples_duration_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[50].Get(isolate), v8_value).ToChecked();
}
if (hasTotalSamplesReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_total_samples_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[51].Get(isolate), v8_value).ToChecked();
}
if (hasTotalSquaredInterFrameDelay()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_squared_inter_frame_delay_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[52].Get(isolate), v8_value).ToChecked();
}
if (hasTrackIdentifier()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_track_identifier_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[53].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCInboundRtpStreamStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  RTCReceivedRtpStreamStats::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCInboundRtpStreamStats";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("audioLevel");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_audio_level_, member_audio_level_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("bytesReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_bytes_received_, member_bytes_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("concealedSamples");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_concealed_samples_, member_concealed_samples_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("concealmentEvents");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_concealment_events_, member_concealment_events_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("contentType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_content_type_, member_content_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("decoderImplementation");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_decoder_implementation_, member_decoder_implementation_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("estimatedPlayoutTimestamp");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_estimated_playout_timestamp_, member_estimated_playout_timestamp_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("fecBytesReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_fec_bytes_received_, member_fec_bytes_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("fecPacketsDiscarded");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_fec_packets_discarded_, member_fec_packets_discarded_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("fecPacketsReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), has_fec_packets_received_, member_fec_packets_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("fecSsrc");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), has_fec_ssrc_, member_fec_ssrc_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("firCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), has_fir_count_, member_fir_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("frameHeight");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), has_frame_height_, member_frame_height_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("frameWidth");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[13].Get(isolate), has_frame_width_, member_frame_width_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("framesAssembledFromMultiplePackets");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[14].Get(isolate), has_frames_assembled_from_multiple_packets_, member_frames_assembled_from_multiple_packets_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("framesDecoded");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[15].Get(isolate), has_frames_decoded_, member_frames_decoded_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("framesDropped");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[16].Get(isolate), has_frames_dropped_, member_frames_dropped_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("framesPerSecond");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[17].Get(isolate), has_frames_per_second_, member_frames_per_second_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("framesReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[18].Get(isolate), has_frames_received_, member_frames_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("freezeCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[19].Get(isolate), has_freeze_count_, member_freeze_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("googTimingFrameInfo");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[20].Get(isolate), has_goog_timing_frame_info_, member_goog_timing_frame_info_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("headerBytesReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[21].Get(isolate), has_header_bytes_received_, member_header_bytes_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("insertedSamplesForDeceleration");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[22].Get(isolate), has_inserted_samples_for_deceleration_, member_inserted_samples_for_deceleration_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("jitterBufferDelay");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[23].Get(isolate), has_jitter_buffer_delay_, member_jitter_buffer_delay_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("jitterBufferEmittedCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[24].Get(isolate), has_jitter_buffer_emitted_count_, member_jitter_buffer_emitted_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("jitterBufferMinimumDelay");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[25].Get(isolate), has_jitter_buffer_minimum_delay_, member_jitter_buffer_minimum_delay_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("jitterBufferTargetDelay");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[26].Get(isolate), has_jitter_buffer_target_delay_, member_jitter_buffer_target_delay_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("keyFramesDecoded");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[27].Get(isolate), has_key_frames_decoded_, member_key_frames_decoded_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("lastPacketReceivedTimestamp");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[28].Get(isolate), has_last_packet_received_timestamp_, member_last_packet_received_timestamp_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mid");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[29].Get(isolate), has_mid_, member_mid_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("nackCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[30].Get(isolate), has_nack_count_, member_nack_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("packetsDiscarded");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[31].Get(isolate), has_packets_discarded_, member_packets_discarded_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("pauseCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[32].Get(isolate), has_pause_count_, member_pause_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("playoutId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[33].Get(isolate), has_playout_id_, member_playout_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("pliCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[34].Get(isolate), has_pli_count_, member_pli_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("powerEfficientDecoder");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[35].Get(isolate), has_power_efficient_decoder_, member_power_efficient_decoder_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("qpSum");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[36].Get(isolate), has_qp_sum_, member_qp_sum_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("remoteId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[37].Get(isolate), has_remote_id_, member_remote_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("removedSamplesForAcceleration");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[38].Get(isolate), has_removed_samples_for_acceleration_, member_removed_samples_for_acceleration_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("retransmittedBytesReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[39].Get(isolate), has_retransmitted_bytes_received_, member_retransmitted_bytes_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("retransmittedPacketsReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[40].Get(isolate), has_retransmitted_packets_received_, member_retransmitted_packets_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rtxSsrc");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[41].Get(isolate), has_rtx_ssrc_, member_rtx_ssrc_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("silentConcealedSamples");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[42].Get(isolate), has_silent_concealed_samples_, member_silent_concealed_samples_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalAssemblyTime");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[43].Get(isolate), has_total_assembly_time_, member_total_assembly_time_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalAudioEnergy");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[44].Get(isolate), has_total_audio_energy_, member_total_audio_energy_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalDecodeTime");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[45].Get(isolate), has_total_decode_time_, member_total_decode_time_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalFreezesDuration");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[46].Get(isolate), has_total_freezes_duration_, member_total_freezes_duration_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalInterFrameDelay");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[47].Get(isolate), has_total_inter_frame_delay_, member_total_inter_frame_delay_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalPausesDuration");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[48].Get(isolate), has_total_pauses_duration_, member_total_pauses_duration_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalProcessingDelay");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[49].Get(isolate), has_total_processing_delay_, member_total_processing_delay_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalSamplesDuration");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[50].Get(isolate), has_total_samples_duration_, member_total_samples_duration_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalSamplesReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[51].Get(isolate), has_total_samples_received_, member_total_samples_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalSquaredInterFrameDelay");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[52].Get(isolate), has_total_squared_inter_frame_delay_, member_total_squared_inter_frame_delay_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("trackIdentifier");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[53].Get(isolate), fallback_presence_var, member_track_identifier_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCInboundRtpStreamStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"audioLevel",
"bytesReceived",
"concealedSamples",
"concealmentEvents",
"contentType",
"decoderImplementation",
"estimatedPlayoutTimestamp",
"fecBytesReceived",
"fecPacketsDiscarded",
"fecPacketsReceived",
"fecSsrc",
"firCount",
"frameHeight",
"frameWidth",
"framesAssembledFromMultiplePackets",
"framesDecoded",
"framesDropped",
"framesPerSecond",
"framesReceived",
"freezeCount",
"googTimingFrameInfo",
"headerBytesReceived",
"insertedSamplesForDeceleration",
"jitterBufferDelay",
"jitterBufferEmittedCount",
"jitterBufferMinimumDelay",
"jitterBufferTargetDelay",
"keyFramesDecoded",
"lastPacketReceivedTimestamp",
"mid",
"nackCount",
"packetsDiscarded",
"pauseCount",
"playoutId",
"pliCount",
"powerEfficientDecoder",
"qpSum",
"remoteId",
"removedSamplesForAcceleration",
"retransmittedBytesReceived",
"retransmittedPacketsReceived",
"rtxSsrc",
"silentConcealedSamples",
"totalAssemblyTime",
"totalAudioEnergy",
"totalDecodeTime",
"totalFreezesDuration",
"totalInterFrameDelay",
"totalPausesDuration",
"totalProcessingDelay",
"totalSamplesDuration",
"totalSamplesReceived",
"totalSquaredInterFrameDelay",
"trackIdentifier",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
