// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_codec.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCRtpCodec* RTCRtpCodec::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCRtpCodec* dictionary = MakeGarbageCollected<RTCRtpCodec>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCRtpCodec";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCRtpCodec::RTCRtpCodec() {
  
}

 RTCRtpCodec::RTCRtpCodec(v8::Isolate* isolate) {
  
}















void RTCRtpCodec::setMimeType(const String& value) {
  member_mime_type_ = value;
}

void RTCRtpCodec::setMimeType(String&& value) {
  member_mime_type_ = std::move(value);
}




String RTCRtpCodec::getSdpFmtpLineOr(const String& fallback_value) const {
  if (!hasSdpFmtpLine()) {
  return fallback_value;
}
return member_sdp_fmtp_line_;
}

String RTCRtpCodec::getSdpFmtpLineOr(String&& fallback_value) const {
  if (!hasSdpFmtpLine()) {
  return std::move(fallback_value);
}
return member_sdp_fmtp_line_;
}

void RTCRtpCodec::setSdpFmtpLine(const String& value) {
  member_sdp_fmtp_line_ = value;
has_sdp_fmtp_line_ = true;
}

void RTCRtpCodec::setSdpFmtpLine(String&& value) {
  member_sdp_fmtp_line_ = std::move(value);
has_sdp_fmtp_line_ = true;
}




void RTCRtpCodec::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint16_t>::Trace(visitor, member_channels_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_clock_rate_);
TraceIfNeeded<String>::Trace(visitor, member_mime_type_);
TraceIfNeeded<String>::Trace(visitor, member_sdp_fmtp_line_);
bindings::DictionaryBase::Trace(visitor);
}

bool RTCRtpCodec::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasChannels()) {
  v8_value = ToV8Traits<IDLUnsignedShort>::ToV8(script_state, member_channels_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasClockRate()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_clock_rate_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasMimeType()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_mime_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasSdpFmtpLine()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_sdp_fmtp_line_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCRtpCodec::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "RTCRtpCodec";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("channels");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_channels_, member_channels_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("clockRate");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_clock_rate_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mimeType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_mime_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sdpFmtpLine");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_sdp_fmtp_line_, member_sdp_fmtp_line_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCRtpCodec::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"channels",
"clockRate",
"mimeType",
"sdpFmtpLine",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
