// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_send_parameters.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_encoding_parameters.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCRtpSendParameters* RTCRtpSendParameters::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCRtpSendParameters* dictionary = MakeGarbageCollected<RTCRtpSendParameters>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCRtpSendParameters";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCRtpSendParameters::RTCRtpSendParameters() {
  
}

 RTCRtpSendParameters::RTCRtpSendParameters(v8::Isolate* isolate) : RTCRtpParameters(isolate) {
  
}










void RTCRtpSendParameters::setEncodings(const HeapVector<Member<RTCRtpEncodingParameters>>& value) {
  member_encodings_ = value;
}

void RTCRtpSendParameters::setEncodings(HeapVector<Member<RTCRtpEncodingParameters>>&& value) {
  member_encodings_ = std::move(value);
}




void RTCRtpSendParameters::setTransactionId(const String& value) {
  member_transaction_id_ = value;
}

void RTCRtpSendParameters::setTransactionId(String&& value) {
  member_transaction_id_ = std::move(value);
}




void RTCRtpSendParameters::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8RTCDegradationPreference>::Trace(visitor, member_degradation_preference_);
TraceIfNeeded<HeapVector<Member<RTCRtpEncodingParameters>>>::Trace(visitor, member_encodings_);
TraceIfNeeded<String>::Trace(visitor, member_transaction_id_);
RTCRtpParameters::Trace(visitor);
}

bool RTCRtpSendParameters::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!RTCRtpParameters::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasDegradationPreference()) {
  v8_value = ToV8Traits<V8RTCDegradationPreference>::ToV8(script_state, member_degradation_preference_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasEncodings()) {
  v8_value = ToV8Traits<IDLSequence<RTCRtpEncodingParameters>>::ToV8(script_state, member_encodings_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasTransactionId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_transaction_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCRtpSendParameters::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  RTCRtpParameters::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCRtpSendParameters";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("degradationPreference");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCDegradationPreference, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_degradation_preference_, member_degradation_preference_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("encodings");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<RTCRtpEncodingParameters>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_encodings_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("transactionId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_transaction_id_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCRtpSendParameters::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"degradationPreference",
"encodings",
"transactionId",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
