// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_stream_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCRtpStreamStats* RTCRtpStreamStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCRtpStreamStats* dictionary = MakeGarbageCollected<RTCRtpStreamStats>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCRtpStreamStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCRtpStreamStats::RTCRtpStreamStats() {
  
}

 RTCRtpStreamStats::RTCRtpStreamStats(v8::Isolate* isolate) : RTCStats(isolate) {
  
}



String RTCRtpStreamStats::getCodecIdOr(const String& fallback_value) const {
  if (!hasCodecId()) {
  return fallback_value;
}
return member_codec_id_;
}

String RTCRtpStreamStats::getCodecIdOr(String&& fallback_value) const {
  if (!hasCodecId()) {
  return std::move(fallback_value);
}
return member_codec_id_;
}

void RTCRtpStreamStats::setCodecId(const String& value) {
  member_codec_id_ = value;
has_codec_id_ = true;
}

void RTCRtpStreamStats::setCodecId(String&& value) {
  member_codec_id_ = std::move(value);
has_codec_id_ = true;
}




void RTCRtpStreamStats::setKind(const String& value) {
  member_kind_ = value;
}

void RTCRtpStreamStats::setKind(String&& value) {
  member_kind_ = std::move(value);
}




String RTCRtpStreamStats::getMediaTypeOr(const String& fallback_value) const {
  if (!hasMediaType()) {
  return fallback_value;
}
return member_media_type_;
}

String RTCRtpStreamStats::getMediaTypeOr(String&& fallback_value) const {
  if (!hasMediaType()) {
  return std::move(fallback_value);
}
return member_media_type_;
}

void RTCRtpStreamStats::setMediaType(const String& value) {
  member_media_type_ = value;
has_media_type_ = true;
}

void RTCRtpStreamStats::setMediaType(String&& value) {
  member_media_type_ = std::move(value);
has_media_type_ = true;
}









String RTCRtpStreamStats::getTransportIdOr(const String& fallback_value) const {
  if (!hasTransportId()) {
  return fallback_value;
}
return member_transport_id_;
}

String RTCRtpStreamStats::getTransportIdOr(String&& fallback_value) const {
  if (!hasTransportId()) {
  return std::move(fallback_value);
}
return member_transport_id_;
}

void RTCRtpStreamStats::setTransportId(const String& value) {
  member_transport_id_ = value;
has_transport_id_ = true;
}

void RTCRtpStreamStats::setTransportId(String&& value) {
  member_transport_id_ = std::move(value);
has_transport_id_ = true;
}




void RTCRtpStreamStats::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_codec_id_);
TraceIfNeeded<String>::Trace(visitor, member_kind_);
TraceIfNeeded<String>::Trace(visitor, member_media_type_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_ssrc_);
TraceIfNeeded<String>::Trace(visitor, member_transport_id_);
RTCStats::Trace(visitor);
}

bool RTCRtpStreamStats::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!RTCStats::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasCodecId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_codec_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasKind()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_kind_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasMediaType()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_media_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasSsrc()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_ssrc_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasTransportId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_transport_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCRtpStreamStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  RTCStats::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCRtpStreamStats";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("codecId");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_codec_id_, member_codec_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("kind");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_kind_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mediaType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_media_type_, member_media_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("ssrc");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_ssrc_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("transportId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_transport_id_, member_transport_id_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCRtpStreamStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"codecId",
"kind",
"mediaType",
"ssrc",
"transportId",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
