// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_transceiver_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_encoding_parameters.h"
#include "third_party/blink/renderer/modules/mediastream/media_stream.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCRtpTransceiverInit* RTCRtpTransceiverInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCRtpTransceiverInit* dictionary = MakeGarbageCollected<RTCRtpTransceiverInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCRtpTransceiverInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCRtpTransceiverInit::RTCRtpTransceiverInit() {
  
}

 RTCRtpTransceiverInit::RTCRtpTransceiverInit(v8::Isolate* isolate) {
  
}








void RTCRtpTransceiverInit::setSendEncodings(const HeapVector<Member<RTCRtpEncodingParameters>>& value) {
  member_send_encodings_ = value;
}

void RTCRtpTransceiverInit::setSendEncodings(HeapVector<Member<RTCRtpEncodingParameters>>&& value) {
  member_send_encodings_ = std::move(value);
}




void RTCRtpTransceiverInit::setStreams(const HeapVector<Member<MediaStream>>& value) {
  member_streams_ = value;
}

void RTCRtpTransceiverInit::setStreams(HeapVector<Member<MediaStream>>&& value) {
  member_streams_ = std::move(value);
}




void RTCRtpTransceiverInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8RTCRtpTransceiverDirection>::Trace(visitor, member_direction_);
TraceIfNeeded<HeapVector<Member<RTCRtpEncodingParameters>>>::Trace(visitor, member_send_encodings_);
TraceIfNeeded<HeapVector<Member<MediaStream>>>::Trace(visitor, member_streams_);
bindings::DictionaryBase::Trace(visitor);
}

bool RTCRtpTransceiverInit::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasDirection()) {
  v8_value = ToV8Traits<V8RTCRtpTransceiverDirection>::ToV8(script_state, member_direction_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasSendEncodings()) {
  v8_value = ToV8Traits<IDLSequence<RTCRtpEncodingParameters>>::ToV8(script_state, member_send_encodings_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasStreams()) {
  v8_value = ToV8Traits<IDLSequence<MediaStream>>::ToV8(script_state, member_streams_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCRtpTransceiverInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "RTCRtpTransceiverInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("direction");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCRtpTransceiverDirection, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_direction_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sendEncodings");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<RTCRtpEncodingParameters>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_send_encodings_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("streams");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<MediaStream>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_streams_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCRtpTransceiverInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"direction",
"sendEncodings",
"streams",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
