// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_track_event_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/mediastream/media_stream.h"
#include "third_party/blink/renderer/modules/mediastream/media_stream_track.h"
#include "third_party/blink/renderer/modules/peerconnection/rtc_rtp_receiver.h"
#include "third_party/blink/renderer/modules/peerconnection/rtc_rtp_transceiver.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCTrackEventInit* RTCTrackEventInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCTrackEventInit* dictionary = MakeGarbageCollected<RTCTrackEventInit>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCTrackEventInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCTrackEventInit::RTCTrackEventInit() {
  
}

 RTCTrackEventInit::RTCTrackEventInit(v8::Isolate* isolate) : EventInit(isolate) {
  
}








void RTCTrackEventInit::setStreams(const HeapVector<Member<MediaStream>>& value) {
  member_streams_ = value;
}

void RTCTrackEventInit::setStreams(HeapVector<Member<MediaStream>>&& value) {
  member_streams_ = std::move(value);
}














void RTCTrackEventInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<RTCRtpReceiver>>::Trace(visitor, member_receiver_);
TraceIfNeeded<HeapVector<Member<MediaStream>>>::Trace(visitor, member_streams_);
TraceIfNeeded<Member<MediaStreamTrack>>::Trace(visitor, member_track_);
TraceIfNeeded<Member<RTCRtpTransceiver>>::Trace(visitor, member_transceiver_);
EventInit::Trace(visitor);
}

bool RTCTrackEventInit::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!EventInit::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasReceiver()) {
  v8_value = ToV8Traits<RTCRtpReceiver>::ToV8(script_state, member_receiver_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasStreams()) {
  v8_value = ToV8Traits<IDLSequence<MediaStream>>::ToV8(script_state, member_streams_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasTrack()) {
  v8_value = ToV8Traits<MediaStreamTrack>::ToV8(script_state, member_track_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasTransceiver()) {
  v8_value = ToV8Traits<RTCRtpTransceiver>::ToV8(script_state, member_transceiver_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCTrackEventInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  EventInit::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCTrackEventInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("receiver");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<RTCRtpReceiver, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_receiver_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("streams");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<MediaStream>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_streams_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("track");
if (!bindings::GetDictionaryMemberFromV8Object<MediaStreamTrack, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_track_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("transceiver");
if (!bindings::GetDictionaryMemberFromV8Object<RTCRtpTransceiver, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_transceiver_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCTrackEventInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"receiver",
"streams",
"track",
"transceiver",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
