// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_transport_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCTransportStats* RTCTransportStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCTransportStats* dictionary = MakeGarbageCollected<RTCTransportStats>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCTransportStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCTransportStats::RTCTransportStats() {
  
}

 RTCTransportStats::RTCTransportStats(v8::Isolate* isolate) : RTCStats(isolate) {
  
}

















String RTCTransportStats::getDtlsCipherOr(const String& fallback_value) const {
  if (!hasDtlsCipher()) {
  return fallback_value;
}
return member_dtls_cipher_;
}

String RTCTransportStats::getDtlsCipherOr(String&& fallback_value) const {
  if (!hasDtlsCipher()) {
  return std::move(fallback_value);
}
return member_dtls_cipher_;
}

void RTCTransportStats::setDtlsCipher(const String& value) {
  member_dtls_cipher_ = value;
has_dtls_cipher_ = true;
}

void RTCTransportStats::setDtlsCipher(String&& value) {
  member_dtls_cipher_ = std::move(value);
has_dtls_cipher_ = true;
}
















String RTCTransportStats::getIceLocalUsernameFragmentOr(const String& fallback_value) const {
  if (!hasIceLocalUsernameFragment()) {
  return fallback_value;
}
return member_ice_local_username_fragment_;
}

String RTCTransportStats::getIceLocalUsernameFragmentOr(String&& fallback_value) const {
  if (!hasIceLocalUsernameFragment()) {
  return std::move(fallback_value);
}
return member_ice_local_username_fragment_;
}

void RTCTransportStats::setIceLocalUsernameFragment(const String& value) {
  member_ice_local_username_fragment_ = value;
has_ice_local_username_fragment_ = true;
}

void RTCTransportStats::setIceLocalUsernameFragment(String&& value) {
  member_ice_local_username_fragment_ = std::move(value);
has_ice_local_username_fragment_ = true;
}


















String RTCTransportStats::getLocalCertificateIdOr(const String& fallback_value) const {
  if (!hasLocalCertificateId()) {
  return fallback_value;
}
return member_local_certificate_id_;
}

String RTCTransportStats::getLocalCertificateIdOr(String&& fallback_value) const {
  if (!hasLocalCertificateId()) {
  return std::move(fallback_value);
}
return member_local_certificate_id_;
}

void RTCTransportStats::setLocalCertificateId(const String& value) {
  member_local_certificate_id_ = value;
has_local_certificate_id_ = true;
}

void RTCTransportStats::setLocalCertificateId(String&& value) {
  member_local_certificate_id_ = std::move(value);
has_local_certificate_id_ = true;
}


















String RTCTransportStats::getRemoteCertificateIdOr(const String& fallback_value) const {
  if (!hasRemoteCertificateId()) {
  return fallback_value;
}
return member_remote_certificate_id_;
}

String RTCTransportStats::getRemoteCertificateIdOr(String&& fallback_value) const {
  if (!hasRemoteCertificateId()) {
  return std::move(fallback_value);
}
return member_remote_certificate_id_;
}

void RTCTransportStats::setRemoteCertificateId(const String& value) {
  member_remote_certificate_id_ = value;
has_remote_certificate_id_ = true;
}

void RTCTransportStats::setRemoteCertificateId(String&& value) {
  member_remote_certificate_id_ = std::move(value);
has_remote_certificate_id_ = true;
}




String RTCTransportStats::getRtcpTransportStatsIdOr(const String& fallback_value) const {
  if (!hasRtcpTransportStatsId()) {
  return fallback_value;
}
return member_rtcp_transport_stats_id_;
}

String RTCTransportStats::getRtcpTransportStatsIdOr(String&& fallback_value) const {
  if (!hasRtcpTransportStatsId()) {
  return std::move(fallback_value);
}
return member_rtcp_transport_stats_id_;
}

void RTCTransportStats::setRtcpTransportStatsId(const String& value) {
  member_rtcp_transport_stats_id_ = value;
has_rtcp_transport_stats_id_ = true;
}

void RTCTransportStats::setRtcpTransportStatsId(String&& value) {
  member_rtcp_transport_stats_id_ = std::move(value);
has_rtcp_transport_stats_id_ = true;
}











String RTCTransportStats::getSelectedCandidatePairIdOr(const String& fallback_value) const {
  if (!hasSelectedCandidatePairId()) {
  return fallback_value;
}
return member_selected_candidate_pair_id_;
}

String RTCTransportStats::getSelectedCandidatePairIdOr(String&& fallback_value) const {
  if (!hasSelectedCandidatePairId()) {
  return std::move(fallback_value);
}
return member_selected_candidate_pair_id_;
}

void RTCTransportStats::setSelectedCandidatePairId(const String& value) {
  member_selected_candidate_pair_id_ = value;
has_selected_candidate_pair_id_ = true;
}

void RTCTransportStats::setSelectedCandidatePairId(String&& value) {
  member_selected_candidate_pair_id_ = std::move(value);
has_selected_candidate_pair_id_ = true;
}




String RTCTransportStats::getSrtpCipherOr(const String& fallback_value) const {
  if (!hasSrtpCipher()) {
  return fallback_value;
}
return member_srtp_cipher_;
}

String RTCTransportStats::getSrtpCipherOr(String&& fallback_value) const {
  if (!hasSrtpCipher()) {
  return std::move(fallback_value);
}
return member_srtp_cipher_;
}

void RTCTransportStats::setSrtpCipher(const String& value) {
  member_srtp_cipher_ = value;
has_srtp_cipher_ = true;
}

void RTCTransportStats::setSrtpCipher(String&& value) {
  member_srtp_cipher_ = std::move(value);
has_srtp_cipher_ = true;
}




String RTCTransportStats::getTlsVersionOr(const String& fallback_value) const {
  if (!hasTlsVersion()) {
  return fallback_value;
}
return member_tls_version_;
}

String RTCTransportStats::getTlsVersionOr(String&& fallback_value) const {
  if (!hasTlsVersion()) {
  return std::move(fallback_value);
}
return member_tls_version_;
}

void RTCTransportStats::setTlsVersion(const String& value) {
  member_tls_version_ = value;
has_tls_version_ = true;
}

void RTCTransportStats::setTlsVersion(String&& value) {
  member_tls_version_ = std::move(value);
has_tls_version_ = true;
}




void RTCTransportStats::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint64_t>::Trace(visitor, member_bytes_received_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_bytes_sent_);
TraceIfNeeded<String>::Trace(visitor, member_dtls_cipher_);
TraceIfNeeded<V8RTCDtlsRole>::Trace(visitor, member_dtls_role_);
TraceIfNeeded<V8RTCDtlsTransportState>::Trace(visitor, member_dtls_state_);
TraceIfNeeded<String>::Trace(visitor, member_ice_local_username_fragment_);
TraceIfNeeded<V8RTCIceRole>::Trace(visitor, member_ice_role_);
TraceIfNeeded<V8RTCIceTransportState>::Trace(visitor, member_ice_state_);
TraceIfNeeded<String>::Trace(visitor, member_local_certificate_id_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_packets_received_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_packets_sent_);
TraceIfNeeded<String>::Trace(visitor, member_remote_certificate_id_);
TraceIfNeeded<String>::Trace(visitor, member_rtcp_transport_stats_id_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_selected_candidate_pair_changes_);
TraceIfNeeded<String>::Trace(visitor, member_selected_candidate_pair_id_);
TraceIfNeeded<String>::Trace(visitor, member_srtp_cipher_);
TraceIfNeeded<String>::Trace(visitor, member_tls_version_);
RTCStats::Trace(visitor);
}

bool RTCTransportStats::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!RTCStats::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasBytesReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_bytes_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasBytesSent()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_bytes_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasDtlsCipher()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_dtls_cipher_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasDtlsRole()) {
  v8_value = ToV8Traits<V8RTCDtlsRole>::ToV8(script_state, member_dtls_role_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasDtlsState()) {
  v8_value = ToV8Traits<V8RTCDtlsTransportState>::ToV8(script_state, member_dtls_state_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasIceLocalUsernameFragment()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_ice_local_username_fragment_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasIceRole()) {
  v8_value = ToV8Traits<V8RTCIceRole>::ToV8(script_state, member_ice_role_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (hasIceState()) {
  v8_value = ToV8Traits<V8RTCIceTransportState>::ToV8(script_state, member_ice_state_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
if (hasLocalCertificateId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_local_certificate_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[8].Get(isolate), v8_value).ToChecked();
}
if (hasPacketsReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_packets_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[9].Get(isolate), v8_value).ToChecked();
}
if (hasPacketsSent()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_packets_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[10].Get(isolate), v8_value).ToChecked();
}
if (hasRemoteCertificateId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_remote_certificate_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[11].Get(isolate), v8_value).ToChecked();
}
if (hasRtcpTransportStatsId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_rtcp_transport_stats_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[12].Get(isolate), v8_value).ToChecked();
}
if (hasSelectedCandidatePairChanges()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_selected_candidate_pair_changes_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[13].Get(isolate), v8_value).ToChecked();
}
if (hasSelectedCandidatePairId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_selected_candidate_pair_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[14].Get(isolate), v8_value).ToChecked();
}
if (hasSrtpCipher()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_srtp_cipher_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[15].Get(isolate), v8_value).ToChecked();
}
if (hasTlsVersion()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_tls_version_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[16].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCTransportStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  RTCStats::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCTransportStats";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("bytesReceived");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_bytes_received_, member_bytes_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("bytesSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_bytes_sent_, member_bytes_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("dtlsCipher");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_dtls_cipher_, member_dtls_cipher_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("dtlsRole");
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCDtlsRole, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_dtls_role_, member_dtls_role_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("dtlsState");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCDtlsTransportState, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_dtls_state_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("iceLocalUsernameFragment");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_ice_local_username_fragment_, member_ice_local_username_fragment_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("iceRole");
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCIceRole, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_ice_role_, member_ice_role_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("iceState");
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCIceTransportState, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_ice_state_, member_ice_state_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("localCertificateId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_local_certificate_id_, member_local_certificate_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("packetsReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), has_packets_received_, member_packets_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("packetsSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), has_packets_sent_, member_packets_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("remoteCertificateId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), has_remote_certificate_id_, member_remote_certificate_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rtcpTransportStatsId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), has_rtcp_transport_stats_id_, member_rtcp_transport_stats_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("selectedCandidatePairChanges");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[13].Get(isolate), has_selected_candidate_pair_changes_, member_selected_candidate_pair_changes_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("selectedCandidatePairId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[14].Get(isolate), has_selected_candidate_pair_id_, member_selected_candidate_pair_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("srtpCipher");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[15].Get(isolate), has_srtp_cipher_, member_srtp_cipher_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("tlsVersion");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[16].Get(isolate), has_tls_version_, member_tls_version_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCTransportStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"bytesReceived",
"bytesSent",
"dtlsCipher",
"dtlsRole",
"dtlsState",
"iceLocalUsernameFragment",
"iceRole",
"iceState",
"localCertificateId",
"packetsReceived",
"packetsSent",
"remoteCertificateId",
"rtcpTransportStatsId",
"selectedCandidatePairChanges",
"selectedCandidatePairId",
"srtpCipher",
"tlsVersion",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
