// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_SCHEDULER_YIELD_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_SCHEDULER_YIELD_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_scheduler_signal_inherit.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_scheduler_yield_priority.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class AbortSignal;
class ExceptionState;
class V8UnionAbortSignalOrSchedulerSignalInherit;

class MODULES_EXPORT SchedulerYieldOptions : public bindings::DictionaryBase {
  
  public:
static SchedulerYieldOptions* Create() {
  return MakeGarbageCollected<SchedulerYieldOptions>();
}
static SchedulerYieldOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<SchedulerYieldOptions>(isolate);
}
static SchedulerYieldOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  SchedulerYieldOptions();
explicit  SchedulerYieldOptions(v8::Isolate* isolate);

bool hasPriority() const {
  return has_priority_;
}
V8SchedulerYieldPriority priority() const {
  DCHECK(hasPriority());
return member_priority_;
}
V8SchedulerYieldPriority getPriorityOr(V8SchedulerYieldPriority fallback_value) const {
  if (!hasPriority()) {
  return fallback_value;
}
return member_priority_;
}
void setPriority(V8SchedulerYieldPriority value) {
  member_priority_ = value;
has_priority_ = true;
}
void setPriority(V8SchedulerYieldPriority::Enum value) {
  member_priority_ = V8SchedulerYieldPriority(value);
has_priority_ = true;
}

bool hasSignal() const {
  return has_signal_;
}
V8UnionAbortSignalOrSchedulerSignalInherit* signal() const {
  DCHECK(hasSignal());
return member_signal_.Get();
}
V8UnionAbortSignalOrSchedulerSignalInherit* getSignalOr(V8UnionAbortSignalOrSchedulerSignalInherit* fallback_value) const {
  if (!hasSignal()) {
  return fallback_value;
}
return member_signal_.Get();
}
void setSignal(V8UnionAbortSignalOrSchedulerSignalInherit* value) {
  member_signal_ = value;
has_signal_ = true;
DCHECK(member_signal_);
}


// Obsolete accessor functions
void setPriority(const String& value) {
  member_priority_ = V8SchedulerYieldPriority::Create(value).value();
has_priority_ = true;
}

void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_priority_ = false;
bool has_signal_ = false;

V8SchedulerYieldPriority member_priority_{static_cast<V8SchedulerYieldPriority::Enum>(0)};
Member<V8UnionAbortSignalOrSchedulerSignalInherit> member_signal_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_SCHEDULER_YIELD_OPTIONS_H_
