// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_serial_port_request_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_string_unsignedlong.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_serial_port_filter.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



SerialPortRequestOptions* SerialPortRequestOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  SerialPortRequestOptions* dictionary = MakeGarbageCollected<SerialPortRequestOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "SerialPortRequestOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 SerialPortRequestOptions::SerialPortRequestOptions() {
  
}

 SerialPortRequestOptions::SerialPortRequestOptions(v8::Isolate* isolate) {
  
}



HeapVector<Member<V8UnionStringOrUnsignedLong>> SerialPortRequestOptions::getAllowedBluetoothServiceClassIdsOr(const HeapVector<Member<V8UnionStringOrUnsignedLong>>& fallback_value) const {
  if (!hasAllowedBluetoothServiceClassIds()) {
  return fallback_value;
}
return member_allowed_bluetooth_service_class_ids_;
}

HeapVector<Member<V8UnionStringOrUnsignedLong>> SerialPortRequestOptions::getAllowedBluetoothServiceClassIdsOr(HeapVector<Member<V8UnionStringOrUnsignedLong>>&& fallback_value) const {
  if (!hasAllowedBluetoothServiceClassIds()) {
  return std::move(fallback_value);
}
return member_allowed_bluetooth_service_class_ids_;
}

void SerialPortRequestOptions::setAllowedBluetoothServiceClassIds(const HeapVector<Member<V8UnionStringOrUnsignedLong>>& value) {
  member_allowed_bluetooth_service_class_ids_ = value;
has_allowed_bluetooth_service_class_ids_ = true;
}

void SerialPortRequestOptions::setAllowedBluetoothServiceClassIds(HeapVector<Member<V8UnionStringOrUnsignedLong>>&& value) {
  member_allowed_bluetooth_service_class_ids_ = std::move(value);
has_allowed_bluetooth_service_class_ids_ = true;
}




HeapVector<Member<SerialPortFilter>> SerialPortRequestOptions::getFiltersOr(const HeapVector<Member<SerialPortFilter>>& fallback_value) const {
  if (!hasFilters()) {
  return fallback_value;
}
return member_filters_;
}

HeapVector<Member<SerialPortFilter>> SerialPortRequestOptions::getFiltersOr(HeapVector<Member<SerialPortFilter>>&& fallback_value) const {
  if (!hasFilters()) {
  return std::move(fallback_value);
}
return member_filters_;
}

void SerialPortRequestOptions::setFilters(const HeapVector<Member<SerialPortFilter>>& value) {
  member_filters_ = value;
has_filters_ = true;
}

void SerialPortRequestOptions::setFilters(HeapVector<Member<SerialPortFilter>>&& value) {
  member_filters_ = std::move(value);
has_filters_ = true;
}




void SerialPortRequestOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<V8UnionStringOrUnsignedLong>>>::Trace(visitor, member_allowed_bluetooth_service_class_ids_);
TraceIfNeeded<HeapVector<Member<SerialPortFilter>>>::Trace(visitor, member_filters_);
bindings::DictionaryBase::Trace(visitor);
}

bool SerialPortRequestOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAllowedBluetoothServiceClassIds()) {
  v8_value = ToV8Traits<IDLSequence<V8UnionStringOrUnsignedLong>>::ToV8(script_state, member_allowed_bluetooth_service_class_ids_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasFilters()) {
  v8_value = ToV8Traits<IDLSequence<SerialPortFilter>>::ToV8(script_state, member_filters_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void SerialPortRequestOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "SerialPortRequestOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("allowedBluetoothServiceClassIds");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8UnionStringOrUnsignedLong>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_allowed_bluetooth_service_class_ids_, member_allowed_bluetooth_service_class_ids_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("filters");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<SerialPortFilter>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_filters_, member_filters_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> SerialPortRequestOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"allowedBluetoothServiceClassIds",
"filters",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
