// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_smart_card_connect_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



SmartCardConnectOptions* SmartCardConnectOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  SmartCardConnectOptions* dictionary = MakeGarbageCollected<SmartCardConnectOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "SmartCardConnectOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 SmartCardConnectOptions::SmartCardConnectOptions() {
  
}

 SmartCardConnectOptions::SmartCardConnectOptions(v8::Isolate* isolate) {
  
}



Vector<V8SmartCardProtocol> SmartCardConnectOptions::getPreferredProtocolsOr(const Vector<V8SmartCardProtocol>& fallback_value) const {
  if (!hasPreferredProtocols()) {
  return fallback_value;
}
return member_preferred_protocols_;
}

Vector<V8SmartCardProtocol> SmartCardConnectOptions::getPreferredProtocolsOr(Vector<V8SmartCardProtocol>&& fallback_value) const {
  if (!hasPreferredProtocols()) {
  return std::move(fallback_value);
}
return member_preferred_protocols_;
}

void SmartCardConnectOptions::setPreferredProtocols(const Vector<V8SmartCardProtocol>& value) {
  member_preferred_protocols_ = value;
has_preferred_protocols_ = true;
}

void SmartCardConnectOptions::setPreferredProtocols(Vector<V8SmartCardProtocol>&& value) {
  member_preferred_protocols_ = std::move(value);
has_preferred_protocols_ = true;
}




void SmartCardConnectOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Vector<V8SmartCardProtocol>>::Trace(visitor, member_preferred_protocols_);
bindings::DictionaryBase::Trace(visitor);
}

bool SmartCardConnectOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (hasPreferredProtocols()) {
  v8::Local<v8::Value> v8_value;
v8_value = ToV8Traits<IDLSequence<V8SmartCardProtocol>>::ToV8(script_state, member_preferred_protocols_);
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
return true;
}

void SmartCardConnectOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "SmartCardConnectOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("preferredProtocols");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8SmartCardProtocol>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_preferred_protocols_, member_preferred_protocols_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> SmartCardConnectOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"preferredProtocols",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
