// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_SMART_CARD_READER_STATE_OUT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_SMART_CARD_READER_STATE_OUT_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/core/typed_arrays/array_buffer_view_helpers.h"
#include "third_party/blink/renderer/core/typed_arrays/dom_typed_array.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class SmartCardReaderStateFlagsOut;

class MODULES_EXPORT SmartCardReaderStateOut : public bindings::DictionaryBase {
  
  public:
static SmartCardReaderStateOut* Create() {
  return MakeGarbageCollected<SmartCardReaderStateOut>();
}
static SmartCardReaderStateOut* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<SmartCardReaderStateOut>(isolate);
}
static SmartCardReaderStateOut* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  SmartCardReaderStateOut();
explicit  SmartCardReaderStateOut(v8::Isolate* isolate);

bool hasAnswerToReset() const {
  return true;
}
DOMArrayBuffer* answerToReset() const {
  return member_answer_to_reset_.Get();
}
void setAnswerToReset(DOMArrayBuffer* value) {
  member_answer_to_reset_ = value;
DCHECK(member_answer_to_reset_);
}

bool hasEventCount() const {
  return true;
}
uint32_t eventCount() const {
  return member_event_count_;
}
void setEventCount(uint32_t value) {
  member_event_count_ = value;
}

bool hasEventState() const {
  return true;
}
SmartCardReaderStateFlagsOut* eventState() const {
  return member_event_state_.Get();
}
void setEventState(SmartCardReaderStateFlagsOut* value) {
  member_event_state_ = value;
DCHECK(member_event_state_);
}

bool hasReaderName() const {
  return true;
}
const String& readerName() const {
  return member_reader_name_;
}
void setReaderName(const String& value);
void setReaderName(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



Member<DOMArrayBuffer> member_answer_to_reset_;
uint32_t member_event_count_;
Member<SmartCardReaderStateFlagsOut> member_event_state_;
String member_reader_name_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_SMART_CARD_READER_STATE_OUT_H_
