// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_socket_open_info.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/streams/readable_stream.h"
#include "third_party/blink/renderer/core/streams/writable_stream.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



SocketOpenInfo* SocketOpenInfo::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  SocketOpenInfo* dictionary = MakeGarbageCollected<SocketOpenInfo>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "SocketOpenInfo";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 SocketOpenInfo::SocketOpenInfo() {
  
}

 SocketOpenInfo::SocketOpenInfo(v8::Isolate* isolate) {
  
}



String SocketOpenInfo::getLocalAddressOr(const String& fallback_value) const {
  if (!hasLocalAddress()) {
  return fallback_value;
}
return member_local_address_;
}

String SocketOpenInfo::getLocalAddressOr(String&& fallback_value) const {
  if (!hasLocalAddress()) {
  return std::move(fallback_value);
}
return member_local_address_;
}

void SocketOpenInfo::setLocalAddress(const String& value) {
  member_local_address_ = value;
has_local_address_ = true;
}

void SocketOpenInfo::setLocalAddress(String&& value) {
  member_local_address_ = std::move(value);
has_local_address_ = true;
}


















String SocketOpenInfo::getRemoteAddressOr(const String& fallback_value) const {
  if (!hasRemoteAddress()) {
  return fallback_value;
}
return member_remote_address_;
}

String SocketOpenInfo::getRemoteAddressOr(String&& fallback_value) const {
  if (!hasRemoteAddress()) {
  return std::move(fallback_value);
}
return member_remote_address_;
}

void SocketOpenInfo::setRemoteAddress(const String& value) {
  member_remote_address_ = value;
has_remote_address_ = true;
}

void SocketOpenInfo::setRemoteAddress(String&& value) {
  member_remote_address_ = std::move(value);
has_remote_address_ = true;
}


















void SocketOpenInfo::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_local_address_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_local_port_);
TraceIfNeeded<Member<ReadableStream>>::Trace(visitor, member_readable_);
TraceIfNeeded<String>::Trace(visitor, member_remote_address_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_remote_port_);
TraceIfNeeded<Member<WritableStream>>::Trace(visitor, member_writable_);
bindings::DictionaryBase::Trace(visitor);
}

bool SocketOpenInfo::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasLocalAddress()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_local_address_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasLocalPort()) {
  v8_value = ToV8Traits<IDLUnsignedShort>::ToV8(script_state, member_local_port_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasReadable()) {
  v8_value = ToV8Traits<ReadableStream>::ToV8(script_state, member_readable_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasRemoteAddress()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_remote_address_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasRemotePort()) {
  v8_value = ToV8Traits<IDLUnsignedShort>::ToV8(script_state, member_remote_port_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasWritable()) {
  v8_value = ToV8Traits<WritableStream>::ToV8(script_state, member_writable_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
return true;
}

void SocketOpenInfo::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "SocketOpenInfo";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("localAddress");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_local_address_, member_local_address_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("localPort");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_local_port_, member_local_port_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("readable");
if (!bindings::GetDictionaryMemberFromV8Object<ReadableStream, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_readable_, member_readable_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("remoteAddress");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_remote_address_, member_remote_address_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("remotePort");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_remote_port_, member_remote_port_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("writable");
if (!bindings::GetDictionaryMemberFromV8Object<WritableStream, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_writable_, member_writable_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> SocketOpenInfo::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"localAddress",
"localPort",
"readable",
"remoteAddress",
"remotePort",
"writable",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
