// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_top_level_storage_access_permission_descriptor.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



TopLevelStorageAccessPermissionDescriptor* TopLevelStorageAccessPermissionDescriptor::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  TopLevelStorageAccessPermissionDescriptor* dictionary = MakeGarbageCollected<TopLevelStorageAccessPermissionDescriptor>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "TopLevelStorageAccessPermissionDescriptor";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 TopLevelStorageAccessPermissionDescriptor::TopLevelStorageAccessPermissionDescriptor() {
  
}

 TopLevelStorageAccessPermissionDescriptor::TopLevelStorageAccessPermissionDescriptor(v8::Isolate* isolate) : PermissionDescriptor(isolate) {
  
}



void TopLevelStorageAccessPermissionDescriptor::setRequestedOrigin(const String& value) {
  member_requested_origin_ = value;
}

void TopLevelStorageAccessPermissionDescriptor::setRequestedOrigin(String&& value) {
  member_requested_origin_ = std::move(value);
}




void TopLevelStorageAccessPermissionDescriptor::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_requested_origin_);
PermissionDescriptor::Trace(visitor);
}

bool TopLevelStorageAccessPermissionDescriptor::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!PermissionDescriptor::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

if (hasRequestedOrigin()) {
  v8::Local<v8::Value> v8_value;
v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_requested_origin_);
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
return true;
}

void TopLevelStorageAccessPermissionDescriptor::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  PermissionDescriptor::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "TopLevelStorageAccessPermissionDescriptor";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("requestedOrigin");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_requested_origin_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> TopLevelStorageAccessPermissionDescriptor::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"requestedOrigin",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
