// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_FORMATTEDTEXTRUN_FORMATTEDTEXTRUNORSTRINGSEQUENCE_STRING_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_FORMATTEDTEXTRUN_FORMATTEDTEXTRUNORSTRINGSEQUENCE_STRING_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class FormattedTextRun;
class V8UnionFormattedTextRunOrString;

class MODULES_EXPORT V8UnionFormattedTextRunOrFormattedTextRunOrStringSequenceOrString final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kFormattedTextRun, kFormattedTextRunOrStringSequence, kV8FormattedTextRunList = kFormattedTextRunOrStringSequence, kString
};

static V8UnionFormattedTextRunOrFormattedTextRunOrStringSequenceOrString* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionFormattedTextRunOrFormattedTextRunOrStringSequenceOrString(FormattedTextRun* value) : content_type_(ContentType::kFormattedTextRun), member_formatted_text_run_(value) {
  DCHECK(value);
}
explicit  V8UnionFormattedTextRunOrFormattedTextRunOrStringSequenceOrString(const HeapVector<Member<V8UnionFormattedTextRunOrString>>& value);
explicit  V8UnionFormattedTextRunOrFormattedTextRunOrStringSequenceOrString(HeapVector<Member<V8UnionFormattedTextRunOrString>>&& value);
explicit  V8UnionFormattedTextRunOrFormattedTextRunOrStringSequenceOrString(const String& value);
explicit  V8UnionFormattedTextRunOrFormattedTextRunOrStringSequenceOrString(String&& value);

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsFormattedTextRun() const {
  return content_type_ == ContentType::kFormattedTextRun;
}
FormattedTextRun* GetAsFormattedTextRun() const {
  DCHECK_EQ(content_type_, ContentType::kFormattedTextRun);
return member_formatted_text_run_.Get();
}
void Set(FormattedTextRun* value) {
  DCHECK(value);
Clear();
member_formatted_text_run_ = value;
content_type_ = ContentType::kFormattedTextRun;
}

bool IsFormattedTextRunOrStringSequence() const {
  return content_type_ == ContentType::kFormattedTextRunOrStringSequence;
}
const HeapVector<Member<V8UnionFormattedTextRunOrString>>& GetAsFormattedTextRunOrStringSequence() const {
  DCHECK_EQ(content_type_, ContentType::kFormattedTextRunOrStringSequence);
return member_formatted_text_run_or_string_sequence_;
}
void Set(const HeapVector<Member<V8UnionFormattedTextRunOrString>>& value);
void Set(HeapVector<Member<V8UnionFormattedTextRunOrString>>&& value);
bool IsV8FormattedTextRunList() const {
  return content_type_ == ContentType::kV8FormattedTextRunList;
}
const HeapVector<Member<V8UnionFormattedTextRunOrString>>& GetAsV8FormattedTextRunList() const {
  DCHECK_EQ(content_type_, ContentType::kV8FormattedTextRunList);
return member_formatted_text_run_or_string_sequence_;
}

bool IsString() const {
  return content_type_ == ContentType::kString;
}
const String& GetAsString() const {
  DCHECK_EQ(content_type_, ContentType::kString);
return member_string_;
}
void Set(const String& value);
void Set(String&& value);

bool IsV8UnionFormattedTextRunOrString() const {
  return content_type_ == ContentType::kFormattedTextRun || content_type_ == ContentType::kString;
}
V8UnionFormattedTextRunOrString* GetAsV8UnionFormattedTextRunOrString() const;
void Set(const V8UnionFormattedTextRunOrString* value);
bool IsV8FormattedTextRunSingle() const {
  return IsV8UnionFormattedTextRunOrString();
}
V8UnionFormattedTextRunOrString* GetAsV8FormattedTextRunSingle() const {
  return GetAsV8UnionFormattedTextRunOrString();
}


v8::Local<v8::Value> ToV8(ScriptState* script_state) const override;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(DOMString or FormattedTextRun or sequence<FormattedTextRunSingle>)";
}

ContentType content_type_;

Member<FormattedTextRun> member_formatted_text_run_;
HeapVector<Member<V8UnionFormattedTextRunOrString>> member_formatted_text_run_or_string_sequence_;
String member_string_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_FORMATTEDTEXTRUN_FORMATTEDTEXTRUNORSTRINGSEQUENCE_STRING_H_
