// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_FORMATTEDTEXTRUN_STRING_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_FORMATTEDTEXTRUN_STRING_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class FormattedTextRun;

class MODULES_EXPORT V8UnionFormattedTextRunOrString final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kFormattedTextRun, kString
};

static V8UnionFormattedTextRunOrString* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionFormattedTextRunOrString(FormattedTextRun* value) : content_type_(ContentType::kFormattedTextRun), member_formatted_text_run_(value) {
  DCHECK(value);
}
explicit  V8UnionFormattedTextRunOrString(const String& value);
explicit  V8UnionFormattedTextRunOrString(String&& value);

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsFormattedTextRun() const {
  return content_type_ == ContentType::kFormattedTextRun;
}
FormattedTextRun* GetAsFormattedTextRun() const {
  DCHECK_EQ(content_type_, ContentType::kFormattedTextRun);
return member_formatted_text_run_.Get();
}
void Set(FormattedTextRun* value) {
  DCHECK(value);
Clear();
member_formatted_text_run_ = value;
content_type_ = ContentType::kFormattedTextRun;
}

bool IsString() const {
  return content_type_ == ContentType::kString;
}
const String& GetAsString() const {
  DCHECK_EQ(content_type_, ContentType::kString);
return member_string_;
}
void Set(const String& value);
void Set(String&& value);


v8::Local<v8::Value> ToV8(ScriptState* script_state) const override;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(DOMString or FormattedTextRun)";
}

ContentType content_type_;

Member<FormattedTextRun> member_formatted_text_run_;
String member_string_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_FORMATTEDTEXTRUN_STRING_H_
