// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_usb_device_filter.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



USBDeviceFilter* USBDeviceFilter::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  USBDeviceFilter* dictionary = MakeGarbageCollected<USBDeviceFilter>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "USBDeviceFilter";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 USBDeviceFilter::USBDeviceFilter() {
  
}

 USBDeviceFilter::USBDeviceFilter(v8::Isolate* isolate) {
  
}
























String USBDeviceFilter::getSerialNumberOr(const String& fallback_value) const {
  if (!hasSerialNumber()) {
  return fallback_value;
}
return member_serial_number_;
}

String USBDeviceFilter::getSerialNumberOr(String&& fallback_value) const {
  if (!hasSerialNumber()) {
  return std::move(fallback_value);
}
return member_serial_number_;
}

void USBDeviceFilter::setSerialNumber(const String& value) {
  member_serial_number_ = value;
has_serial_number_ = true;
}

void USBDeviceFilter::setSerialNumber(String&& value) {
  member_serial_number_ = std::move(value);
has_serial_number_ = true;
}


















void USBDeviceFilter::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint8_t>::Trace(visitor, member_class_code_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_product_id_);
TraceIfNeeded<uint8_t>::Trace(visitor, member_protocol_code_);
TraceIfNeeded<String>::Trace(visitor, member_serial_number_);
TraceIfNeeded<uint8_t>::Trace(visitor, member_subclass_code_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_vendor_id_);
bindings::DictionaryBase::Trace(visitor);
}

bool USBDeviceFilter::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasClassCode()) {
  v8_value = ToV8Traits<IDLOctet>::ToV8(script_state, member_class_code_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasProductId()) {
  v8_value = ToV8Traits<IDLUnsignedShort>::ToV8(script_state, member_product_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasProtocolCode()) {
  v8_value = ToV8Traits<IDLOctet>::ToV8(script_state, member_protocol_code_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasSerialNumber()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_serial_number_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasSubclassCode()) {
  v8_value = ToV8Traits<IDLOctet>::ToV8(script_state, member_subclass_code_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasVendorId()) {
  v8_value = ToV8Traits<IDLUnsignedShort>::ToV8(script_state, member_vendor_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
return true;
}

void USBDeviceFilter::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "USBDeviceFilter";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("classCode");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLOctet, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_class_code_, member_class_code_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("productId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_product_id_, member_product_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("protocolCode");
if (!bindings::GetDictionaryMemberFromV8Object<IDLOctet, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_protocol_code_, member_protocol_code_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("serialNumber");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_serial_number_, member_serial_number_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("subclassCode");
if (!bindings::GetDictionaryMemberFromV8Object<IDLOctet, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_subclass_code_, member_subclass_code_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("vendorId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_vendor_id_, member_vendor_id_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> USBDeviceFilter::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"classCode",
"productId",
"protocolCode",
"serialNumber",
"subclassCode",
"vendorId",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
