// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_video_color_space_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



VideoColorSpaceInit* VideoColorSpaceInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  VideoColorSpaceInit* dictionary = MakeGarbageCollected<VideoColorSpaceInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "VideoColorSpaceInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 VideoColorSpaceInit::VideoColorSpaceInit() {
  
}

 VideoColorSpaceInit::VideoColorSpaceInit(v8::Isolate* isolate) {
  
}























void VideoColorSpaceInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<absl::optional<bool>>::Trace(visitor, member_full_range_);
TraceIfNeeded<absl::optional<V8VideoMatrixCoefficients>>::Trace(visitor, member_matrix_);
TraceIfNeeded<absl::optional<V8VideoColorPrimaries>>::Trace(visitor, member_primaries_);
TraceIfNeeded<absl::optional<V8VideoTransferCharacteristics>>::Trace(visitor, member_transfer_);
bindings::DictionaryBase::Trace(visitor);
}

bool VideoColorSpaceInit::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasFullRange()) {
  v8_value = ToV8Traits<IDLNullable<IDLBoolean>>::ToV8(script_state, member_full_range_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasMatrix()) {
  v8_value = ToV8Traits<IDLNullable<V8VideoMatrixCoefficients>>::ToV8(script_state, member_matrix_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasPrimaries()) {
  v8_value = ToV8Traits<IDLNullable<V8VideoColorPrimaries>>::ToV8(script_state, member_primaries_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasTransfer()) {
  v8_value = ToV8Traits<IDLNullable<V8VideoTransferCharacteristics>>::ToV8(script_state, member_transfer_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void VideoColorSpaceInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "VideoColorSpaceInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("fullRange");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLBoolean>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_full_range_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("matrix");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<V8VideoMatrixCoefficients>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_matrix_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("primaries");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<V8VideoColorPrimaries>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_primaries_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("transfer");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<V8VideoTransferCharacteristics>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_transfer_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> VideoColorSpaceInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"fullRange",
"matrix",
"primaries",
"transfer",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
