// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_video_encoder_encode_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_video_encoder_encode_options_for_av_1.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_video_encoder_encode_options_for_avc.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_video_encoder_encode_options_for_vp_9.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



VideoEncoderEncodeOptions* VideoEncoderEncodeOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  VideoEncoderEncodeOptions* dictionary = MakeGarbageCollected<VideoEncoderEncodeOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "VideoEncoderEncodeOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 VideoEncoderEncodeOptions::VideoEncoderEncodeOptions() {
  
}

 VideoEncoderEncodeOptions::VideoEncoderEncodeOptions(v8::Isolate* isolate) {
  
}





























void VideoEncoderEncodeOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<VideoEncoderEncodeOptionsForAv1>>::Trace(visitor, member_av_1_);
TraceIfNeeded<Member<VideoEncoderEncodeOptionsForAvc>>::Trace(visitor, member_avc_);
TraceIfNeeded<bool>::Trace(visitor, member_key_frame_);
TraceIfNeeded<Member<VideoEncoderEncodeOptionsForVp9>>::Trace(visitor, member_vp_9_);
bindings::DictionaryBase::Trace(visitor);
}

bool VideoEncoderEncodeOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAv1()) {
  v8_value = ToV8Traits<VideoEncoderEncodeOptionsForAv1>::ToV8(script_state, member_av_1_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasAvc()) {
  v8_value = ToV8Traits<VideoEncoderEncodeOptionsForAvc>::ToV8(script_state, member_avc_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasKeyFrame()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_key_frame_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasVp9()) {
  v8_value = ToV8Traits<VideoEncoderEncodeOptionsForVp9>::ToV8(script_state, member_vp_9_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void VideoEncoderEncodeOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "VideoEncoderEncodeOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("av1");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<VideoEncoderEncodeOptionsForAv1, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_av_1_, member_av_1_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("avc");
if (!bindings::GetDictionaryMemberFromV8Object<VideoEncoderEncodeOptionsForAvc, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_avc_, member_avc_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("keyFrame");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_key_frame_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("vp9");
if (!bindings::GetDictionaryMemberFromV8Object<VideoEncoderEncodeOptionsForVp9, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_vp_9_, member_vp_9_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> VideoEncoderEncodeOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"av1",
"avc",
"keyFrame",
"vp9",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
