// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_web_print_job_attributes.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



WebPrintJobAttributes* WebPrintJobAttributes::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  WebPrintJobAttributes* dictionary = MakeGarbageCollected<WebPrintJobAttributes>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "WebPrintJobAttributes";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 WebPrintJobAttributes::WebPrintJobAttributes() {
  
}

 WebPrintJobAttributes::WebPrintJobAttributes(v8::Isolate* isolate) {
  
}



String WebPrintJobAttributes::getJobNameOr(const String& fallback_value) const {
  if (!hasJobName()) {
  return fallback_value;
}
return member_job_name_;
}

String WebPrintJobAttributes::getJobNameOr(String&& fallback_value) const {
  if (!hasJobName()) {
  return std::move(fallback_value);
}
return member_job_name_;
}

void WebPrintJobAttributes::setJobName(const String& value) {
  member_job_name_ = value;
has_job_name_ = true;
}

void WebPrintJobAttributes::setJobName(String&& value) {
  member_job_name_ = std::move(value);
has_job_name_ = true;
}

























void WebPrintJobAttributes::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_job_name_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_job_pages_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_job_pages_completed_);
TraceIfNeeded<V8WebPrintJobState>::Trace(visitor, member_job_state_);
bindings::DictionaryBase::Trace(visitor);
}

bool WebPrintJobAttributes::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasJobName()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_job_name_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasJobPages()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_job_pages_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasJobPagesCompleted()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_job_pages_completed_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasJobState()) {
  v8_value = ToV8Traits<V8WebPrintJobState>::ToV8(script_state, member_job_state_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void WebPrintJobAttributes::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "WebPrintJobAttributes";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("jobName");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_job_name_, member_job_name_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("jobPages");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_job_pages_, member_job_pages_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("jobPagesCompleted");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_job_pages_completed_, member_job_pages_completed_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("jobState");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintJobState, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_job_state_, member_job_state_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> WebPrintJobAttributes::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"jobName",
"jobPages",
"jobPagesCompleted",
"jobState",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
