// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_web_printer_attributes.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_web_printing_range.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_web_printing_resolution.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



WebPrinterAttributes* WebPrinterAttributes::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  WebPrinterAttributes* dictionary = MakeGarbageCollected<WebPrinterAttributes>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "WebPrinterAttributes";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 WebPrinterAttributes::WebPrinterAttributes() {
  
}

 WebPrinterAttributes::WebPrinterAttributes(v8::Isolate* isolate) {
  
}
























Vector<V8WebPrintingMimeMediaType> WebPrinterAttributes::getDocumentFormatSupportedOr(const Vector<V8WebPrintingMimeMediaType>& fallback_value) const {
  if (!hasDocumentFormatSupported()) {
  return fallback_value;
}
return member_document_format_supported_;
}

Vector<V8WebPrintingMimeMediaType> WebPrinterAttributes::getDocumentFormatSupportedOr(Vector<V8WebPrintingMimeMediaType>&& fallback_value) const {
  if (!hasDocumentFormatSupported()) {
  return std::move(fallback_value);
}
return member_document_format_supported_;
}

void WebPrinterAttributes::setDocumentFormatSupported(const Vector<V8WebPrintingMimeMediaType>& value) {
  member_document_format_supported_ = value;
has_document_format_supported_ = true;
}

void WebPrinterAttributes::setDocumentFormatSupported(Vector<V8WebPrintingMimeMediaType>&& value) {
  member_document_format_supported_ = std::move(value);
has_document_format_supported_ = true;
}











Vector<V8WebPrintingMultipleDocumentHandling> WebPrinterAttributes::getMultipleDocumentHandlingSupportedOr(const Vector<V8WebPrintingMultipleDocumentHandling>& fallback_value) const {
  if (!hasMultipleDocumentHandlingSupported()) {
  return fallback_value;
}
return member_multiple_document_handling_supported_;
}

Vector<V8WebPrintingMultipleDocumentHandling> WebPrinterAttributes::getMultipleDocumentHandlingSupportedOr(Vector<V8WebPrintingMultipleDocumentHandling>&& fallback_value) const {
  if (!hasMultipleDocumentHandlingSupported()) {
  return std::move(fallback_value);
}
return member_multiple_document_handling_supported_;
}

void WebPrinterAttributes::setMultipleDocumentHandlingSupported(const Vector<V8WebPrintingMultipleDocumentHandling>& value) {
  member_multiple_document_handling_supported_ = value;
has_multiple_document_handling_supported_ = true;
}

void WebPrinterAttributes::setMultipleDocumentHandlingSupported(Vector<V8WebPrintingMultipleDocumentHandling>&& value) {
  member_multiple_document_handling_supported_ = std::move(value);
has_multiple_document_handling_supported_ = true;
}











Vector<V8WebPrintColorMode> WebPrinterAttributes::getPrintColorModeSupportedOr(const Vector<V8WebPrintColorMode>& fallback_value) const {
  if (!hasPrintColorModeSupported()) {
  return fallback_value;
}
return member_print_color_mode_supported_;
}

Vector<V8WebPrintColorMode> WebPrinterAttributes::getPrintColorModeSupportedOr(Vector<V8WebPrintColorMode>&& fallback_value) const {
  if (!hasPrintColorModeSupported()) {
  return std::move(fallback_value);
}
return member_print_color_mode_supported_;
}

void WebPrinterAttributes::setPrintColorModeSupported(const Vector<V8WebPrintColorMode>& value) {
  member_print_color_mode_supported_ = value;
has_print_color_mode_supported_ = true;
}

void WebPrinterAttributes::setPrintColorModeSupported(Vector<V8WebPrintColorMode>&& value) {
  member_print_color_mode_supported_ = std::move(value);
has_print_color_mode_supported_ = true;
}











Vector<V8WebPrintQuality> WebPrinterAttributes::getPrintQualitySupportedOr(const Vector<V8WebPrintQuality>& fallback_value) const {
  if (!hasPrintQualitySupported()) {
  return fallback_value;
}
return member_print_quality_supported_;
}

Vector<V8WebPrintQuality> WebPrinterAttributes::getPrintQualitySupportedOr(Vector<V8WebPrintQuality>&& fallback_value) const {
  if (!hasPrintQualitySupported()) {
  return std::move(fallback_value);
}
return member_print_quality_supported_;
}

void WebPrinterAttributes::setPrintQualitySupported(const Vector<V8WebPrintQuality>& value) {
  member_print_quality_supported_ = value;
has_print_quality_supported_ = true;
}

void WebPrinterAttributes::setPrintQualitySupported(Vector<V8WebPrintQuality>&& value) {
  member_print_quality_supported_ = std::move(value);
has_print_quality_supported_ = true;
}




String WebPrinterAttributes::getPrinterNameOr(const String& fallback_value) const {
  if (!hasPrinterName()) {
  return fallback_value;
}
return member_printer_name_;
}

String WebPrinterAttributes::getPrinterNameOr(String&& fallback_value) const {
  if (!hasPrinterName()) {
  return std::move(fallback_value);
}
return member_printer_name_;
}

void WebPrinterAttributes::setPrinterName(const String& value) {
  member_printer_name_ = value;
has_printer_name_ = true;
}

void WebPrinterAttributes::setPrinterName(String&& value) {
  member_printer_name_ = std::move(value);
has_printer_name_ = true;
}











HeapVector<Member<WebPrintingResolution>> WebPrinterAttributes::getPrinterResolutionSupportedOr(const HeapVector<Member<WebPrintingResolution>>& fallback_value) const {
  if (!hasPrinterResolutionSupported()) {
  return fallback_value;
}
return member_printer_resolution_supported_;
}

HeapVector<Member<WebPrintingResolution>> WebPrinterAttributes::getPrinterResolutionSupportedOr(HeapVector<Member<WebPrintingResolution>>&& fallback_value) const {
  if (!hasPrinterResolutionSupported()) {
  return std::move(fallback_value);
}
return member_printer_resolution_supported_;
}

void WebPrinterAttributes::setPrinterResolutionSupported(const HeapVector<Member<WebPrintingResolution>>& value) {
  member_printer_resolution_supported_ = value;
has_printer_resolution_supported_ = true;
}

void WebPrinterAttributes::setPrinterResolutionSupported(HeapVector<Member<WebPrintingResolution>>&& value) {
  member_printer_resolution_supported_ = std::move(value);
has_printer_resolution_supported_ = true;
}











String WebPrinterAttributes::getPrinterStateMessageOr(const String& fallback_value) const {
  if (!hasPrinterStateMessage()) {
  return fallback_value;
}
return member_printer_state_message_;
}

String WebPrinterAttributes::getPrinterStateMessageOr(String&& fallback_value) const {
  if (!hasPrinterStateMessage()) {
  return std::move(fallback_value);
}
return member_printer_state_message_;
}

void WebPrinterAttributes::setPrinterStateMessage(const String& value) {
  member_printer_state_message_ = value;
has_printer_state_message_ = true;
}

void WebPrinterAttributes::setPrinterStateMessage(String&& value) {
  member_printer_state_message_ = std::move(value);
has_printer_state_message_ = true;
}




Vector<V8WebPrinterStateReason> WebPrinterAttributes::getPrinterStateReasonsOr(const Vector<V8WebPrinterStateReason>& fallback_value) const {
  if (!hasPrinterStateReasons()) {
  return fallback_value;
}
return member_printer_state_reasons_;
}

Vector<V8WebPrinterStateReason> WebPrinterAttributes::getPrinterStateReasonsOr(Vector<V8WebPrinterStateReason>&& fallback_value) const {
  if (!hasPrinterStateReasons()) {
  return std::move(fallback_value);
}
return member_printer_state_reasons_;
}

void WebPrinterAttributes::setPrinterStateReasons(const Vector<V8WebPrinterStateReason>& value) {
  member_printer_state_reasons_ = value;
has_printer_state_reasons_ = true;
}

void WebPrinterAttributes::setPrinterStateReasons(Vector<V8WebPrinterStateReason>&& value) {
  member_printer_state_reasons_ = std::move(value);
has_printer_state_reasons_ = true;
}











Vector<V8WebPrintingSides> WebPrinterAttributes::getSidesSupportedOr(const Vector<V8WebPrintingSides>& fallback_value) const {
  if (!hasSidesSupported()) {
  return fallback_value;
}
return member_sides_supported_;
}

Vector<V8WebPrintingSides> WebPrinterAttributes::getSidesSupportedOr(Vector<V8WebPrintingSides>&& fallback_value) const {
  if (!hasSidesSupported()) {
  return std::move(fallback_value);
}
return member_sides_supported_;
}

void WebPrinterAttributes::setSidesSupported(const Vector<V8WebPrintingSides>& value) {
  member_sides_supported_ = value;
has_sides_supported_ = true;
}

void WebPrinterAttributes::setSidesSupported(Vector<V8WebPrintingSides>&& value) {
  member_sides_supported_ = std::move(value);
has_sides_supported_ = true;
}




void WebPrinterAttributes::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_copies_default_);
TraceIfNeeded<Member<WebPrintingRange>>::Trace(visitor, member_copies_supported_);
TraceIfNeeded<V8WebPrintingMimeMediaType>::Trace(visitor, member_document_format_default_);
TraceIfNeeded<Vector<V8WebPrintingMimeMediaType>>::Trace(visitor, member_document_format_supported_);
TraceIfNeeded<V8WebPrintingMultipleDocumentHandling>::Trace(visitor, member_multiple_document_handling_default_);
TraceIfNeeded<Vector<V8WebPrintingMultipleDocumentHandling>>::Trace(visitor, member_multiple_document_handling_supported_);
TraceIfNeeded<V8WebPrintColorMode>::Trace(visitor, member_print_color_mode_default_);
TraceIfNeeded<Vector<V8WebPrintColorMode>>::Trace(visitor, member_print_color_mode_supported_);
TraceIfNeeded<V8WebPrintQuality>::Trace(visitor, member_print_quality_default_);
TraceIfNeeded<Vector<V8WebPrintQuality>>::Trace(visitor, member_print_quality_supported_);
TraceIfNeeded<String>::Trace(visitor, member_printer_name_);
TraceIfNeeded<Member<WebPrintingResolution>>::Trace(visitor, member_printer_resolution_default_);
TraceIfNeeded<HeapVector<Member<WebPrintingResolution>>>::Trace(visitor, member_printer_resolution_supported_);
TraceIfNeeded<V8WebPrinterState>::Trace(visitor, member_printer_state_);
TraceIfNeeded<String>::Trace(visitor, member_printer_state_message_);
TraceIfNeeded<Vector<V8WebPrinterStateReason>>::Trace(visitor, member_printer_state_reasons_);
TraceIfNeeded<V8WebPrintingSides>::Trace(visitor, member_sides_default_);
TraceIfNeeded<Vector<V8WebPrintingSides>>::Trace(visitor, member_sides_supported_);
bindings::DictionaryBase::Trace(visitor);
}

bool WebPrinterAttributes::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasCopiesDefault()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_copies_default_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasCopiesSupported()) {
  v8_value = ToV8Traits<WebPrintingRange>::ToV8(script_state, member_copies_supported_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasDocumentFormatDefault()) {
  v8_value = ToV8Traits<V8WebPrintingMimeMediaType>::ToV8(script_state, member_document_format_default_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasDocumentFormatSupported()) {
  v8_value = ToV8Traits<IDLSequence<V8WebPrintingMimeMediaType>>::ToV8(script_state, member_document_format_supported_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasMultipleDocumentHandlingDefault()) {
  v8_value = ToV8Traits<V8WebPrintingMultipleDocumentHandling>::ToV8(script_state, member_multiple_document_handling_default_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasMultipleDocumentHandlingSupported()) {
  v8_value = ToV8Traits<IDLSequence<V8WebPrintingMultipleDocumentHandling>>::ToV8(script_state, member_multiple_document_handling_supported_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasPrintColorModeDefault()) {
  v8_value = ToV8Traits<V8WebPrintColorMode>::ToV8(script_state, member_print_color_mode_default_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (hasPrintColorModeSupported()) {
  v8_value = ToV8Traits<IDLSequence<V8WebPrintColorMode>>::ToV8(script_state, member_print_color_mode_supported_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
if (hasPrintQualityDefault()) {
  v8_value = ToV8Traits<V8WebPrintQuality>::ToV8(script_state, member_print_quality_default_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[8].Get(isolate), v8_value).ToChecked();
}
if (hasPrintQualitySupported()) {
  v8_value = ToV8Traits<IDLSequence<V8WebPrintQuality>>::ToV8(script_state, member_print_quality_supported_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[9].Get(isolate), v8_value).ToChecked();
}
if (hasPrinterName()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_printer_name_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[10].Get(isolate), v8_value).ToChecked();
}
if (hasPrinterResolutionDefault()) {
  v8_value = ToV8Traits<WebPrintingResolution>::ToV8(script_state, member_printer_resolution_default_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[11].Get(isolate), v8_value).ToChecked();
}
if (hasPrinterResolutionSupported()) {
  v8_value = ToV8Traits<IDLSequence<WebPrintingResolution>>::ToV8(script_state, member_printer_resolution_supported_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[12].Get(isolate), v8_value).ToChecked();
}
if (hasPrinterState()) {
  v8_value = ToV8Traits<V8WebPrinterState>::ToV8(script_state, member_printer_state_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[13].Get(isolate), v8_value).ToChecked();
}
if (hasPrinterStateMessage()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_printer_state_message_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[14].Get(isolate), v8_value).ToChecked();
}
if (hasPrinterStateReasons()) {
  v8_value = ToV8Traits<IDLSequence<V8WebPrinterStateReason>>::ToV8(script_state, member_printer_state_reasons_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[15].Get(isolate), v8_value).ToChecked();
}
if (hasSidesDefault()) {
  v8_value = ToV8Traits<V8WebPrintingSides>::ToV8(script_state, member_sides_default_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[16].Get(isolate), v8_value).ToChecked();
}
if (hasSidesSupported()) {
  v8_value = ToV8Traits<IDLSequence<V8WebPrintingSides>>::ToV8(script_state, member_sides_supported_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[17].Get(isolate), v8_value).ToChecked();
}
return true;
}

void WebPrinterAttributes::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "WebPrinterAttributes";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("copiesDefault");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_copies_default_, member_copies_default_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("copiesSupported");
if (!bindings::GetDictionaryMemberFromV8Object<WebPrintingRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_copies_supported_, member_copies_supported_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("documentFormatDefault");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintingMimeMediaType, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_document_format_default_, member_document_format_default_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("documentFormatSupported");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8WebPrintingMimeMediaType>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_document_format_supported_, member_document_format_supported_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("multipleDocumentHandlingDefault");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintingMultipleDocumentHandling, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_multiple_document_handling_default_, member_multiple_document_handling_default_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("multipleDocumentHandlingSupported");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8WebPrintingMultipleDocumentHandling>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_multiple_document_handling_supported_, member_multiple_document_handling_supported_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printColorModeDefault");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintColorMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_print_color_mode_default_, member_print_color_mode_default_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printColorModeSupported");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8WebPrintColorMode>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_print_color_mode_supported_, member_print_color_mode_supported_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printQualityDefault");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintQuality, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_print_quality_default_, member_print_quality_default_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printQualitySupported");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8WebPrintQuality>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), has_print_quality_supported_, member_print_quality_supported_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printerName");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), has_printer_name_, member_printer_name_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printerResolutionDefault");
if (!bindings::GetDictionaryMemberFromV8Object<WebPrintingResolution, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), has_printer_resolution_default_, member_printer_resolution_default_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printerResolutionSupported");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<WebPrintingResolution>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), has_printer_resolution_supported_, member_printer_resolution_supported_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printerState");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrinterState, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[13].Get(isolate), has_printer_state_, member_printer_state_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printerStateMessage");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[14].Get(isolate), has_printer_state_message_, member_printer_state_message_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printerStateReasons");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8WebPrinterStateReason>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[15].Get(isolate), has_printer_state_reasons_, member_printer_state_reasons_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sidesDefault");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintingSides, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[16].Get(isolate), has_sides_default_, member_sides_default_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sidesSupported");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8WebPrintingSides>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[17].Get(isolate), has_sides_supported_, member_sides_supported_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> WebPrinterAttributes::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"copiesDefault",
"copiesSupported",
"documentFormatDefault",
"documentFormatSupported",
"multipleDocumentHandlingDefault",
"multipleDocumentHandlingSupported",
"printColorModeDefault",
"printColorModeSupported",
"printQualityDefault",
"printQualitySupported",
"printerName",
"printerResolutionDefault",
"printerResolutionSupported",
"printerState",
"printerStateMessage",
"printerStateReasons",
"sidesDefault",
"sidesSupported",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
