// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_websocket_open_info.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/streams/readable_stream.h"
#include "third_party/blink/renderer/core/streams/writable_stream.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



WebSocketOpenInfo* WebSocketOpenInfo::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  WebSocketOpenInfo* dictionary = MakeGarbageCollected<WebSocketOpenInfo>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "WebSocketOpenInfo";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 WebSocketOpenInfo::WebSocketOpenInfo() {
  
}

 WebSocketOpenInfo::WebSocketOpenInfo(v8::Isolate* isolate) {
  
}



String WebSocketOpenInfo::getExtensionsOr(const String& fallback_value) const {
  if (!hasExtensions()) {
  return fallback_value;
}
return member_extensions_;
}

String WebSocketOpenInfo::getExtensionsOr(String&& fallback_value) const {
  if (!hasExtensions()) {
  return std::move(fallback_value);
}
return member_extensions_;
}

void WebSocketOpenInfo::setExtensions(const String& value) {
  member_extensions_ = value;
has_extensions_ = true;
}

void WebSocketOpenInfo::setExtensions(String&& value) {
  member_extensions_ = std::move(value);
has_extensions_ = true;
}




String WebSocketOpenInfo::getProtocolOr(const String& fallback_value) const {
  if (!hasProtocol()) {
  return fallback_value;
}
return member_protocol_;
}

String WebSocketOpenInfo::getProtocolOr(String&& fallback_value) const {
  if (!hasProtocol()) {
  return std::move(fallback_value);
}
return member_protocol_;
}

void WebSocketOpenInfo::setProtocol(const String& value) {
  member_protocol_ = value;
has_protocol_ = true;
}

void WebSocketOpenInfo::setProtocol(String&& value) {
  member_protocol_ = std::move(value);
has_protocol_ = true;
}


















void WebSocketOpenInfo::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_extensions_);
TraceIfNeeded<String>::Trace(visitor, member_protocol_);
TraceIfNeeded<Member<ReadableStream>>::Trace(visitor, member_readable_);
TraceIfNeeded<Member<WritableStream>>::Trace(visitor, member_writable_);
bindings::DictionaryBase::Trace(visitor);
}

bool WebSocketOpenInfo::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasExtensions()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_extensions_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasProtocol()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_protocol_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasReadable()) {
  v8_value = ToV8Traits<ReadableStream>::ToV8(script_state, member_readable_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasWritable()) {
  v8_value = ToV8Traits<WritableStream>::ToV8(script_state, member_writable_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void WebSocketOpenInfo::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "WebSocketOpenInfo";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("extensions");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_extensions_, member_extensions_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("protocol");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_protocol_, member_protocol_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("readable");
if (!bindings::GetDictionaryMemberFromV8Object<ReadableStream, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_readable_, member_readable_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("writable");
if (!bindings::GetDictionaryMemberFromV8Object<WritableStream, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_writable_, member_writable_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> WebSocketOpenInfo::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"extensions",
"protocol",
"readable",
"writable",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
