// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_xr_hit_test_options_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/xr/xr_ray.h"
#include "third_party/blink/renderer/modules/xr/xr_space.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



XRHitTestOptionsInit* XRHitTestOptionsInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  XRHitTestOptionsInit* dictionary = MakeGarbageCollected<XRHitTestOptionsInit>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "XRHitTestOptionsInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 XRHitTestOptionsInit::XRHitTestOptionsInit() {
  
}

 XRHitTestOptionsInit::XRHitTestOptionsInit(v8::Isolate* isolate) {
  
}



Vector<V8XRHitTestTrackableType> XRHitTestOptionsInit::getEntityTypesOr(const Vector<V8XRHitTestTrackableType>& fallback_value) const {
  if (!hasEntityTypes()) {
  return fallback_value;
}
return member_entity_types_;
}

Vector<V8XRHitTestTrackableType> XRHitTestOptionsInit::getEntityTypesOr(Vector<V8XRHitTestTrackableType>&& fallback_value) const {
  if (!hasEntityTypes()) {
  return std::move(fallback_value);
}
return member_entity_types_;
}

void XRHitTestOptionsInit::setEntityTypes(const Vector<V8XRHitTestTrackableType>& value) {
  member_entity_types_ = value;
has_entity_types_ = true;
}

void XRHitTestOptionsInit::setEntityTypes(Vector<V8XRHitTestTrackableType>&& value) {
  member_entity_types_ = std::move(value);
has_entity_types_ = true;
}
















void XRHitTestOptionsInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<Vector<V8XRHitTestTrackableType>>::Trace(visitor, member_entity_types_);
TraceIfNeeded<Member<XRRay>>::Trace(visitor, member_offset_ray_);
TraceIfNeeded<Member<XRSpace>>::Trace(visitor, member_space_);
bindings::DictionaryBase::Trace(visitor);
}

bool XRHitTestOptionsInit::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (RuntimeEnabledFeatures::WebXRHitTestEntityTypesEnabled()) {
  if (hasEntityTypes()) {
  v8_value = ToV8Traits<IDLArray<V8XRHitTestTrackableType>>::ToV8(script_state, member_entity_types_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
}
if (hasOffsetRay()) {
  v8_value = ToV8Traits<XRRay>::ToV8(script_state, member_offset_ray_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasSpace()) {
  v8_value = ToV8Traits<XRSpace>::ToV8(script_state, member_space_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void XRHitTestOptionsInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "XRHitTestOptionsInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (RuntimeEnabledFeatures::WebXRHitTestEntityTypesEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("entityTypes");
if (!bindings::GetDictionaryMemberFromV8Object<IDLArray<V8XRHitTestTrackableType>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_entity_types_, member_entity_types_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("offsetRay");
if (!bindings::GetDictionaryMemberFromV8Object<XRRay, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_offset_ray_, member_offset_ray_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("space");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<XRSpace, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_space_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> XRHitTestOptionsInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"entityTypes",
"offsetRay",
"space",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
