/* Generated by wayland-scanner 1.22.0 */

#ifndef TOUCHPAD_HAPTICS_UNSTABLE_V1_CLIENT_PROTOCOL_H
#define TOUCHPAD_HAPTICS_UNSTABLE_V1_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_touchpad_haptics_unstable_v1 The touchpad_haptics_unstable_v1 protocol
 * @section page_ifaces_touchpad_haptics_unstable_v1 Interfaces
 * - @subpage page_iface_zcr_touchpad_haptics_v1 - Allows to play haptic feedback effects on touchpad
 * @section page_copyright_touchpad_haptics_unstable_v1 Copyright
 * <pre>
 *
 * Copyright 2021 The Chromium Authors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct zcr_touchpad_haptics_v1;

#ifndef ZCR_TOUCHPAD_HAPTICS_V1_INTERFACE
#define ZCR_TOUCHPAD_HAPTICS_V1_INTERFACE
/**
 * @page page_iface_zcr_touchpad_haptics_v1 zcr_touchpad_haptics_v1
 * @section page_iface_zcr_touchpad_haptics_v1_desc Description
 *
 * Allows to play haptic feedback effects on touchpad.
 *
 * Warning! The protocol described in this file is experimental and
 * backward incompatible changes may be made. Backward compatible changes
 * may be added together with the corresponding uinterface version bump.
 * Backward incompatible changes are done by bumping the version number in
 * the protocol and uinterface names and resetting the interface version.
 * Once the protocol is to be declared stable, the 'z' prefix and the
 * version number in the protocol and interface names are removed and the
 * interface version number is reset.
 * @section page_iface_zcr_touchpad_haptics_v1_api API
 * See @ref iface_zcr_touchpad_haptics_v1.
 */
/**
 * @defgroup iface_zcr_touchpad_haptics_v1 The zcr_touchpad_haptics_v1 interface
 *
 * Allows to play haptic feedback effects on touchpad.
 *
 * Warning! The protocol described in this file is experimental and
 * backward incompatible changes may be made. Backward compatible changes
 * may be added together with the corresponding uinterface version bump.
 * Backward incompatible changes are done by bumping the version number in
 * the protocol and uinterface names and resetting the interface version.
 * Once the protocol is to be declared stable, the 'z' prefix and the
 * version number in the protocol and interface names are removed and the
 * interface version number is reset.
 */
extern const struct wl_interface zcr_touchpad_haptics_v1_interface;
#endif

#ifndef ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_ENUM
#define ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_ENUM
enum zcr_touchpad_haptics_v1_effect {
	/**
	 * UI feedback for snapping into place
	 */
	ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_SNAP = 0,
	/**
	 * UI feedback for snapping out of place
	 */
	ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_SNAP_REVERSE = 1,
	/**
	 * UI feedback for reaching a limit or boundary
	 */
	ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_KNOCK = 2,
	/**
	 * UI feedback for discrete state changes
	 */
	ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_TICK = 3,
	/**
	 * UI feedback for activating a feature
	 */
	ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_TOGGLE_ON = 4,
	/**
	 * UI feedback for deactivating a feature
	 */
	ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_TOGGLE_OFF = 5,
	/**
	 * Standard touchpad button down effect
	 */
	ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_PRESS = 6,
	/**
	 * Standard touchpad button up effect
	 */
	ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_RELEASE = 7,
	/**
	 * Deeper (more force) touchpad button down effect
	 */
	ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_DEEP_PRESS = 8,
	/**
	 * Deeper (more force) touchpad button up effect
	 */
	ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_DEEP_RELEASE = 9,
};
#endif /* ZCR_TOUCHPAD_HAPTICS_V1_EFFECT_ENUM */

/**
 * @ingroup iface_zcr_touchpad_haptics_v1
 * @struct zcr_touchpad_haptics_v1_listener
 */
struct zcr_touchpad_haptics_v1_listener {
	/**
	 * touchpad haptics activated
	 *
	 * Inform the client that a haptic touchpad is present and ready
	 * to perform effects.
	 */
	void (*activated)(void *data,
			  struct zcr_touchpad_haptics_v1 *zcr_touchpad_haptics_v1);
	/**
	 * touchpad haptics deactivated
	 *
	 * Inform the client that no haptic touchpad is available, likely
	 * because the user disabled haptic effects.
	 */
	void (*deactivated)(void *data,
			    struct zcr_touchpad_haptics_v1 *zcr_touchpad_haptics_v1);
};

/**
 * @ingroup iface_zcr_touchpad_haptics_v1
 */
static inline int
zcr_touchpad_haptics_v1_add_listener(struct zcr_touchpad_haptics_v1 *zcr_touchpad_haptics_v1,
				     const struct zcr_touchpad_haptics_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zcr_touchpad_haptics_v1,
				     (void (**)(void)) listener, data);
}

#define ZCR_TOUCHPAD_HAPTICS_V1_DESTROY 0
#define ZCR_TOUCHPAD_HAPTICS_V1_PLAY 1

/**
 * @ingroup iface_zcr_touchpad_haptics_v1
 */
#define ZCR_TOUCHPAD_HAPTICS_V1_ACTIVATED_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_touchpad_haptics_v1
 */
#define ZCR_TOUCHPAD_HAPTICS_V1_DEACTIVATED_SINCE_VERSION 1

/**
 * @ingroup iface_zcr_touchpad_haptics_v1
 */
#define ZCR_TOUCHPAD_HAPTICS_V1_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_touchpad_haptics_v1
 */
#define ZCR_TOUCHPAD_HAPTICS_V1_PLAY_SINCE_VERSION 1

/** @ingroup iface_zcr_touchpad_haptics_v1 */
static inline void
zcr_touchpad_haptics_v1_set_user_data(struct zcr_touchpad_haptics_v1 *zcr_touchpad_haptics_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zcr_touchpad_haptics_v1, user_data);
}

/** @ingroup iface_zcr_touchpad_haptics_v1 */
static inline void *
zcr_touchpad_haptics_v1_get_user_data(struct zcr_touchpad_haptics_v1 *zcr_touchpad_haptics_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zcr_touchpad_haptics_v1);
}

static inline uint32_t
zcr_touchpad_haptics_v1_get_version(struct zcr_touchpad_haptics_v1 *zcr_touchpad_haptics_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zcr_touchpad_haptics_v1);
}

/**
 * @ingroup iface_zcr_touchpad_haptics_v1
 *
 * Destroy touchpad_haptics object.
 */
static inline void
zcr_touchpad_haptics_v1_destroy(struct zcr_touchpad_haptics_v1 *zcr_touchpad_haptics_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_touchpad_haptics_v1,
			 ZCR_TOUCHPAD_HAPTICS_V1_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_touchpad_haptics_v1), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_zcr_touchpad_haptics_v1
 *
 * Play the given haptic feedback with the given strength.
 * The strength should be in [1, 5].
 */
static inline void
zcr_touchpad_haptics_v1_play(struct zcr_touchpad_haptics_v1 *zcr_touchpad_haptics_v1, uint32_t effect, int32_t strength)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_touchpad_haptics_v1,
			 ZCR_TOUCHPAD_HAPTICS_V1_PLAY, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_touchpad_haptics_v1), 0, effect, strength);
}

#ifdef  __cplusplus
}
#endif

#endif
