// ui/display/mojom/display_color_management.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_DISPLAY_MOJOM_DISPLAY_COLOR_MANAGEMENT_MOJOM_H_
#define UI_DISPLAY_MOJOM_DISPLAY_COLOR_MANAGEMENT_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "ui/display/mojom/display_color_management.mojom-features.h"
#include "ui/display/mojom/display_color_management.mojom-shared.h"
#include "ui/display/mojom/display_color_management.mojom-forward.h"
#include "skia/public/mojom/skcolorspace.mojom.h"
#include "ui/display/mojom/gamma_ramp_rgb_entry.mojom.h"
#include <string>
#include <vector>




#include "ui/display/mojom/display_color_management_mojom_traits.h"
#include "ui/display/mojom/display_configuration_params_mojom_traits.h"




namespace display::mojom {











class  GammaCurve {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<GammaCurve, T>::value>;
  using DataView = GammaCurveDataView;
  using Data_ = internal::GammaCurve_Data;

  template <typename... Args>
  static GammaCurvePtr New(Args&&... args) {
    return GammaCurvePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static GammaCurvePtr From(const U& u) {
    return mojo::TypeConverter<GammaCurvePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, GammaCurve>::Convert(*this);
  }


  GammaCurve();

  explicit GammaCurve(
      std::vector<::display::GammaRampRGBEntry> lut);


  ~GammaCurve();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = GammaCurvePtr>
  GammaCurvePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, GammaCurve::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, GammaCurve::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, GammaCurve::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        GammaCurve::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        GammaCurve::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::GammaCurve_UnserializedMessageContext<
            UserType, GammaCurve::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<GammaCurve::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return GammaCurve::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::GammaCurve_UnserializedMessageContext<
            UserType, GammaCurve::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<GammaCurve::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::vector<::display::GammaRampRGBEntry> lut;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, GammaCurve::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, GammaCurve::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, GammaCurve::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, GammaCurve::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ColorCalibration {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ColorCalibration, T>::value>;
  using DataView = ColorCalibrationDataView;
  using Data_ = internal::ColorCalibration_Data;

  template <typename... Args>
  static ColorCalibrationPtr New(Args&&... args) {
    return ColorCalibrationPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ColorCalibrationPtr From(const U& u) {
    return mojo::TypeConverter<ColorCalibrationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ColorCalibration>::Convert(*this);
  }


  ColorCalibration();

  ColorCalibration(
      const ::display::GammaCurve& srgb_to_linear,
      const ::skcms_Matrix3x3& srgb_to_device_matrix,
      const ::display::GammaCurve& linear_to_device);


  ~ColorCalibration();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ColorCalibrationPtr>
  ColorCalibrationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ColorCalibration::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ColorCalibration::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ColorCalibration::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ColorCalibration::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ColorCalibration::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ColorCalibration_UnserializedMessageContext<
            UserType, ColorCalibration::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ColorCalibration::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ColorCalibration::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ColorCalibration_UnserializedMessageContext<
            UserType, ColorCalibration::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ColorCalibration::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::display::GammaCurve srgb_to_linear;
  
  ::skcms_Matrix3x3 srgb_to_device_matrix;
  
  ::display::GammaCurve linear_to_device;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ColorCalibration::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ColorCalibration::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ColorCalibration::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ColorCalibration::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ColorTemperatureAdjustment {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ColorTemperatureAdjustment, T>::value>;
  using DataView = ColorTemperatureAdjustmentDataView;
  using Data_ = internal::ColorTemperatureAdjustment_Data;

  template <typename... Args>
  static ColorTemperatureAdjustmentPtr New(Args&&... args) {
    return ColorTemperatureAdjustmentPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ColorTemperatureAdjustmentPtr From(const U& u) {
    return mojo::TypeConverter<ColorTemperatureAdjustmentPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ColorTemperatureAdjustment>::Convert(*this);
  }


  ColorTemperatureAdjustment();

  explicit ColorTemperatureAdjustment(
      const ::skcms_Matrix3x3& srgb_matrix);


  ~ColorTemperatureAdjustment();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ColorTemperatureAdjustmentPtr>
  ColorTemperatureAdjustmentPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ColorTemperatureAdjustment::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ColorTemperatureAdjustment::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ColorTemperatureAdjustment::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ColorTemperatureAdjustment::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ColorTemperatureAdjustment::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ColorTemperatureAdjustment_UnserializedMessageContext<
            UserType, ColorTemperatureAdjustment::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ColorTemperatureAdjustment::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ColorTemperatureAdjustment::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ColorTemperatureAdjustment_UnserializedMessageContext<
            UserType, ColorTemperatureAdjustment::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ColorTemperatureAdjustment::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::skcms_Matrix3x3 srgb_matrix;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ColorTemperatureAdjustment::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ColorTemperatureAdjustment::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ColorTemperatureAdjustment::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ColorTemperatureAdjustment::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  GammaAdjustment {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<GammaAdjustment, T>::value>;
  using DataView = GammaAdjustmentDataView;
  using Data_ = internal::GammaAdjustment_Data;

  template <typename... Args>
  static GammaAdjustmentPtr New(Args&&... args) {
    return GammaAdjustmentPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static GammaAdjustmentPtr From(const U& u) {
    return mojo::TypeConverter<GammaAdjustmentPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, GammaAdjustment>::Convert(*this);
  }


  GammaAdjustment();

  explicit GammaAdjustment(
      const ::display::GammaCurve& curve);


  ~GammaAdjustment();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = GammaAdjustmentPtr>
  GammaAdjustmentPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, GammaAdjustment::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, GammaAdjustment::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, GammaAdjustment::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        GammaAdjustment::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        GammaAdjustment::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::GammaAdjustment_UnserializedMessageContext<
            UserType, GammaAdjustment::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<GammaAdjustment::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return GammaAdjustment::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::GammaAdjustment_UnserializedMessageContext<
            UserType, GammaAdjustment::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<GammaAdjustment::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::display::GammaCurve curve;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, GammaAdjustment::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, GammaAdjustment::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, GammaAdjustment::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, GammaAdjustment::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
GammaCurvePtr GammaCurve::Clone() const {
  return New(
      mojo::Clone(lut)
  );
}

template <typename T, GammaCurve::EnableIfSame<T>*>
bool GammaCurve::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->lut, other_struct.lut))
    return false;
  return true;
}

template <typename T, GammaCurve::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.lut < rhs.lut)
    return true;
  if (rhs.lut < lhs.lut)
    return false;
  return false;
}
template <typename StructPtrType>
ColorCalibrationPtr ColorCalibration::Clone() const {
  return New(
      mojo::Clone(srgb_to_linear),
      mojo::Clone(srgb_to_device_matrix),
      mojo::Clone(linear_to_device)
  );
}

template <typename T, ColorCalibration::EnableIfSame<T>*>
bool ColorCalibration::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->srgb_to_linear, other_struct.srgb_to_linear))
    return false;
  if (!mojo::Equals(this->srgb_to_device_matrix, other_struct.srgb_to_device_matrix))
    return false;
  if (!mojo::Equals(this->linear_to_device, other_struct.linear_to_device))
    return false;
  return true;
}

template <typename T, ColorCalibration::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.srgb_to_linear < rhs.srgb_to_linear)
    return true;
  if (rhs.srgb_to_linear < lhs.srgb_to_linear)
    return false;
  if (lhs.srgb_to_device_matrix < rhs.srgb_to_device_matrix)
    return true;
  if (rhs.srgb_to_device_matrix < lhs.srgb_to_device_matrix)
    return false;
  if (lhs.linear_to_device < rhs.linear_to_device)
    return true;
  if (rhs.linear_to_device < lhs.linear_to_device)
    return false;
  return false;
}
template <typename StructPtrType>
ColorTemperatureAdjustmentPtr ColorTemperatureAdjustment::Clone() const {
  return New(
      mojo::Clone(srgb_matrix)
  );
}

template <typename T, ColorTemperatureAdjustment::EnableIfSame<T>*>
bool ColorTemperatureAdjustment::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->srgb_matrix, other_struct.srgb_matrix))
    return false;
  return true;
}

template <typename T, ColorTemperatureAdjustment::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.srgb_matrix < rhs.srgb_matrix)
    return true;
  if (rhs.srgb_matrix < lhs.srgb_matrix)
    return false;
  return false;
}
template <typename StructPtrType>
GammaAdjustmentPtr GammaAdjustment::Clone() const {
  return New(
      mojo::Clone(curve)
  );
}

template <typename T, GammaAdjustment::EnableIfSame<T>*>
bool GammaAdjustment::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->curve, other_struct.curve))
    return false;
  return true;
}

template <typename T, GammaAdjustment::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.curve < rhs.curve)
    return true;
  if (rhs.curve < lhs.curve)
    return false;
  return false;
}


}  // display::mojom

namespace mojo {


template <>
struct  StructTraits<::display::mojom::GammaCurve::DataView,
                                         ::display::mojom::GammaCurvePtr> {
  static bool IsNull(const ::display::mojom::GammaCurvePtr& input) { return !input; }
  static void SetToNull(::display::mojom::GammaCurvePtr* output) { output->reset(); }

  static const decltype(::display::mojom::GammaCurve::lut)& lut(
      const ::display::mojom::GammaCurvePtr& input) {
    return input->lut;
  }

  static bool Read(::display::mojom::GammaCurve::DataView input, ::display::mojom::GammaCurvePtr* output);
};


template <>
struct  StructTraits<::display::mojom::ColorCalibration::DataView,
                                         ::display::mojom::ColorCalibrationPtr> {
  static bool IsNull(const ::display::mojom::ColorCalibrationPtr& input) { return !input; }
  static void SetToNull(::display::mojom::ColorCalibrationPtr* output) { output->reset(); }

  static const decltype(::display::mojom::ColorCalibration::srgb_to_linear)& srgb_to_linear(
      const ::display::mojom::ColorCalibrationPtr& input) {
    return input->srgb_to_linear;
  }

  static const decltype(::display::mojom::ColorCalibration::srgb_to_device_matrix)& srgb_to_device_matrix(
      const ::display::mojom::ColorCalibrationPtr& input) {
    return input->srgb_to_device_matrix;
  }

  static const decltype(::display::mojom::ColorCalibration::linear_to_device)& linear_to_device(
      const ::display::mojom::ColorCalibrationPtr& input) {
    return input->linear_to_device;
  }

  static bool Read(::display::mojom::ColorCalibration::DataView input, ::display::mojom::ColorCalibrationPtr* output);
};


template <>
struct  StructTraits<::display::mojom::ColorTemperatureAdjustment::DataView,
                                         ::display::mojom::ColorTemperatureAdjustmentPtr> {
  static bool IsNull(const ::display::mojom::ColorTemperatureAdjustmentPtr& input) { return !input; }
  static void SetToNull(::display::mojom::ColorTemperatureAdjustmentPtr* output) { output->reset(); }

  static const decltype(::display::mojom::ColorTemperatureAdjustment::srgb_matrix)& srgb_matrix(
      const ::display::mojom::ColorTemperatureAdjustmentPtr& input) {
    return input->srgb_matrix;
  }

  static bool Read(::display::mojom::ColorTemperatureAdjustment::DataView input, ::display::mojom::ColorTemperatureAdjustmentPtr* output);
};


template <>
struct  StructTraits<::display::mojom::GammaAdjustment::DataView,
                                         ::display::mojom::GammaAdjustmentPtr> {
  static bool IsNull(const ::display::mojom::GammaAdjustmentPtr& input) { return !input; }
  static void SetToNull(::display::mojom::GammaAdjustmentPtr* output) { output->reset(); }

  static const decltype(::display::mojom::GammaAdjustment::curve)& curve(
      const ::display::mojom::GammaAdjustmentPtr& input) {
    return input->curve;
  }

  static bool Read(::display::mojom::GammaAdjustment::DataView input, ::display::mojom::GammaAdjustmentPtr* output);
};

}  // namespace mojo

#endif  // UI_DISPLAY_MOJOM_DISPLAY_COLOR_MANAGEMENT_MOJOM_H_