// ui/ozone/platform/wayland/mojom/wayland_overlay_config.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PLATFORM_WAYLAND_MOJOM_WAYLAND_OVERLAY_CONFIG_MOJOM_H_
#define UI_OZONE_PLATFORM_WAYLAND_MOJOM_WAYLAND_OVERLAY_CONFIG_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "ui/ozone/platform/wayland/mojom/wayland_overlay_config.mojom-features.h"
#include "ui/ozone/platform/wayland/mojom/wayland_overlay_config.mojom-shared.h"
#include "ui/ozone/platform/wayland/mojom/wayland_overlay_config.mojom-forward.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include "ui/gfx/mojom/color_space.mojom.h"
#include "ui/gfx/mojom/gpu_fence_handle.mojom.h"
#include "ui/gfx/mojom/overlay_transform.mojom.h"
#include "ui/gfx/mojom/overlay_priority_hint.mojom.h"
#include "ui/gfx/mojom/rrect_f.mojom.h"
#include "ui/gfx/mojom/transform.mojom.h"
#include "skia/public/mojom/skcolor4f.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "ui/ozone/platform/wayland/mojom/wayland_overlay_config_mojom_traits.h"




namespace wl::mojom {






class  TransformUnion {
 public:
  using DataView = TransformUnionDataView;
  using Data_ = internal::TransformUnion_Data;
  using Tag = Data_::TransformUnion_Tag;

  template <typename... Args>
  static TransformUnionPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |overlay_transform|.
  static TransformUnionPtr
  NewOverlayTransform(
      ::gfx::OverlayTransform value) {
    auto result = TransformUnionPtr(absl::in_place);
    result->set_overlay_transform(std::move(value));
    return result;
  }
  // Construct an instance holding |matrix_transform|.
  static TransformUnionPtr
  NewMatrixTransform(
      const ::gfx::Transform& value) {
    auto result = TransformUnionPtr(absl::in_place);
    result->set_matrix_transform(std::move(value));
    return result;
  }

  template <typename U>
  static TransformUnionPtr From(const U& u) {
    return mojo::TypeConverter<TransformUnionPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TransformUnion>::Convert(*this);
  }

  TransformUnion();
  ~TransformUnion();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  TransformUnion(const TransformUnion& other) = delete;
  TransformUnion& operator=(const TransformUnion& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = TransformUnionPtr>
  TransformUnionPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, TransformUnion>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, TransformUnion>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_overlay_transform() const { return tag_ == Tag::kOverlayTransform; }

  
  ::gfx::OverlayTransform get_overlay_transform() const {
    CHECK(tag_ == Tag::kOverlayTransform);
    return data_.overlay_transform;
  }

  
  void set_overlay_transform(
      ::gfx::OverlayTransform overlay_transform);
  
  bool is_matrix_transform() const { return tag_ == Tag::kMatrixTransform; }

  
  ::gfx::Transform& get_matrix_transform() const {
    CHECK(tag_ == Tag::kMatrixTransform);
    return *(data_.matrix_transform);
  }

  
  void set_matrix_transform(
      const ::gfx::Transform& matrix_transform);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TransformUnion::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<TransformUnion::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    ::gfx::OverlayTransform overlay_transform;
    ::gfx::Transform* matrix_transform;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class  WaylandOverlayConfig {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<WaylandOverlayConfig, T>::value>;
  using DataView = WaylandOverlayConfigDataView;
  using Data_ = internal::WaylandOverlayConfig_Data;

  template <typename... Args>
  static WaylandOverlayConfigPtr New(Args&&... args) {
    return WaylandOverlayConfigPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static WaylandOverlayConfigPtr From(const U& u) {
    return mojo::TypeConverter<WaylandOverlayConfigPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, WaylandOverlayConfig>::Convert(*this);
  }


  WaylandOverlayConfig();

  WaylandOverlayConfig(
      int32_t z_order,
      const std::optional<::gfx::ColorSpace>& color_space,
      const ::absl::variant<::gfx::OverlayTransform, ::gfx::Transform>& transform,
      uint32_t buffer_id,
      float surface_scale_factor,
      const ::gfx::RectF& bounds_rect,
      const ::gfx::RectF& crop_rect,
      const ::gfx::Rect& damage_region,
      bool enable_blend,
      float opacity,
      ::gfx::GpuFenceHandle access_fence_handle,
      ::gfx::OverlayPriorityHint priority_hint,
      const std::optional<::gfx::RRectF>& rounded_clip_bounds,
      const std::optional<::SkColor4f>& background_color,
      const std::optional<::gfx::Rect>& clip_rect);

WaylandOverlayConfig(const WaylandOverlayConfig&) = delete;
WaylandOverlayConfig& operator=(const WaylandOverlayConfig&) = delete;

  ~WaylandOverlayConfig();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = WaylandOverlayConfigPtr>
  WaylandOverlayConfigPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, WaylandOverlayConfig::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, WaylandOverlayConfig::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, WaylandOverlayConfig::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        WaylandOverlayConfig::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::WaylandOverlayConfig_UnserializedMessageContext<
            UserType, WaylandOverlayConfig::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<WaylandOverlayConfig::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return WaylandOverlayConfig::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::WaylandOverlayConfig_UnserializedMessageContext<
            UserType, WaylandOverlayConfig::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<WaylandOverlayConfig::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  int32_t z_order;
  
  std::optional<::gfx::ColorSpace> color_space;
  
  ::absl::variant<::gfx::OverlayTransform, ::gfx::Transform> transform;
  
  uint32_t buffer_id;
  
  float surface_scale_factor;
  
  ::gfx::RectF bounds_rect;
  
  ::gfx::RectF crop_rect;
  
  ::gfx::Rect damage_region;
  
  bool enable_blend;
  
  float opacity;
  
  ::gfx::GpuFenceHandle access_fence_handle;
  
  ::gfx::OverlayPriorityHint priority_hint;
  
  std::optional<::gfx::RRectF> rounded_clip_bounds;
  
  std::optional<::SkColor4f> background_color;
  
  std::optional<::gfx::Rect> clip_rect;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, WaylandOverlayConfig::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, WaylandOverlayConfig::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, WaylandOverlayConfig::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, WaylandOverlayConfig::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename UnionPtrType>
TransformUnionPtr TransformUnion::Clone() const {
  switch (tag_) {
    case Tag::kOverlayTransform:
      return NewOverlayTransform(
          mojo::Clone(data_.overlay_transform));
    case Tag::kMatrixTransform:
      return NewMatrixTransform(
          mojo::Clone(*data_.matrix_transform));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, TransformUnion>::value>::type*>
bool TransformUnion::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kOverlayTransform:
      return mojo::Equals(data_.overlay_transform, other.data_.overlay_transform);
    case Tag::kMatrixTransform:
      return mojo::Equals(*(data_.matrix_transform), *(other.data_.matrix_transform));
  }

  return false;
}
template <typename StructPtrType>
WaylandOverlayConfigPtr WaylandOverlayConfig::Clone() const {
  return New(
      mojo::Clone(z_order),
      mojo::Clone(color_space),
      mojo::Clone(transform),
      mojo::Clone(buffer_id),
      mojo::Clone(surface_scale_factor),
      mojo::Clone(bounds_rect),
      mojo::Clone(crop_rect),
      mojo::Clone(damage_region),
      mojo::Clone(enable_blend),
      mojo::Clone(opacity),
      mojo::Clone(access_fence_handle),
      mojo::Clone(priority_hint),
      mojo::Clone(rounded_clip_bounds),
      mojo::Clone(background_color),
      mojo::Clone(clip_rect)
  );
}

template <typename T, WaylandOverlayConfig::EnableIfSame<T>*>
bool WaylandOverlayConfig::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->z_order, other_struct.z_order))
    return false;
  if (!mojo::Equals(this->color_space, other_struct.color_space))
    return false;
  if (!mojo::Equals(this->transform, other_struct.transform))
    return false;
  if (!mojo::Equals(this->buffer_id, other_struct.buffer_id))
    return false;
  if (!mojo::Equals(this->surface_scale_factor, other_struct.surface_scale_factor))
    return false;
  if (!mojo::Equals(this->bounds_rect, other_struct.bounds_rect))
    return false;
  if (!mojo::Equals(this->crop_rect, other_struct.crop_rect))
    return false;
  if (!mojo::Equals(this->damage_region, other_struct.damage_region))
    return false;
  if (!mojo::Equals(this->enable_blend, other_struct.enable_blend))
    return false;
  if (!mojo::Equals(this->opacity, other_struct.opacity))
    return false;
  if (!mojo::Equals(this->access_fence_handle, other_struct.access_fence_handle))
    return false;
  if (!mojo::Equals(this->priority_hint, other_struct.priority_hint))
    return false;
  if (!mojo::Equals(this->rounded_clip_bounds, other_struct.rounded_clip_bounds))
    return false;
  if (!mojo::Equals(this->background_color, other_struct.background_color))
    return false;
  if (!mojo::Equals(this->clip_rect, other_struct.clip_rect))
    return false;
  return true;
}

template <typename T, WaylandOverlayConfig::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.z_order < rhs.z_order)
    return true;
  if (rhs.z_order < lhs.z_order)
    return false;
  if (lhs.color_space < rhs.color_space)
    return true;
  if (rhs.color_space < lhs.color_space)
    return false;
  if (lhs.transform < rhs.transform)
    return true;
  if (rhs.transform < lhs.transform)
    return false;
  if (lhs.buffer_id < rhs.buffer_id)
    return true;
  if (rhs.buffer_id < lhs.buffer_id)
    return false;
  if (lhs.surface_scale_factor < rhs.surface_scale_factor)
    return true;
  if (rhs.surface_scale_factor < lhs.surface_scale_factor)
    return false;
  if (lhs.bounds_rect < rhs.bounds_rect)
    return true;
  if (rhs.bounds_rect < lhs.bounds_rect)
    return false;
  if (lhs.crop_rect < rhs.crop_rect)
    return true;
  if (rhs.crop_rect < lhs.crop_rect)
    return false;
  if (lhs.damage_region < rhs.damage_region)
    return true;
  if (rhs.damage_region < lhs.damage_region)
    return false;
  if (lhs.enable_blend < rhs.enable_blend)
    return true;
  if (rhs.enable_blend < lhs.enable_blend)
    return false;
  if (lhs.opacity < rhs.opacity)
    return true;
  if (rhs.opacity < lhs.opacity)
    return false;
  if (lhs.access_fence_handle < rhs.access_fence_handle)
    return true;
  if (rhs.access_fence_handle < lhs.access_fence_handle)
    return false;
  if (lhs.priority_hint < rhs.priority_hint)
    return true;
  if (rhs.priority_hint < lhs.priority_hint)
    return false;
  if (lhs.rounded_clip_bounds < rhs.rounded_clip_bounds)
    return true;
  if (rhs.rounded_clip_bounds < lhs.rounded_clip_bounds)
    return false;
  if (lhs.background_color < rhs.background_color)
    return true;
  if (rhs.background_color < lhs.background_color)
    return false;
  if (lhs.clip_rect < rhs.clip_rect)
    return true;
  if (rhs.clip_rect < lhs.clip_rect)
    return false;
  return false;
}


}  // wl::mojom

namespace mojo {


template <>
struct  StructTraits<::wl::mojom::WaylandOverlayConfig::DataView,
                                         ::wl::mojom::WaylandOverlayConfigPtr> {
  static bool IsNull(const ::wl::mojom::WaylandOverlayConfigPtr& input) { return !input; }
  static void SetToNull(::wl::mojom::WaylandOverlayConfigPtr* output) { output->reset(); }

  static decltype(::wl::mojom::WaylandOverlayConfig::z_order) z_order(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->z_order;
  }

  static const decltype(::wl::mojom::WaylandOverlayConfig::color_space)& color_space(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->color_space;
  }

  static const decltype(::wl::mojom::WaylandOverlayConfig::transform)& transform(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->transform;
  }

  static decltype(::wl::mojom::WaylandOverlayConfig::buffer_id) buffer_id(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->buffer_id;
  }

  static decltype(::wl::mojom::WaylandOverlayConfig::surface_scale_factor) surface_scale_factor(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->surface_scale_factor;
  }

  static const decltype(::wl::mojom::WaylandOverlayConfig::bounds_rect)& bounds_rect(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->bounds_rect;
  }

  static const decltype(::wl::mojom::WaylandOverlayConfig::crop_rect)& crop_rect(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->crop_rect;
  }

  static const decltype(::wl::mojom::WaylandOverlayConfig::damage_region)& damage_region(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->damage_region;
  }

  static decltype(::wl::mojom::WaylandOverlayConfig::enable_blend) enable_blend(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->enable_blend;
  }

  static decltype(::wl::mojom::WaylandOverlayConfig::opacity) opacity(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->opacity;
  }

  static  decltype(::wl::mojom::WaylandOverlayConfig::access_fence_handle)& access_fence_handle(
       ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->access_fence_handle;
  }

  static decltype(::wl::mojom::WaylandOverlayConfig::priority_hint) priority_hint(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->priority_hint;
  }

  static const decltype(::wl::mojom::WaylandOverlayConfig::rounded_clip_bounds)& rounded_clip_bounds(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->rounded_clip_bounds;
  }

  static const decltype(::wl::mojom::WaylandOverlayConfig::background_color)& background_color(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->background_color;
  }

  static const decltype(::wl::mojom::WaylandOverlayConfig::clip_rect)& clip_rect(
      const ::wl::mojom::WaylandOverlayConfigPtr& input) {
    return input->clip_rect;
  }

  static bool Read(::wl::mojom::WaylandOverlayConfig::DataView input, ::wl::mojom::WaylandOverlayConfigPtr* output);
};


template <>
struct  UnionTraits<::wl::mojom::TransformUnion::DataView,
                                        ::wl::mojom::TransformUnionPtr> {
  static bool IsNull(const ::wl::mojom::TransformUnionPtr& input) { return !input; }
  static void SetToNull(::wl::mojom::TransformUnionPtr* output) { output->reset(); }

  static ::wl::mojom::TransformUnion::Tag GetTag(const ::wl::mojom::TransformUnionPtr& input) {
    return input->which();
  }

  static  ::gfx::OverlayTransform overlay_transform(const ::wl::mojom::TransformUnionPtr& input) {
    return input->get_overlay_transform();
  }

  static const ::gfx::Transform& matrix_transform(const ::wl::mojom::TransformUnionPtr& input) {
    return input->get_matrix_transform();
  }

  static bool Read(::wl::mojom::TransformUnion::DataView input, ::wl::mojom::TransformUnionPtr* output);
};

}  // namespace mojo

#endif  // UI_OZONE_PLATFORM_WAYLAND_MOJOM_WAYLAND_OVERLAY_CONFIG_MOJOM_H_