// Copyright 2017 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// vector_icons.cc.template is used to generate vector_icons.cc. Edit the former
// rather than the latter.

#include "ui/views/vector_icons.h"

#include "components/vector_icons/cc_macros.h"
#include "ui/gfx/vector_icon_types.h"

#define DECLARE_VECTOR_COMMAND(x) using gfx::x;
DECLARE_VECTOR_COMMANDS

namespace views {

VECTOR_ICON_REP_TEMPLATE(kCheckboxActivePath, CANVAS_DIMENSIONS, 16,
MOVE_TO, 12.996f, 14,
H_LINE_TO, 3.004f,
CUBIC_TO, 2.449f, 14, 2, 13.551f, 2, 12.996f,
V_LINE_TO, 3.004f,
CUBIC_TO, 2, 2.449f, 2.449f, 2, 3.004f, 2,
R_H_LINE_TO, 9.993f,
CUBIC_TO, 13.551f, 2, 14, 2.449f, 14, 3.004f,
R_V_LINE_TO, 9.993f,
CUBIC_TO, 14, 13.551f, 13.551f, 14, 12.996f, 14,
CLOSE,
MOVE_TO, 6.5f, 11,
LINE_TO, 3.5f, 8,
LINE_TO, 4.5f, 7,
LINE_TO, 6.5f, 9,
LINE_TO, 11.5f, 4.5f,
LINE_TO, 12.5f, 5.5f,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kCheckboxActiveRepList, kCheckboxActiveIcon, {kCheckboxActivePath, std::size(kCheckboxActivePath)})
VECTOR_ICON_REP_TEMPLATE(kCheckboxCheckCr2023Path, CANVAS_DIMENSIONS, 16,
NEW_PATH,
MOVE_TO, 12.19f, 4.12f,
LINE_TO, 6.18f, 10.13f,
LINE_TO, 4.06f, 8.01f,
LINE_TO, 3, 9.07f,
R_LINE_TO, 2.12f, 2.12f,
R_LINE_TO, 0.71f, 0.71f,
R_LINE_TO, 0.35f, 0.35f,
R_LINE_TO, 7.07f, -7.07f,
R_LINE_TO, -1.06f, -1.06f,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kCheckboxCheckCr2023RepList, kCheckboxCheckCr2023Icon, {kCheckboxCheckCr2023Path, std::size(kCheckboxCheckCr2023Path)})
VECTOR_ICON_REP_TEMPLATE(kCheckboxNormalPath, CANVAS_DIMENSIONS, 16,
MOVE_TO, 12.5f, 3.5f,
R_V_LINE_TO, 9,
R_H_LINE_TO, -9,
R_V_LINE_TO, -9,
H_LINE_TO, 12.5f,
MOVE_TO, 12.996f, 2,
H_LINE_TO, 3.004f,
CUBIC_TO, 2.449f, 2, 2, 2.449f, 2, 3.004f,
R_V_LINE_TO, 9.993f,
CUBIC_TO, 2, 13.551f, 2.449f, 14, 3.004f, 14,
R_H_LINE_TO, 9.993f,
CUBIC_TO, 13.551f, 14, 14, 13.551f, 14, 12.996f,
V_LINE_TO, 3.004f,
CUBIC_TO, 14, 2.449f, 13.551f, 2, 12.996f, 2,
LINE_TO, 12.996f, 2,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kCheckboxNormalRepList, kCheckboxNormalIcon, {kCheckboxNormalPath, std::size(kCheckboxNormalPath)})
VECTOR_ICON_REP_TEMPLATE(kCheckboxNormalCr2023Path, CANVAS_DIMENSIONS, 16,
NEW_PATH,
ROUND_RECT, 0, 0, 16, 16, 2,
MOVE_TO, 12.996f, 2,
H_LINE_TO, 3.004f,
CUBIC_TO, 2.449f, 2, 2, 2.449f, 2, 3.004f,
R_V_LINE_TO, 9.993f,
CUBIC_TO, 2, 13.551f, 2.449f, 14, 3.004f, 14,
R_H_LINE_TO, 9.993f,
CUBIC_TO, 13.551f, 14, 14, 13.551f, 14, 12.996f,
V_LINE_TO, 3.004f,
CUBIC_TO, 14, 2.449f, 13.551f, 2, 12.996f, 2,
LINE_TO, 12.996f, 2,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kCheckboxNormalCr2023RepList, kCheckboxNormalCr2023Icon, {kCheckboxNormalCr2023Path, std::size(kCheckboxNormalCr2023Path)})
VECTOR_ICON_REP_TEMPLATE(kClosePath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 12.07f, 6.8f,
LINE_TO, 10, 8.87f,
LINE_TO, 7.93f, 6.8f,
LINE_TO, 6.8f, 7.93f,
LINE_TO, 8.87f, 10,
LINE_TO, 6.8f, 12.07f,
LINE_TO, 7.93f, 13.2f,
LINE_TO, 10, 11.13f,
R_LINE_TO, 2.07f, 2.07f,
R_LINE_TO, 1.13f, -1.13f,
LINE_TO, 11.13f, 10,
LINE_TO, 13.2f, 7.93f,
LINE_TO, 12.07f, 6.8f,
CLOSE,
MOVE_TO, 10, 2,
R_CUBIC_TO, -4.42f, 0, -8, 3.58f, -8, 8,
R_CUBIC_TO, 0, 4.42f, 3.58f, 8, 8, 8,
R_CUBIC_TO, 4.42f, 0, 8, -3.58f, 8, -8,
R_CUBIC_TO, 0, -4.42f, -3.58f, -8, -8, -8,
CLOSE,
R_MOVE_TO, 0, 14,
R_CUBIC_TO, -3.31f, 0, -6, -2.69f, -6, -6,
R_CUBIC_TO, 0, -3.31f, 2.69f, -6, 6, -6,
R_CUBIC_TO, 3.31f, 0, 6, 2.69f, 6, 6,
R_CUBIC_TO, 0, 3.31f, -2.69f, 6, -6, 6,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kCloseRepList, kCloseIcon, {kClosePath, std::size(kClosePath)})
VECTOR_ICON_REP_TEMPLATE(kDragGeneralSelectionPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 12.5f, 4.5f,
R_H_LINE_TO, -1.67f,
V_LINE_TO, 2.83f,
H_LINE_TO, 12.5f,
V_LINE_TO, 4.5f,
CLOSE,
R_MOVE_TO, 1.67f, 3.33f,
R_H_LINE_TO, 1.67f,
V_LINE_TO, 6.17f,
R_H_LINE_TO, -1.67f,
R_V_LINE_TO, 1.67f,
CLOSE,
R_MOVE_TO, 0, 3.33f,
R_H_LINE_TO, 1.67f,
V_LINE_TO, 9.5f,
R_H_LINE_TO, -1.67f,
R_V_LINE_TO, 1.67f,
CLOSE,
MOVE_TO, 7.5f, 17.83f,
R_H_LINE_TO, 1.67f,
R_V_LINE_TO, -1.67f,
H_LINE_TO, 7.5f,
R_V_LINE_TO, 1.67f,
CLOSE,
MOVE_TO, 4.17f, 4.5f,
R_H_LINE_TO, 1.67f,
V_LINE_TO, 2.83f,
H_LINE_TO, 4.17f,
V_LINE_TO, 4.5f,
CLOSE,
R_MOVE_TO, -3.33f, 10,
H_LINE_TO, 2.5f,
R_V_LINE_TO, -1.67f,
H_LINE_TO, 0.83f,
V_LINE_TO, 14.5f,
CLOSE,
MOVE_TO, 2.5f, 17.83f,
R_V_LINE_TO, -1.67f,
H_LINE_TO, 0.83f,
R_CUBIC_TO, 0, 0.92f, 0.75f, 1.67f, 1.67f, 1.67f,
CLOSE,
R_MOVE_TO, 11.67f, -15,
V_LINE_TO, 4.5f,
R_H_LINE_TO, 1.67f,
R_CUBIC_TO, 0, -0.92f, -0.75f, -1.67f, -1.67f, -1.67f,
CLOSE,
MOVE_TO, 7.5f, 4.5f,
R_H_LINE_TO, 1.67f,
V_LINE_TO, 2.83f,
H_LINE_TO, 7.5f,
V_LINE_TO, 4.5f,
CLOSE,
MOVE_TO, 0.83f, 7.83f,
H_LINE_TO, 2.5f,
V_LINE_TO, 6.17f,
H_LINE_TO, 0.83f,
R_V_LINE_TO, 1.67f,
CLOSE,
R_MOVE_TO, 3.33f, 10,
R_H_LINE_TO, 1.67f,
R_V_LINE_TO, -1.67f,
H_LINE_TO, 4.17f,
R_V_LINE_TO, 1.67f,
CLOSE,
MOVE_TO, 0.83f, 11.17f,
H_LINE_TO, 2.5f,
V_LINE_TO, 9.5f,
H_LINE_TO, 0.83f,
R_V_LINE_TO, 1.67f,
CLOSE,
R_MOVE_TO, 0, -6.67f,
H_LINE_TO, 2.5f,
V_LINE_TO, 2.83f,
R_CUBIC_TO, -0.92f, 0, -1.67f, 0.75f, -1.67f, 1.67f,
CLOSE,
MOVE_TO, 10.83f, 16.17f,
R_V_LINE_TO, 1.67f,
R_H_LINE_TO, 3.34f,
R_LINE_TO, -0.01f, 3.33f,
R_H_LINE_TO, 1.67f,
R_LINE_TO, 0.01f, -3.32f,
R_LINE_TO, 3.33f, -0.01f,
R_V_LINE_TO, -1.67f,
R_LINE_TO, -3.33f, 0.01f,
R_V_LINE_TO, -3.33f,
R_H_LINE_TO, -1.67f,
R_V_LINE_TO, 3.33f,
R_H_LINE_TO, -3.33f,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kDragGeneralSelectionRepList, kDragGeneralSelectionIcon, {kDragGeneralSelectionPath, std::size(kDragGeneralSelectionPath)})
VECTOR_ICON_REP_TEMPLATE(kEyePath, CANVAS_DIMENSIONS, 16,
MOVE_TO, 8, 5.67f,
CUBIC_TO, 7.47f, 5.67f, 6.96f, 5.88f, 6.59f, 6.25f,
CUBIC_TO, 6.21f, 6.63f, 6, 7.14f, 6, 7.67f,
CUBIC_TO, 6, 8.2f, 6.21f, 8.71f, 6.59f, 9.08f,
CUBIC_TO, 6.96f, 9.46f, 7.47f, 9.67f, 8, 9.67f,
CUBIC_TO, 8.53f, 9.67f, 9.04f, 9.46f, 9.41f, 9.08f,
CUBIC_TO, 9.79f, 8.71f, 10, 8.2f, 10, 7.67f,
CUBIC_TO, 10, 7.14f, 9.79f, 6.63f, 9.41f, 6.25f,
CUBIC_TO, 9.04f, 5.88f, 8.53f, 5.67f, 8, 5.67f,
CLOSE,
MOVE_TO, 8, 11,
CUBIC_TO, 7.12f, 11, 6.27f, 10.65f, 5.64f, 10.02f,
CUBIC_TO, 5.02f, 9.4f, 4.67f, 8.55f, 4.67f, 7.67f,
CUBIC_TO, 4.67f, 6.78f, 5.02f, 5.93f, 5.64f, 5.31f,
CUBIC_TO, 6.27f, 4.68f, 7.12f, 4.33f, 8, 4.33f,
CUBIC_TO, 8.88f, 4.33f, 9.73f, 4.68f, 10.36f, 5.31f,
CUBIC_TO, 10.98f, 5.93f, 11.33f, 6.78f, 11.33f, 7.67f,
CUBIC_TO, 11.33f, 8.55f, 10.98f, 9.4f, 10.36f, 10.02f,
CUBIC_TO, 9.73f, 10.65f, 8.88f, 11, 8, 11,
V_LINE_TO, 11,
CLOSE,
MOVE_TO, 8, 2.67f,
CUBIC_TO, 4.67f, 2.67f, 1.82f, 4.74f, 0.67f, 7.67f,
CUBIC_TO, 1.82f, 10.59f, 4.67f, 12.67f, 8, 12.67f,
CUBIC_TO, 11.33f, 12.67f, 14.18f, 10.59f, 15.33f, 7.67f,
CUBIC_TO, 14.18f, 4.74f, 11.33f, 2.67f, 8, 2.67f,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kEyeRepList, kEyeIcon, {kEyePath, std::size(kEyePath)})
VECTOR_ICON_REP_TEMPLATE(kEyeCrossedPath, CANVAS_DIMENSIONS, 16,
MOVE_TO, 2.53f, 1.47f,
LINE_TO, 14.53f, 13.47f,
LINE_TO, 13.47f, 14.53f,
LINE_TO, 11.01f, 12.07f,
CUBIC_TO, 10.08f, 12.45f, 9.07f, 12.67f, 8, 12.67f,
CUBIC_TO, 4.67f, 12.67f, 1.82f, 10.59f, 0.67f, 7.67f,
CUBIC_TO, 1.2f, 6.32f, 2.09f, 5.15f, 3.22f, 4.28f,
LINE_TO, 1.47f, 2.53f,
LINE_TO, 2.53f, 1.47f,
CLOSE,
MOVE_TO, 5.05f, 6.11f,
CUBIC_TO, 4.8f, 6.59f, 4.67f, 7.12f, 4.67f, 7.67f,
CUBIC_TO, 4.67f, 8.55f, 5.02f, 9.4f, 5.64f, 10.02f,
CUBIC_TO, 6.27f, 10.65f, 7.12f, 11, 8, 11,
CUBIC_TO, 8.55f, 11, 9.08f, 10.87f, 9.55f, 10.62f,
LINE_TO, 8.53f, 9.59f,
CUBIC_TO, 8.36f, 9.64f, 8.18f, 9.67f, 8, 9.67f,
CUBIC_TO, 7.47f, 9.67f, 6.96f, 9.46f, 6.59f, 9.08f,
CUBIC_TO, 6.21f, 8.71f, 6, 8.2f, 6, 7.67f,
CUBIC_TO, 6, 7.48f, 6.02f, 7.31f, 6.07f, 7.13f,
LINE_TO, 5.05f, 6.11f,
CLOSE,
MOVE_TO, 7.44f, 4.38f,
LINE_TO, 5.99f, 2.93f,
CUBIC_TO, 6.63f, 2.76f, 7.3f, 2.67f, 8, 2.67f,
CUBIC_TO, 11.33f, 2.67f, 14.18f, 4.74f, 15.33f, 7.67f,
CUBIC_TO, 14.92f, 8.72f, 14.29f, 9.66f, 13.49f, 10.43f,
LINE_TO, 11.29f, 8.23f,
CUBIC_TO, 11.32f, 8.04f, 11.33f, 7.86f, 11.33f, 7.67f,
CUBIC_TO, 11.33f, 6.78f, 10.98f, 5.93f, 10.36f, 5.31f,
CUBIC_TO, 9.73f, 4.68f, 8.88f, 4.33f, 8, 4.33f,
CUBIC_TO, 7.81f, 4.33f, 7.62f, 4.35f, 7.44f, 4.38f,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kEyeCrossedRepList, kEyeCrossedIcon, {kEyeCrossedPath, std::size(kEyeCrossedPath)})
VECTOR_ICON_REP_TEMPLATE(kEyeCrossedRefreshPath, CANVAS_DIMENSIONS, 20,
R_MOVE_TO, 13.3f, 11.06f,
R_LINE_TO, -1.51f, -1.51f,
R_ARC_TO, 1.24f, 1.24f, 0, 0, 0, -0.38f, -1.03f,
R_ARC_TO, 1.25f, 1.25f, 0, 0, 0, -1.01f, -0.37f,
LINE_TO, 8.94f, 6.68f,
R_CUBIC_TO, 0.17f, -0.06f, 0.35f, -0.11f, 0.53f, -0.14f,
R_CUBIC_TO, 0.18f, -0.03f, 0.36f, -0.04f, 0.53f, -0.04f,
R_CUBIC_TO, 0.97f, 0, 1.8f, 0.34f, 2.48f, 1.02f,
R_CUBIC_TO, 0.68f, 0.68f, 1.02f, 1.51f, 1.02f, 2.48f,
R_CUBIC_TO, 0, 0.16f, -0.02f, 0.34f, -0.04f, 0.53f,
R_ARC_TO, 2.15f, 2.15f, 0, 0, 1, -0.16f, 0.53f,
CLOSE,
R_MOVE_TO, 2.9f, 2.91f,
R_LINE_TO, -1.18f, -1.2f,
R_CUBIC_TO, 0.48f, -0.38f, 0.91f, -0.8f, 1.3f, -1.25f,
ARC_TO, 7.41f, 7.41f, 0, 0, 0, 17.34f, 10,
R_ARC_TO, 7.81f, 7.81f, 0, 0, 0, -3.01f, -3.3f,
CUBIC_TO, 13.02f, 5.9f, 11.57f, 5.5f, 10, 5.5f,
R_CUBIC_TO, -0.36f, 0, -0.71f, 0.02f, -1.03f, 0.06f,
R_ARC_TO, 6.38f, 6.38f, 0, 0, 0, -0.96f, 0.19f,
R_LINE_TO, -1.34f, -1.34f,
R_ARC_TO, 7.61f, 7.61f, 0, 0, 1, 1.64f, -0.44f,
ARC_TO, 11.67f, 11.67f, 0, 0, 1, 10, 3.84f,
R_CUBIC_TO, 2.01f, 0, 3.85f, 0.55f, 5.52f, 1.64f,
R_CUBIC_TO, 1.68f, 1.09f, 2.89f, 2.6f, 3.64f, 4.52f,
R_ARC_TO, 8.65f, 8.65f, 0, 0, 1, -1.23f, 2.19f,
R_ARC_TO, 11.67f, 11.67f, 0, 0, 1, -1.73f, 1.79f,
CLOSE,
R_MOVE_TO, -0.26f, 4.21f,
R_LINE_TO, -2.62f, -2.62f,
R_ARC_TO, 9.38f, 9.38f, 0, 0, 1, -1.61f, 0.45f,
R_ARC_TO, 9.84f, 9.84f, 0, 0, 1, -1.71f, 0.15f,
R_ARC_TO, 9.89f, 9.89f, 0, 0, 1, -5.52f, -1.64f,
CUBIC_TO, 2.8f, 13.41f, 1.59f, 11.91f, 0.84f, 10,
R_ARC_TO, 8.99f, 8.99f, 0, 0, 1, 1.21f, -2.18f,
ARC_TO, 10.59f, 10.59f, 0, 0, 1, 3.8f, 6.02f,
LINE_TO, 1.73f, 3.97f,
R_LINE_TO, 1.12f, -1.12f,
LINE_TO, 17.05f, 17.07f,
CLOSE,
MOVE_TO, 4.98f, 7.2f,
R_CUBIC_TO, -0.48f, 0.4f, -0.92f, 0.82f, -1.32f, 1.26f,
R_CUBIC_TO, -0.4f, 0.45f, -0.73f, 0.96f, -1, 1.54f,
R_ARC_TO, 7.7f, 7.7f, 0, 0, 0, 3, 3.3f,
R_ARC_TO, 8.2f, 8.2f, 0, 0, 0, 5.33f, 1.13f,
R_ARC_TO, 9.12f, 9.12f, 0, 0, 0, 1.02f, -0.19f,
R_LINE_TO, -0.94f, -0.94f,
ARC_TO, 3.08f, 3.08f, 0, 0, 1, 10, 13.5f,
R_CUBIC_TO, -0.97f, 0, -1.8f, -0.34f, -2.48f, -1.02f,
R_CUBIC_TO, -0.68f, -0.68f, -1.02f, -1.51f, -1.02f, -2.48f,
R_CUBIC_TO, 0, -0.18f, 0.02f, -0.35f, 0.07f, -0.53f,
R_CUBIC_TO, 0.04f, -0.18f, 0.08f, -0.36f, 0.12f, -0.54f,
CLOSE,
R_MOVE_TO, 6.1f, 1.76f,
CLOSE,
MOVE_TO, 8.93f, 11.04f,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kEyeCrossedRefreshRepList, kEyeCrossedRefreshIcon, {kEyeCrossedRefreshPath, std::size(kEyeCrossedRefreshPath)})
VECTOR_ICON_REP_TEMPLATE(kEyeRefreshPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 10, 13.5f,
R_CUBIC_TO, 0.97f, 0, 1.8f, -0.34f, 2.48f, -1.02f,
R_CUBIC_TO, 0.68f, -0.68f, 1.02f, -1.51f, 1.02f, -2.48f,
R_CUBIC_TO, 0, -0.97f, -0.34f, -1.8f, -1.02f, -2.48f,
R_CUBIC_TO, -0.68f, -0.68f, -1.51f, -1.02f, -2.48f, -1.02f,
R_CUBIC_TO, -0.97f, 0, -1.8f, 0.34f, -2.48f, 1.02f,
CUBIC_TO, 6.84f, 8.2f, 6.5f, 9.03f, 6.5f, 10,
R_CUBIC_TO, 0, 0.97f, 0.34f, 1.8f, 1.02f, 2.48f,
R_CUBIC_TO, 0.68f, 0.68f, 1.51f, 1.02f, 2.48f, 1.02f,
CLOSE,
R_MOVE_TO, 0, -1.6f,
R_CUBIC_TO, -0.52f, 0, -0.97f, -0.18f, -1.34f, -0.55f,
ARC_TO, 1.84f, 1.84f, 0, 0, 1, 8.11f, 10,
R_CUBIC_TO, 0, -0.52f, 0.18f, -0.97f, 0.55f, -1.34f,
R_CUBIC_TO, 0.37f, -0.37f, 0.82f, -0.55f, 1.34f, -0.55f,
R_CUBIC_TO, 0.52f, 0, 0.97f, 0.18f, 1.34f, 0.55f,
R_CUBIC_TO, 0.37f, 0.37f, 0.55f, 0.82f, 0.55f, 1.34f,
R_CUBIC_TO, 0, 0.52f, -0.18f, 0.97f, -0.55f, 1.34f,
R_CUBIC_TO, -0.37f, 0.37f, -0.82f, 0.55f, -1.34f, 0.55f,
CLOSE,
R_MOVE_TO, 0, 4.26f,
R_CUBIC_TO, -2.02f, 0, -3.85f, -0.56f, -5.51f, -1.69f,
CUBIC_TO, 2.84f, 13.35f, 1.62f, 11.86f, 0.84f, 10,
R_CUBIC_TO, 0.78f, -1.85f, 1.99f, -3.35f, 3.65f, -4.47f,
CUBIC_TO, 6.15f, 4.41f, 7.98f, 3.84f, 10, 3.84f,
R_CUBIC_TO, 2.02f, 0, 3.86f, 0.56f, 5.51f, 1.69f,
R_CUBIC_TO, 1.66f, 1.12f, 2.87f, 2.61f, 3.65f, 4.47f,
R_CUBIC_TO, -0.78f, 1.86f, -1.99f, 3.35f, -3.65f, 4.47f,
R_CUBIC_TO, -1.65f, 1.13f, -3.49f, 1.69f, -5.51f, 1.69f,
CLOSE,
MOVE_TO, 10, 10,
CLOSE,
R_MOVE_TO, 0, 4.5f,
R_CUBIC_TO, 1.55f, 0, 2.99f, -0.4f, 4.3f, -1.21f,
ARC_TO, 8.12f, 8.12f, 0, 0, 0, 17.34f, 10,
R_ARC_TO, 8.12f, 8.12f, 0, 0, 0, -3.04f, -3.29f,
ARC_TO, 8.06f, 8.06f, 0, 0, 0, 10, 5.5f,
R_CUBIC_TO, -1.55f, 0, -2.99f, 0.4f, -4.3f, 1.21f,
ARC_TO, 8.12f, 8.12f, 0, 0, 0, 2.66f, 10,
R_ARC_TO, 8.12f, 8.12f, 0, 0, 0, 3.04f, 3.29f,
ARC_TO, 8.06f, 8.06f, 0, 0, 0, 10, 14.5f,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kEyeRefreshRepList, kEyeRefreshIcon, {kEyeRefreshPath, std::size(kEyeRefreshPath)})
VECTOR_ICON_REP_TEMPLATE(kIcClosePath, CANVAS_DIMENSIONS, 48,
MOVE_TO, 38, 12.82f,
LINE_TO, 35.18f, 10,
LINE_TO, 24, 21.18f,
LINE_TO, 12.82f, 10,
LINE_TO, 10, 12.82f,
LINE_TO, 21.18f, 24,
LINE_TO, 10, 35.18f,
LINE_TO, 12.82f, 38,
LINE_TO, 24, 26.82f,
LINE_TO, 35.18f, 38,
LINE_TO, 38, 35.18f,
LINE_TO, 26.82f, 24,
CLOSE)
VECTOR_ICON_REP_TEMPLATE(kIcClose24Path, CANVAS_DIMENSIONS, 24,
MOVE_TO, 19, 6.41f,
LINE_TO, 17.59f, 5,
LINE_TO, 12, 10.59f,
LINE_TO, 6.41f, 5,
LINE_TO, 5, 6.41f,
LINE_TO, 10.59f, 12,
LINE_TO, 5, 17.59f,
LINE_TO, 6.41f, 19,
LINE_TO, 12, 13.41f,
LINE_TO, 17.59f, 19,
LINE_TO, 19, 17.59f,
LINE_TO, 13.41f, 12,
CLOSE)
VECTOR_ICON_REP_TEMPLATE(kIcClose20Path, CANVAS_DIMENSIONS, 20,
MOVE_TO, 16, 5.41f,
LINE_TO, 14.59f, 4,
LINE_TO, 10, 8.59f,
LINE_TO, 5.41f, 4,
LINE_TO, 4, 5.41f,
LINE_TO, 8.59f, 10,
LINE_TO, 4, 14.59f,
LINE_TO, 5.41f, 16,
LINE_TO, 10, 11.41f,
LINE_TO, 14.59f, 16,
LINE_TO, 16, 14.59f,
LINE_TO, 11.41f, 10,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kIcCloseRepList, kIcCloseIcon, {kIcClosePath, std::size(kIcClosePath)}, {kIcClose24Path, std::size(kIcClose24Path)}, {kIcClose20Path, std::size(kIcClose20Path)})
VECTOR_ICON_REP_TEMPLATE(kInfoPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 9, 14,
R_H_LINE_TO, 2,
R_V_LINE_TO, -4,
H_LINE_TO, 9,
R_V_LINE_TO, 4,
CLOSE,
R_MOVE_TO, 1, -12,
R_CUBIC_TO, -4.42f, 0, -8, 3.58f, -8, 8,
R_CUBIC_TO, 0, 4.42f, 3.58f, 8, 8, 8,
R_CUBIC_TO, 4.42f, 0, 8, -3.58f, 8, -8,
R_CUBIC_TO, 0, -4.42f, -3.58f, -8, -8, -8,
CLOSE,
R_MOVE_TO, 0, 14,
R_CUBIC_TO, -3.31f, 0, -6, -2.69f, -6, -6,
R_CUBIC_TO, 0, -3.31f, 2.69f, -6, 6, -6,
R_CUBIC_TO, 3.31f, 0, 6, 2.69f, 6, 6,
R_CUBIC_TO, 0, 3.31f, -2.69f, 6, -6, 6,
CLOSE,
MOVE_TO, 9, 8,
R_H_LINE_TO, 2,
V_LINE_TO, 6,
H_LINE_TO, 9,
R_V_LINE_TO, 2,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kInfoRepList, kInfoIcon, {kInfoPath, std::size(kInfoPath)})
VECTOR_ICON_REP_TEMPLATE(kInfoChromeRefreshPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 9.18f, 14.07f,
R_H_LINE_TO, 1.65f,
V_LINE_TO, 9,
H_LINE_TO, 9.18f,
CLOSE,
R_MOVE_TO, 0.82f, -6.47f,
R_ARC_TO, 0.83f, 0.83f, 0, 0, 0, 0.61f, -0.25f,
R_ARC_TO, 0.81f, 0.81f, 0, 0, 0, 0.25f, -0.6f,
R_ARC_TO, 0.83f, 0.83f, 0, 0, 0, -0.25f, -0.61f,
R_ARC_TO, 0.81f, 0.81f, 0, 0, 0, -0.6f, -0.25f,
R_ARC_TO, 0.83f, 0.83f, 0, 0, 0, -0.61f, 0.25f,
R_ARC_TO, 0.81f, 0.81f, 0, 0, 0, -0.25f, 0.6f,
R_CUBIC_TO, 0, 0.24f, 0.08f, 0.44f, 0.25f, 0.61f,
R_CUBIC_TO, 0.16f, 0.16f, 0.36f, 0.25f, 0.6f, 0.25f,
CLOSE,
R_MOVE_TO, 0.01f, 10.57f,
R_ARC_TO, 7.99f, 7.99f, 0, 0, 1, -3.18f, -0.64f,
R_ARC_TO, 8.22f, 8.22f, 0, 0, 1, -4.36f, -4.36f,
R_ARC_TO, 7.99f, 7.99f, 0, 0, 1, -0.64f, -3.18f,
R_CUBIC_TO, 0, -1.13f, 0.21f, -2.19f, 0.64f, -3.18f,
ARC_TO, 8.22f, 8.22f, 0, 0, 1, 6.82f, 2.47f,
R_ARC_TO, 7.99f, 7.99f, 0, 0, 1, 3.18f, -0.64f,
R_CUBIC_TO, 1.13f, 0, 2.19f, 0.21f, 3.18f, 0.64f,
R_ARC_TO, 8.22f, 8.22f, 0, 0, 1, 2.59f, 1.75f,
R_ARC_TO, 8.2f, 8.2f, 0, 0, 1, 1.75f, 2.6f,
R_CUBIC_TO, 0.43f, 0.99f, 0.64f, 2.05f, 0.64f, 3.18f,
R_CUBIC_TO, 0, 1.13f, -0.21f, 2.19f, -0.64f, 3.18f,
R_ARC_TO, 8.22f, 8.22f, 0, 0, 1, -4.35f, 4.36f,
R_ARC_TO, 7.94f, 7.94f, 0, 0, 1, -3.18f, 0.64f,
CLOSE,
MOVE_TO, 10, 16.44f,
R_CUBIC_TO, 1.79f, 0, 3.31f, -0.62f, 4.56f, -1.88f,
R_CUBIC_TO, 1.25f, -1.25f, 1.88f, -2.77f, 1.88f, -4.56f,
R_CUBIC_TO, 0, -1.79f, -0.62f, -3.31f, -1.88f, -4.56f,
CUBIC_TO, 13.31f, 4.18f, 11.79f, 3.56f, 10, 3.56f,
R_CUBIC_TO, -1.79f, 0, -3.31f, 0.63f, -4.56f, 1.88f,
CUBIC_TO, 4.18f, 6.69f, 3.56f, 8.21f, 3.56f, 10,
R_CUBIC_TO, 0, 1.79f, 0.63f, 3.31f, 1.88f, 4.56f,
R_CUBIC_TO, 1.25f, 1.25f, 2.77f, 1.88f, 4.56f, 1.88f,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kInfoChromeRefreshRepList, kInfoChromeRefreshIcon, {kInfoChromeRefreshPath, std::size(kInfoChromeRefreshPath)})
VECTOR_ICON_REP_TEMPLATE(kLaunchPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 16, 16,
H_LINE_TO, 4,
V_LINE_TO, 4,
R_H_LINE_TO, 6,
V_LINE_TO, 2,
H_LINE_TO, 4,
CUBIC_TO, 3, 2, 2, 3, 2, 4,
R_V_LINE_TO, 12,
R_CUBIC_TO, 0, 1, 1, 2, 2, 2,
R_H_LINE_TO, 12,
R_CUBIC_TO, 1, 0, 2, -1, 2, -2,
R_V_LINE_TO, -6,
R_H_LINE_TO, -2,
R_V_LINE_TO, 6,
CLOSE,
MOVE_TO, 12, 2,
R_V_LINE_TO, 2,
R_H_LINE_TO, 2.5f,
LINE_TO, 6, 12.5f,
LINE_TO, 7.5f, 14,
LINE_TO, 16, 5.5f,
V_LINE_TO, 8,
R_H_LINE_TO, 2,
V_LINE_TO, 2,
R_H_LINE_TO, -6,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kLaunchRepList, kLaunchIcon, {kLaunchPath, std::size(kLaunchPath)})
VECTOR_ICON_REP_TEMPLATE(kLinuxHighDensityPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 7, 17,
V_LINE_TO, 7,
R_H_LINE_TO, 10,
R_V_LINE_TO, 10,
CLOSE,
R_MOVE_TO, 8, -2,
V_LINE_TO, 9,
H_LINE_TO, 9,
R_V_LINE_TO, 6,
CLOSE,
R_MOVE_TO, 2, -10,
R_H_LINE_TO, -2,
V_LINE_TO, 3,
R_H_LINE_TO, 2,
CLOSE,
MOVE_TO, 5, 17,
H_LINE_TO, 3,
R_V_LINE_TO, -2,
R_H_LINE_TO, 2,
CLOSE,
R_MOVE_TO, 8, -12,
R_H_LINE_TO, -2,
V_LINE_TO, 3,
R_H_LINE_TO, 2,
CLOSE,
MOVE_TO, 9, 5,
H_LINE_TO, 7,
V_LINE_TO, 3,
R_H_LINE_TO, 2,
CLOSE,
MOVE_TO, 5, 5,
H_LINE_TO, 3,
V_LINE_TO, 3,
R_H_LINE_TO, 2,
CLOSE,
R_MOVE_TO, 0, 4,
H_LINE_TO, 3,
V_LINE_TO, 7,
R_H_LINE_TO, 2,
CLOSE,
R_MOVE_TO, 0, 4,
H_LINE_TO, 3,
R_V_LINE_TO, -2,
R_H_LINE_TO, 2,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kLinuxHighDensityRepList, kLinuxHighDensityIcon, {kLinuxHighDensityPath, std::size(kLinuxHighDensityPath)})
VECTOR_ICON_REP_TEMPLATE(kLinuxLowDensityPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 9, 17,
H_LINE_TO, 3,
V_LINE_TO, 3,
R_H_LINE_TO, 14,
R_V_LINE_TO, 6,
R_H_LINE_TO, -2,
V_LINE_TO, 5,
H_LINE_TO, 5,
R_V_LINE_TO, 10,
R_H_LINE_TO, 4,
CLOSE,
R_MOVE_TO, 8, 0,
R_H_LINE_TO, -2,
R_V_LINE_TO, -2,
R_H_LINE_TO, 2,
CLOSE,
R_MOVE_TO, -4, 0,
R_H_LINE_TO, -2,
R_V_LINE_TO, -2,
R_H_LINE_TO, 2,
CLOSE,
R_MOVE_TO, -4, -4,
H_LINE_TO, 7,
R_V_LINE_TO, -2,
R_H_LINE_TO, 2,
CLOSE,
R_MOVE_TO, 0, -4,
H_LINE_TO, 7,
V_LINE_TO, 7,
R_H_LINE_TO, 2,
CLOSE,
R_MOVE_TO, 4, 0,
R_H_LINE_TO, -2,
V_LINE_TO, 7,
R_H_LINE_TO, 2,
CLOSE,
R_MOVE_TO, 4, 4,
R_H_LINE_TO, -2,
R_V_LINE_TO, -2,
R_H_LINE_TO, 2,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kLinuxLowDensityRepList, kLinuxLowDensityIcon, {kLinuxLowDensityPath, std::size(kLinuxLowDensityPath)})
VECTOR_ICON_REP_TEMPLATE(kMenuCheckPath, CANVAS_DIMENSIONS, 32,
MOVE_TO, 5, 18.78f,
R_LINE_TO, 2.53f, -2.57f,
R_LINE_TO, 4.48f, 4.63f,
LINE_TO, 25.48f, 7,
LINE_TO, 28, 9.59f,
LINE_TO, 12.02f, 26,
LINE_TO, 5, 18.78f,
CLOSE)
VECTOR_ICON_REP_TEMPLATE(kMenuCheck16Path, CANVAS_DIMENSIONS, 16,
MOVE_TO, 2, 9.22f,
R_LINE_TO, 1.36f, -1.38f,
R_LINE_TO, 2.4f, 2.48f,
R_LINE_TO, 7.2f, -7.4f,
R_LINE_TO, 1.35f, 1.39f,
R_LINE_TO, -8.55f, 8.78f,
LINE_TO, 2, 9.22f,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kMenuCheckRepList, kMenuCheckIcon, {kMenuCheckPath, std::size(kMenuCheckPath)}, {kMenuCheck16Path, std::size(kMenuCheck16Path)})
VECTOR_ICON_REP_TEMPLATE(kMenuDropArrowPath, CANVAS_DIMENSIONS, 11,
MOVE_TO, 1, 3,
R_H_LINE_TO, 10,
R_LINE_TO, -5, 6,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kMenuDropArrowRepList, kMenuDropArrowIcon, {kMenuDropArrowPath, std::size(kMenuDropArrowPath)})
VECTOR_ICON_REP_TEMPLATE(kMenuRadioEmptyPath, CANVAS_DIMENSIONS, 32,
CIRCLE, 16, 16, 14,
CIRCLE, 16, 16, 11)
VECTOR_ICON_TEMPLATE_CC(kMenuRadioEmptyRepList, kMenuRadioEmptyIcon, {kMenuRadioEmptyPath, std::size(kMenuRadioEmptyPath)})
VECTOR_ICON_REP_TEMPLATE(kMenuRadioSelectedPath, CANVAS_DIMENSIONS, 32,
CIRCLE, 16, 16, 14,
CIRCLE, 16, 16, 11,
CIRCLE, 16, 16, 7)
VECTOR_ICON_TEMPLATE_CC(kMenuRadioSelectedRepList, kMenuRadioSelectedIcon, {kMenuRadioSelectedPath, std::size(kMenuRadioSelectedPath)})
VECTOR_ICON_REP_TEMPLATE(kNewIncognitoWindowPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 8.13f, 2.04f,
LINE_TO, 10, 2.67f,
R_LINE_TO, 1.85f, -0.62f,
R_ARC_TO, 0.89f, 0.89f, 0, 0, 1, 1.11f, 0.54f,
LINE_TO, 15, 8,
H_LINE_TO, 5,
R_LINE_TO, 2.03f, -5.42f,
R_ARC_TO, 0.89f, 0.89f, 0, 0, 1, 1.11f, -0.54f,
CLOSE,
MOVE_TO, 18, 10,
H_LINE_TO, 2,
V_LINE_TO, 9,
R_H_LINE_TO, 16,
R_V_LINE_TO, 1,
CLOSE,
R_MOVE_TO, -4.06f, 7,
R_ARC_TO, 3.03f, 3.03f, 0, 0, 1, -3.03f, -2.75f,
R_CUBIC_TO, -0.84f, -0.53f, -1.55f, -0.2f, -1.8f, -0.01f,
CUBIC_TO, 8.97f, 15.78f, 7.67f, 17, 6.06f, 17,
CUBIC_TO, 4.37f, 17, 3, 15.65f, 3, 14,
R_CUBIC_TO, 0, -1.65f, 1.37f, -3, 3.06f, -3,
R_CUBIC_TO, 1.45f, 0, 2.65f, 0.98f, 2.98f, 2.31f,
R_ARC_TO, 2.45f, 2.45f, 0, 0, 1, 1.92f, 0.01f,
ARC_TO, 3.04f, 3.04f, 0, 0, 1, 13.94f, 11,
CUBIC_TO, 15.63f, 11, 17, 12.35f, 17, 14,
R_CUBIC_TO, 0, 1.65f, -1.37f, 3, -3.06f, 3,
CLOSE,
MOVE_TO, 14, 16,
R_ARC_TO, 2, 2, 0, 1, 0, 0, -4,
R_ARC_TO, 2, 2, 0, 0, 0, 0, 4,
CLOSE,
R_MOVE_TO, -8, 0,
R_ARC_TO, 2, 2, 0, 1, 0, 0, -4,
R_ARC_TO, 2, 2, 0, 0, 0, 0, 4,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kNewIncognitoWindowRepList, kNewIncognitoWindowIcon, {kNewIncognitoWindowPath, std::size(kNewIncognitoWindowPath)})
VECTOR_ICON_REP_TEMPLATE(kNewTabPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 4, 2,
R_H_LINE_TO, 12,
R_ARC_TO, 2, 2, 0, 0, 1, 2, 2,
R_V_LINE_TO, 12,
R_ARC_TO, 2, 2, 0, 0, 1, -2, 2,
H_LINE_TO, 4,
R_ARC_TO, 2, 2, 0, 0, 1, -2, -2,
V_LINE_TO, 4,
R_ARC_TO, 2, 2, 0, 0, 1, 2, -2,
CLOSE,
R_MOVE_TO, 0, 2,
R_V_LINE_TO, 12,
R_H_LINE_TO, 12,
V_LINE_TO, 4,
H_LINE_TO, 4,
CLOSE,
R_MOVE_TO, 4, 0,
R_H_LINE_TO, 8,
R_V_LINE_TO, 4,
R_H_LINE_TO, -6,
R_ARC_TO, 2, 2, 0, 0, 1, -2, -2,
V_LINE_TO, 4,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kNewTabRepList, kNewTabIcon, {kNewTabPath, std::size(kNewTabPath)})
VECTOR_ICON_REP_TEMPLATE(kNewWindowPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 15, 5,
R_H_LINE_TO, 3,
R_V_LINE_TO, 2,
R_H_LINE_TO, -3,
R_V_LINE_TO, 3,
R_H_LINE_TO, -2,
V_LINE_TO, 7,
R_H_LINE_TO, -3,
V_LINE_TO, 5,
R_H_LINE_TO, 3,
V_LINE_TO, 2,
R_H_LINE_TO, 2,
R_V_LINE_TO, 3,
CLOSE,
R_MOVE_TO, 1, 11,
R_V_LINE_TO, -4,
R_H_LINE_TO, 2,
R_V_LINE_TO, 4,
R_CUBIC_TO, 0, 1, -1, 2, -2, 2,
H_LINE_TO, 4,
R_CUBIC_TO, -1, 0, -2, -1, -2, -2,
V_LINE_TO, 4,
R_CUBIC_TO, 0, -1, 1, -2, 2, -2,
R_H_LINE_TO, 4,
R_V_LINE_TO, 2,
H_LINE_TO, 4,
R_V_LINE_TO, 12,
R_H_LINE_TO, 12,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kNewWindowRepList, kNewWindowIcon, {kNewWindowPath, std::size(kNewWindowPath)})
VECTOR_ICON_REP_TEMPLATE(kOpenPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 6, 4,
R_V_LINE_TO, 2,
R_H_LINE_TO, 6.5f,
LINE_TO, 4, 14.5f,
LINE_TO, 5.5f, 16,
LINE_TO, 14, 7.5f,
V_LINE_TO, 14,
R_H_LINE_TO, 2,
V_LINE_TO, 4,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kOpenRepList, kOpenIcon, {kOpenPath, std::size(kOpenPath)})
VECTOR_ICON_REP_TEMPLATE(kOptionsPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 14, 10,
R_ARC_TO, 2, 2, 0, 1, 1, 4, 0,
ARC_TO, 2, 2, 0, 0, 1, 14, 10,
CLOSE,
R_MOVE_TO, -2, 0,
R_ARC_TO, 2, 2, 0, 1, 1, -4, 0,
ARC_TO, 2, 2, 0, 0, 1, 12, 10,
CLOSE,
R_MOVE_TO, -6, 0,
R_ARC_TO, 2, 2, 0, 1, 1, -4, 0,
ARC_TO, 2, 2, 0, 0, 1, 6, 10,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kOptionsRepList, kOptionsIcon, {kOptionsPath, std::size(kOptionsPath)})
VECTOR_ICON_REP_TEMPLATE(kPinPath, CANVAS_DIMENSIONS, 24,
MOVE_TO, 7, 3,
R_V_LINE_TO, 2,
R_H_LINE_TO, 1,
R_V_LINE_TO, 7,
R_LINE_TO, -2, 2,
R_V_LINE_TO, 2,
R_H_LINE_TO, 5,
R_V_LINE_TO, 6,
R_LINE_TO, 1, 1,
R_LINE_TO, 1, -1,
R_V_LINE_TO, -6,
R_H_LINE_TO, 5,
R_V_LINE_TO, -2,
R_LINE_TO, -2, -2,
V_LINE_TO, 5,
R_H_LINE_TO, 1,
V_LINE_TO, 3,
CLOSE,
R_MOVE_TO, 3, 2,
R_H_LINE_TO, 4,
R_V_LINE_TO, 7.83f,
LINE_TO, 15.17f, 14,
R_H_LINE_TO, -6.34f,
LINE_TO, 10, 12.83f,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kPinRepList, kPinIcon, {kPinPath, std::size(kPinPath)})
VECTOR_ICON_REP_TEMPLATE(kRadioButtonActivePath, CANVAS_DIMENSIONS, 32,
CIRCLE, 16, 16, 14,
CIRCLE, 16, 16, 11,
CIRCLE, 16, 16, 7)
VECTOR_ICON_TEMPLATE_CC(kRadioButtonActiveRepList, kRadioButtonActiveIcon, {kRadioButtonActivePath, std::size(kRadioButtonActivePath)})
VECTOR_ICON_REP_TEMPLATE(kRadioButtonNormalPath, CANVAS_DIMENSIONS, 32,
CIRCLE, 16, 16, 14,
CIRCLE, 16, 16, 11)
VECTOR_ICON_TEMPLATE_CC(kRadioButtonNormalRepList, kRadioButtonNormalIcon, {kRadioButtonNormalPath, std::size(kRadioButtonNormalPath)})
VECTOR_ICON_REP_TEMPLATE(kUninstallPath, CANVAS_DIMENSIONS, 20,
MOVE_TO, 13, 3,
V_LINE_TO, 2,
H_LINE_TO, 7,
R_V_LINE_TO, 1,
H_LINE_TO, 3,
R_V_LINE_TO, 2,
R_H_LINE_TO, 1,
R_V_LINE_TO, 11,
R_CUBIC_TO, 0, 1.1f, 0.9f, 2, 2, 2,
R_H_LINE_TO, 8,
R_CUBIC_TO, 1.1f, 0, 2, -0.9f, 2, -2,
V_LINE_TO, 5,
R_H_LINE_TO, 1,
V_LINE_TO, 3,
R_H_LINE_TO, -4,
CLOSE,
R_MOVE_TO, 1, 13,
H_LINE_TO, 6,
V_LINE_TO, 5,
R_H_LINE_TO, 8,
R_V_LINE_TO, 11,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kUninstallRepList, kUninstallIcon, {kUninstallPath, std::size(kUninstallPath)})
VECTOR_ICON_REP_TEMPLATE(kUnpinPath, CANVAS_DIMENSIONS, 24,
MOVE_TO, 7, 3,
R_H_LINE_TO, 10,
R_V_LINE_TO, 2,
R_H_LINE_TO, -1,
R_V_LINE_TO, 7,
R_LINE_TO, 2, 2,
R_V_LINE_TO, 2,
R_H_LINE_TO, -5,
R_V_LINE_TO, 6,
R_LINE_TO, -1, 1,
R_LINE_TO, -1, -1,
R_V_LINE_TO, -6,
H_LINE_TO, 6,
R_V_LINE_TO, -2,
R_LINE_TO, 2, -2,
V_LINE_TO, 5,
H_LINE_TO, 7,
CLOSE)
VECTOR_ICON_TEMPLATE_CC(kUnpinRepList, kUnpinIcon, {kUnpinPath, std::size(kUnpinPath)})

}
